#include "Primitive3D.h"

#include "Basic3DMath.h"
#include "../logger.h"

Primitive3D::~Primitive3D()
{
    for ( size_t i = 0; i < m_points.GetCount(); ++i )
    {
        delete m_points[i];
    }

    m_points.Empty();
}

void Primitive3D::transform( const Matrix* m )
{
    for ( size_t i = 0; i < m_points.GetCount(); ++i )
    {
        Basic3DMath::transform( m_points[i], m );
    }
}

void Primitive3D::homDiv()
{
    for ( size_t i = 0; i < m_points.GetCount(); ++i )
    {
        m_points[i]->homDiv();
    }
}

void Primitive3D::render( wxDC& dc, int w, int h, const Matrix* m )
{
    transform( m );
    homDiv();
    draw( dc, w, h );
}
