#include "TableEditor3DSQLHelper.h"
#include "../vemsgauge/GaugeGroupManager.h"
#include "../gaugedesc/GaugeDescManager.h"


void TableEditor3DSQLHelper::loadParams( int id, GaugeGroupManager* groupManager, TableEditor3DParams& params )
{
    wxVariantHash datas;

    int res = groupManager->GetGaugeDescMgr()->GetGaugeSettings( _T("table3D"), id, datas);

    if( res < 0 ) return;

    params.rotationAngleX   = datas[_T("RotationX")].GetDouble();
    params.rotationAngleY   = datas[_T("RotationY")].GetDouble();
    params.cameraEyeX       = datas[_T("CameraEyeX")].GetDouble();
    params.cameraEyeY       = datas[_T("CameraEyey")].GetDouble();
    params.zoom             = datas[_T("ZoomLevel")].GetDouble();
    params.showAxes         = datas[_T("ShowAxes")].GetBool();
}

void TableEditor3DSQLHelper::saveParams( int id, GaugeGroupManager* groupManager, const TableEditor3DParams& params )
{
    wxVariantHash datas;

    datas[_T("RotationX")]  = params.rotationAngleX;
    datas[_T("RotationY")]  = params.rotationAngleY;
    datas[_T("CameraEyeX")] = params.cameraEyeX;
    datas[_T("CameraEyey")] = params.cameraEyeY;
    datas[_T("ZoomLevel")]  = params.zoom;
    datas[_T("ShowAxes")]   = params.showAxes;

    groupManager->GetGaugeDescMgr()->SaveGaugeSettings( _T("table3D"), id, datas );
}

