#ifndef COMMUNICATIONBASE_H
#define COMMUNICATIONBASE_H

#include "common/typedef.h"
#include <wx/wx.h>

class CommunicationBase
{
    public:
        CommunicationBase();
        virtual ~CommunicationBase();

        virtual int SendString(const wxString& str) =0;
        virtual int SendString(const uint8_t* chr) =0;
        virtual int SendString(const uint8_t* str, size_t len) =0;
        virtual int sendStringBlock(uint8_t* value, size_t len, size_t blockLen) = 0;

        virtual int Read(uint8_t* str, size_t len) = 0;
        virtual int ReadString(uint8_t* str, size_t len) =0;
        virtual int ReadString(uint8_t* data, size_t len, int maxTryCount) = 0;
        //virtual int ReadUntilEOS(char ** readbuf, char * eosString , long timeout_in_ms) = 0;

        virtual void setBaudRate( int baudRate ) = 0;
        virtual int  getBaudRate() = 0;

        virtual void setPortName( const wxString& portname ) = 0;
        virtual wxString getPortName() const = 0;

        virtual int sendNumber(uint32_t number, int length) =0;
        virtual int sendNumber(uint16_t number) =0;


        bool getAnswer(uint8_t* command, int expLen, int acceptedLen,
            int maxTryCount, wxString* response);


        virtual int open() = 0;
        virtual void close() = 0;
        virtual int  clear() = 0;
    	virtual bool IsOpen() = 0;

    private:
        uint8_t m_buffer[255];

};



#endif // COMMUNICATIONBASE_H

