#include "DatabaseHelper.h"

#include <wx/regex.h>
#include <wx/filename.h>

#include "logger.h"

wxString DatabaseHelper::GetUniqueFilenameFromTitle(const wxString& title, const wxString& path, const wxString& extension)
{

    wxString filename = title;

    wxRegEx exp1;
    exp1.Compile(_T("[^a-zA-Z0-9_]"));
    exp1.ReplaceAll(&filename,_T(""));

    wxString ext = _T(".") + extension;

    if( wxFileExists( path + filename + ext ) ){
        size_t a=0;
        wxString fn;
        while(1){
            fn = filename + wxString::Format(_T("-%i"),a);

            if( !wxFileExists( path + fn + ext) ) break;

            a++;
        }

        filename = fn;
    }

    filename += ext;

    return filename;
}


