#include "FileDropManagerBase.h"

#include "common/FileDropTarget.h"
#include "FileDropTargetBase.h"
#include "FileDropRegistrator.h"
#include "logger.h"

FileDropManagerBase::FileDropManagerBase(wxWindow* dropTarget, FileDropRegistrator* reg)
{
    //ctor
    new FileDropTargetExt<FileDropManagerBase>( this, dropTarget );

    m_registrator = reg;
}

FileDropManagerBase::~FileDropManagerBase()
{
    //dtor
}

void FileDropManagerBase::RegisterTarget(FileDropTargetBase* target)
{
    LOGP(wxString::Format(_T("target=%p"),target));
    m_registrator->m_registeredTargets.Add(target);
}

void FileDropManagerBase::UnRegisterTarget(FileDropTargetBase* target)
{
    m_registrator->m_registeredTargets.Remove(target);
}

bool FileDropManagerBase::onDropFiles( const wxArrayString& filenames )
{
    bool toNext = true;
    for(size_t a = 0; a < m_registrator->m_registeredTargets.GetCount() && toNext; a++) {
        FileDropTargetBase* target = m_registrator->m_registeredTargets[a];

        Logger::logf(LOG_MSG,_T("FileDropManagerBase::onDropFiles target=%p"),target);

        if(target->AcceptDrop()) toNext = ! target->DropFiles( filenames );
    }
	return true;
}

