#ifndef FILEDROPTARGETBASE_H
#define FILEDROPTARGETBASE_H


class FileDropTargetBase
{
    public:
        FileDropTargetBase();
        virtual ~FileDropTargetBase();

        virtual bool AcceptDrop() = 0;

        virtual bool DropFiles( const wxArrayString& files ) = 0;

};

template <class T>
class FileDropTargetRel: public FileDropTargetBase
{
    public:
        FileDropTargetRel( T* owner ) {
            m_owner = owner;
        }

        bool AcceptDrop() { return m_owner->AcceptDrop(); };

        bool DropFiles( const wxArrayString& files ) {
            return m_owner->DropFiles( files );
        };

    private:
        T* m_owner;
};


#endif // FILEDROPTARGETBASE_H
