#ifndef NMEAPARSE_H
#define NMEAPARSE_H

#include "../common/typedef.h"
/**constant of state, we store Sequence of state in m_gprmc_sate_arra and _gpgga_sate_array,
**     m_noOfdecimalfraction is choose which array is current (format(whichformat()) set m_noOfdecimalfraction)
**/

#define START -1
#define FORMAT 0
#define NMEA_UTC 1
#define STATUS 2
#define LATITUDE 3
#define LATITUDEIN 4
#define LONGNITUDE 5
#define LONGNITUDEIN 6
#define SPEED 7
#define COURSE 8
#define DATEOFPOSITION 9
#define MAGNETICVARIATION 10
#define MAGNETICVARIATIONIN 11
#define MODEINDICATOR 12
#define CHECKSUM 13
#define END 14
#define POSITIONINDICATOR 15
#define NOOFSATELITE 16
#define HORIZDILUTIONOFPRECISION 17
#define ANTENNAHEIGH 18
#define GEODIALHEIGH 19
#define AGEOFDGPS 20
#define REFERENCESTATION 21
#define RECIVEM 22
#define UNKNOWN_FORMAT 23

#define CHARACTER -1

/*store in data what is receiving*/
/// GPSDataStruct should be better name
struct GPSDataStruct{

        char        format[5];
        int         dataFormat;
        int         utc;
        uint8_t     status;
        uint32_t    latitude;
        uint8_t     latitudeindicator;
        uint32_t    longnitude;
        uint8_t     longnitudeindicator;
        uint16_t    speed;
        int         course;
        int         dateofposition;
        int         magneticvariation;
        char        magneticvariationdirection;
        char        modeindicator;
        int         positionindic;
        int         noofsatellite;
        uint16_t    horizontalprecision;
        int         antennaheight;
        uint32_t    geodialheight;
        int         dgps;
        int         station;
        uint8_t     checksum;
        uint32_t    errorbyte;

};

class NMEAParse
{
    public:
        NMEAParse();
        virtual ~NMEAParse();
        enum GPSFormat{
            GPS_FORMAT_GPRMC = 30,
            GPS_FORMAT_GPGGA = 31
        };
        GPSDataStruct gpsdata;
/*
        enum GPSFOrder{
            START = -1,
            FORMAT,
            UTC,
            STATUS,
            LATITUDE,
            LATITUDEIN,
            LONGNITUDE,
            LONGNITUDEIN,
            SPEED,
            COURSE,
            DATEOFPOSITION,
            MAGNETICVARIATION,
            MAGNETICVARIATIONIN,
            MODEINDICATOR,
            CHECKSUM,
            END,
            POSITIONINDICATOR,
            NOOFSATELITE,
            HORIZDILUTIONOFPRECISION,
            ANTENNAHEIGH,
            GEODIALHEIGH,
            AGEOFDGPS,
            REFERENCESTATION,
            RECIVEM
        };
*/

        int feedGPScharacter(char c);

        void print_struct();
        void printbinaryarray();
        void printTestVektor();
    protected:
    private:
        char *m_testvektor;
        uint8_t binary_array[21];// include utc time(4 element), latitude(4 element),longnitude(4 element),speed(3 element),
                                // antennaheight(4 element),horizontalprecision(2 element)
        uint16_t n; // MI EZ?
        int storeNumber(char c);
        int hextobin(char c);
        int checkout();
        void initiation();
        int wichformat(char c);
        bool isNextSate(char c);
        void writeToStruct();
        void getData( char* dest );
        int getvaluefrombinaryformat(char howmanybit,char idx);

        char *m_statearray;   //  char *m_statearray; //show array of current format

        char  m_calculatedchecksum; //store in  count out checksum

        int   m_tempnumber;// store current (received) number of digit's

        char  m_counter; //normaly  count fraction of digit
                        //;or receive  high bine of checksum  m_couner = 1
                         //;or show state when find out which format received

        char  m_noOfdecimalfraction;//normaly how many is fraction digit of date  evry state is other
                                    // if < 0 receive character
        char  m_formatNow;          // ; =0 if receive GPRMC format, or =1 receive GPGGA format else =-1


        char  m_idx; //which is state

        enum Sync { FIRST_CHARACTER_OF_GPRMC_OR_GPGGA   = 0,
                    SECOUND_CHARACTER_OF_GPRMC_OR_GPGGA = 1,
                    THIRD_CHARACTER_OF_GPRMC            = 2,
                    FOURTH_CHARACTER_OF_GPRMC           = 3,
                    FIFTH_CHARACTER_OF_GPRMC            = 4,
                    THIRD_AND_FOURTH_CHARACTER_OF_GPGGA = 5,
                    FIFTH_CHARACTER_OF_GPGGA            = 6
                  };

};



#endif // NMEAPARSE_H
