//http://www.vems.hu/files/MembersPage/NanassyPeter/AIM_support/AIM-ECU%20protocol.pdf
#ifndef AIMPROTOCOLL_H
#define AIMPROTOCOLL_H

#include "../common/typedef.h"

#define LASTBITONE 0x8000
#define LASTBITNULL 0x7fff
#define BREAK 0xFF

#define PERIOD0 9// each 10. value same type
#define PERIOD2 1/10.0
#define AIMCONST 0xA3

#define CHANNEL 0
#define RECEIVAIMCONST 1
#define HIGHBINE 2
#define LOWBINE 3
#define CHECKS 4

#define RPMVALUE 1
#define WHEELSPEED 5
#define WATERTEMP 17
#define FUELPRESSURE 21
#define BATTERYVOLTAGE 33
#define THROTTLEANGLE 45
#define MAINFOLDPRESS 69
#define AIRCHARGETEMP 97
#define EXHAUSTTEMP 101
#define LAMBDASENSOR 105
#define DUMMY 0
///not used:
#define OILPRESSURE 9
#define OILTEMP 13
#define FUELTEMP 109
#define GEAR 113
#define ERRORS 125




#define IDX 130//for test
class AIMProtocoll
{
    public:



        AIMProtocoll();
        virtual ~AIMProtocoll();
     //send
        uint8_t sendaimprotocol(void);
        uint8_t aimbinary_array[IDX];
      //receiving
        void feddAIMcharacter(uint8_t c);

        struct m_data_t{// srore in received data
            int16_t rpmvalue;
            int16_t wheelspeed;
            int16_t throttleangle;
            int16_t manifoldpress;
            int16_t lambdasensor;
            int16_t fuelpressure;
            int16_t batteryvoltage;
            int16_t watertemp;
            int16_t airchargetemp;
            int16_t exhausttemp;
            int16_t errorbyte;
        };
      //test
        void test(void);
        void print_struct(void);
        void print_occurrence(void);
        void printaimbinaryarray(void);


       m_data_t aimdata;
  //test
       struct occurrence_t{
            uint8_t rpmvalue;
            uint8_t wheelspeed;
            uint8_t throttleangle;
            uint8_t manifoldpress;
            uint8_t lambdasensor;
            uint8_t fuelpressure;
            uint8_t batteryvoltage;
            uint8_t watertemp;
            uint8_t airchargetemp ;
            uint8_t exhausttemp;
            uint8_t errorbyte;
       };
        occurrence_t oc;
    protected:
        //send
        uint8_t curentbyte(int16_t value, char channel);
        //test
        int16_t getrpmvalue(void);
        int16_t getwheelspeed(void);
        int16_t getthrottleangle(void);
        int16_t getmanifoldpress(void);
        int16_t airchargetemp(void);
        int16_t exhausttemp(void);
        int16_t getlambdasensor(void);
        int16_t getfuelpressure(void);
        int16_t getbatteryvoltage(void);
        int16_t getwatertemp(void);
        int16_t getdummy(void);
        //receiving
        void savevalue(uint8_t val,uint8_t bine);
    private:
       //send
        uint8_t bytestate;// which byte is sent (forexample: chanel,amiconstant(A3),value,summa )
        uint16_t sum;//= chanel + amiconstant(A3) + value
        uint16_t m_count;
      //receiving
       // int16_t  m_receivcount;
        uint8_t receivbytestate;// which byte is received (forexample: chanel,ami const(a3),value,summa )
        uint8_t receivtypestate;// which type is received (forexample: rpm,wheelspeed,throttleangle..... )
        uint16_t m_receivsum;//recount sum
        //test
        int16_t randomvalue(void);
        int16_t randomcounter; //if it is divisible by five creat new random number
        int16_t randomnumber;
        int16_t receivdata;


};

#endif // AMIPROTOCOLL_H
