#include "ImageLoader.h"

#include <wx/url.h>

#include "logger.h"

ImageLoader::ImageLoader(int id)
{
    //ctor
    m_id = id;

    m_error = NONE;
    m_state = IDLE;
}

ImageLoader::~ImageLoader()
{
    //dtor

    stop();
}

void ImageLoader::Load(const wxString& url, long type)
{
    if( isRunning() ) return;

    m_url = url;
    m_imType = type;

    m_state = LOADING;

    start();
}

bool ImageLoader::process()
{
    LOGP(m_url)

    observerNotify(0,m_id);

    wxURL url( m_url );

    if(url.GetError() == wxURL_NOERR) {
        wxInputStream *ins = NULL;

        ins = url.GetInputStream();

        if(ins) {
            m_image = wxImage(*ins,m_imType);
            observerNotify(1,m_id);
            m_error = NONE;
        } else {
            m_error = SERVER_NOT_RESPONDING;
        }

    } else {
        m_error = WRONG_URL;
    }

    m_state = IDLE;

    return false;
}
