#ifndef LOGDIRMANAGER_H
#define LOGDIRMANAGER_H
#include <wx/wx.h>

#include <wx/wxsqlite3.h>

#define MAX_RECENT_ECU_NUM 10

class RecentECUs {
public:
    RecentECUs() { ECUName = _T(""); menuID = -1; }
    wxString ECUName;
    int menuID;
};

class LogDirManager
{
    public:
        static void openDB();

        static void SetDbPath(const wxString & dbpath);
        static void SetDefaultWorkDir(const wxString & workdir);
        static wxString GetDefaultWorkDir();

        static wxArrayString GetRecentECUs(int limit = MAX_RECENT_ECU_NUM);
        static RecentECUs& GetRecentECU( int i );
        static void SetRecentECU( int i, RecentECUs& r);
        static wxString selectedECU();
        static wxArrayString GetECUList();

        static wxString getNameBySerialNumber(unsigned int SerialNumber, wxString ECUType = _T(""));
        static wxString getNameBySerialNumber(const wxString & SerialNumber);

        static int  checkForUsedECU();
        static bool insertSerialNumber(unsigned int SerialNumber, const wxString & name, wxString ECUType = _T(""), int timestamp = -1);
        static bool insertSerialNumber(const wxString & SerialNumber, const wxString & name, int timestamp = -1);

        static void updateSerialNumber(unsigned int SerialNumber, wxString ECUType = _T(""));
        static void updateSerialNumber(const wxString& SerialNumber);

        static bool deleteSerialNumber(unsigned int SerialNumber, wxString ECUType = _T(""));
        static bool deleteSerialNumber(const wxString& SerialNumber);

        static wxArrayString searchForDirectories( unsigned int SerialNumber, wxString ECUType = _T("") );

        /// FOR TESTING
        static void dropTables();
        ///

    protected:
    private:
        static void checkDb();
        static wxString m_dbpath;
        static wxString m_defworkdir;
        static wxSQLite3Database db;
        static RecentECUs rECU[MAX_RECENT_ECU_NUM];
        static wxString SNToString(unsigned num, wxString ECUType = _T(""));

    /// deprecated
    public:
        // static void updateByName(const wxString& ECUName);
        // static bool ecuNameExists(const wxString& ECUName);
};

#endif // LOGDIRMANAGER_H
