// #include <iostream>
// #include "..\VemsGauge\vemsgauge.h"
// #include "gaugeframe.h"

#include <math.h>
#include "MGraphics.h"

#include <wx/dcclient.h>
#include <wx/brush.h>

#include <wx/image.h>

#include "../logger.h"


//-----------------------------------------------------------------------
// 1 pixel vastag vonalakhooz!
//
void TMGraphics::DrawLine_1(TRGB RGB, double x1, double y1, double x2, double y2)
  {
    double  dx, dy;
    double  x,  y;
    double  e,  f;
    double  fe, ff;
    int     X,  Y;
    int     X2, Y2;
    BYTE    R, G, B;
    BYTE    *pB;

    // TODO
    /**
    A scanline-okat alulrl kerektve kell indtani!!!
    s fellrl kerektsig kell futtani!
    Az els pixelnl az alulrl kerektssel is kell interpollni
    Az utols pixelnl a fellrl kerektssel is kell interpollni!

    A futindexet a kezd kerektsnek megfelelen korriglni kell!
    **/

    R = RGB.R;
    G = RGB.G;
    B = RGB.B;


    W = BMP->GetWidth();
    H = BMP->GetHeight();

    if(abs((int)(x2 - x1)) < abs((int)(y2 - y1)))
      {
        // RGB_CYAN
        if(y2 < y1)
          {
            double t;
            t = y2;
            y2 = y1;
            y1 = t;

            t = x2;
            x2 = x1;
            x1 = t;
          }

        x  = x1;
        dx = (x2 - x1) / (y2 - y1);

        Y = (int)floor(y1);
        Y2 = (int)ceil(y2);

        if(Y < 0)
          {
            Y = 0;
            x = x1 + dx * (-1) * y1;
          }

        if(H < Y2)
          Y2 = H - 1;

        while(Y <= Y2)
          {
            if(0 < dx)
              {
                X = (int)floor(x);
                e = x - X;
                f = 1 - e;
              }
            else
              {
                X = (int)ceil(x);
                e = X - x;
                f = 1 - e;
              }

            if((0 <= X) && (X < W))
              {

                // pB = &pB[3 * X];
                // pB = pB  + 3 * X;

                //-----------------------------------------------------------
                // Ha ilyeneket rhatok az az igazi lvezet Hejjjj

                pB = SL[Y] + 3 * X;
                *pB++ = (BYTE)(e * *pB + f * B);
                *pB++ = (BYTE)(e * *pB + f * G);
                *pB   = (BYTE)(e * *pB + f * R);

                // BEGIN_ALIAS
                // SET_PIXEL
              }

            if(0 < dx)
              X++;
            else
              X--;

            if((0 <= X) && (X < W))
              {
                END_ALIAS
                // SET_PIXEL
              }

            x += dx;
            Y++;
          }
      }
    else
      {
        // RGB_YELLOW
        if(x2 < x1)
          {
            double t;
            t = y2;
            y2 = y1;
            y1 = t;

            t = x2;
            x2 = x1;
            x1 = t;
          }


        dy = (y2 - y1) / (x2 - x1);

        X = (int)floor(x1);
        X2 = (int)ceil(x2);
        y = y1;

        if(X < 0)
          {
            X = 0;
            y = y1 + dy * (-1) * x1;
          }

        if(W < X2)
          X2 = W - 1;

        while(X <= X2)
          {
            if(0 < dy)
              {
                Y = (int)floor(y);
                e = y - Y;
                f = 1 - e;
              }
            else
              {
                Y = (int)ceil(y);
                e = Y - y;
                f = 1 - e;
              }

            fe = f * e;
            ff = f * f;

            if((0 <= Y) && (Y < H))
              {
                BEGIN_ALIAS
                // SET_PIXEL
              }

            if(0 < dy)
              Y++;
            else
              Y--;

            if((0 <= Y) && (Y < H))
              {
                END_ALIAS
                // SET_PIXEL
              }

            y += dy;
            X++;
          }
      }
  }//TMGraphics::DrawLine_1()


//---------------------------------------------------------------------------
void TMGraphics::DrawLine(TRGB RGB, int w, double x1, double y1, double x2, double y2)
  {
    TDPoint     P[4];         // (double) Points of the the line bounded polygon
    double      dx, dy;       // 1 level step differences
    int         X,   Y;       // common cycle varibles
    double      Alpha;        // Angle of line, and angle of perpendicular capline (end of line)
    double      t;            // temporary variable
    TSegChain   **CBuffer;    //
    BYTE        R,  G,  B;
    int         From, To;
    BYTE        *pB;

    //-----------------------------------------------------------------------
    // special cases
    if((w < 2) || (40 < w))
      {
        if(w == 1)
          {
            // special case, call DrawALine_1() function
            DrawLine_1(RGB, x1, y1, x2, y2);
          }
        // not allowed cases
        return;
      }

    dx = x2 - x1;
    dy = y2 - y1;


    if((dx == 0) && (dy == 0))
      {
        // Points are equal
        return;
      }

    if((dx == 0) || (dy == 0))
      {
        // this is an orthogonal line, use the original line function
        // if applicate transparent mode, than have to implement this case too
        // ToDo - call original function

        DrawOrthoLine(RGB, w, (int)x1, (int)y1, (int)x2, (int)y2);
        return;
      }

    // Alpha = atan(dy / dx);     // dangerous old function, result value restricted between -(Pi/2) and (Pi/2)
    Alpha = atan2(dy , dx);
    Alpha = Alpha - (M_PI / 2);


    //-----------------------------------------------------------------------
    // Calculate bound points

    t = cos(Alpha) * (w / 2);
    P[0].x = x1 + t;
    P[1].x = x1 - t;
    P[2].x = x2 - t;
    P[3].x = x2 + t;

    t = sin(Alpha) * (w / 2);
    P[0].y = y1 + t;
    P[1].y = y1 - t;
    P[2].y = y2 - t;
    P[3].y = y2 + t;


    /**
    // Corner points for testing
    R =  G =  B = 255;     // white
    p.MoveTo(data, P[0].x, P[0].y);
    SET_PIXEL

    B = G = 0;              // red
    p.MoveTo(data, P[1].x, P[1].y);
    SET_PIXEL

    R = 0;
    G = 255;                // green
    p.MoveTo(data, P[2].x, P[2].y);
    SET_PIXEL

    G = 0;
    B = 255;                // blue
    p.MoveTo(data, P[3].x, P[3].y);
    SET_PIXEL
    **/

    //-----------------------------------------------------------------------
    // Create CBuffer

    H = BMP->GetHeight();
    W = BMP->GetWidth();

    CBuffer = new TSegChain*[H];
    for(Y=0; Y<H; Y++)
      {
        CBuffer[Y] = NULL;
      }


    // Ebbl egy maximlis mrett kell ltrehozni a program indulsakor
    // klnben az lland ltrehozs megsemmists sok idt vehet el!


    //-----------------------------------------------------------------------
    // Draw smooth (antialiased) pixels

    DrawSmootLine(RGB, P[0],P[1], CBuffer);

    DrawSmootLine(RGB, P[1],P[2], CBuffer);

    DrawSmootLine(RGB, P[2],P[3], CBuffer);

    DrawSmootLine(RGB, P[3],P[0], CBuffer);


    //-----------------------------------------------------------------------
    // Fill body of the line, by CBuffer

    RGB.GetRGB(&R, &G, &B);


    for(Y=0; Y<H; Y++)
      {
        if(SearchBound(CBuffer[Y], &From, &To))

        if(From < -1)
          From = -1;
        if(W < To)
          To = W;

        for(X = (From+1) ; X<(To); X++)
          {
            SET_PIXEL
          }
      }

    //-----------------------------------------------------------------------
    // delete allocated memories

    for(Y=0; Y<H; Y++)
      Clear(CBuffer[Y]);

    delete CBuffer;

  }//TMGraphics::DrawLine()


