#ifndef MTCONFIGCHECKER_H
#define MTCONFIGCHECKER_H

#include <wx/wx.h>

#include <wx/textfile.h>


class MTConfigData;
class UserDialog;
class UserEditField;
class VemsTableDesc;
class UserMenu;
class UserMenuItem;
class SuperCurveDescriptorH;
class VemsCurveDialogDescH;
class UserMenuList;


//class MTConfigValidatorBase
//{
//    public:
//        virtual bool validate() = 0;
//};
//
//class SuperCurveDescValidator
//{
//    public:
//        SuperCurveDescValidator(    const SuperCurveDescriptorH* superCurveDescs,
//                                    const VemsCurveDialogDescH* curveDescs,
//                                    UserMenuList* userMenu );
//
//        bool validate();
//
//    private:
//        const SuperCurveDescriptorH*    m_superCurveDescs;
//        const VemsCurveDialogDescH*     m_curveDescs;
//        UserMenuList*                   m_userMenu;
//};

class MTConfigChecker
{
    public:
        MTConfigChecker( MTConfigData* config );
        virtual ~MTConfigChecker() {}

        void check();

    private:
        MTConfigData*   m_config;
        wxTextFile      m_logFile;
        wxString        m_logFileName;

        void openLogFile();
        void closeLogFile();
        void doLog( const wxString& msg );

        void checkUserDialogs();
        bool checkUserDialog( UserDialog* desc );
        bool checkUserEditField( UserEditField& desc );
        void checkTableEditors();
        bool checkTableEditor( const VemsTableDesc* desc );
        void checkUserMenuList();
        void checkUserMenu( UserMenu* um );
        bool checkUserMenuItem( UserMenuItem* umi );
        bool findUserDialog( const wxString& name );
        bool findTableEditor( const wxString& name );
        bool findCurveEditor( const wxString& name );
        bool findSuperCurveEditor( const wxString& name );
        bool findTableMapper( const wxString& name );
        void checkSymbols();
        bool findSymbolInDialogs( const wxString& name );
        bool findSymbolInDialog( const wxString& name, UserDialog* desc );
};


#endif // MTCONFIGCHECKER_H
