#include "NMEAParse.h"

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <math.h>
char m_gprmc_state_array[] = {  START,
                                FORMAT,
                                UTC,
                                STATUS,
                                LATITUDE,
                                LATITUDEIN,
                                LONGNITUDE,
                                LONGNITUDEIN,
                                SPEED,
                                COURSE,
                                DATEOFPOSITION,
                                MAGNETICVARIATION,
                                MAGNETICVARIATIONIN,
                                MODEINDICATOR,
                                CHECKSUM,
                                END};

char m_gpgga_state_array[] = {  START,
                                FORMAT,
                                UTC,
                                LATITUDE,
                                LATITUDEIN,
                                LONGNITUDE,
                                LONGNITUDEIN,
                                POSITIONINDICATOR,
                                NOOFSATELITE,
                                HORIZDILUTIONOFPRECISION,
                                ANTENNAHEIGH,
                                RECIVEM,
                                GEODIALHEIGH,
                                RECIVEM,
                                AGEOFDGPS,
                                REFERENCESTATION,
                                CHECKSUM,
                                END};

NMEAParse::NMEAParse()
:m_calculatedchecksum(0)
,m_tempnumber(0)
,m_counter(0)
,m_idx(0)
,valuestate(0)
,bytestate(0)
,state(0)
,sum(0)
,m_count(0)
{
int counter = 0;
for( counter = 0; counter < INDEX; counter++){
 amibinary_array[counter] = 0;
}
m_statearray = m_gprmc_state_array;
gpsdata.errorbyte=0;
     // m_testvektor2 = "$GPRMC,160342.000,A,4728.5725,N,01914.0230,E,0.00,,";
     // m_testvektor = "$GPRMC,160346.000,A,4728.5725,N,01914.0230,E,0.00,,091207,,,A*7B";

        //m_testvektor = "$GPRMC,160347.000,A,4728.5725,N,01914.0230,E,0.00,,091207,,,A*78$GPRMC,160346.000,A,4728.5725,N,01914.0230,E,0.00,,091207,,,A*7B";
        m_testvektor = "$GPGGA,160339.000,4728.5725,N,01914.0230,E,1,07,1.1,164.1,M,41.0,M,,0000*52";
}

NMEAParse::~NMEAParse()
{
    //dtor
}

void NMEAParse::printTestVektor()
{
    printf("print_testvektor()");
    int nn = 0;
    for(nn = 0; nn < 100; nn++){
//     if(*(m_testvektor+nn) == NULL){break;}
     printf("n=%d m_testvektor=%c\n ",nn,m_testvektor[nn]);
    }
     printf("END print_testvektor()");
}

void NMEAParse::feddGPScharacter(char c)
{

   if(c == '$' ){
       initiation();
        m_idx = 1;
        m_calculatedchecksum = 0;
        m_counter = 0;
        gpsdata.errorbyte = 0;
        m_noOfdecimalfraction = -1;
    }else{
            char state = *(m_statearray + m_idx);
            switch(state){
                        case START:
                                printf("waiting for $ character\n");
                        break;

                        case FORMAT:
                            m_calculatedchecksum ^=c;
                            if( c == ','){
                                if( m_noOfdecimalfraction == 0 ){
                                    m_statearray = m_gprmc_state_array;
                                    m_idx++;
                                    m_counter = 0;
                                    break;
                                }else if( m_noOfdecimalfraction == 1 ){
                                    m_statearray = m_gpgga_state_array;
                                    m_idx++;
                                    m_counter = 0;
                                    break;
                                }else{
                                     printf("invalid format");
                                     gpsdata.errorbyte |= 1;
                                }
                            }
                            m_noOfdecimalfraction = wichformat(c);

                        break;



                        case UTC:
                                m_calculatedchecksum ^=c;
                                m_noOfdecimalfraction = 2;
                                printf("utc=%d",m_tempnumber);
                                if(c==','){
                                            checkout();
                                            gpsdata.utc = m_tempnumber;
                                    m_tempnumber = 0;
                                    m_counter = 0;
                                    m_idx++;
                                    break;
                                }
                                if( ( isdigit (c) ) || (c == '.') ){///isdigit == (0..9)
                                    storeNumber(c);
                                }
                                else{
                                    gpsdata.errorbyte |= 2;
                                    printf("invalid data\n");
                                }
                        break;

                        case STATUS:
                                printf("------------UTC%c\n",c);
                                m_calculatedchecksum ^=c;
                                if(c==','){
                                    m_idx++;
                                    break;
                                }
                                if( ( c == 'A' ) || (c == 'V') ){
                                    gpsdata.status = c ;
                                }else{
                                  gpsdata.errorbyte |= 4;
                                }
                        break;

                        case LATITUDE:
                                m_calculatedchecksum ^=c;
                                m_noOfdecimalfraction = 4;
                                if(c==','){
                                    checkout();
                                    gpsdata.latitude = m_tempnumber;
                                    m_tempnumber = 0;
                                    m_counter = 0;
                                    m_idx++;
                                    break;
                                }
                                if( ( isdigit (c) ) || (c == '.') ){///isdigit== (0..9)
                                        storeNumber(c);
                                }
                                else{
                                    gpsdata.errorbyte |= 8;
                                }
                        break;

                        case LATITUDEIN:
                                m_calculatedchecksum ^=c;
                                if(c==','){
                                    m_idx++;
                                    break;
                                }
                                if( ( c == 'N' ) || ( c == 'S')){
                                    gpsdata.latitudeindicator = c ;
                                }else{
                                   gpsdata.errorbyte |= 16;
                                }
                        break;

                        case LONGNITUDE:
                                m_calculatedchecksum ^=c;
                                m_noOfdecimalfraction = 4;
                                if(c==','){
                                    checkout();
                                    gpsdata.longnitude = m_tempnumber;
                                    m_tempnumber = 0;
                                    m_counter = 0;
                                    m_idx++;
                                    break;
                                }
                                if( ( isdigit (c) ) || (c == '.') ){///isdigit== (0..9)
                                    storeNumber(c);
                                }
                                else{
                                    gpsdata.errorbyte |= 32;
                                    printf("invalid data\n");
                                }
                        break;

                        case LONGNITUDEIN:
                                m_calculatedchecksum ^=c;
                                if(c==','){
                                    m_idx++;
                                    break;
                                }
                                if( ( c == 'E' ) || ( c == 'W')){
                                    gpsdata.longnitudeindicator = c ;
                                }else{
                                    gpsdata.errorbyte |= 64;
                                    printf("invalid data\n");
                                }
                        break;

                        case SPEED:
                                m_calculatedchecksum ^=c;
                                m_noOfdecimalfraction = 1;
                                if(c==','){
                                    checkout();
                                    gpsdata.speed = m_tempnumber;
                                    m_tempnumber = 0;
                                    m_counter = 0;
                                    m_idx++;
                                    break;
                                }
                                if( ( isdigit (c) ) || (c == '.') ){///isdigit== (0..9)
                                    storeNumber(c);
                                }
                                else{
                                    gpsdata.errorbyte |= 128;
                                    printf("invalid data\n");
                                }
                        break;

                        case COURSE:
                                m_calculatedchecksum ^=c;
                                m_noOfdecimalfraction = 1;
                                if(c==','){
                                    checkout();
                                    gpsdata.course = m_tempnumber;
                                    m_tempnumber = 0;
                                    m_counter = 0;
                                    m_idx++;
                                    break;
                                }
                                if( ( isdigit (c) ) || (c == '.') ){///isdigit== (0..9)
                                    storeNumber(c);
                                }
                                else{
                                    gpsdata.errorbyte |= 256;
                                    printf("invalid data\n");
                                }
                        break;
                            case DATEOFPOSITION:
                                m_calculatedchecksum ^=c;
                                m_noOfdecimalfraction = 0;
                                if(c==','){
                                    checkout();
                                    gpsdata.dateofposition = m_tempnumber;
                                    m_tempnumber = 0;
                                    m_counter = 0;
                                    m_idx++;
                                    break;
                                }
                                if(  ( isdigit (c) ) || (c == '.') ){///isdigit== (0..9)
                                   storeNumber(c);
                                }
                                else{
                                    gpsdata.errorbyte |= 512;
                                    printf("invalid data\n");
                                }
                        break;
                        case MAGNETICVARIATION:
                                m_calculatedchecksum ^=c;
                                m_noOfdecimalfraction = 1;
                                if(c==','){
                                    checkout();
                                    gpsdata.magneticvariation  = m_tempnumber;
                                    m_tempnumber = 0;
                                    m_counter = 0;
                                    m_idx++;
                                    break;
                                }
                                if( ( isdigit (c) ) || (c == '.') ){///isdigit== (0..9)
                                    storeNumber(c);
                                }
                                else{
                                    gpsdata.errorbyte |= 1024;
                                    printf("invalid data\n");
                                }
                        break;
                        case MAGNETICVARIATIONIN:
                                m_calculatedchecksum ^=c;
                                if(c==','){
                                    m_idx++;
                                    break;
                                }
                               if( ( c == 'E' ) || ( c == 'W' ) ) {
                                    gpsdata.magneticvariationdirection = c ;
                                }else{
                                  printf("invalid data\n");
                                }
                        break;
                        case MODEINDICATOR :
                                if(c=='*'){
                                   m_idx++;
                                   m_counter = 0;
                                    break;
                                }
                                m_calculatedchecksum ^=c;
                                if( ( c == 'N' ) || ( c == 'A' ) || ( c == 'D' ) || ( c == 'E' ) ) {
                                    gpsdata.modeindicator = c ;
                                }else{

                                    printf("invalid datab\n");
                                      gpsdata.errorbyte |= 2048;
                                }

                        break;
                        case CHECKSUM :
                                if(m_counter == 0){
                                    gpsdata.checksum = 0;
                                    printf("----------------%c",c);
                                    gpsdata.checksum = (hextobin(c) << 4 );
                                    m_counter++;
                                    break;
                                }
                                if(m_counter == 1){
                                    printf("----------------%c",c);
                                    gpsdata.checksum += hextobin(c) ;
                                    m_idx++;
                                }

                                if(gpsdata.checksum == m_calculatedchecksum){
                                    printf("data is valid");
                                }else{
                                   gpsdata.errorbyte |= 4096; //0x1000;
                                   printf("data is invalid!!!!!!!!!!!!!!!!!!!!\n");
                                }
                                m_counter = 0;
                        break;


                        case POSITIONINDICATOR  :
                               m_calculatedchecksum ^=c;
                               if(c==','){
                                    m_idx++;
                                    break;
                                }

                               if( (c == '0' ) || ( c == '1' ) || ( c == '2' ) ){
                                        gpsdata.positionindic = c - '0';
                               }else{
                                        gpsdata.errorbyte |= 8192;
                              }
                        break;

                        case NOOFSATELITE  :
                                m_calculatedchecksum ^=c;
                                m_noOfdecimalfraction = 1;
                                if(c==','){
                                    checkout();
                                    gpsdata.noofsatellite = m_tempnumber;
                                    m_tempnumber = 0;
                                    m_counter = 0;
                                    m_idx++;
                                    break;
                                }
                                if( ( isdigit (c) ) ){///isdigit== (0..9)
                                   storeNumber(c);
                                }
                                else{
                                    gpsdata.errorbyte |= 16384;
                                    printf("invalid data\n");
                                }


                        break;

                        case HORIZDILUTIONOFPRECISION  :
                                m_calculatedchecksum ^=c;
                                m_noOfdecimalfraction = 1;
                                if(c==','){
                                    checkout();
                                    gpsdata.horizontalprecision = m_tempnumber;
                                    m_tempnumber = 0;
                                    m_counter = 0;
                                    m_idx++;
                                    break;
                                }
                                if( ( isdigit (c) ) || (c == '.') ){///isdigit== (0..9)
                                    storeNumber(c);
                                }
                                else{
                                    gpsdata.errorbyte |= 32768;
                                    printf("invalid data\n");
                                }
                        break;
                        case ANTENNAHEIGH  :
                                m_calculatedchecksum ^=c;
                                m_noOfdecimalfraction = 1;
                                if(c==','){
                                    checkout();
                                    gpsdata.antennaheight = m_tempnumber;
                                    m_tempnumber = 0;
                                    m_counter = 0;
                                    m_idx++;
                                    break;
                                }
                                if( ( isdigit (c) ) || (c == '.') ){///isdigit== (0..9)
                                    storeNumber(c);
                                }
                                else{
                                    gpsdata.errorbyte |= 65536;
                                    printf("invalid data\n");
                                }
                        break;
                        /*gpgga format include M character after and before geoidal height*/
                        case RECIVEM :
                               m_calculatedchecksum ^=c;
                               if( c == ','){
                                   m_idx++;
                                   break;
                               }

                               if( c != 'M'){
                                    gpsdata.errorbyte |= 131072;
                                    printf("invalid data\n");
                               }
                        break;

                        case GEODIALHEIGH  :
                                m_calculatedchecksum ^=c;
                                m_noOfdecimalfraction = 1;
                                if(c==','){
                                    checkout();
                                    gpsdata.geodialheight = m_tempnumber;
                                    m_tempnumber = 0;
                                    m_counter = 0;
                                    m_idx++;
                                    break;
                                }
                                if( ( isdigit (c) ) || (c == '.') ){///isdigit== (0..9)
                                    storeNumber(c);
                                }
                                else{
                                    gpsdata.errorbyte |= 262144;
                                    printf("invalid data\n");
                                }

                        break;
                        case AGEOFDGPS  :
                               m_calculatedchecksum ^=c;
                               if(c==','){
                                    m_idx++;
                            }
                        break;

                        case REFERENCESTATION   :
                                m_noOfdecimalfraction = 0;
                                if(c=='*'){
                                    checkout();
                                    gpsdata.station = m_tempnumber;
                                    m_tempnumber = 0;
                                    m_counter = 0;
                                    m_idx++;
                                    break;
                                }
                                m_calculatedchecksum ^=c;
                                if( ( isdigit (c) ) || (c == '.') ){///isdigit== (0..9)
                                    storeNumber(c);
                                }
                                else{
                                    gpsdata.errorbyte |= 524288;
                                    printf("invalid data%c\n",c);
                                }

                        break;


                        case END  :
                               printf("END");
                        break;

            }

       }
}
/**character's to number  ***/
int NMEAParse::storeNumber(char c)
{

    if( m_counter >= 1 ){

        m_counter++;
    }

    if(m_counter > m_noOfdecimalfraction +1 ){
        return m_tempnumber;
    }


    if((c != '.')){
        m_tempnumber *=10;
        m_tempnumber += c - '0' ;
    }else{
        m_counter = 1;
    }
return m_tempnumber;
}

/** if recived less character we want (m_noOfdecimalfraction)  compensate it (return 0)
**/
int NMEAParse::checkout()
{
    m_counter--;
    if(m_counter <  m_noOfdecimalfraction ){
        m_tempnumber *= (int)pow((double)10, (double)(m_noOfdecimalfraction  - m_counter));
        return 0;
    }else{
        return 1;
    }
}


void NMEAParse::print_struct()
{  printf("print_struct(int n)\n");

    printf("UTC = %d\n",gpsdata.utc);
    printf("status = %c\n",gpsdata.status);
    printf("latitude = %d\n",gpsdata.latitude);
    printf("latitudeindicator = %c\n",gpsdata.latitudeindicator);
    printf("longnitude = %d\n",gpsdata.longnitude);
    printf("longnitudeindicator = %c\n",gpsdata.longnitudeindicator);
    printf("speed = %d\n",gpsdata.speed);
    printf("course = %d\n",gpsdata.course);
    printf("dateofposition = %d\n",gpsdata.dateofposition);
    printf("m_magneticvariation = %d\n",gpsdata.magneticvariation);
    printf("magneticvariationdirection = %c\n",gpsdata.magneticvariationdirection);
    printf("modeindicator = %c\n",gpsdata. modeindicator);
    printf("gpsdata.checksum = %d\n",gpsdata.checksum);
    printf("positionindic = %d\n", gpsdata.positionindic);
    printf("noofsatellite = %d\n", gpsdata.noofsatellite);
    printf("horizontalprecision = %d\n", gpsdata.horizontalprecision);
    printf("antennaheight = %d\n", gpsdata.antennaheight);
    printf("geodialheight = %d\n", gpsdata.geodialheight);
    printf("dgps = %d\n", gpsdata.dgps);
    printf("station = %d\n", gpsdata.station);
    printf("errorbyte = %d\n", gpsdata.errorbyte);
    printf("calculatedchecksum = %d\n", m_calculatedchecksum);
    printf("recived checksum = %d\n",gpsdata.checksum);
}

int NMEAParse::hextobin(char c)
{
    if( ( c >= '0' ) && ( c <= '9' ) ){
    return c -48;
    }

    if( ( c >= 'A' ) && ( c <= 'F' ) ){
    return c - ('A' - 10);
    }
    printf("invalid data");
return -1;
}
/**
set null all data in gpsdat
**/
void NMEAParse::initiation()
{
                int nn;
                for(nn=0;nn<5;nn++)
                {
                    gpsdata.format[nn] = 0;
                }
                gpsdata.utc = 0;
                gpsdata.status = 0;
                gpsdata.latitude = 0;
                gpsdata.latitudeindicator = 0;
                gpsdata.longnitude = 0;
                gpsdata.longnitudeindicator = 0;
                gpsdata.speed = 0;
                gpsdata.course = 0;
                gpsdata.dateofposition = 0;
                gpsdata.magneticvariation = 0;
                gpsdata.magneticvariationdirection = 0;
                gpsdata.modeindicator = 0;
                gpsdata.positionindic = 0;
                gpsdata.noofsatellite = 0;
                gpsdata.horizontalprecision = 0;
                gpsdata.antennaheight = 0;
                gpsdata.geodialheight = 0;
                gpsdata.dgps = 0;
                gpsdata.station = 0;
                gpsdata.checksum = 0;
                gpsdata.errorbyte = 0;
}
/**
**  decide gprmc or gpgga format is topical
**/
int NMEAParse::wichformat(char c)
{
      switch(m_counter){
                case 0:
                         if( c == 'G'){
                            m_counter++;
                         }
                         break;

                case 1:
                         if( c == 'P'){
                            m_counter++;
                         }
                         break;

                case 2:

                         if( c == 'R'){
                            m_counter++;
                         }else if( c == 'G'){
                            m_counter +=3;
                         }else{
                            //m_counter = 0;
                         }
                         break;

                case 3:
                         if( c == 'M'){
                            m_counter++;
                         }else{
                            //m_counter = 0;
                         }
                         break;

                case 4:
                         if( c == 'C'){

                            return 0;

                         }else{
                            //m_counter = 0;
                         }
                         break;
                case 5:
                         if( c == 'G'){
                                m_counter++;
                         }else{
                            //m_counter = 0;
                         }
                         break;

                case 6:
                         if( c == 'A'){

                            return 1;
                         }else{
                            //m_counter = 0;
                         }
                         break;
      }
return -1;
}
/**
*  search current byte by idx and return with
**/
uint8_t NMEAParse::get_binpacked(uint8_t idx)
{
    int bine = 0;
    switch(idx){

            case 0:

                   int utc;
                   utc = gpsdata.utc;
                   bine = get_fourthbine(utc) ;
                   break;

            case 1:

                   int utc1;
                   utc1 = gpsdata.utc;
                   bine = get_thirdbine(utc1);
                   break;

            case 2:

                   int utc2;
                   utc2 = gpsdata.utc;
                   bine = get_secondbine(utc2);
                   break;
            case 3:

                   int utc3;
                   utc3 = gpsdata.utc;
                   bine = get_firstbine(utc3);
                   break;

            case 4:

                   int latitude ;
                   latitude = gpsdata.latitude;
                   bine = get_fourthbine(latitude) ;
                   break;

            case 5:

                   int latitude1 ;
                   latitude1 = gpsdata.latitude;
                   bine = get_thirdbine(latitude1);
                   break;

            case 6:

                   int latitude2 ;
                   latitude2 = gpsdata.latitude;
                   bine = get_secondbine(latitude2);
                   break;

            case 7:

                   int latitude3 ;
                   latitude3 = gpsdata.latitude;
                   bine = get_firstbine(latitude3);
                   break;

            case 8:

                   int longnitude;
                   longnitude = gpsdata.longnitude;
                   bine = get_fourthbine(longnitude);
                   break;

            case 9:

                   int longnitude1;
                   longnitude1 = gpsdata.longnitude;
                   bine =  get_thirdbine(longnitude1);
                   break;

            case 10:

                   int longnitude2;
                   longnitude2 = gpsdata.longnitude;
                   bine =  get_secondbine(longnitude2);
                   break;

            case 11:

                   int longnitude3;
                   longnitude3 = gpsdata.longnitude;
                   bine =  get_firstbine(longnitude3);
                   break;

            case 12:

                   int speed;
                   speed = gpsdata.speed;
                   bine = get_thirdbine(speed);
                   break;

            case 13:

                   int speed1;
                   speed1 = gpsdata.speed;;
                   bine = get_secondbine(speed1);
                   break;

            case 14:

                   int speed2;
                   speed2 = gpsdata.speed;;
                   bine = get_firstbine(speed2);
                   break;

            case 15:

                   int antennaheight;
                   antennaheight = gpsdata.antennaheight;
                   bine = get_fourthbine(antennaheight);
                   break;

            case 16:

                   int antennaheight1;
                   antennaheight1 = gpsdata.antennaheight;
                   bine = get_thirdbine(antennaheight1);
                   break;

            case 17:

                   int antennaheight2;
                   antennaheight2 = gpsdata.antennaheight;
                   bine = get_secondbine(antennaheight2);
                   break;


            case 18:

                   int antennaheight3;
                   antennaheight3 = gpsdata.antennaheight;
                   bine = get_firstbine(antennaheight3);
                   break;


            case 19:

                   int horizontalprecision;
                   horizontalprecision = gpsdata.horizontalprecision;
                   bine = get_secondbine(horizontalprecision);
                   break;

            case 20:

                   int horizontalprecision1;
                   horizontalprecision1 = gpsdata.horizontalprecision;
                   bine = get_firstbine(horizontalprecision1);
                   break;
    }
    return bine;
}

uint8_t NMEAParse::get_firstbine(int number){

        number &= 0x000000ff;
        return (uint8_t)number;
}
uint8_t NMEAParse::get_secondbine(int number){

        number &= 0x0000ff00;
        number >>= 8;
        return (uint8_t)number;
}

uint8_t NMEAParse::get_thirdbine(int number){

        number &= 0x00ff0000;
        number >>= 16;
        return (uint8_t)number;
}
uint8_t NMEAParse::get_fourthbine(int number){

        number &= 0xff000000;
        number >>= 24;
        return (uint8_t)number;
}

void NMEAParse::printbinaryarray(){

   int counter= 0;
   for(counter = 0; counter < 21; counter++){
        printf("%d.bin value =%d\n",counter,binary_array[counter]);
   }
}

void NMEAParse::writeToStruct()
{
            initiation();///set null all data in gpsdata
            gpsdata.utc = getvaluefrombinaryformat(4,0);
            gpsdata.latitude = getvaluefrombinaryformat(4,4);
            gpsdata.longnitude = getvaluefrombinaryformat(4,8);
            gpsdata.speed = getvaluefrombinaryformat(3,12);
            gpsdata.antennaheight = getvaluefrombinaryformat(4,15);
            gpsdata.horizontalprecision = getvaluefrombinaryformat(2,19);
}

int NMEAParse::getvaluefrombinaryformat(char howmanybyte,char idx)
{
        int value = 0;

           for(; howmanybyte !=0 ;howmanybyte--){
                int number = binary_array[(int)idx] ;
                number <<= ( 8* ( howmanybyte - 1 ) ) ;
                value |= number ;
                idx++;
           }
        return value;
}
/*
uint8_t NMEAParse::sendamiprotocoll(void)
{
    uint8_t byte = 0;
    uint16_t value = 0;
      if( valuestate & LASTBITONE ){

          byte = 0xFF;
          bytestate++;
          if( bytestate > 1 ){
            valuestate &= LASTBITNULL;
            bytestate = 0;
          }

      }else{

              int value = 0;
              switch(valuestate){

                      case 0 :
                              value = getrpmvalue();
                              byte = 0;//curentbyte(value,1);
                              valuestate++;
                             //  valuestate |= LASTBITONE;
                      break;

                      case 1 :
                              value = getwheelspeed();
                              byte  = 1;//curentbyte(value,5);
                              valuestate++;
                               //valuestate |= LASTBITONE;
                      break;

                      case 2 :
                              value = getthrottleangle();
                              byte  = 2;//curentbyte(value,45);
                              valuestate++;
                               //valuestate |= LASTBITONE;
                      break;

                      case 3 :
                              value = getmanifoldpress();
                              byte  = 3;//curentbyte(value,69);
                              valuestate++;
                               //valuestate |= LASTBITONE;
                      break;

                      case 4 :
                              value = getlambdasensor();
                              byte  = 4;//curentbyte(value,105);
                              valuestate++;
                             // valuestate++;
                            //   valuestate |= LASTBITONE;
                      break;

                      case 5 :
                              if( (state & 0x1) == 1){
                              printf("5=%d\n",state);
                              value = getfuelpressure();
                              byte  = 5;//curentbyte(value,21);
                              //valuestate = 0;
                              state &=0xfffe;
                              }else{
                              printf("6=%d\n",state);
                              value =getbatteryvoltage();
                              byte  = 6;//curentbyte(value,33);
                              //valuestate =0;
                              state |= 1;
                              }
                              valuestate++;
                               //valuestate |= LASTBITONE;
                      break;

                      case 6 :
                              //printf("6");
                              valuestate ++;
                              uint8_t st;
                              st = state & 0xe;
                              if( st == 0 ){
                              printf("7=%d\n",state);
                              value =
                              byte  = 7;//curentbyte(value);
                              state |= 2;
                              //state &= 0xFFF;

                              }else if(st == 2 ){
                              printf("8=%d\n",state);
                              byte  = 8;//curentbyte(value);
                              state |= 4;
                              state &= 0xFFFD;

                              }else if(st== 4 ){
                              printf("9=%d\n",state);
                              byte  = 9;
                              state |= 2;
                              state |= 4;

                              }else if( st == 6 ){
                              printf("10=%d\n",state);
                              state |= 8;
                              byte  = 10;
                              }else if( st == 0xE ){
                              printf("10=%d\n",state);
                              state &= 0xFFF1;
                              byte  = -1;
                              }


                              //valuestate |= LASTBITONE;
                      break;

                      case 7 :
                                printf("hetes");
                              byte = -1;
                              valuestate = 0;
                      break;

            }


    }
return byte;
}
*/
/*
uint8_t NMEAParse::curentbyte(int16_t value, char channel)
{
    uint8_t byte = 0;
    switch(bytestate){
            case 0:
                   byte = channel;
                   sum  +=byte;
                   bytestate++;
            break;

            case 1:
                   byte = AMICONST //0xA3;   //208;
                   sum  += byte;
                   bytestate++;

            break;

            case 2:
                   uint8_t highbine;
                   highbine = value >> 8;
                   byte     = highbine;
                   sum     += byte;
                   bytestate++;

            break;

            case 3:
                   uint8_t lowbine;
                   lowbine = value & 0x00FF;
                   byte    = lowbine;
                   sum    += byte;
                   bytestate++;
            break;

            case 4:;
                   byte      = sum & 0x00FF;
                   sum       = 0;
                   bytestate = 0;
                   valuestate++;
                   m_count  |= LASTBITONE;
                   m_count++;
            break;


    }
return byte;
}
*/
void NMEAParse::printamibinaryarray(void)
{
   int counter= 0;
   for(counter = 0; counter < INDEX; counter++){
        printf("%d.bin value =%d\n",counter,amibinary_array[counter]);
   }



}
int16_t NMEAParse::getrpmvalue(void)
{
return 0x0001;
}
int16_t NMEAParse::getwheelspeed(void)
{
return 0x0203;
}
int16_t NMEAParse::getthrottleangle(void)
{
return 0x0304;
}
int16_t NMEAParse::getmanifoldpress(void)
{
return 0x0506;
}
int16_t NMEAParse::getlambdasensor(void)
{
return 0x0708;
}
int16_t NMEAParse::getfuelpressure(void)
{
return 0x0809;
}
int16_t NMEAParse::getbatteryvoltage(void)
{
return 0x0A0B;
}
int16_t NMEAParse::getwatertemp(void)
{
return 0x0c0d;
}
int16_t  NMEAParse::getdummy(void)
{
return 0x08FF;
}
/*
uint8_t NMEAParse::sendamiprotocol(void)
{
    uint8_t byte = 0;
    uint16_t value = 0;
      if( m_count & LASTBITONE ){
          byte = 0xFF;
          bytestate++;
          if( bytestate > 1 ){
            m_count &= LASTBITNULL;
            bytestate = 0;
          }

      }else{

    if(m_count % PERIOD == 0){
            value = getrpmvalue();
            byte = curentbyte(value,1);

    }else if(m_count % PERIOD == 1){
            value = getrpmvalue();
            byte = curentbyte(value,1);
    }else if(m_count % PERIOD == 2){
            value = getrpmvalue();
            byte = curentbyte(value,1);
    }else if(m_count % PERIOD == 3){
            value = getrpmvalue();
            byte = curentbyte(value,1);
    }else if(m_count % PERIOD == 4){
            value = getrpmvalue();
            byte = curentbyte(value,1);

    }else if(m_count % PERIOD == 5){
        int quotient;
        quotient = m_count/PERIOD;
        if(quotient % 2){
            value = getrpmvalue();
            byte = curentbyte(value,1);
        }else{
            value = getrpmvalue();
            byte = curentbyte(value,1);
        }

    }else if(m_count % PERIOD == 6){
       int quotient;
       quotient = m_count/PERIOD;
        if(quotient % 4 == 0){
            value = getrpmvalue();
            byte = curentbyte(value,1);
        }else if(quotient % 4 == 1){
            value = getrpmvalue();
            byte = curentbyte(value,1);
        }else if(quotient % 4 == 2){
            value = getrpmvalue();
            byte = curentbyte(value,1);
        }else if(quotient % 4 == 3){
            value = getrpmvalue();
            byte = curentbyte(value,1);
        }
    }else if(m_count % PERIOD == 7){
            value = getrpmvalue();
            byte = curentbyte(value,1);
    }

      }

    return byte;
}

*/
