#include "RawToHighLogConverter.h"

#include "vemsprotocol/VemsLogReader.h"
#include "vemsprotocol/SIPRTypes.h"

#include "rtdatamanager/RTDataMgrFacade.h"
#include "stdatamanager/STDataMgrFacade.h"

#include "logger.h"

RawToHighLogConverter::RawToHighLogConverter(RTDataMgrFacade* rtDataMgr, STDataMgrFacade* stController, VemsLogReader* reader)
    {
    //ctor

    //m_observer = NULL;
    m_rtDataMgr = rtDataMgr;
    m_stController = stController;
    m_vemsLogReader = reader;


}

RawToHighLogConverter::~RawToHighLogConverter()
{
    Logger::logf(LOG_MSG,_T("RawToHighLogConverter EXIT") );
    SendThreadStatusFlag(TS_EXIT);
}

void* RawToHighLogConverter::Entry()
{
    //SIPRPacket siprPacket;
    uint8_t buffer[64];
    buffer[2] = SiprSensorType::SIPR_RT_MT_NORMAL;
    SIPRPacket siprPacket( 0, SIPR_READ_SENSORS, 64,  buffer ); /// copy to tmp

    bool res = true;
    while ( !this->TestDestroy() && res ){

        //if(m_observer != NULL)
        //    m_observer->notify(m_vemsLogReader->GetFileSize(),m_vemsLogReader->GetFilePos());
        int result = m_vemsLogReader->getNext(siprPacket);
        if(result < 0){
            res = false;
            continue;
            //Logger::logf(LOG_MSG, _T("RawToHighLogConverter::Entry: before exit \n"));
            ///m_DataLogWriter->flushBuffers();
            ///Exit();
            //Logger::logf(LOG_MSG, _T("RawToHighLogConverter::Entry: after exit \n"));
        }
            //Logger::logf(LOG_MSG,_T("RawToHighLogConverter::Entry() 100") );
        switch ( siprPacket.type() )
        {
            case SIPR_GET_TABLEDATA:
            case SIPR_GET_CONFIG_1:
            case SIPR_GET_CONFIG_2:
                Logger::logf(LOG_MSG,_T("RawToHighLogConverter::Entry() CONFIG DATA") );
                m_stController->process( siprPacket );
                //Logger::logf(LOG_MSG,_T("RawToHighLogConverter::Entry() CONFIG DATA 2") );
                break;
            default:
                int subType = siprPacket.getSubType();
                if(subType == SiprSensorType::GPS){
                    //Logger::logf(LOG_MSG,_T("RawToHighLogConverter::Entry() GPS") );
                    m_rtDataMgr->process(siprPacket);
                }else if(subType == SiprSensorType::SIPR_RT_MT_NORMAL){
                    //Logger::logf(LOG_MSG,_T("RawToHighLogConverter::Entry() MEGATUNE") );
                    m_rtDataMgr->process(siprPacket);
                    m_rtDataMgr->notifyViewers();
                }else if(subType == SiprSensorType::SIPR_RT_MT_EXT){
                    //Logger::logf(LOG_MSG,_T("RawToHighLogConverter::Entry() MEGATUNE") );
                    m_rtDataMgr->process(siprPacket);
                    m_rtDataMgr->notifyViewers();
                }
                break;
        }


            //Logger::logf(LOG_MSG,_T("RawToHighLogConverter::Entry() 200") );


        ///Exit(); ///DebuG;
    }
    return 0;
}

/** @brief SetObserver
  *
  * @todo: document this function
  */
/*
void RawToHighLogConverter::SetObserver(ObserverBase *observ)
{
    m_observer = observ;
}
*/

/*
bool RawToHighLogConverter::ParseHeader(const wxString& filename, FirmwareInfo &fwInfo )
{
    //m_vemsLogReader = new RTDataInputRawLog( &(m_mtConfigData->getSymbolMgr()), m_viewerModel );

    if( m_vemsLogReader->SetInputFile( filename ) < 0 ) {
        //delete m_vemsLogReader;
        return false;
    }

    if( m_vemsLogReader->ParseHeader() < 0 ) {
        //delete m_vemsLogReader;
        return false;
    }

    //((RTDataMgrFacade*)m_rtDataMgr)->SetInput(m_vemsLogReader);

    const StringHash& headerHash = m_vemsLogReader->getHeaderHash();
    RawLogHelper::fillFirmwareInfo(fwInfo, headerHash);

    return true;
}
*/
