#ifndef RECENTVEMSFILES_H
#define RECENTVEMSFILES_H

#include <wx/wx.h>
#include "common/typedef.h"
#include <wx/wxsqlite3.h>

enum RecentVemsFilesType
{
    RECENT_LOGFILE = 1,
    RECENT_CONFIGFILE = 2,
    RECENT_ALL = RECENT_LOGFILE | RECENT_CONFIGFILE
};

class RecentVemsFiles
{
    public:
        RecentVemsFiles();

        static wxArrayString&   getRecentFiles( bool logFile = true, size_t maxFiles = 10 );

        static void             updateFile( const wxString& filename, bool logFile );
        static void             deleteFile( const wxString& filename, bool logFile );
        static void             setDbDir( wxString dbdir );
        static int              getMaxFiles() { return m_maxFiles; }

    protected:

    private:
        static wxArrayString m_lfileA;
        static wxArrayString m_cfileA;
        static unsigned int m_maxFiles;
        static wxSQLite3Database m_db;
        static wxString m_dbdir;

        static void checkDb();
        static void openDb();
        // uint8_t fileTypes: 1 = only log, 2 = only cfg, 1|2 = all
        static void refreshList( uint8_t fileTypes );
};

#endif // RECENTVEMSFILES_H
