#include "StringHelper.h"
#include "common/typedef.h"

#include "logger.h"

StringHelper::StringHelper()
{
    //ctor
}

StringHelper::~StringHelper()
{
    //dtor
}



void StringHelper::Split(const wxString &str, const wxChar &splitter, wxArrayString &result, bool FilterEmtpyItems)
{



    uint16_t lastidx = 0;
    wxString tmp1;

    for(uint16_t a=0;a<str.Len();a++)
        if(str[a] == splitter) {
            tmp1 = str.Mid(lastidx, a - lastidx);
            if( !(FilterEmtpyItems && tmp1==wxEmptyString) )
                result.Add(tmp1);
            while(str[a] == splitter)
                a++;
            lastidx = a;
        }

    tmp1 = str.Mid(lastidx);

    if( !(FilterEmtpyItems && tmp1==wxEmptyString) )
        result.Add(tmp1);

}

wxString StringHelper::StringShorter(const wxString& str, size_t maxlen, int threepointstrpos, const wxString& threepointstr)
{
    //Logger::logf(LOG_MSG,_T("str.Len()=%i"),str.Len());
    if( str.Len() <= maxlen ) return str;

    wxString tmp = str;

    wxString part1,part2,part3;

    if(threepointstrpos == wxALIGN_RIGHT) {
        part1 = str.Mid(0,maxlen-threepointstr.Len());
        part2 = threepointstr;
    } else if(threepointstrpos == wxALIGN_LEFT) {
        part2 = str.Mid(0,maxlen-threepointstr.Len());
        part1 = threepointstr;
    } else if(threepointstrpos == wxALIGN_CENTER) {
        int len = (maxlen-threepointstr.Len())/2;
        part1 = str.Mid(0,len);
        part2 = threepointstr;
        part3 = str.Mid( str.Len() - len );
    }

    return part1+part2+part3;
}

wxString StringHelper::StrElevator(const wxString &str, const wxString &substr, StrElevType type)
{

    int f;
    wxString res;

    switch (type) {

        case SE_FIRST:

            f = str.Find(substr);
            if( f == wxNOT_FOUND) return str;


            res = str.Mid(0,f);
            res += str.Mid(f+substr.length());

            return res;

        default:
            return str;
    }

}
