#ifndef TCPCLIENTHANDLER_H
#define TCPCLIENTHANDLER_H

#include <wx/socket.h>


#include "CommunicationBase.h"
#include "common/types/ByteArray.h"



class TCPClientHandler: public CommunicationBase, public wxEvtHandler
{
    public:
        TCPClientHandler(const wxString &host, unsigned short port);
        virtual ~TCPClientHandler();

        int open();

        virtual int SendString(const wxString& str);
        virtual int SendString(const uint8_t* chr);
        virtual int SendString(const uint8_t* str, size_t len);
        virtual int sendStringBlock(uint8_t* value, size_t len, size_t blockLen);

        virtual int Read(uint8_t* str, size_t len);
        virtual int ReadString(uint8_t* str, size_t len);
        virtual int ReadString(uint8_t* data, size_t len, int maxTryCount);
        virtual int ReadUntilEOS(char ** readbuf, char * eosString , long timeout_in_ms) ;

        virtual void setBaudRate( int baudRate );
        virtual int  getBaudRate() ;

        void setPortName( const wxString& portname ) {}
        wxString getPortName() const;

        virtual int sendNumber(uint32_t number, int length);
        virtual int sendNumber(uint16_t number);

        virtual void close();
        virtual int  clear();
        bool IsOpen();

    protected:
    private:
        enum {
            isSocketClient

        };

        void OnSocket(wxSocketEvent& event);
        int getTimeOut(size_t len);

        wxSocketClient * m_sockClient;
        wxIPV4address m_address;

        ByteArray   m_buff;

        wxCriticalSection           m_criticialSection;

        DECLARE_EVENT_TABLE();

};

#endif // TCPCLIENTHANDLER_H
