#ifndef THEMEABLE_H
#define THEMEABLE_H
#include <wx/wx.h>

#include "ThemeAbleBase.h"

class ThemeAble: public ThemeAbleBase
{
    public:
        ThemeAble();
        virtual ~ThemeAble();

        virtual void SetNewTheme(WidgetThemeTable *theme)=0;
        virtual void SetNewTheme(const wxString& name)  {
            if(m_thMenu)
                m_thMenu->Check(m_thMenu->FindItem(name),true);

            SetNewTheme(SearchTheme(name));
        };

        virtual wxString& GetThemeName();

    protected:

        WidgetThemeTable * SearchTheme(const wxString& name);
        void OnThemeSelect(wxCommandEvent& event);
        wxMenu * CreateThemeMenu(wxObjectEventFunction func);

};



#endif // THEMEABLE_H
