#ifndef THEMESHELPER_H
#define THEMESHELPER_H

#include <wx/wx.h>




class WidgetThemeTable;
class WidgetThemeTableArray;

class ThemeGroupPair
{
    public:
        ThemeGroupPair() {};
        ~ThemeGroupPair() {};

    wxString    Theme;
    wxString    Group;
    bool        Checked;

};

WX_DECLARE_HASH_MAP( int, ThemeGroupPair*, wxIntegerHash, wxIntegerEqual, ThemeGroupPairHash);


class ThemesHelper
{
    public:
        ThemesHelper();
        virtual ~ThemesHelper();

        static bool parseWidgetThemeFile();

        static const WidgetThemeTableArray* GetWidgetThemes() { return &m_widgetThemes; }

        static wxString m_defaultThemeName;

        static wxMenu* CreateThemeMenu(const WidgetThemeTableArray *themes, wxEvtHandler *target, wxObjectEventFunction func, const wxString& chkTheme, const wxString& grp = wxEmptyString, ThemeGroupPairHash *grph = NULL);

        static void GetDefinedColornames(const WidgetThemeTableArray *arr, const wxString themename, wxArrayString &colornames);

        static void GetThemeNameList( wxArrayString &arr );

    protected:

    private:

        static wxString m_widgetThemeFile;


        static WidgetThemeTableArray    m_widgetThemes;

};



#endif // THEMESHELPER_H
