#ifndef TINYCHARS_H
#define TINYCHARS_H

/**
                                                                                           S
                                                                                         F P
                                                                                         U A
                                                                                         L C
                                     A,B,C,D,E,F,G,H,I,J,K,L,M,N,O,P,Q,R,S,T,U,V,W,X,Y,Z,L,E,/         */
unsigned char TinyCharsWidth[29] = { 5,5,4,5,5,4,5,5,1,5,5,4,5,5,4,4,5,4,4,5,5,5,5,5,5,5,5,4,3 };

bool TinyCharMatrix[29][5][5]=
{
  /// A
 {{1,1,1,1,1},
  {1,0,0,0,1},
  {1,1,1,1,1},
  {1,0,0,0,1},
  {1,0,0,0,1}},

  /// B
 {{1,1,1,1,1},
  {1,0,0,0,1},
  {1,1,1,1,0},
  {1,0,0,0,1},
  {1,1,1,1,1}},

  /// C
 {{1,1,1,1,0},
  {1,0,0,0,0},
  {1,0,0,0,0},
  {1,0,0,0,0},
  {1,1,1,1,0}},

  /// D
 {{1,1,1,1,0},
  {1,0,0,0,1},
  {1,0,0,0,1},
  {1,0,0,0,1},
  {1,1,1,1,0}},

  /// E
 {{1,1,1,1,1},
  {1,0,0,0,0},
  {1,1,1,1,0},
  {1,0,0,0,0},
  {1,1,1,1,1}},

  /// F
 {{1,1,1,1,0},
  {1,0,0,0,0},
  {1,1,1,0,0},
  {1,0,0,0,0},
  {1,0,0,0,0}},

  /// G
 {{1,1,1,1,1},
  {1,0,0,0,0},
  {1,0,1,1,1},
  {1,0,0,0,1},
  {1,1,1,1,1}},

  /// H
 {{1,0,0,0,1},
  {1,0,0,0,1},
  {1,1,1,1,1},
  {1,0,0,0,1},
  {1,0,0,0,1}},

  /// I
 {{1,0,0,0,0},
  {1,0,0,0,0},
  {1,0,0,0,0},
  {1,0,0,0,0},
  {1,0,0,0,0}},

  /// J
 {{0,0,0,0,1},
  {0,0,0,0,1},
  {0,0,0,0,1},
  {1,0,0,0,1},
  {1,1,1,1,1}},

  /// K
 {{1,0,0,0,1},
  {1,0,0,1,0},
  {1,1,1,0,0},
  {1,0,0,1,0},
  {1,0,0,0,1}},

  /// L
 {{1,0,0,0,0},
  {1,0,0,0,0},
  {1,0,0,0,0},
  {1,0,0,0,0},
  {1,1,1,1,0}},

  /// M
 {{1,0,0,0,1},
  {1,1,0,1,1},
  {1,0,1,0,1},
  {1,0,0,0,1},
  {1,0,0,0,1}},

  /// N
 {{1,0,0,0,1},
  {1,1,0,0,1},
  {1,0,1,0,1},
  {1,0,0,1,1},
  {1,0,0,0,1}},

  /// O
 {{1,1,1,1,0},
  {1,0,0,1,0},
  {1,0,0,1,0},
  {1,0,0,1,0},
  {1,1,1,1,0}},

  /// P
 {{1,1,1,1,0},
  {1,0,0,1,0},
  {1,1,1,1,0},
  {1,0,0,0,0},
  {1,0,0,0,0}},

  /// Q
 {{1,1,1,1,1},
  {1,0,0,0,1},
  {1,0,0,0,1},
  {1,0,1,0,1},
  {1,1,1,1,1}},

  /// R
 {{1,1,1,1,0},
  {1,0,0,1,0},
  {1,1,1,1,0},
  {1,0,1,0,0},
  {1,0,0,1,0}},

  /// S
 {{1,1,1,1,0},
  {1,0,0,0,0},
  {1,1,1,1,0},
  {0,0,0,1,0},
  {1,1,1,1,0}},

  /// T
 {{1,1,1,1,1},
  {0,0,1,0,0},
  {0,0,1,0,0},
  {0,0,1,0,0},
  {0,0,1,0,0}},

  /// U
 {{1,0,0,0,1},
  {1,0,0,0,1},
  {1,0,0,0,1},
  {1,0,0,0,1},
  {0,1,1,1,0}},

  /// V
 {{1,0,0,0,1},
  {1,0,0,0,1},
  {1,0,0,0,1},
  {0,1,0,1,0},
  {0,0,1,0,0}},

  /// W
 {{1,0,0,0,1},
  {1,0,0,0,1},
  {1,0,1,0,1},
  {1,1,0,1,1},
  {1,0,0,0,1}},

  /// X
 {{1,0,0,0,1},
  {0,1,0,1,0},
  {0,0,1,0,0},
  {0,1,0,1,0},
  {1,0,0,0,1}},

  /// Y
 {{1,0,0,0,1},
  {0,1,0,1,0},
  {0,0,1,0,0},
  {0,0,1,0,0},
  {0,0,1,0,0}},

  /// Z
 {{1,1,1,1,1},
  {0,0,0,1,0},
  {0,0,1,0,0},
  {0,1,0,0,0},
  {1,1,1,1,1}},

  /// full
 {{1,1,1,1,1},
  {1,1,1,1,1},
  {1,1,1,1,1},
  {1,1,1,1,1},
  {1,1,1,1,1}},

  /// SPACE
 {{0,0,0,0,0},
  {0,0,0,0,0},
  {0,0,0,0,0},
  {0,0,0,0,0},
  {0,0,0,0,0}},

  /// /
 {{0,0,1,0,0},
  {0,1,0,0,0},
  {0,1,0,0,0},
  {0,1,0,0,0},
  {1,0,0,0,0}}

};



#endif // TINYCHARS_H
