#ifndef VEMSINITIALSCREEN_H
#define VEMSINITIALSCREEN_H

#include <wx/wx.h>
#include "ThreadStatus.h"

#include "stdatamanager/VemsEvent.h"

class ProgressBarObserverWidget;
class ObserverBase;

class ConfigLoaderThread: public ThreadStatusSender
{
    public:
        ConfigLoaderThread() { m_observer = NULL; m_dest = NULL; };
        virtual ~ConfigLoaderThread() {};

        virtual void* Entry();

        void SetObserver( ObserverBase *ob) { m_observer = ob; };
        void SetEvtHandlerObj(wxEvtHandler *dest) { m_dest = dest; };



    private:

        ObserverBase    *m_observer;
        wxEvtHandler    *m_dest;

};

class VemsInitialScreen : public wxFrame
{
    public:
        VemsInitialScreen(wxWindow* parent, wxWindowID id,const wxString& title, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxDEFAULT_FRAME_STYLE);
        virtual ~VemsInitialScreen();
        void SetThreadStatusListener(ThreadStatusListener *listener) { m_threadStatusListener = listener; };

        bool ConfigInit();

        void SetEvtHandlerObj(wxEvtHandler *dest)
        {
            if(m_loader != NULL)
                m_loader->SetEvtHandlerObj(dest);
        };

        void SetInitText(const wxString& text);

    protected:

        DECLARE_EVENT_TABLE();

        void OnPaint(wxPaintEvent& event);

    private:

        wxStaticText                *m_progressText;
        ProgressBarObserverWidget   *m_progressBar;

        ThreadStatusListener        *m_threadStatusListener;

        ConfigLoaderThread          *m_loader;

        wxBitmap    m_logoBMP;
};



#endif // VEMSINITIALSCREEN_H
