#ifndef VEMSNUMPAD_H
#define VEMSNUMPAD_H

#include <wx/wx.h>
//#include <wx/dialog.h>
#include <wx/sizer.h>
#include "common/typedef.h"

#define VNP_TITLE   1
#define VNP_CAPTION 2
#define VNP_DEFAULT 3


WX_DECLARE_HASH_MAP(int, wxButton*, wxIntegerHash, wxIntegerEqual, NumButtonHash);

class VemsNumPad: public wxDialog
{
    public:
        VemsNumPad(wxWindow *parent, long numStyle = VNP_DEFAULT, wxWindowID id = wxID_ANY, const wxString &title = _T("NumPad"), wxPoint pos = wxDefaultPosition, wxSize size = wxDefaultSize, long style = wxDEFAULT_DIALOG_STYLE);

        virtual ~VemsNumPad();

        wxString GetValueAsString();
        double GetValueAsDouble();

        void SetValue(const wxString &value);
        void SetValue(double value, const wxString &format = _T("%.2f"));

        void SetTitle(const wxString &value);
        void SetValueCaption(const wxString &value);

    protected:

        void CreateNumButtons();
        void CreateControls();


    private:

        void OnButton(wxCommandEvent &evt);

        wxStaticText    *m_titleText;
        wxStaticText    *m_valueCaption;
        wxTextCtrl      *m_value;

        wxBoxSizer      *m_mainsizer;

        NumButtonHash   m_buttonHash;

        long            m_style;

};



#endif // VEMSNUMPAD_H

