#include "WindowReg.h"

#include "logger.h"

#include "common/typedef.h"

WindowReg::WindowReg(wxWindow *window)
{
	//ctor
	m_mainwindow = window;

}

WindowReg::~WindowReg()
{
	//dtor
}

void WindowReg::AddWindow(wxWindow *window, bool ShowState)
{

	m_WindowArray.Add(window);
	m_IsShowArray.Add(ShowState);

}

void WindowReg::Minimize()
{

    for(uint8_t a=0;a<m_WindowArray.GetCount();a++)
        m_WindowArray[a]->Hide();

}

void WindowReg::Maximize()
{
    Logger::logf(LOG_MSG,_T("WindowReg::Maximize() START"));

    if(!m_WindowArray.GetCount()) return;

    uint16_t a=0;

    for(;a<m_WindowArray.GetCount();a++)
        if(m_IsShowArray[a])
            m_WindowArray[a]->Show(true);


    Logger::logf(LOG_MSG,_T("WindowReg::Maximize() END cycle=%i"),a);
}

void WindowReg::SetMainWin(wxWindow *window)
{

	m_mainwindow = window;

}

void WindowReg::SearchAndReg(wxWindow *actwind)
{
	//Logger::log(LOG_MSG,_T("WindowReg::SearchAndReg"));

    wxWindowList wlist = actwind->GetChildren();

    for(uint8_t a=0;a<wlist.GetCount();a++) {
        wxWindow *w = wlist.Item(a)->GetData();
        AddWindow(w,w->IsShown());
        SearchAndReg(w);
    }

}

void WindowReg::UpdateList()
{

	Logger::logf(LOG_MSG,_T("WindowReg::UpdateList"));

    m_WindowArray.Clear();
    m_IsShowArray.Clear();

    AddWindow(m_mainwindow,m_mainwindow->IsShown());

	SearchAndReg(m_mainwindow);

    Logger::logf(LOG_MSG,wxString::Format(_T("m_WindowArray.GetCount() = %i"),m_WindowArray.GetCount()));

}



