#ifndef AIMCOMMUNICATIONTHREAD_H
#define AIMCOMMUNICATIONTHREAD_H

#include <wx/wx.h>

#include "../serialconfig.h"
#include "../communication/clients/AIMDetector.h"
#include "../configmanager/VemsDeviceControllerConfig.h"

class AIMDeviceController;
class AIMDetectorEvent;

class AIMCommunicationThread : public wxEvtHandler
{
    public:
        AIMCommunicationThread( SerialConfig& scfg, wxEvtHandler* evtHandler );
        ~AIMCommunicationThread();

    public:
        void    start();
        void    stop();
        void    restart();
        bool    isRunning() const { return m_isRunning; }
        void    setSerialConfig( SerialConfig& scfg );

        void    sendSiprAIM( SIPRPacket& packet );

    private:
        VemsDeviceControllerConfig  m_cfg;
        wxEvtHandler*               m_evtHandler;
        AIMDeviceController*        m_aimcontroller;
        bool                        m_isRunning;

    private:

        void    OnAimDetectEvent( AIMDetectorEvent& event );
};

#endif // AIMCOMMUNICATIONTHREAD_H
