#ifndef AIMDETECTOREVENT_H
#define AIMDETECTOREVENT_H

#include <wx/wx.h>

extern const wxEventType wxEVT_AIMDETECTOR;

#define EVT_AIMDETECTOR(func) \
    wx__DECLARE_EVT0(wxEVT_AIMDETECTOR, AIMDetectorEventHandler(func))

class AIMDetectorEvent : public wxEvent
{
    public:
        AIMDetectorEvent(int id = 0) : wxEvent( id, wxEVT_AIMDETECTOR ) {}
        virtual wxEvent *Clone() const { return new AIMDetectorEvent(*this); }

        void SetString( const wxString& str ) { m_evt = str; }
        wxString GetString() const { return m_evt; }

    public:
        DECLARE_DYNAMIC_CLASS(AIMDetectorEvent)
    private:
        wxString m_evt;
};

typedef void (wxEvtHandler::*AIMDetectorEventFunction)(AIMDetectorEvent&);

#define AIMDetectorEventHandler(func) \
    (wxObjectEventFunction)(wxEventFunction)wxStaticCastEvent(AIMDetectorEventFunction, &func)

#endif // AIMDETECTOREVENT_H
