#ifndef BCLINKLABEL_H
#define BCLINKLABEL_H

#include "bcLabel.h"
#include "bcLinkInfo.h"

class bcLinkLabel: public bcLabel
{
    public:
        bcLinkLabel(BitmapCanvasParentBase* parent, const bcLinkInfo& info = bcLinkInfo(),  int id = wxID_ANY, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize);
        virtual ~bcLinkLabel();

        void SetHoverColor(const wxColor& color);
        void SetLinkInfo(const bcLinkInfo& info);
        bcLinkInfo GetLinkInfo() { return m_linkInfo; }

        void SetAutoJumpURL(bool set) { m_autoJumpURL = set; };
        bool GetAutoJumpURL() { return m_autoJumpURL; };

    protected:

        void OnEnter(wxMouseEvent& evt);
        void OnLeave(wxMouseEvent& evt);

        void OnLeftUp(wxMouseEvent& evt);

    private:

        TextDesc    m_hoverDesc;
        TextDesc    m_normalDesc;

        bcLinkInfo  m_linkInfo;

        bool        m_autoJumpURL;

        bool        m_isSettedToolTip;

        DECLARE_EVENT_TABLE();
};

#endif // BCLINKLABEL_H
