#ifndef BCPROGRESSBAR_H
#define BCPROGRESSBAR_H

enum bcProgressBarStyles{
    BCPBS_NORMAL     = 0x00,
    BCPBS_INFINITY   = 0x01,
    BCPBS_SHOW_TEXT  = 0x02,
    BCPBS_SHOW_TITLE = 0x04,

    BCPBS_DEFAULT = BCPBS_NORMAL | BCPBS_SHOW_TEXT
};


#include "BitmapCanvasWidgetBase.h"

class bcProgressBar: public BitmapCanvasWidgetBase
{
    DECLARE_DYNAMIC_CLASS(bcProgressBar);

    public:
        bcProgressBar() {}
        bcProgressBar(BitmapCanvasParentBase* parent, int id = wxID_ANY, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = BCPBS_DEFAULT);
        virtual ~bcProgressBar();

        virtual void Create(BitmapCanvasParentBase* parent, wxVariantIntHash& properties);

        void SetValue(double value);
        double GetValue();

        void SetMinValue(double value);
        double GetMinValue();

        void SetMaxValue(double value);
        double GetMaxValue();

        enum bcProgressBarProps {
            BCPB_CURR_VALUE,
            BCPB_MIN_VALUE,
            BCPB_MAX_VALUE,
            BCPB_TITLE,
            BCPB_TEXT_FORMAT,
            BCPB_ANIM_INTERVAL,
            BCPB_SEGMENT_STEPPX
        };


        void StartAnim();
        void StopAnim();

        bool IsPlay();

        virtual void DrawWidget();

        void SetAnimInterval(long milliseconds);
        long GetAnimInterval() { return GetPropLong(BCPB_ANIM_INTERVAL); }

        void SetStepPx(double step = 0); /// 0 = auto
        double GetStepPx();

    protected:

        void OnTimer(wxTimerEvent& evt);

    private:

        enum {
            idTimer1

        };

        wxTimer     m_timer;

        double      m_segmentOffset;

        DECLARE_EVENT_TABLE();

};

#endif // BCPROGRESSBAR_H
