#ifndef BCWRAPPER_H
#define BCWRAPPER_H

class BitmapCanvasWidgetBase;

class bcWrapper: public wxWindow
{
    DECLARE_DYNAMIC_CLASS(bcWrapper);

    public:
        bcWrapper() {}
        bcWrapper(BitmapCanvasWidgetBase* widget);
        virtual ~bcWrapper();

        BitmapCanvasWidgetBase* GetWidget() { return m_widget; };

        virtual bool Show( bool show = true );
        virtual bool Enable( bool enable = true );
        virtual bool IsShown() const;
        virtual bool IsEnabled() const;

    protected:

        virtual void DoGetSize( int *width, int *height ) const;
        virtual void DoGetPosition( int *x, int *y ) const;

        virtual void DoSetSize(int x, int y, int width, int height, int sizeFlags = wxSIZE_AUTO);
        virtual void DoSetClientSize(int width, int height);

        virtual void DoMoveWindow(int x, int y, int width, int height);

    private:

        BitmapCanvasWidgetBase* m_widget;

};
#endif // BCWRAPPER_H
