#ifndef BCLINKEVENT_H
#define BCLINKEVENT_H

#include "../bcLinkInfo.h"

extern const wxEventType wxEVT_BCLINK;    /// without this MinGW gives undifened referenced linker error

#define EVT_BCLINK(id,func) \
    wx__DECLARE_EVT1(wxEVT_BCLINK, id, bcLinkEventHandler(func))

class bcLinkEvent : public wxEvent
{
    public:
        bcLinkEvent( const bcLinkInfo& info = bcLinkInfo(), int id = 0 );
        virtual wxEvent *Clone() const { return new bcLinkEvent( *this ); }

        void SetLinkInfo(const bcLinkInfo& info) { m_linkInfo = info; }
        bcLinkInfo GetLinkInfo() { return m_linkInfo; }

    public:
        DECLARE_DYNAMIC_CLASS(bcLinkEvent)

    private:

        bcLinkInfo  m_linkInfo;

};

typedef void (wxEvtHandler::*bcLinkEventFunction)(bcLinkEvent&);

#define bcLinkEventHandler(func) \
    (wxObjectEventFunction)(wxEventFunction)wxStaticCastEvent(bcLinkEventFunction, &func)

#endif // BCLINKEVENT_H
