#include "FSMAIM.h"

const uint8_t AIMPacket::AIM_CONST = 0xA3;


FSMAIM::FSMAIM()
{
    //ctor
    reset();
}

FSMAIM::~FSMAIM()
{
    //dtor
}

void AIMPacket::reset()
{
    channel = 0;
    data    = 0;
    sum     = 0;
}

void FSMAIM::reset()
{
    m_data.reset();
    m_prevByte = 0;
    m_sum = 0;
    m_state = 0;
}

int FSMAIM::feed( uint8_t c )
{
    if( (c == AIMPacket::AIM_CONST) && (m_state == 0) )
    {
        m_data.reset();
        m_data.channel = m_prevByte;
        //m_sum = 0;
        m_sum = m_data.channel + c;
        m_state = DATA_HIGH;
        return m_state;
    }

    switch( m_state )
    {
        case DATA_HIGH:
        {
            m_data.data = c << 8;
            m_sum += c;
            return ++m_state;
        }
        case DATA_LOW :
        {
            m_data.data += c;
            m_sum += c;
            return ++m_state;
        }
        case CHECKSUM:
        {
            m_state = 0;
            if( m_sum == c ) {
                m_data.sum = c;
                return END;
            } else {
                return CHECKSUM_ERROR;
            }
        }
    }

    m_prevByte = c;

    return m_state;
}
