#ifndef HELPUTIL_H
#define HELPUTIL_H
#include <wx/wx.h>

class wxHtmlHelpController;

class HelpUtil : public wxEvtHandler
{
    public:
        HelpUtil();
        virtual ~HelpUtil();

        static void addBook( const wxString& book );
        static void addBookToDialog( const wxString& book );
        static void addBookToHelp( const wxString& book );

        static void showHelp( const wxString& helpTitle );
        static bool showDialogHelp( wxWindow* window, const wxString& helpTitle );

        static bool isHelpShown() { return m_helpshown; }

    private:
        static bool m_helpshown;
        static wxHtmlHelpController* s_dialogHelpController;
        static wxHtmlHelpController* s_mainHelpController;

        static wxRect calculateHelpWindowRect( const wxRect& parentRect );

        void OnHelpWinClose( wxCloseEvent& e );

};

#endif // HELPUTIL_H
