#ifndef ICONSETSHELPER_H
#define ICONSETSHELPER_H

#include "types/Int2StringHash.h"

enum IconSetsType {
    IS_BLACK_GRAVEN,
    IS_GREY_GRAVEN,
    IS_WHITE_RAISED
};

enum IconSetSize {
    IS_16 = 16,
    IS_24 = 24,
    IS_32 = 32,
    IS_48 = 48
};

//the name of the icons must be *.png! -> see Init()
enum IconSetIconName {
    IS_REFRESH,
    IS_LEFT,
    IS_RIGHT,
    IS_HOME,
    IS_SEARCH,
    IS_FOLDER,
    IS_X,
    IS_RECYCLE_EMPTY
};

class IconSetsHelper
{
    public:
        static void Init();

        static wxString GetIconPath(IconSetsType setname, IconSetIconName icon, IconSetSize size);

        static wxImage GetImage(IconSetsType setname, IconSetIconName icon, IconSetSize size);
        static wxBitmap GetBitmap(IconSetsType setname, IconSetIconName icon, IconSetSize size);

        static wxImage GetImage(IconSetIconName icon, IconSetSize size = IS_16);
        static wxBitmap GetBitmap(IconSetIconName icon, IconSetSize size = IS_16);

        static IconSetsType GetDefaultSet() { return m_defaultIconSet; }
        static bool SetDefaultSet(IconSetsType set);

    private:

        static Int2StringHash  m_setsDirname;
        static Int2StringHash  m_iconsFilename;

        static IconSetsType m_defaultIconSet;

};

#endif // ICONSETSHELPER_H
