#ifndef TXDATA_H
#define TXDATA_H

#include <wx/string.h>
#include <cstring>
#include "typedef.h"


class TxData
{
    public:
        TxData()
        {
            this->size = 0;
            this->data = NULL;
        }

        TxData( const uint8_t* data, size_t size )
        {
            this->size = size;
            this->data = new char[this->size];
            memcpy( this->data, data, this->size );
        }

        TxData( const char* str )
        {
			size = strlen( str );
            data = new char[size];
    		memcpy( data, str, size );
        }

        TxData( size_t size )
        {
            this->size = size;
            this->data = new char[size];
        }

        TxData( const wxString& command )
        {
            #if defined (WIN32) || (__WINCE_STANDARDSDK__)
                char* c = _strdup( command.mb_str() );
            #else
                char* c = strdup( command.mb_str() );
            #endif

            this->size = strlen( c );
            this->data = new char[this->size];
            memcpy( this->data, c, this->size );
            delete c;
        }

        TxData( const TxData& txData )
        {
            size = txData.size;
            data = new char[size];
            memcpy( data, txData.data, size );
        }

        virtual ~TxData()
        {
            delete[] data;
        }

        TxData& operator=( const TxData& txData )
        {
            if ( this == &txData ) {
                return *this;
            }

            delete[] data;

            size = txData.size;
            data = new char[size];
            memcpy( data, txData.data, size );

            return *this;
        }

        bool isEmpty() { return !size; }

        wxString toString()
        {

            return wxString::From8BitData( data, size );
        }

        char*   data;
        size_t  size;
};

#endif // TXDATA_H
