#include "VemsMessage.h"

#include "types/StringHash.h"

VemsMessage::VemsMessage(VemsMessageType type, const wxString& name, const wxString& msg, const wxString& htmlMsg)
{
    m_type = type;
    m_name = name;
    m_msg = msg;
    m_htmlMsg = htmlMsg;
}

VemsMessage::~VemsMessage()
{
    //dtor
}

VemsMessageType VemsMessage::getTypeFromString(const wxString &str)
{
    if( str == _T("warning") )
        return VMT_WARNING;
    else if( str == _T("error") )
        return VMT_ERROR;
    else if( str == _T("info") )
        return VMT_INFO;

    return VMT_UNKNOWN;
}

bool VemsMessage::parseHtmlTemplates(StringHash * paramlist)
{
    if(!paramlist) return false;

    for( StringHash::iterator it = paramlist->begin(); it != paramlist->end(); it++)
        m_htmlMsg.Replace( _T("$")+it->first + _T(" "), it->second + _(" ") );

    return true;
}

bool VemsMessage::parseMessageTemplates(const StringHash& paramlist)
{
    StringHash::const_iterator it = paramlist.begin();
    for(; it != paramlist.end(); it++){
        m_msg.Replace( _T("$")+it->first + _T(" "), it->second + _(" ") );
    }
    return true;
}
