#ifndef VEMSMESSAGE_H
#define VEMSMESSAGE_H
#include <wx/wx.h>

enum VemsMessageType{
    VMT_WARNING,
    VMT_ERROR,
    VMT_INFO,
    VMT_UNKNOWN
};

class StringHash;

class VemsMessage
{

     public:
        VemsMessage();
        VemsMessage(VemsMessageType type, const wxString& name, const wxString& msg = wxEmptyString,
        const wxString& htmlMsg = wxEmptyString);
        virtual ~VemsMessage();
        VemsMessageType  getType() const { return m_type; };
        wxString getName() const { return m_name; }
        wxString getMsg() const {return m_msg; }
        wxString getHtmlMsg() const {return m_htmlMsg; }

        bool parseHtmlTemplates(StringHash * paramlist);
        bool parseMessageTemplates(const StringHash& paramlist);

        static VemsMessageType getTypeFromString(const wxString &str);

    private:
        VemsMessageType m_type;
        wxString        m_name;
        wxString        m_msg;
        wxString        m_htmlMsg;
};

#endif // VEMSMESSAGE_H
