#include "VemsMessageHashHelper.h"

#include <wx/xml/xml.h>
#include "../DirHelper.h"

#include "../logger.h"
#include "VemsContext.h"

IMPLEMENT_DYNAMIC_CLASS(VemsMessageHashClass, wxObject)

VemsMessageHashClass::~VemsMessageHashClass()
{
    WX_CLEAR_HASH_MAP( VemsMessageHash, *this );
}

VemsMessage VemsMessageHashHelper::GetVemsMsg(const wxString &name, StringHash * paramlist)
{

    wxObject * obj = VemsContext::getObject(_T("VemsMessageHashClass"));

    //VemsMessage * vmsg;

    if( !obj ) {
//        vmsg = new VemsMessage( VMT_ERROR, _T("n/a"), _T("Msg handler not found!"), _T("<b>Message handler error!</b>") );
//        return vmsg;
        return VemsMessage( VMT_ERROR, _T("n/a"), _T("Msg handler not found!"), _T("<b>Message handler error!</b>") );
    }

    VemsMessageHashClass & hash = *((VemsMessageHashClass*)(obj));

    if( hash.find(name) == hash.end() ){
//        vmsg = new VemsMessage( VMT_ERROR, _T("n/a"), _T("Msg name not found!"), _T("<b>Message handler error!</b><br>Msg name not found!") );
        Logger::logf(LOG_MSG,_T("VemsMessageHashHelper::GetVemsMsg error, not found: name=")+name);
//        return vmsg;
        return VemsMessage( VMT_ERROR, _T("n/a"), _T("Msg name not found!"), _T("<b>Message handler error!</b><br>Msg name not found!") );
    }

    VemsMessage* vmsg = hash[name];

    VemsMessage newMessage(*vmsg);
    newMessage.parseHtmlTemplates( paramlist );

    return newMessage;

}

bool VemsMessageHashHelper::Parse( VemsMessageHashClass & hash )
{
    Logger::logf(LOG_MSG,_T("VemsMessageHashHelper 1"));

    wxString path = DirHelper::GetPath( dCONFIG ) + _T("VemsErrorMessages.xml");

    wxXmlDocument doc;

    if(!doc.Load( path, _T("UTF-8"))) {
        return false;
    }

    wxXmlNode* root = doc.GetRoot();

    if( root->GetName() != _T("ErrorMessages") ) return false;

    for(wxXmlNode * msgNode = root->GetChildren(); msgNode ;msgNode = msgNode->GetNext() ){

        if(msgNode->GetName() != _T("Message")) continue;

        wxString name = msgNode->GetPropVal(_T("name"),wxEmptyString);
        wxString type = msgNode->GetPropVal(_T("type"),wxEmptyString);
        wxString msg = msgNode->GetPropVal(_T("message"),wxEmptyString);

        wxXmlNode * hmn = msgNode->GetChildren();

        wxString htmlmsg = _T("");

        if( hmn )
            htmlmsg = hmn->GetContent();

        hash[name] = new VemsMessage( VemsMessage::getTypeFromString( type ), name, msg, htmlmsg);

    }

    if( !hash.size() ) return false;

    return true;
}
