#include "wxCSVParser.h"

//#include <wx/jsonreader.h>
#include <wx/tokenzr.h>
#include <wx/regex.h>
#include <wx/arrimpl.cpp>
WX_DEFINE_OBJARRAY(wxArrayStringRefArray);

#include "../logger.h"


wxCSVParser::wxCSVParser(const wxString& rawtext)
{
    //ctor
    m_rawText = rawtext;
}

wxCSVParser::~wxCSVParser()
{
    //dtor
}
/// TODO: implement...
bool wxCSVParser::Parse(const wxString& data_separator, const wxString& textlimiter)
{
    wxArrayString lines = wxStringTokenize(m_rawText,_T("\n"));
    m_lines.Clear();

    wxRegEx re;
    re.Compile(_T("$")+textlimiter+_T("(.+)")+textlimiter+_T("^"));

    Logger::logf(LOG_MSG,_T("wxCSVParser::Parse lines=%i"),lines.GetCount());

    for(size_t a=0;a<lines.GetCount();a++) {
        Logger::logf(LOG_MSG,_T("wxCSVParser::Parse line%i"),a);

        wxArrayString line_data;// = wxStringTokenize(lines[a],textlimiter+data_separator+textlimiter);
/*
        wxJSONReader reader;
        wxJSONValue root;
        reader.Parse(_T("[")+lines[a]+_T("]"),&root);

        const wxJSONInternalArray * list = root.AsArray();

        if(!list) continue;

        for(size_t a=0;a<list->GetCount();a++) {
            wxString cell = list->Item(a).AsString(
                                                   );
            Logger::logf(LOG_MSG,_T("data:")+cell);
            line_data.Add(cell);
        }
*/
        m_lines.Add(line_data);

    }

    return m_lines.GetCount();
}

CSVErrorCode wxCSVParser::GetLine(size_t line, StringHash& data)
{
    if(line >= m_lines.GetCount()) return CSV_ERROR_TO_LARGE_LINE_PARAM;
    if(m_lines.GetCount()<2) return CSV_ERROR_NOT_ENOUGH_LINE_FOR_HEADERHASH;

    wxArrayString& header = m_lines[0];
    wxArrayString& line_data = m_lines[line];

    if(header.GetCount() != line_data.GetCount()) return CSV_ERROR_HEADER_AND_DATA_COUNT_NOT_EQUALS;

    if(header.GetCount() < 1) return CSV_ERROR_HEADER_EMPTY;

    for(size_t a=0;a<header.GetCount();a++) {
        data[ header[a] ] = line_data[a];
    }

    return CSV_NO_ERROR;
}

CSVErrorCode wxCSVParser::GetLine(size_t line, wxArrayString& data)
{
    if(line >= m_lines.GetCount()) return CSV_ERROR_TO_LARGE_LINE_PARAM;

    return CSV_NO_ERROR;
}
