#include "wxHtmlHelpTools.h"

#ifdef WXACTIVEX_HTML_RENDERER
#include <wxWebControl.h>
#else
#include <wx/html/htmlwin.h>
#endif


wxFrame* wxHtmlHelpTools::ShowFileHelpFrame(const wxString& filepath, wxWindow* parent, const wxPoint& pos, const wxSize& size)
{
    wxFrame* frame = new wxFrame(parent,wxID_ANY,_T("Help"));

    ShowFileHelp(filepath, frame);

    return frame;
}

wxFrame* wxHtmlHelpTools::ShowHelpFrame(const wxString& content, wxWindow* parent, const wxPoint& pos, const wxSize& size)
{
    wxFrame* frame = new wxFrame(parent,wxID_ANY,_T("Help"));

    ShowHelp(content, frame);

    return frame;
}

wxWindow* wxHtmlHelpTools::ShowFileHelp(const wxString& filepath, wxWindow* parent)
{
    wxWindow* win = NULL;

#ifdef WXACTIVEX_HTML_RENDERER
    wxWebControl* webctrl = new wxWebControl(parent);
    webctrl->LoadUrl(filepath);
    win = webctrl;
#else
    wxHtmlWindow* htmlwin = new wxHtmlWindow(parent);
    htmlwin->LoadFile(wxFileName(filepath));
    win = htmlwin;
#endif

    return win;
}

wxWindow* wxHtmlHelpTools::ShowHelp(const wxString& content, wxWindow* parent)
{
    wxWindow* win = NULL;

#ifdef WXACTIVEX_HTML_RENDERER
    wxWebControl* webctrl = new wxWebControl(parent);
    webctrl->LoadString(content);
    win = webctrl;
#else
    wxHtmlWindow* htmlwin = new wxHtmlWindow(parent);
    htmlwin->SetPage(content);
    win = htmlwin;
#endif

    return win;
}
