#include "CommunicationTimer.h"

CommunicationTimer::CommunicationTimer()
{
    m_interval = 0;
}

CommunicationTimer::~CommunicationTimer()
{
}

void CommunicationTimer::start( size_t interval )
{
    m_startTime = wxDateTime::UNow();
    m_interval  = interval;
}

bool CommunicationTimer::isTimedout() const
{

    return ( getElapsedTime() >= m_interval );
}

long CommunicationTimer::getElapsedTime() const
{
    wxDateTime now = wxDateTime::UNow();
    wxTimeSpan timeSpan = now.Subtract( m_startTime );
    long elapsedTime = timeSpan.GetMilliseconds().ToLong();

    return elapsedTime;
}
