#ifndef DEVICEDETECTOR_H
#define DEVICEDETECTOR_H

#include <wx/wx.h>

#include "../CommunicationControllerClient.h"
#include "../../vemsprotocol/ECUInfo.h"
#include "../../common/typedef.h"
#include "../../common/types/DeviceRecognizerPtrArray.h"

class DeviceDetectorListener;

class DeviceDetector : public CommunicationControllerClient
{
    public:
        DeviceDetector( DeviceDetectorListener* listener );
        virtual ~DeviceDetector();

        ///CommunicationControllerClient methods
        void write( uint8_t* buffer, int& size );
        void read( uint8_t* buffer, int size );
        void finish();
        bool isFinished();

    private:
        enum State { SEND, WAIT, DEVICE_FOUND, DEVICE_NOT_FOUND };
        enum { TIMEOUT = 256 };

        DeviceRecognizerPtrArray            m_recognizers;
        State                               m_state;
        size_t                              m_timeoutCount;

        DeviceDetectorListener*             m_listener;
        ECUInfo::Device                     m_device;
        ECUInfo::EcuMode                    m_mode;
};

#endif // DEVICEDETECTOR_H
