#ifndef SERIALPORTSCANNER_H
#define SERIALPORTSCANNER_H


//#include "../CommunicationClientEventHandler.h"
#include "DeviceDetectorListener.h"
#include "../../vemsprotocol/DeviceInfo.h"
#include "../../common/types/IntArray.h"


class CommunicationController2;
class CommunicationControllerClient;
class CommunicationBase;
class CommunicationEvent;


class SerialPortScanner : public wxEvtHandler, public DeviceDetectorListener
{
    public:
        SerialPortScanner(  wxEvtHandler* eventHandler,
                            const wxArrayString& ports, const IntArray& baudrates,
                            size_t timeout, size_t interWriteDelay,
                            const wxString& firstPort = wxEmptyString, int firstBaudrate = 0 );

        virtual ~SerialPortScanner();

//        /// CommunicationClientEventHandler methods
//        void handleEvent( CommunicationClientEvent::Type eventType );

        /// DeviceDetectorListener methods
        void OnDeviceFound( ECUInfo::Device device, ECUInfo::EcuMode deviceMode );
        void OnDeviceNotFound();

    private:
        wxEvtHandler*                   m_eventHandler;
        CommunicationController2*       m_commController;
        CommunicationControllerClient*  m_commClient;
        CommunicationBase*              m_commBase;
        DeviceInfo                      m_deviceInfo;

        wxArrayString                   m_ports;
        IntArray                        m_baudrates;
        wxString                        m_firstPort;
        int                             m_firstBaudrate;

        size_t                          m_currPortIdx;
        size_t                          m_currBaudrateIdx;

        size_t                          m_timeout;
        size_t                          m_interWriteDelay;

        size_t                          m_maxBaudrateTryCount;
        size_t                          m_baudrateTryCount;

    private:
        void scanPort();
        void setCommunicationBase();
        void registerDeviceDetector();
        void startCommunicationController();

        void deviceFound();
        void deviceNotFound();

        void sendSerialPortScannerEvent( int eventId, bool isScanningFinished );

        void onStartEvent( wxCommandEvent& event );
        void OnCommunicationEvent( CommunicationEvent& event );
};

#endif // SERIALPORTSCANNER_H
