#ifndef V3FIRMWAREINFOFETCHER_H
#define V3FIRMWAREINFOFETCHER_H


#include <wx/wx.h>


#include "../CommunicationControllerClient.h"
#include "../../common/typedef.h"
#include "../../common/types/ResponseRecognizerPtrArray.h"


class FirmwareInfo;
class FirmwareInfoFetcherListener;
class TimeoutListener;


class V3FirmwareInfoFetcher : public CommunicationControllerClient
{
    public:
        V3FirmwareInfoFetcher( FirmwareInfoFetcherListener* listener, TimeoutListener* timeoutListener );
        virtual ~V3FirmwareInfoFetcher();

        void write( uint8_t* buffer, int& size );
        void read( uint8_t* buffer, int size );
        void finish();
        bool isFinished();

    private:
        enum State { CLEAR, SEND, WAIT, FIRMWAREINFO_FETCHED, TIMEDOUT };
        enum { TIMEOUT = 100 };

        enum CommandID
        {
            MAN = 0,
            CTIME,
            FIRMWARE_VERSION,
            SERIAL_NUMBER,
            MEGATUNE,
            SIGNATURE,
            OPTIONS,
        };

        size_t                      m_currentRecognizerIdx;
        State                       m_state;
        ResponseRecognizerPtrArray  m_recognizers;
        FirmwareInfo*               m_firmwareInfo;
        bool                        m_isTimedout;

        FirmwareInfoFetcherListener*    m_listener;
        TimeoutListener*                m_timeoutListener;
};

#endif // V3FIRMWAREINFOFETCHER_H
