#include "ConfigHashHelper.h"

#include "../ConfigBase.h"

void ConfigHashHelper::SaveValues(wxObject* class_withRTTI, wxVariantHash& data, ConfigBase* config)
{
    wxString classname = class_withRTTI->GetClassInfo()->GetClassName();
    SaveValues(classname,data,config);
}

void ConfigHashHelper::GetValues(wxObject* class_withRTTI, wxVariantHash& data, ConfigBase* config)
{
    wxString classname = class_withRTTI->GetClassInfo()->GetClassName();
    GetValues(classname,data,config);
}

void ConfigHashHelper::SaveValues(const wxString& name, wxVariantHash& data, ConfigBase* config)
{
    config->setPath(_T("/autosaveddata/")+name);

    for(wxVariantHash::iterator it = data.begin(); it != data.end(); it++  ) {
        config->write( it->first , it->second.MakeString() );
    }

    config->flush();
    config->save();
}

void ConfigHashHelper::GetValues(const wxString& name, wxVariantHash& data, ConfigBase* config)
{
    config->setPath(_T("/autosaveddata/")+name);

    for(wxVariantHash::iterator it = data.begin(); it != data.end(); it++  ) {
        wxVariant& value = it->second;

        wxString val_type = value.GetType();

        if( val_type == _T("long") ) {

            value = config->read(it->first, value.GetLong() );

        } else if( val_type == _T("double") ) {

            value = config->read(it->first, value.GetDouble() );

        } else if( val_type == _T("bool") ) {

            value = config->read(it->first, value.GetBool() );

        } else {

            value = config->read(it->first, value.GetString() );

        }
    }
}
