#include "ConfigHelper2.h"
#include "../ConfigFile.h"
#include "../DirHelper.h"
#include "../logger.h"

Int2StringHash ConfigHelper2::s_fileHash;
ConfigBaseHash ConfigHelper2::s_cfgHash;


void ConfigHelper2::init()
{
    wxString fileName;
    #if defined(__WINCE_STANDARDSDK__)
    fileName = _T("v3cockpit.cfg");
    #elif defined(__WXMSW__)
    fileName = _T("v3gui.cfg");
    #elif defined(__UNIX__)
    fileName = _T("v3guil.cfg");
    #endif
    s_fileHash[CONFIG_MAIN] = fileName;
    s_fileHash[CONFIG_LAYOUT] = _T("gui.cfg");
}

void ConfigHelper2::cleanup()
{
    s_fileHash.clear();

    ConfigBaseHash::iterator it = s_cfgHash.begin();
    for(; it !=s_cfgHash.end(); ++it){
        ConfigBase* config = it->second;
        delete config;
    }
    s_cfgHash.clear();
}

wxString ConfigHelper2::getConfigFile(char mode)
{
    wxString dir = DirHelper::GetPath(dCONFIG);
    dir.Append( s_fileHash[mode] );
    return dir;
}

ConfigBase* ConfigHelper2::getConfig(char mode)
{
    ConfigBaseHash::iterator it = s_cfgHash.find(mode);
    if(it == s_cfgHash.end() ){
        ConfigBase* cfg = new ConfigFile( getConfigFile(mode) );
        s_cfgHash[mode] = cfg;
        return cfg;
    }
    return it->second;
}

void ConfigHelper2::getEntryHash( const wxString &path, StringHash& vHash )
{
    Logger::logf(LOG_MSG, _T("-------------Helper::getEntryHash-------------------")+path);
    wxString group;
    ConfigBase * config = ConfigHelper2::getConfig();
    long dummy;
    wxString oldPath = config->getPath();
    config->setPath(path);
    bool bCont = config->getFirstEntry( group, dummy);
     Logger::logf(LOG_MSG, _T("dummy1=%ld"),dummy);
    while (bCont)
    {
        wxString msg;
        wxString tmp;
        config->read(group,&tmp);
        msg.Printf(_T("ConfigBase::getGroupArray() group: ") +group+ _T(", value: ") + tmp + _T(", %d"), dummy);
        Logger::log(LOG_MSG,msg);
        vHash[group] = tmp;
        bCont = config->getNextEntry( group, dummy);
    }
    wxString temp = vHash[group];
    Logger::logf(LOG_MSG, _T("dummy2=%ld"),dummy);
    config->setPath(oldPath);
}

