#ifndef WXBITMAPTOGGLEBUTTON_H
#define WXBITMAPTOGGLEBUTTON_H

#include <wx/wx.h>
#include <wx/tglbtn.h>

class wxStaticBitmapEx;

class wxBitmapToggleButton: public wxToggleButton
{

    DECLARE_DYNAMIC_CLASS(wxBitmapToggleButton)

    public:
        wxBitmapToggleButton() {};
        wxBitmapToggleButton(wxWindow* parent, wxWindowID id, const wxBitmap &bmp, int groupid = -1, int border = 4, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0, const wxValidator& val = wxDefaultValidator, const wxString& name = _T("checkBox"));
        virtual ~wxBitmapToggleButton();

        void Init();

        void SetValueEx(bool isdown);

        int GetGroupID() { return m_grpID; };
        void SetGroupID(int id) { m_grpID = id; };

    protected:

        void OnLeftDown(wxMouseEvent &evt);
        void OnToggle(wxCommandEvent &evt);

        void LayoutBitmap(bool isnegate = false);

    private:

        wxStaticBitmapEx    *   m_bitmapControl;

        wxPoint                 m_bmpBorder;

        int m_grpID;

        DECLARE_EVENT_TABLE();



};

class wxStaticBitmapEx: public wxStaticBitmap
{
    public:
        wxStaticBitmapEx(wxWindow* parent, wxWindowID id, const wxBitmap& label, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0, const wxString& name = _T("staticBitmap")){
            Create(parent,id,label,pos,size,style,name);
        };

    protected:

        void OnAllMouseEvents(wxMouseEvent& evt);

        DECLARE_EVENT_TABLE();
};

#endif // WXBITMAPTOGGLEBUTTON_H
