#include "wxComboBoxNullEx.h"

#include "../logger.h"

BEGIN_EVENT_TABLE(wxComboBoxNullEx, wxComboBox)

    EVT_SET_FOCUS(wxComboBoxNullEx::OnSetFocus)
    EVT_KILL_FOCUS(wxComboBoxNullEx::OnKillFocus)


END_EVENT_TABLE()

IMPLEMENT_DYNAMIC_CLASS(wxComboBoxNullEx,wxComboBox);

wxComboBoxNullEx::wxComboBoxNullEx(wxWindow* parent, wxWindowID id, const wxString& value, const wxString& nullstr, const wxPoint& pos, const wxSize& size, const wxArrayString&  choices, long style, const wxValidator& validator, const wxString& name, bool isPending)
    :wxComboBox(parent,id,value,pos,size,choices,style,validator,name)
    ,ControlColorContentValidator(this,value,nullstr,isPending)
{
    //ctor

    Connect(wxEVT_COMMAND_TEXT_UPDATED, wxCommandEventHandler(wxComboBoxNullEx::OnUpdated) );
}

wxComboBoxNullEx::~wxComboBoxNullEx()
{
    //dtor
}


void wxComboBoxNullEx::OnUpdated(wxCommandEvent& evt)
{
    evt.Skip();
    DoOnUpdated();
}

void wxComboBoxNullEx::OnSetFocus(wxFocusEvent& evt)
{
    evt.Skip();
    DoSetFocus();
}

void wxComboBoxNullEx::OnKillFocus(wxFocusEvent& evt)
{
    evt.Skip();
    DoKillFocus();
}
