#include "wxTextCtrlNullEx.h"

#include "../logger.h"

BEGIN_EVENT_TABLE(wxTextCtrlNullEx, wxTextCtrl)

    EVT_SET_FOCUS(wxTextCtrlNullEx::OnSetFocus)
    EVT_KILL_FOCUS(wxTextCtrlNullEx::OnKillFocus)

END_EVENT_TABLE()

IMPLEMENT_DYNAMIC_CLASS(wxTextCtrlNullEx,wxTextCtrl);

wxTextCtrlNullEx::wxTextCtrlNullEx(wxWindow* parent, wxWindowID id, const wxString& value, const wxString& nullstr, const wxPoint& pos, const wxSize& size, long style, const wxValidator& validator, const wxString& name, bool isPending)
    :wxTextCtrl(parent,id,value,pos,size,style,validator,name)
    ,ControlColorContentValidator(this,value,nullstr,isPending)
{
    //ctor


    Connect(wxEVT_COMMAND_TEXT_UPDATED, wxCommandEventHandler(wxTextCtrlNullEx::OnUpdated) );

}

wxTextCtrlNullEx::~wxTextCtrlNullEx()
{
    //dtor
}


void wxTextCtrlNullEx::OnUpdated(wxCommandEvent& evt)
{
    evt.Skip();
    DoOnUpdated();
}

void wxTextCtrlNullEx::OnSetFocus(wxFocusEvent& evt)
{
    evt.Skip();
    DoSetFocus();
}

void wxTextCtrlNullEx::OnKillFocus(wxFocusEvent& evt)
{
    evt.Skip();
    DoKillFocus();
}
