#include "EepromCfgSaverV3.h"

#include "../serialhelper.h"
#include "../VemsTuneController.h"

#include "../events/EepromRawDataEvent.h"
#include "../events/GeneralEvent.h"

#include "../vemsprotocol/EepromDownloadController.h"
#include "../vemsprotocol/ECUInfo.h"

BEGIN_EVENT_TABLE( EepromCfgSaverV3, EepromCfgSaverBase )
    EVT_EEPROM_RAWDATA( EepromCfgSaverV3::onEepromRawDataEvent )
END_EVENT_TABLE()

EepromCfgSaverV3::EepromCfgSaverV3( VemsTuneController* vtc )
{
    m_vtc = vtc;
}

EepromCfgSaverV3::~EepromCfgSaverV3()
{
}

void EepromCfgSaverV3::getEepromData()
{
    EepromDownloadController* m_ctrl = new EepromDownloadController( m_vtc, SerialHelper::getECUComm(), false, this );
    m_ctrl->start();
}

void EepromCfgSaverV3::onEepromRawDataEvent( EepromRawDataEvent& event )
{
    wxMemoryBuffer& buf = event.GetDataBuffer();

    //delete m_ctrl;

    m_size = buf.GetDataLen();

    if ( m_size != 4096 )
    {
        GeneralEvent evt;
        evt.SetLong( EEPROM_SAVE_ERROR );
        AddPendingEvent( evt );
    }
    else
    {
        memcpy( m_eepromdata, buf.GetData(), 4096 );
        GeneralEvent evt;
        evt.SetLong( EEPROM_SAVE_OK );
        AddPendingEvent( evt );
    }
}
