#ifndef EVAL_H
#define EVAL_H

#include <wx/sstream.h>
#include "common/types/DoubleHash.h"

using namespace std;
//#include<iostream>

class ZeroDivideException{};
class SyntaxError{
        public:
            wxString s;
            SyntaxError(wxString& e) {s = e;}
            wxString get(){return s;}
};

class Eval
{
    public:
        Eval();
        virtual ~Eval();
        void test();
        double evaluate(const wxString);
    protected:
    private:
    enum Token_value{
        NAME,           NUMBER,         FUNCTION,       END,
        PLUS='+',       MINUS='-',      MUL='*',        DIV='/',
        PRINT=';',      ASSIGN='=',     LP='(',         RP=')', COMMA=','
    };

    wxStringInputStream * is;
    Token_value curr_tok;
    double number_value;
    wxString variableName;

    double result;
    //
    Token_value get_token();
    double prim(bool);
    double term(bool);
    double expr(bool);

    bool isDigit(char ch);
    double getDouble();
    wxString getVariable();

    DoubleHash constTable;

};



#endif // EVAL_H
