#ifndef AIMEVENT_H
#define AIMEVENT_H

#include <wx/event.h>

extern const wxEventType wxEVT_AIM;    /// without this MinGW gives undifened referenced linker error

#define EVT_AIM(id, func) \
    wx__DECLARE_EVT1(wxEVT_AIM, id, AIMEventHandler(func))

class AIMEvent : public wxEvent
{
    public:
      //  enum State { NOT_CONNECTED = 0, CONNECTED, DATA, NO_DATA };
        enum State { NOT_CONNECTED = 0, CONNECTED = 1, AIM_DATA = 2, NO_AIM_DATA = 3 };
        AIMEvent(int id = 0);
        virtual wxEvent *Clone() const { return new AIMEvent(*this); }
//        State state;
//      wxString getStateAsString();
        DECLARE_DYNAMIC_CLASS(AIMEvent)
};

typedef void (wxEvtHandler::*AIMEventFunction)(AIMEvent&);

#define AIMEventHandler(func) \
    (wxObjectEventFunction)(wxEventFunction)wxStaticCastEvent(AIMEventFunction, &func)

#endif // AIMEVENT_H
