#ifndef DOWNLOADINGSTATUSEVENT_H
#define DOWNLOADINGSTATUSEVENT_H

#include <wx/wx.h>
#include "../common/types/wxVariantHash.h"

extern const wxEventType EVT_DOWNLOADING_STATUS;    /// without this MinGW gives undifened referenced linker error

#define EVT_DOWNLOADING_STATUS_EVENT(id, func) \
    wx__DECLARE_EVT1(EVT_DOWNLOADING_STATUS, id, DownloadingStatusEventHandler(func))


class DownloadingStatusEvent : public wxEvent
{
    public:
        DownloadingStatusEvent(int id = 0);
        virtual ~DownloadingStatusEvent();

        virtual wxEvent *Clone() const { return new DownloadingStatusEvent(*this); }

        void SetProperties(wxVariantHash props){ m_properties = props; };
        wxVariantHash& GetProperties(){ return m_properties; };

        DECLARE_DYNAMIC_CLASS(DownloadingStatusEvent);


    protected:
    private:

        wxVariantHash   m_properties;

};

typedef void (wxEvtHandler::*DownloadingStatusEventFunction)(DownloadingStatusEvent&);

#define DownloadingStatusEventHandler(func) \
    (wxObjectEventFunction)(wxEventFunction)wxStaticCastEvent(DownloadingStatusEventFunction, &func)


#endif // DOWNLOADINGSTATUSEVENT_H
