#ifndef ECULOGEVENT_H
#define ECULOGEVENT_H

#include <wx/event.h>

extern const wxEventType wxEVT_ECU_LOG;    /// without this MinGW gives undifened referenced linker error

#define EVT_ECU_LOG(id, func) \
    wx__DECLARE_EVT1(wxEVT_ECU_LOG, id, ECULogEventHandler(func))

class ECULogEvent : public wxEvent
{
    public:
        enum State { OFF = 0, ON = 1 };
        ECULogEvent(int id = 0);
        virtual wxEvent *Clone() const { return new ECULogEvent(*this); }
        State state;
    public:
        DECLARE_DYNAMIC_CLASS(ECULogEvent)
};

typedef void (wxEvtHandler::*ECULogEventFunction)(ECULogEvent&);

#define ECULogEventHandler(func) \
    (wxObjectEventFunction)(wxEventFunction)wxStaticCastEvent(ECULogEventFunction, &func)



#endif // ECULOGEVENT_H
