#ifndef ECUCOMMEVENT_H
#define ECUCOMMEVENT_H

#include <wx/event.h>

extern const wxEventType wxEVT_ECU_COMM;    /// without this MinGW gives undifened referenced linker error

#define EVT_ECU_COMM(id, func) \
    wx__DECLARE_EVT1(wxEVT_ECU_COMM, id, ECUCommEventHandler(func))

class ECUCommEvent : public wxEvent
{
    public:
        enum State { OFFLINE = 0, ONLINE = 1 };
        ECUCommEvent(int id = 0, State state = OFFLINE );
        virtual wxEvent *Clone() const { return new ECUCommEvent(*this); }
        State state;
    public:
        DECLARE_DYNAMIC_CLASS(ECUCommEvent)
};

typedef void (wxEvtHandler::*ECUCommEventFunction)(ECUCommEvent&);

#define ECUCommEventHandler(func) \
    (wxObjectEventFunction)(wxEventFunction)wxStaticCastEvent(ECUCommEventFunction, &func)



#endif // ECUCOMMEVENT_H
