#ifndef EEPROMRAWDATAEVENT_H
#define EEPROMRAWDATAEVENT_H

#include <wx/event.h>
#include <wx/stream.h>

extern const wxEventType wxEVT_EEPROM_RAWDATA;    /// without this MinGW gives undifened referenced linker error

#define EVT_EEPROM_RAWDATA(func) \
    wx__DECLARE_EVT0(wxEVT_EEPROM_RAWDATA, EepromRawDataEventHandler(func))

class EepromRawDataEvent : public wxEvent
{
    public:

        EepromRawDataEvent( int id = 0 ) : wxEvent( id, wxEVT_EEPROM_RAWDATA ) { }

        virtual ~EepromRawDataEvent() { }

    public:

        virtual wxEvent     *Clone() const { return new EepromRawDataEvent( *this ); }

        void                SetDataBuffer( wxMemoryBuffer& databuffer ) { m_databuffer = databuffer; }

        wxMemoryBuffer&     GetDataBuffer() { return m_databuffer; }

        DECLARE_DYNAMIC_CLASS( EepromRawDataEvent )

    private:
        wxMemoryBuffer  m_databuffer;
};

typedef void ( wxEvtHandler::*EepromRawDataEventFunction )( EepromRawDataEvent& );

#define EepromRawDataEventHandler(func) \
    (wxObjectEventFunction)(wxEventFunction)wxStaticCastEvent( EepromRawDataEventFunction, &func )


#endif // EEPROMRAWDATAEVENT_H
