#ifndef RAWTRIGGERLOGEVENT_H
#define RAWTRIGGERLOGEVENT_H

#include <wx/event.h>
#include <wx/stream.h>

extern const wxEventType wxEVT_RAW_TRIGGER_LOG;    /// without this MinGW gives undifened referenced linker error

#define EVT_RAW_TRIGGER_LOG(id, func) \
    wx__DECLARE_EVT1(wxEVT_RAW_TRIGGER_LOG, id, RawTriggerLogEventHandler(func))

class RawTriggerLogEvent: public wxEvent
{
    public:
        RawTriggerLogEvent(int id = 0) : wxEvent( id, wxEVT_RAW_TRIGGER_LOG ) {}
        virtual ~RawTriggerLogEvent() {}

        virtual wxEvent *Clone() const { return new RawTriggerLogEvent(*this); }

        void SetData(wxMemoryBuffer &data) { m_dataBuffer = data; };

        wxMemoryBuffer & GetDataBuffer() { return m_dataBuffer; };

        DECLARE_DYNAMIC_CLASS(RawTriggerLogEvent)

    private:
        wxMemoryBuffer m_dataBuffer;

};

typedef void (wxEvtHandler::*RawTriggerLogEventFunction)(RawTriggerLogEvent&);

#define RawTriggerLogEventHandler(func) \
    (wxObjectEventFunction)(wxEventFunction)wxStaticCastEvent(RawTriggerLogEventFunction, &func)

#endif // RAWTRIGGERLOGEVENT_H
