#include "UserLogEvent.h"

DEFINE_EVENT_TYPE( wxEVT_USER_LOG )
IMPLEMENT_DYNAMIC_CLASS( UserLogEvent, wxEvent )

UserLogEvent::UserLogEvent( int id ) : wxEvent( id, wxEVT_USER_LOG )
{
    m_userLogType       = ULOG_INFO;
    m_userLogLineSize   = ULOGLS_PREDEFINED;
    m_showPolicy        = SPC_NORMAL;
    m_message           = wxEmptyString;
}

UserLogEvent::UserLogEvent( UserLogType logType,
                            const wxString& message,
                            UserLogLineSize size,
                            ShowPolicy pol,
                            int id )
    : wxEvent( id, wxEVT_USER_LOG )
{
    m_userLogType       = logType;
    m_userLogLineSize   = size;
    m_showPolicy        = pol;
    m_message           = message;
}
