#ifndef USERLOGEVENT_H
#define USERLOGEVENT_H


#include <wx/event.h>
#include "../UserLog.h"


extern const wxEventType wxEVT_USER_LOG;    /// without this MinGW gives undifened referenced linker error


#define EVT_USER_LOG(id, func) \
    wx__DECLARE_EVT1(wxEVT_USER_LOG, id, UserLogEventHandler(func))


class UserLogEvent : public wxEvent
{
    public:
        UserLogEvent( int id = 0 );
        UserLogEvent(   UserLogType logType,
                        const wxString& message,
                        UserLogLineSize size = ULOGLS_PREDEFINED,
                        ShowPolicy pol = SPC_NORMAL,
                        int id = 0 );

        virtual UserLogEvent *Clone() const
        { return new UserLogEvent(*this); }

        DECLARE_DYNAMIC_CLASS(UserLogEvent)

        UserLogType         getLogType() const { return m_userLogType; }
        UserLogLineSize     getLineSize() const { return m_userLogLineSize; }
        ShowPolicy          getShowPolicy() const { return m_showPolicy; }
        wxString            getMessage() const { return m_message; }

    private:
        UserLogType         m_userLogType;
        UserLogLineSize     m_userLogLineSize;
        ShowPolicy          m_showPolicy;
        wxString            m_message;
};

typedef void (wxEvtHandler::*UserLogEventFunction)(UserLogEvent&);

#define UserLogEventHandler(func) \
    (wxObjectEventFunction)(wxEventFunction)wxStaticCastEvent(UserLogEventFunction, &func)

#endif // USERLOGEVENT_H
