#include "ExpressionFvInterpolate.h"
#include "../Math.h"

void ExpressionFvInterpolate::interpret( RPNStack& rpnStack )
{
    RPNStackItem* itemX     = rpnStack.pop();
    RPNStackItem* itemY1    = rpnStack.pop();
    RPNStackItem* itemY0    = rpnStack.pop();
    RPNStackItem* itemX1    = rpnStack.pop();
    RPNStackItem* itemX0    = rpnStack.pop();

    if (    itemX->getType() != RPNStackItem::NUMBER ||
            itemY1->getType() != RPNStackItem::NUMBER ||  itemY0->getType() != RPNStackItem::NUMBER ||
            itemX1->getType() != RPNStackItem::NUMBER ||  itemX0->getType() != RPNStackItem::NUMBER )
    {
        delItem( &itemX, &itemY1, &itemY0, &itemX1, &itemX0, NULL );
        throw ExpError::VariableException( _T("function interpolate2d parameter mismatch") );
    }

    double x = itemX->getNumber();
    double p0[2] = { itemX0->getNumber(), itemY0->getNumber() };
    double p1[2] = { itemX1->getNumber(), itemY1->getNumber() };

    double y  = Math::linearInterpolation2D( p0, p1, x );

    RPNStackItem* item = new RPNStackItem();
    item->setNumber( y );
    rpnStack.push( item );

    delItem( &itemX, &itemY1, &itemY0, &itemX1, &itemX0, NULL );
}

