#ifndef EXPRESSIONFVXOR_H
#define EXPRESSIONFVXOR_H

#include "ExpressionBase.h"
#include "RPNStackItem.h"
#include "../logger.h"
class ExpressionFvXor : public ExpressionBase
{
    public:
        ExpressionFvXor()
        {
            setPrec( 80 );
            setAssoc( ASSOC_LEFT );
            setType( OPERATOR );
        }
        virtual ~ExpressionFvXor();

        void interpret(RPNStack& rpnStack)
        {
            RPNStackItem * a = rpnStack.pop();
            RPNStackItem * b = rpnStack.pop();

            if(a->getType() == RPNStackItem::NUMBER && b->getType() == RPNStackItem::NUMBER)
            {
                int number1 = (int) a->getNumber();
                int number2 = (int) b->getNumber();

                number2 = number1 ^ number2;

                RPNStackItem* item = new RPNStackItem();
                item->setNumber( (double) number2 );
                rpnStack.push( item );
            }
            else
            {
                    // throw
            }
            delete a;
            delete b;
        }
        wxString toString() { return _T("^"); }
    protected:
    private:
};



#endif // EXPRESSIONFVXOR_H
