#ifndef EXPRESSIONSTACK_H
#define EXPRESSIONSTACK_H

#include "InfixToken.h"
#include <stack>

using namespace std;

typedef stack<InfixToken *> ExpStack;

namespace ExpError{

    class ExpError{
    };

    class ZeroDivide :public ExpError
    {

    };

    class SyntaxError :public ExpError{
        public: SyntaxError(){}
        wxString p;
        SyntaxError(const wxString& q){ p=q; }
    };
    class VariableException : public ExpError{

    };
}


class ExpressionStack
{
    public:
        ExpressionStack();
        virtual ~ExpressionStack();

        InfixToken*    pop() {

            InfixToken* tmp = NULL;
            if(! m_expStack.empty() ){
                tmp = m_expStack.top();
                m_expStack.pop();
            }else{
                    throw ExpError::SyntaxError( _T("ExpressionStack()::pop stack underflow") );
            }
            return tmp;
        }

        void                    push(InfixToken * item){
                m_expStack.push(item);
        }
        void clear()
        {
                 while(! m_expStack.empty() ){
                     InfixToken* tmp = m_expStack.top();
                     if ( tmp )
                        delete tmp;
                     m_expStack.pop();
                 }
        }

    protected:
    private:

    ExpStack m_expStack;
};



#endif // EXPRESSIONSTACK_H
