#ifndef INFIXTOKENIZER_H
#define INFIXTOKENIZER_H

#include <wx/string.h>
#include <wx/arrstr.h>

#include "InfixToken.h"
#include "InfixOperator.h"

#include "ExpressionBase.h"

class InfixTokenizer
{
    public:
        InfixTokenizer();
        virtual ~InfixTokenizer();
        void parse( const wxString& str, InfixTokenA& tokenA_out);
        uint32_t getPrec(const wxString& t);
    protected:
    private:
        wxString        m_string;
        InfixOperatorA  m_ops;
        InfixToken::TokenType m_prevType;

        bool getOperator( const wxString& str, InfixTokenA& tokenA_out);
        bool getNumber( const wxString& str, InfixTokenA& tokenA_out );
        bool getVariable( const wxString& str, InfixTokenA& tokenA_out);
};

#endif // INFIXTOKENIZER_H

