#ifndef RPNPARSER_H
#define RPNPARSER_H

#include "ExpressionBase.h"
#include "../common/types/StringHashSet.h"
#include "../common/types/StringHash.h"
#include "../common/types/Int2ArrayStringHash.h"

class VariableData;
class SymbolMgr;
class SymbolArray;

WX_DECLARE_STRING_HASH_MAP(RPNTokenA*, RPNCache);

class RPNParser
{
    public:
        RPNParser();
        virtual ~RPNParser();

        //void    setVariableHash( DoubleHash* varH );
        void    setVariableData( VariableData* data );
        double  calculate( const wxString& expr );
        double  calculateNoCache( const wxString& expr );
        StringHashSet getVariables( const wxString& expr );
        wxArrayString getVariablesArray( const wxString& expr );
        Int2ArrayStringHash getPVariables( const wxString& expr );
        SymbolArray& getStaticVariablesUsedInExpressions(const SymbolMgr& symbolMgr);

        void    setShowExceptions( bool showexceptions ) { m_shExceptions = showexceptions; }

        void    reset();
    protected:
    private:
        RPNTokenA*      m_rpnTokenA;
        InfixTokenA     m_infixTokenA;
        RPNStack        m_stack;
        //DoubleHash*     m_variableH;
        VariableData*   m_data;
        RPNCache        m_cache;

        StringHash      m_variableNotFound;
        StringHash      m_badExpression;

        bool            m_shExceptions;

        //void    parse( const wxString& str );
        void    parseInfix( const wxString& infixStr );
        void    infixToRpn();
        double  evaluate();
        void    clearCache();
};

#endif // RPNPARSER_H
