#ifndef EXTENDEDHEADERPARSER_H
#define EXTENDEDHEADERPARSER_H

#include "parserbase.h"

#include <wx/arrstr.h>

#include "../common/types/wxVariantHashHash.h"
#include "../common/types/String2IntHash.h"
#include "../common/types/IntArray.h"
#include "../Symbol.h"
#include "../SymbolMgr.h"


class ExtendedHeaderParser : public ParserBase
{
    public:
        ExtendedHeaderParser( SymbolMgr* symbolMgr, wxVariantHashHash& sections, bool parseMyMake = false );

    public:
        void        parseLine();

    private:
        wxArrayString       m_sectNames;
        wxArrayString       m_structNames;
        IntArray            m_sectPages;
        IntArray            m_sectPrefix;
        IntArray            m_sectAddresses;

        IntArray            m_structAddresses;

        //SymbolTable&        m_symbols;
        SymbolMgr*          m_symbolMgr;
        bool                m_mymakeParsed;
        bool                m_hastoParseMyMake;

        int                 m_state;
        int                 m_offset;
        int                 m_page;


        String2IntHash      m_defines;
        int                 m_ifdeflevel;
        bool                m_validDef[255]; // #ifdef TRUE etc (max 255 level)
        wxVariantHash       m_globalHdefs;



    private:
        void        addSymbol( const wxString& name );
        void        createSymbol( const wxString& name, size_t size );

        wxString    addPrefix( const wxString& name );

        void        parseMyMake();
        bool        evaluateExpression( wxString& operand1, wxString& operand2, wxString& op );
};

#endif // EXTENDEDHEADERPARSER_H
