#ifndef IHEXPARSER_H
#define IHEXPARSER_H

#include "parserbase.h"
#include "../vemsprotocol/FirmwareData.h"
#include "../vemsprotocol/ECUInfo.h"

//#define LEADING_BYTECOUNT 1
//#define MIN_MEANINGFUL_LINE_LEN (LEADING_BYTECOUNT + (1+4)*2)
#define LEN_IN_LINE 0
#define ADDRESS_IN_LINE 1
#define TYPE_IN_LINE 3
#define DATA_IN_LINE 4

class IHexParser :public ParserBase
{
    public:
        IHexParser(ECUInfo::Device device );
        virtual ~IHexParser();
         void           parseLine();
         FirmwareData * getFirmwareData();
    protected:
    private:
        uint16_t m_pageSize;
        int m_addressOffset;
        FirmwareData * m_firmwareData;
        void hexString2binaryArray(const wxString& str);
        uint8_t isLineChecksumError();
        uint32_t getLineAddress();
        uint8_t  getLineDataLength();
        uint16_t getPageIdx(uint32_t addressB);
        uint8_t m_lineBuff[256];
        int m_lineBuffLen;
        bool fillFirmwareData(uint16_t& pageIdx);
        uint8_t hex2bin( uint8_t hexchr );
        wxString getData();
        bool detectType();
        void getDataAndCheksum(wxString& hexData, wxString& hexChksum);

};



#endif // IHEXPARSER_H
