#include "parserbase.h"

#include <wx/dir.h>
//#include <wx/font.h>
#include <wx/convauto.h>
#include "../logger.h"


ParserBase::ParserBase()
: m_firstline (true)
{
	m_files = new wxArrayString();
}

ParserBase::~ParserBase()
{
    delete m_files;
}

int ParserBase::openFile(const wxString& strFile)
{
    if ( strFile.Length()  < 1){ return -1; /*FC_INVALID_FILENAME;*/ }
    //wxConvAuto myConv(wxFONTENCODING_ISO8859_1);
    if ( ! m_file.Open(strFile, wxConvAuto() ) ){ return -2; /*FC_CANNOT_OPEN_FILE;*/ }
    //if ( ! m_file.Open(strFile, wxConvISO8859_1) ){ return -2; /*FC_CANNOT_OPEN_FILE;*/ }

    //if ( ! m_file.Open(strFile, wxConvLibc) ){ return -2; /*FC_CANNOT_OPEN_FILE;*/ }
    return 0;
}

bool ParserBase::parseNextLine()
{
        if( m_file.Eof() ){
             closeFile();
             return false;
        }

        if ( m_firstline ){
             m_firstline = false;
             m_line = m_file.GetFirstLine();
        }else
        {
            m_line = m_file.GetNextLine();

        }
        m_lineNumber = m_file.GetCurrentLine();
        parseLine();
        return true;
}

void ParserBase::parseOneLine(const wxString& line)
{
    m_line = line;
    m_lineNumber ++;
    m_totalLineNumber++;

    this->parseLine();
}

int ParserBase::closeFile()
{
     m_file.Close();

	 return 0;
}

int ParserBase::parse(const wxString& strFile,  bool batch)
{
    m_batch = batch;

    int result = openFile(strFile);

    m_fileName = strFile;

    if( !m_batch || result != 0) return result; // in batchMode just open the file;

    m_totalLineNumber = m_file.GetLineCount();

    if ( !m_totalLineNumber ) { return 0; }

    for ( m_line = m_file.GetFirstLine(); !m_file.Eof() && !IsAborted();  m_line = m_file.GetNextLine() )
    {
        m_lineNumber = m_file.GetCurrentLine();
        parseLine();
        observerNotify(m_lineNumber, m_totalLineNumber);
    }

    closeFile();
    return 0; //FC_OK;
}

int ParserBase::parseDir(const wxString& dirname, const wxString& filespec)
{

    wxDir::GetAllFiles(dirname, m_files, filespec);
    for(unsigned int i = 0; i< m_files->Count(); i++){
        wxString file = m_files->Item(i);
        //Logger::log(LOG_MSG, _T("ParserBase::parseDir(): Parsing RACE File: ")+file);
        //lp->parse(_T("C:\\data.log"));
        parse(file);
    }
    return m_files->Count();
}
