#ifndef PARSERUTIL_H
#define PARSERUTIL_H

#include <wx/hashmap.h>

enum firmwareConfig_codes{
    START_parseFile,
    START_parseHeaderFile,
    END_parseHeaderFile,
    START_parseConfigFile,
    END_parseConfigFile,
    START_parseTableFile,
    END_parseTableFile,
    SYMBOL_ALL_COUNT,
    SYMBOL_SCALAR_COUNT,
    SYMBOL_ARRAY_COUNT,
    FC_OK,
    FC_INVALID_FILENAME,
    FC_CANNOT_OPEN_FILE,
    FC_INVALID_TABLE_LINE,
    FC_INVALID_TABLE_KEY,
    FC_HIGH_ROW_COUNT,
    FC_ALTERING_ROW_COUNT,
    FC_HIGH_COL_COUNT,

    FC_UNDEFINED_SYMBOL,
    FC_EXTRA_SYMBOL
};
WX_DECLARE_HASH_MAP(int, wxString, wxIntegerHash, wxIntegerEqual, IntKeyHash);
class ParserUtil
{
    public:
        ParserUtil();
        virtual ~ParserUtil();
        static int truncateComment(wxString& line);
        static int getKeyAndValue(const wxString& line, wxString& key, wxString& value);
        static int getUnitAndValue(const wxString& line, wxString& unit, wxString& value);
        static int getArrayAndSize(const wxString& line, wxString& array, wxString& size);
        static int getCommonNameValue(const wxString& line, const wxString& regexp, wxString& key, wxString& value);
        //
        static void addProcessInfo(firmwareConfig_codes code, ...);
        static wxString getFormat(firmwareConfig_codes format_id);
        static int getArrayColumnAndRow(const wxString& line, wxString& col, wxString& row);

        static wxString COMMENT;
    protected:
    private:
        static IntKeyHash formatHash;

};



#endif // PARSERUTIL_H
