#include "FirmwareConfigMgr.h"

#include "../logger.h"
#include "../expression/VariableData.h"

/*
<ConfigCriteria>
<Config name="egt1_cal" expresion="">
	<CriteriaRange type="ok" minValue="0" maxValue="10" expresion="egt1_cal-73"/>
	<CriteriaRange type="warning" minValue="0" maxValue="10" expresion="75-egt1_cal"/>
</Config>
<Config name="egt1_cal2" expresion="">
	<CriteriaRange type="ok" minValue="0" maxValue="10" expresion="egt1_cal-73"/>
	<CriteriaRange type="warning" minValue="0" maxValue="10" expresion="75-egt1_cal"/>
</Config>
</ConfigCriteria>
*/
FirmwareConfigMgr::FirmwareConfigMgr()
: m_isFound (false)
{
    //ctor
    /*
     ConfigCriteria *cc = new ConfigCriteria(_T("egt1_cal"));
     ConfigCriteriaRange *cr1 = new ConfigCriteriaRange(_T("ok"), 0, 10, _T("egt1_cal-73"));
     ConfigCriteriaRange *cr2 = new ConfigCriteriaRange(_T("error"), 0, 10, _T("75-egt1_cal"));

    cc->AddCriteriaRange(cr1);
    cc->AddCriteriaRange(cr2);

    configCriteriaHash[_T("egt1_cal")] = cc;

    */
    m_configReplaceA.Add(new ConfigReplace(_T("primepOLD"),  _T("primep"), _T("primepOLD-2")));
}

/*
void FirmwareConfigMgr::AddCriteria(const wxString &CriteriaKey, ConfigCriteria* CriteriaValue)
{
    m_criteriaOrder.Add(CriteriaKey);
    configCriteriaHash[CriteriaKey] = CriteriaValue;

}
*/

FirmwareConfigMgr::~FirmwareConfigMgr()
{
    //dtor
}


void FirmwareConfigMgr::validate(FirmwareConfig* fwConfig)
{
/*
    m_fwConfig = fwConfig;
     Logger::logf(LOG_MSG, _T("FirmwareConfigMgr::validate() START") );
    //StringHash configHash = fwConfig->getSymbolKeyValueHash();
    DoubleHash double_hash = fwConfig->getConfigValueHash();
    if(double_hash.size() == 0){
        Logger::logf(LOG_ERROR,_T("FirmwareConfigMgr::validate() configHash is EMPTY!"));
        return;
    }
    //m_eval.setHash(&double_hash);
    VariableDataDH vd( &double_hash );
    m_rpn.setVariableData( &vd );
    //m_rpn.setVariableHash( &double_hash );
    Logger::logf(LOG_MSG,_T("FirmwareConfigMgr::validate() warmup_clt_range[0]=%f"), double_hash[_T("warmup_clt_range[0]")]);

    ConfigCriteriaHash::iterator it;
    for( it = configCriteriaHash.begin(); it != configCriteriaHash.end(); it++){
         //Logger::logf(LOG_MSG, _T("FirmwareConfigMgr::validate() 1") );
        wxString key = it->first;
        ConfigCriteria * configCriteria = it->second;
        wxString name = configCriteria->getName();
        wxString defaultExp = configCriteria->getExp();

        configCriteria->setResult(_T("Range not found!"));
        configCriteria->setRangeFound(false);
        ConfigRangeArray *rangeA = configCriteria->getCriteriaRangeA();
        size_t i;
        for(i =0; i < rangeA->GetCount(); i++){
            ConfigCriteriaRange * range = rangeA->Item(i);
            wxString exp = range->getExp();
            if(exp == wxEmptyString){
                if(defaultExp == wxEmptyString) continue;
                exp = defaultExp;
            }
            double min = range->getMinValue();
            double max = range->getMaxValue();
             wxString type = range->getType();
            //double value = m_eval.calculate(exp);
            double value = m_rpn.calculate( exp );
            Logger::logf(LOG_MSG, _T("FirmwareConfigMgr::validate() Symbol: ") + name + _T(" Expr: ") + exp + _T(", Value: %f"), value );
            if(min <= value && value <= max){
                Logger::logf(LOG_MSG, _T("FirmwareConfigMgr::validate() Criteria Range found: ")+ name + _T(" Type: ") + range->getType() );
                configCriteria->setResult(type);
                 configCriteria->setRangeFound(true);
                 m_isFound = true;
                break;
            }
        }
        Logger::logf(LOG_MSG, _T("FirmwareConfigMgr::validate() Criteria Range NOT found: ")+ name);
    }
*/
}

wxString FirmwareConfigMgr::getResultAsString()
{

    wxString res;
/*
    ConfigCriteriaHash::iterator it;
    for(uint32_t i = 0; i < m_criteriaOrder.GetCount(); i++){
        wxString key =  m_criteriaOrder.Item(i);
        ConfigCriteria * configCriteria = configCriteriaHash[key];
        wxString cRes = configCriteria->getResult();
        StringHash cHash = m_fwConfig->getConfigHash();
        wxString hexValue = cHash[key];
        if ( configCriteria->isRangeFound() ){
            res += _T("Config key: ") + key+ _T("=") +hexValue+ _T(" Result: ") +cRes+_T("\n");
        }
    }
*/
    return res;
}

void FirmwareConfigMgr::replace(FirmwareConfig* fwConfig)
{
/*
     m_fwConfig = fwConfig;
     Logger::logf(LOG_MSG, _T("FirmwareConfigMgr::replace() START") );
    //StringHash configHash = fwConfig->getSymbolKeyValueHash();
    DoubleHash double_hash = fwConfig->getConfigValueHash();
   // wxArrayString configArray = fwConfig->getConfigArray();

    if(double_hash.size() == 0){
        Logger::logf(LOG_ERROR,_T("FirmwareConfigMgr::replace() configHash is EMPTY!"));
        return;
    }
    //m_eval.setHash(&double_hash);
    //m_rpn.setVariableHash( &double_hash );
    VariableDataDH vd( &double_hash );
    m_rpn.setVariableData( &vd );
    //m_rpn.setVariableHash( &double_hash );

        ConfigReplace *cr;
        StringHash::iterator it;
        for(uint32_t i = 0; i < m_configReplaceA.GetCount(); i++){
            cr = m_configReplaceA.Item(i);
//            cr->m_newKey; //TODO: validate new key
            StringHash configHash = fwConfig->getConfigHash();

            if(configHash.find(cr->m_oldKey) != configHash.end() )
            {
                fwConfig->addReplaceCount(1);
                //double value = m_eval.calculate(cr->m_exp);
                double value = m_rpn.calculate( cr->m_exp );
                Logger::logf(LOG_MSG,_T("FirmwareConfigMgr::replace() old config: ") + cr->m_oldKey + _T(" found decimal value: %f"), value);
                int v = (int)value;
                fwConfig->replaceKey(cr->m_oldKey, cr->m_newKey, v);
            }
        }
*/
}
bool FirmwareConfigMgr::isFound()
{
        return m_isFound;
}
