#include "firmwareconfigitem.h"

#include <wx/filename.h>

#include "DirHelper.h"
#include "logger.h"


FirmwareConfigItem::FirmwareConfigItem():
parent (NULL)
{
    //ctor
    grpName = wxEmptyString;
    status = FWIS_VIRGIN;
    lastInPanel = false;
}

FirmwareConfigItem::~FirmwareConfigItem()

{
    //dtor
}

wxString FirmwareConfigItem::getPath()
{
    FirmwareConfigItem * tmp = this;

    wxString path = tmp->value;

    wxString  pathSeparator = wxFileName::GetPathSeparator();

    while( tmp->parent != NULL)
    {
        //Logger::log(LOG_MSG, _T("FirmwareConfigItem getFullPath() path: ")+path );

        wxString value = tmp->parent->value;
        wxFileName fileName(path);
        if(fileName.IsRelative()){
            //Logger::log(LOG_MSG, _T("FirmwareConfigItem getFullPath()  Relative "));
            //Logger::log(LOG_MSG, _T("FirmwareConfigItem getFullPath()  value: ")+ value );

            wxString nValue = value;
            if( value.EndsWith( pathSeparator ) ){
                nValue = value.BeforeLast( wxFileName::GetPathSeparator() );
            }

            //Logger::log(LOG_MSG, _T("FirmwareConfigItem getFullPath() nValue: ")+nValue );

            path =  nValue +  pathSeparator + path;

            //Logger::log(LOG_MSG, _T("FirmwareConfigItem getFullPath() path2: ")+path );

        }else{
            //Logger::log(LOG_MSG, _T("FirmwareConfigItem getFullPath()  absulult "));
        //    path = tmp->value;
        }
        tmp = tmp->parent;
    }

    return path;
}

wxString FirmwareConfigItem::getAbsolutePath()
{
    if( IsRelative() ){
        wxString path = getPath();
        //Logger::log(LOG_MSG, _T("FirmwareConfigItem::getAbsolutePath()  path: ")+ path );
        return DirHelper::GetPath() + wxFileName::GetPathSeparator()+ path;
    }else{
        return getPath();
    }
}

wxString FirmwareConfigItem::getListDir()
{
    /*
        wxFileName fn = wxFileName(value);
         if(fn.IsAbsolute() ){
            return fn.GetPath();
        }
        */

        wxFileName fn = wxFileName(getAbsolutePath() );

        return fn.GetPath();
}

bool FirmwareConfigItem::IsRelative()
{
    wxString path = getPath();
    //Logger::log(LOG_MSG, _T("FirmwareConfigItem::IsRelative(): ") +path);
    wxFileName pathName = wxFileName::FileName(path);
    return pathName.IsRelative();
}


wxString FirmwareConfigItem::getRelativeTo()
{
    FirmwareConfigItem * tmp = this;

    if(tmp->parent == NULL){
        return  DirHelper::GetPath();
    }else{
        return parent->getPath();
        /*
        if(tmp->parent->isFile ){
             return tmp->parent->getListDir();
        }else{
            return tmp->getListDir();
        }
        */
    }
}

void FirmwareConfigItem::toString()
{
    wxString msg = _T(" name: ") + name;
    msg += _T(" value: ") + value;
    msg += _T(" type: ") + type;
    msg += wxString::Format( _T(" mandatory: %i:"), mandatory);
    msg += wxString::Format( _T(" active: %i:"), active);
    msg += wxString::Format( _T(" isFile: %i:"), isFile);

    Logger::log(LOG_MSG, msg);
}
