#ifndef GUIDESCSTRUCTITEM_H
#define GUIDESCSTRUCTITEM_H

#include <wx/wx.h>

enum GUIDescStructItemType {
    GDSI_SYMBOLNAME,
    GDSI_SYMBOLDESC,
    GDSI_COLOR,
    GDSI_NUMBER,
    GDSI_TEXT
};

class GUIDescStructItem
{
    public:
        GUIDescStructItem() {};
        GUIDescStructItem(const wxString& name, int type,bool show = true, bool canNull = true, const wxString& title = wxEmptyString, const wxString& helpstr = wxEmptyString) {
            Name = name;
            Type = type;
            Title = title == wxEmptyString ? name : title;
            HelpStr = helpstr;
            ShowOnEditor = show;
            CanNull = canNull;
        };
        wxString    Name;
        int         Type;
        wxString    Title;
        wxString    HelpStr;
        bool        ShowOnEditor;
        bool        CanNull;

};

WX_DECLARE_OBJARRAY(GUIDescStructItem, GUIDescStructItemArray);

#endif // GUIDESCSTRUCTITEM_H
