#ifndef MULTISYMBOLGAUGEDESCMGR_H
#define MULTISYMBOLGAUGEDESCMGR_H


#include <wx/wxsqlite3.h>
#include "../common/types/wxVariantHash.h"
#include "../common/types/wxVariantHashArray.h"
#include "../wxSQLColumnDesc.h"

class MultiSymbolGaugeDesc
{
    public:
        MultiSymbolGaugeDesc() {};
        MultiSymbolGaugeDesc(long id, const wxString& name);
        MultiSymbolGaugeDesc(wxVariantHash& properties);
        MultiSymbolGaugeDesc(wxSQLite3ResultSet& profileLineResult);

        int GetId();
        wxString GetName();

        wxVariant GetProp(const wxString& key, const wxVariant& defval = wxNullVariant);
        bool SetProp(const wxString& key, const wxVariant& val);

        void AddSymbolProps(wxVariantHash hash) { m_symbols.Add(hash); };

        wxVariantHashArray& GetSymbols() { return m_symbols; }
        wxVariantHash&      GetSymbol(int id);
        wxVariantHash&      GetSymbol(const wxString& name);

    private:

        wxVariantHash       m_properties;
        wxVariantHashArray  m_symbols;

        wxVariantHash       m_dummy;
};

WX_DECLARE_HASH_MAP(int, MultiSymbolGaugeDesc, wxIntegerHash, wxIntegerEqual, Int2MultiSymbolGaugeDescHash);

class MultiSymbolGaugeDescMgr
{
    public:
        MultiSymbolGaugeDescMgr(MultiSymbolGaugeDesc defaultdesc, ColumnDescArrayHash dbStruct);
        virtual ~MultiSymbolGaugeDescMgr();

        bool LoadFromFile(const wxString& filename, const wxString& inipath = wxEmptyString);

        MultiSymbolGaugeDesc& GetProfile(int id);
        MultiSymbolGaugeDesc& GetProfile(const wxString& name);
        bool IsProfileExists(const wxString& name);
        bool IsProfileExists(int id);

        wxString GetLastDbFile() { return m_lastDatabaseFile; }

        Int2MultiSymbolGaugeDescHash& GetProfiles() { return m_profiles; };

    protected:

        bool CheckDB();

    private:

        ColumnDescArrayHash             m_dbStruct;

        wxSQLite3Database               m_db;

        Int2MultiSymbolGaugeDescHash    m_profiles;

        MultiSymbolGaugeDesc            m_defaultDesc;

        wxString                        m_lastDatabaseFile;
};


#endif // MULTISYMBOLGAUGEDESCMGR_H
