#include "VariableDescriptor.h"

#include "../logger.h"

#include <wx/arrimpl.cpp>

WX_DEFINE_OBJARRAY( VariablesArray );
WX_DEFINE_OBJARRAY( StructArray );

void StructDescriptor::printStructure()
{
    wxString structStr = _T("struct ") + name + _T(" {\n");

    size_t starts_on = 0;

    for ( size_t i = 0; i < fields.GetCount(); ++i )
    {
        VariableDescriptor& var = fields.Item( i );

        structStr += _T("\t") + var.strType;

        if ( var.isStruct )
        {
            structStr += _T(" ") + var.structDescriptor->name;
        }

        structStr += _T("\t") + var.name;

        if ( var.isArray && var.arraySize > 0 )
        {
            structStr += wxString::Format( _T("[%d]"), var.arraySize );
        }

        structStr += wxString::Format( _T(";\t/* starts_on %d */\n"), starts_on );

        starts_on += var.getSize();

    }
    structStr += _T("};");

    LOGP( structStr );
}

void StructDescriptor::addVariable( VariableDescriptor& var )
{
    fields.Add( var );
    size += var.getSize();
    //Logger::logf(LOG_MSG, _T("added ") + var.name +_T(" size=%d"), size);
}
