#ifndef EXPRESSIONEXCEPTION_H
#define EXPRESSIONEXCEPTION_H

#include <wx/wx.h>

class ExpressionException
{
    public:
        ExpressionException( const int row, const int col, const int id, const wxString& expr, const char* name = NULL );

    public:
        wxString    err;

        int         errcode;

        enum errcodes {
            SYNTAX_ERROR = 1, SYNTAX_ERROR_, PARENTHESIS_MISSING, EMPTY_EXPR, UNEXPECTED_EOEXPR, UNEXPECTED_EOEXPR_, VALUE_EXPECTED,
            UNKNOWN_OP = 101, UNKNOWN_FUNC, UNKNOWN_VAR,
            EXPR_TOO_LONG = 200,
            DEFINING_VAR_FAILED = 300,
            INTEGER_EXPECTED = 400,
        };

    public:
        wxString    getExprErr() const;
        void        setRow( int row );
        void        setCol( int row );
        int         getRow() const { return m_row; }
        int         getCol() const { return m_col; }

    private:
        int         m_row;
        int         m_col;
        wxString    m_expr;
        wxString    m_name;

    private:
        void    createErr();
};

#endif // EXPRESSIONEXCEPTION_H
