#ifndef GPSCOMMCLIENT_H
#define GPSCOMMCLIENT_H


#include "../GPSInfo.h"
#include "../GPSNMEA/NMEAParse.h"
#include "../communication/CommunicationControllerClient.h"


class GpsCommClient : public CommunicationControllerClient
{
    public:
        GpsCommClient( wxEvtHandler* eventHandler );
        virtual ~GpsCommClient();

        void    write( uint8_t* buffer, int& size );
        void    read( uint8_t* buffer, int size );
        void    finish();
        bool    isFinished();

        int     getGPSState() const { return m_state; }

    private:
        wxEvtHandler*   m_eventHandler;

        NMEAParse   m_parser;
        uint8_t     m_seqence;
        uint8_t     m_packedGpsData[14+3];

        int         m_state;
        int         m_noDataCount;

        void sendInputEvent();
        void sendEvent(GPSInfo::CommState state);
        void sendEvent(GPSInfo::State state);
        void packData(uint8_t* packedGpsData);
};


#endif // GPSCOMMCLIENT_H
