#include "BootModeDialog.h"
#include "../common/types/StringHash.h"
#include "../common/VemsMessageHashHelper.h"

#include <wx/statline.h>
#include <wx/artprov.h>


BEGIN_EVENT_TABLE( BootModeDialog, wxDialog )
    EVT_BUTTON( BMD_STAY, BootModeDialog::OnButton )
    EVT_BUTTON( BMD_LEAVE, BootModeDialog::OnButton )
END_EVENT_TABLE()


BootModeDialog::BootModeDialog( wxWindow* parent,
                                wxWindowID id,
                                const wxString& title,
                                const wxPoint& pos,
                                const wxSize& size,
                                long style,
                                const wxString& name )
{
    Create( parent, id, _T("Boot Mode Detected"), pos, size, style, name );

    SetSizer( new wxBoxSizer( wxVERTICAL ) );

    wxButton* stayButton    = new wxButton( this, BMD_STAY, _T("Stay") );
    wxButton* leaveButton   = new wxButton( this, BMD_LEAVE, _T("Leave") );

    wxBoxSizer* pButtonLineSizer = new wxBoxSizer( wxHORIZONTAL );
    pButtonLineSizer->Add( stayButton, 0, wxALL, 5 );
    pButtonLineSizer->Add( leaveButton, 0, wxALL, 5 );

    wxBoxSizer* pMsgLineSizer = new wxBoxSizer( wxHORIZONTAL );

    wxBitmap bitmap = wxArtProvider::GetIcon(wxART_WARNING, wxART_MESSAGE_BOX);
    wxStaticBitmap *icon = new wxStaticBitmap(this, wxID_ANY, bitmap);
    pMsgLineSizer->Add( icon, 0, wxALIGN_CENTER | wxALL , 5 );

    StringHash hash;
    wxString messageName = _T("boot_mode_detected");
    VemsMessage message = VemsMessageHashHelper::GetVemsMsg( messageName ,&hash );
    wxString messageStr = message.getHtmlMsg();
    //wxStaticText* text = new wxStaticText( this, wxID_ANY, _T("Boot mode. Please, choose an options.") );
    wxStaticText* text = new wxStaticText( this, wxID_ANY, messageStr );
    wxFont font = text->GetFont();
    font.SetPointSize( 12 );
    font.SetWeight( wxFONTWEIGHT_BOLD );
    text->SetFont( font );

    pMsgLineSizer->Add( text, 1, wxALIGN_CENTER | wxALL, 5 );

    GetSizer()->Add( pMsgLineSizer, 0, 0, 0 );
    GetSizer()->Add( new wxStaticLine( this ), 0, wxEXPAND | wxALL, 5 );
    GetSizer()->Add( pButtonLineSizer, 0, wxEXPAND, 0 );

    SetInitialSize();
}

BootModeDialog::~BootModeDialog()
{
    //dtor
}

void BootModeDialog::OnButton( wxCommandEvent& event )
{
    EndModal( event.GetId() );
}
