#ifndef DT_H
#define DT_H

/// DirTraverser class for enumerating only subdirs

#include <wx/dir.h>

class DT : public wxDirTraverser
{
    public:
        DT(wxArrayString& dirs, bool subDirs = false): m_dirs(dirs), m_subdir(subDirs) { }

        virtual wxDirTraverseResult OnFile(const wxString& WXUNUSED(filename))
            { return wxDIR_CONTINUE; }
        virtual wxDirTraverseResult OnDir(const wxString& dirname)
            { m_dirs.Add(dirname); if ( m_subdir ) return wxDIR_CONTINUE; else return wxDIR_IGNORE; }

    private:
        wxArrayString& m_dirs;
        bool           m_subdir;
};
#endif // DT_H
