#ifndef FILEOPENDLGHELPER_H_INCLUDED
#define FILEOPENDLGHELPER_H_INCLUDED

#include <wx/wx.h>
#include <wx/artprov.h>

WX_DECLARE_STRING_HASH_MAP( wxBitmap, BitmapHash2 );

#define FO_FOLDER_ICON  wxART_MAKE_ART_ID(FO_FOLDER_ICON)
#define FO_GO_UP_ICON   wxART_MAKE_ART_ID(FO_GO_UP_ICON)
#define FO_DETAILS_ICON wxART_MAKE_ART_ID(FO_DETAILS_ICON)
#define FO_VEMS_FILE    wxART_MAKE_ART_ID(FO_VEMS_FILE)
#define FO_ICON_UP      wxART_MAKE_ART_ID(FO_ICON_UP)
#define FO_ICON_DOWN    wxART_MAKE_ART_ID(FO_ICON_DOWN)
#define FO_VEMS_CFG     wxART_MAKE_ART_ID(FO_VEMS_CFG)
#define FO_ICON_ANALYZE wxART_MAKE_ART_ID(FO_ICON_ANALYZE)
#define FO_ICON_SEARCH  wxART_MAKE_ART_ID(FO_ICON_SEARCH)
#define FO_ICON_MAGNIFY wxART_MAKE_ART_ID(FO_ICON_MAGNIFY)
#define FO_ICON_GPS     wxART_MAKE_ART_ID(FO_ICON_GPS)
#define FO_ICON_SAT     wxART_MAKE_ART_ID(FO_ICON_SAT)

enum { ICON_FILE, ICON_DOWN, ICON_UP, ICON_NULLBMP, ICON_CFG, ICON_FOLDER };

class FileOpenArtProvider : public wxArtProvider
{
    public:

        FileOpenArtProvider();

    protected:
        wxBitmap CreateBitmap(const wxArtID& id, const wxArtClient& client, const wxSize& size);

    private:
        BitmapHash2  m_bitmaps;
};

class FileDialogSettingsDialog : public wxDialog
{
    public:
        FileDialogSettingsDialog( wxWindow* parent );
    private:

        wxCheckListBox*     m_listBox;

        void        SwapLines( const int& idx1, const int& idx2 );

        void        OnMoveButton( wxCommandEvent& event );

        void        OnSave( wxCommandEvent& event );
        void        OnCheck( wxCommandEvent& event );

        DECLARE_EVENT_TABLE()
};

#endif // FILEOPENDLGHELPER_H_INCLUDED
