#ifndef OPENVEMSCFGDIALOG_H
#define OPENVEMSCFGDIALOG_H


#include <wx/wx.h>

enum OpenVemsCfgDialogButtons{
    OVCDB_OPEN      = 0x01,
    OVCDB_OPENADV   = 0x02,
    OVCDB_GOOFFLINE = 0x04,
    OVCDB_CANCEL    = 0x08,


    OVCDB_DEFAULT = OVCDB_OPEN | OVCDB_CANCEL | OVCDB_GOOFFLINE
};

class OpenVemsCfgDialog : public wxDialog
{
    public:
        enum { ID_CONFIG_UPLOAD, ID_CONFIG_SWITCH_UPLOAD, ID_CONFIG_VERIFY, ID_GO_OFFLINE, ID_CANCEL };

    public:
        OpenVemsCfgDialog(  wxWindow* parent,
                            wxWindowID id,
                            const wxString& title,
                            long buttons = OVCDB_DEFAULT,
                            const wxPoint& pos = wxDefaultPosition,
                            const wxSize& size = wxDefaultSize,
                            long style = wxDEFAULT_DIALOG_STYLE,
                            const wxString& name = _T("dialogBox") );

        virtual ~OpenVemsCfgDialog() {}

    private:

        void OnButton( wxCommandEvent& event );
        DECLARE_EVENT_TABLE()
};


#endif // OPENVEMSCFGDIALOG_H
