#include "OwnBitmapComboBox.h"
#include "../logger.h"

void OwnBitmapComboBox::OnDrawItem( wxDC& dc, const wxRect& rect, int item, int flags ) const
{
    if ( item == wxNOT_FOUND )
        return;

    wxRect r( rect );
    r.Deflate( 3 );
    r.height -= 2;

    wxString dirName = GetString( item );

    int extraspace = 0;

    if ( ! (flags & wxODCB_PAINTING_CONTROL ) )
    {
        int fId = m_folderidarray.Index( item );

        if ( fId != wxNOT_FOUND )
        {
            extraspace += fId * 8;
        }
    }

    dc.DrawBitmap( m_bmparray[item], rect.x + extraspace + 2, rect.y, true );
    dc.DrawText( dirName, rect.x + extraspace + 20, (rect.y + 0) + ( (rect.height/2) - dc.GetCharHeight() ) / 2 + 2 );
}

void OwnBitmapComboBox::OnDrawBackground( wxDC& dc, const wxRect& rect, int item, int flags ) const
{
    //if ( ( flags & ( wxODCB_PAINTING_CONTROL | wxODCB_PAINTING_SELECTED ) ) )

    wxOwnerDrawnComboBox::OnDrawBackground( dc, rect, item, flags );
}

wxCoord OwnBitmapComboBox::OnMeasureItem( size_t WXUNUSED(item) ) const
{
    return 20;
}

wxCoord OwnBitmapComboBox::OnMeasureItemWidth( size_t WXUNUSED(item) ) const
{
    return -1;
}
