#ifndef OWNBITMAPCOMBOBOX_H
#define OWNBITMAPCOMBOBOX_H

#include "wx/wx.h"
#include "wx/combo.h"
#include "wx/odcombo.h"
#include "../common/types/IntArray.h"
#include "../common/types/wxBitmapRefArray.h"



class OwnBitmapComboBox : public wxOwnerDrawnComboBox
{
    public:

        // constructors
        OwnBitmapComboBox() : wxOwnerDrawnComboBox() {}
        OwnBitmapComboBox( wxWindow* parent, wxWindowID id, const wxString& value = _T(""),
            const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, int n = 0,
            const wxString choices[] = NULL, long style = 0, const wxValidator& validator = wxDefaultValidator, const wxString& name = _T("comboBox") ) :
            wxOwnerDrawnComboBox( parent, id, value, pos, size, n, choices, style, validator, name )
        {
        }

        OwnBitmapComboBox( wxWindow* parent, wxWindowID id, const wxString& value, const wxPoint& pos, const wxSize& size,
            const wxArrayString& choices, long style = 0, const wxValidator& validator = wxDefaultValidator, const wxString& name = _T("comboBox") ) :
            wxOwnerDrawnComboBox( parent, id, value, pos, size, choices, style, validator, name )
        {
        }

        // overridden methods
        virtual void OnDrawItem( wxDC& dc, const wxRect& rect, int item, int flags ) const;
        virtual void OnDrawBackground( wxDC& dc, const wxRect& rect, int item, int flags ) const;
        virtual wxCoord OnMeasureItem( size_t WXUNUSED(item) ) const;
        virtual wxCoord OnMeasureItemWidth( size_t WXUNUSED(item) ) const;

        void SetBitmapArray( wxBitmapRefArray arr ) { m_bmparray = arr; }
        void SetFolderIds( IntArray arr ) { m_folderidarray = arr; }

        void AddBitmap( wxBitmap bmp ) { m_bmparray.Add( bmp ); }
        void ClearBitmapArray() { m_bmparray.Clear(); }

    protected:
    private:
        wxBitmapRefArray m_bmparray;
        IntArray         m_folderidarray;
};

#endif // OWNBITMAPCOMBOBOX_H
