#ifndef SDCARDDIRECTOR_H
#define SDCARDDIRECTOR_H


#include <wx/progdlg.h>


class VemsDeviceControllerBase;
class SDCardController;
class SDCardEvent;


class SDCardDirector : public wxEvtHandler
{
    public:
        SDCardDirector( wxWindow* parent, VemsDeviceControllerBase* deviceController );
        virtual ~SDCardDirector();

        void startLog();
        void stopLog();
        void erase();

    private:
        VemsDeviceControllerBase*   m_deviceController;
        SDCardController*           m_sdCardController;
        wxWindow*                   m_parent;
        wxProgressDialog*           m_sdcardDlg;

        enum { TASK_START, TASK_SEARCH, TASK_OTHER };
        int                         m_task;

        void onSDCardEvent( SDCardEvent& event );

        bool checkDifferentFw( const wxString& fwVer, unsigned int fwAsInt );
};

#endif // SDCARDDIRECTOR_H
