#include "TorqueConfigFrame.h"

#include "../SessionSelectPanel.h"
#include "../ConfigEditPanel.h"

TorqueConfigFrame::TorqueConfigFrame( wxWindow* parent, wxWindowID id, const wxString& title, ConfigBase* configBase )
    : wxFrame( parent, id, title )
{
    wxPanel*    mainPanel   = new wxPanel( this, wxID_ANY );
    wxBoxSizer* frameSizer  = new wxBoxSizer( wxVERTICAL );

    wxString defPath    = _T("/defaultTorqueConfig/");
    wxString subPath    = _T("/torqueConfig/");

    m_torquePanel = new ConfigEditPanel( mainPanel, wxID_ANY, _T("/torqueConfig")
                                             , configBase, defPath, defPath, subPath );

    defPath = _T("/defaultTorqueConfig/drivetrain");
    subPath = _T("/torqueConfig/drivetrain/");

    m_torqueDriveTrainPanel = new ConfigEditPanel( mainPanel, wxID_ANY, _T("/torqueConfig/drivetrain")
                                                   , configBase, defPath, defPath, subPath );

    m_sessionSelectPanel = new SessionSelectPanel( mainPanel, wxID_ANY, _T("Project") );

    m_sessionSelectPanel->registerObserver( m_torquePanel );
    m_sessionSelectPanel->registerObserver( m_torqueDriveTrainPanel );

    frameSizer->Add( m_sessionSelectPanel, 0, wxEXPAND | wxALL, 5 );
    frameSizer->Add( m_torquePanel, 0, wxEXPAND | wxALL, 5 );
    frameSizer->Add( m_torqueDriveTrainPanel, 0, wxEXPAND | wxALL, 5 );

    mainPanel->SetSizer( frameSizer );
    mainPanel->Fit();

    SetClientSize( mainPanel->GetSize() );
    SetMinSize( GetSize() );
}

TorqueConfigFrame::~TorqueConfigFrame()
{
    m_sessionSelectPanel->unRegisterObserver( m_torquePanel );
    m_sessionSelectPanel->unRegisterObserver( m_torqueDriveTrainPanel );
}
