#ifndef VEMSWELCOMESCREEN_H
#define VEMSWELCOMESCREEN_H

#include <wx/gbsizer.h>

#include "../bcWidgets/BitmapCanvasParentBase.h"
#include "../bcWidgets/events/bcLinkEvent.h"

///  notes: when derived this class from wxScrolledWindow instead of wxPanel the scrolling is not works correctly

class VemsWelcomeScreen: public wxPanel, public BitmapCanvasParentBase
{
    public:
        VemsWelcomeScreen(wxWindow * parent, int id = wxID_ANY);
        virtual ~VemsWelcomeScreen();

        void SetEventHandler(wxEvtHandler* handler)  { m_eventHandler = handler; };

        void BuildGUI();

    protected:

        void OnPaint(wxPaintEvent& evt);
        void OnSize(wxSizeEvent& evt);
        void OnButton(wxCommandEvent& evt);
        void OnLink(bcLinkEvent& evt);

        void DrawBackground();

        void AddHistoryCaption(wxGridBagSizer* recentSizer, int& line, const wxString& label, int col = 0);
        void AddHistoryLine(wxGridBagSizer* recentSizer,int& line, const wxString& label, const wxImage& iconimage, int startCol = 0);


        void SendCommand(int cmd, const wxString& msg = wxEmptyString);

    private:

        enum {
            idButtonOpenLogFile,
            idButtonOpenConfigFile,
            idButtonAdvOpenLogFile,
            idButtonOpenLogFileExternal,
            idButtonOpenECUComm,
            idButtonOpenGPSComm
        };

        wxBitmap* m_bgBitmap;

        int m_headHeight;

        wxEvtHandler* m_eventHandler;

        DECLARE_EVENT_TABLE()
};

#endif // VEMSWELCOMESCREEN_H
