#ifndef WXHOTKEYMANAGER_H
#define WXHOTKEYMANAGER_H

#include "../common/types/Int2StringHash.h"
#include "../common/types/StringHash.h"

struct HotKeyDesc
{
    wxString Title;
    wxString HotKey;
};

WX_DECLARE_OBJARRAY(HotKeyDesc, HotKeyDescArray);

class wxHotKeyManager
{
    public:
        wxHotKeyManager(const wxString &dbfile);
        wxHotKeyManager(wxObject *baseClassWithRTTI);
        virtual ~wxHotKeyManager();

        wxString GetEvent(wxKeyEvent &evt, const wxString& removeFromKeyStroke = wxEmptyString);

        void ParseConfigFile(const wxString &dbfile = wxEmptyString);

        static Int2StringHash InitNumpadKeyCodes();

        static wxString NumPadKeyStrokeToString(int keycode);

        wxString GetHotKeyStringBySymbol(const wxString &eventsymbol);
        wxString GetHotKeyTitleBySymbol(const wxString &eventsymbol);

        void GetHotKeyList(HotKeyDescArray& arr, wxArrayString* excludesymbols = NULL);

        void RefreshHotKeys();

    protected:

    private:

        wxString    m_dbFile;
        wxString    m_eventsFile;

        StringHash  m_hotKeyToEventStrings;



        static Int2StringHash m_numpadKeycodes;

};

/*
class wxHotKey
{
    public:
        wxHotKey() {};
        wxHotKey(wxKeyEvent &evt) {};

        int KeyCode;
        int Modifiers;
};
*/
#endif // WXHOTKEYMANAGER_H
