#ifndef WXHOTKEYMANAGERGUI_H
#define WXHOTKEYMANAGERGUI_H

#include <wx/wx.h>
#include <wx/gbsizer.h>
#include <wx/wxsqlite3.h>

#include "../Observable.h"
#include "../ObserverBase.h"


class wxTextCtrlHotKey;

class wxHotKeyManagerGUI: public wxFrame, public ObserverBase
{
    public:
        wxHotKeyManagerGUI( wxWindow * parent, const wxString &title = _T("HotKey manager GUI") );
        virtual ~wxHotKeyManagerGUI();

        bool LoadTarget(const wxString &targetTitle);

        virtual void notify( int i );
        virtual void notify(int i, int idx) {};
        virtual void notify(const wxString& str) {};
        virtual void Init(const wxString& name, const wxString& msg, const int max) {};

    protected:

        bool LoadFile(const wxString &dbfile);
        void LoadProfile(const wxString &title);

        void OnListBox(wxCommandEvent &evt);
        void OnButton(wxCommandEvent &evt);

        void OnCombo(wxCommandEvent &evt);

        void PutHotKeys(const wxString &title);

        void AddHotKey();
        void RemoveAllHotKey();
        void RemoveHotKey();
        void SetProfile();
        void UpdateHotKeyList();
        void StartState();
        void MakeNewProfile();
        void DelProfile();
        void BrwProfile();

    private:

        enum{
            idLBHotKey = 1000,
            idLBEvents,
            idTCHotKey,
            idBtnRemove,
            idBtnRemAll,
            idBtnAdd,
            idBtnClose,
            idBtnSetProf,
            idBtnSHCreater,
            idBtnAddNewProfile,
            idBtnBrwProfile,
            idBtnDelProfile,
            idCBProfileList
        };

        wxSQLite3Database   m_db;

        wxString        m_dbFile;
        wxString        m_eventsDbFile;

        wxListBox   *   m_eventsListBox;
        wxListBox   *   m_hotkeyListBox;

        wxButton * m_btnRem;
        wxButton * m_btnRemall;
        wxButton * m_btnAdd;
        wxButton * m_btnSetProf;
        wxButton * m_btnSHCreater;

        wxTextCtrlHotKey  *   m_hotkeyCtrl;
        wxStaticText *  m_hotkeyFeedBack;
        wxGridBagSizer * m_mainsizer;

        wxComboBox  *   m_profileList;

        wxTextCtrl  *   m_newProfileCtrl;

        wxStaticText  * m_title;
        wxStaticText  * m_usedText;
        wxStaticText  * m_addProfText;

        wxGridBagSizer* m_createProfilSizer;

        wxString        m_targetTitle;

        wxString        m_profilesFile;

        DECLARE_EVENT_TABLE();

};


#endif // WXHOTKEYMANAGERGUI_H
