#include "intelhex.h"

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>

IntelHex::IntelHex()
{

    //ctor
}

IntelHex::~IntelHex()
{
    //dtor
}


/*
 * removed line-end character
 * (TODO: check for empty-string - if you care. not appropriate here)
 */
void IntelHex::chomp( char * str )
{
	int i;
	int len = strlen( str );
	for( i = len-1; i; i--){
		if( str[i] == '\r' || str[i] == '\n' ){
			str[i] = '\0';
		} else {
			break;
		}
	}
}

int IntelHex::isComment( char * str )
{
    int len = strlen( str );
    if(len < 1) return -1;
    if( str[0] =='#') return 0;
    return 1;
}
/*
 * clones a string
 */
char * IntelHex::strclone( char * line )
{
	int length;
	char * linecopy;
	length = strlen(line);
	linecopy = (char *) malloc( length );
	if( linecopy == NULL ){
		fprintf( stdout, "Error: malloc failed\n");
		exit(-2);
	}
	if( strcpy( linecopy, line ) != linecopy ){
		fprintf( stdout, "Error: strcpy failed\n");
		exit(-1);
	}
	return linecopy;
}

uint8_t IntelHex::to_hex_char(uint8_t value)
{

	if(
	// (value >= 0) &&
	 (value <= 9) ){
		return '0' + value;
	}
	if( (value > 9) && (value < 16) ){
		return 'A' + value -10;
	}
	fprintf( stdout, "ERROR: value: %d must be in range: 0..15 \n", value );
	return 0;
}

uint8_t IntelHex::hexchr_val( uint8_t hexchr )
{
	if( hexchr >= '0' && hexchr <= '9' ){
		return hexchr - '0';
	}

	if( hexchr >= 'A' && hexchr <= 'F' ){
		return hexchr - 'A' + 10;
	}

	if( hexchr >= 'a' && hexchr <= 'f' ){
		return hexchr - 'a' + 10;
	}

	fprintf( stdout, "ERROR: not a hexa digit: %c\n", hexchr );
	return 0;
}




/*
 * returns (address-0x100) / 16
 * or -1 if bad (range-violation)
 */
 /*
int address_to_idx( int address )
{
	int idx;
	if( address < 0 ){
		return -1;
	}

	// address => idx formula (airdenfactor starts at 0x100)
	idx = (address - ADDRESS_MIN) >> 4;
	if( (address & 0xF) != 0){
		fprintf( stdout, "NOTE: hexfile addr (division by 16) at line %d (addr 0x%x)%s\n",
			linecnt, address, linebuf );
			return -1;
	}

	// check for range violation
	if( idx < 0	|| idx >= FACTOR_PATCH_SIZE	){
		return -1;
	}
	return idx;
}
*/
/** returns address for certain factor,
 * or -1 if err
 */
 /*
int factor_idx( char* line )
{
	int address = factor_address( line );
    return address_to_idx( address );
}
*/


/*
void putLineToPageBuffer(struct line_t parsed_line)
{

	uint16_t addressB = parsed_line.addressB;
	uint16_t pageIdx = getPageIdx( addressB );
	uint16_t offset = addressB - pageIdx;
	//
	uint8_t value;
	int i=0;
	for(i = 0; i < parsed_line.dataLength; i=i+2){
		value = hexchr_val( parsed_line.data[i] ) * 16;
		value += hexchr_val( parsed_line.data[i + 1]);
		pageBuffer[offset + i] = value;
	}
}
*/
// length of ':'
#define LEADING_BYTECOUNT 1
#define MIN_MEANINGFUL_LINE_LEN (LEADING_BYTECOUNT + (1+4)*2)

/*
 * fill lineBuf->rawBytes
 */
int IntelHex::getLineBytes (char * line, struct line_t *lineBuf )
{
	int len = strlen( line );
	uint8_t i, bytecount;
	uint8_t val;
	// 2 hexchar => 1 byte
	bytecount = len >> 1;
	if( len >= MIN_MEANINGFUL_LINE_LEN
		&& line[0] == ':'
		&& ( len == ((bytecount << 1) + LEADING_BYTECOUNT)) // with the ':', even number of hex digits
		 ){
		uint8_t idx = LEADING_BYTECOUNT;
		for( i=0; i < bytecount; i++ ){

			val = hexchr_val(line[ idx++ ]) * 16;
			val += hexchr_val(line[ idx++ ]);

			lineBuf->rawBytes[ i ] = val;
		}
		lineBuf->rawLength = bytecount;
	} else {
		fprintf( stdout, "getLineBytes() error!!!\n" );
		return( -1 );
	}
	return bytecount;
}

/*
 * return true if checksum error
 * (0 if OK)
 */
uint8_t IntelHex::isChecksumError( struct line_t *lineBuf )
{
	uint8_t chksum = 0;
	uint8_t i = lineBuf->rawLength;
	do{
		i--;
		chksum += lineBuf->rawBytes[ i ];
	} while ( i );
	return chksum;
}

#define LEN_IN_LINE 0
#define ADDRESS_IN_LINE 1
#define TYPE_IN_LINE 3
#define DATA_IN_LINE 4

/*
 * retreives big-endian address from rawBytes
 */
uint32_t IntelHex::getLineAddress( struct line_t *lineBuf )
{
	return (lineBuf->rawBytes[ ADDRESS_IN_LINE ] << 8 )
		+ (lineBuf->rawBytes[ ADDRESS_IN_LINE + 1] );
}

/*
 *the intel index file format
 *:10035000A4A3A2A1A0A09F9E9D9C9C9B9A999998C2
 * ^^|   | |	 :0 length (0x10)
 *   ^^^^| |	 :1-2 address: 0x0350
 *       ^^|	 :3 type
 *         ^^	 :4 begin of data
 *	   			checksum:   ^^
 *
 * reads from line, checks chksum,
 * and writes result to lineBuffer (which must have been initiated by caller!)
 * (finds out address by itself)
 *
 * returns number of bytes received (negative for error)
 */
int IntelHex::parseLine(uint8_t * line, struct line_t *lineBuf)
{
	int ret;
	uint8_t type;

	if( line == NULL ){
		return -1;
	}

	// put to byte-array (get length)
	ret = getLineBytes( (char *) line, lineBuf );
	if( ret < 0 ){
		fprintf( stdout, "NOTE: hexfile line neglected (length): %s\n", line );
		return ret;
	}

	type = lineBuf->rawBytes[TYPE_IN_LINE];
	// verify line sanity
	if(type == 0x00){
	    if( isChecksumError( lineBuf ) ){
            fprintf( stdout, "NOTE: hexfile line neglected (checksum): %s\n", line );
            return -3;
        }
        // extract address
        lineBuf->addressB = addressOffset + getLineAddress( lineBuf );
	    return 0;
    }
    if(type == 0x02){
        if( isChecksumError( lineBuf ) ){
            fprintf( stdout, "NOTE: hexfile line neglected (type2)(checksum): %s\n", line );
            return -3;
        }
        addressOffset =0x10000;
        return -3;
    }
/*
	if(
	// not only 16 byte long lines are OK:
	// len != 0x10	||
	  type != 0x00 // only type 00 is known. TODO: for atmega128, extended addr is needed (02?)
	){
	*/
		fprintf( stdout, "NOTE: hexfile line neglected (type=%02x): %s\n", type, line );
		return -2;
	//}

	// verify checksum




	//fprintf( stdout, "factor_address() address: %x \n", address );


}

/*
 * Prints page to standard output
 */
void IntelHex::printPage( struct pagebuffer_t *pageBuffer)
{
	uint32_t baseAddress = pageBuffer->base_address;
	uint8_t l;
	uint16_t pagesize16 = pageBuffer->len >> 4; // the number of lines (16-byte each)
	uint8_t i, val;

	uint16_t pageOffset = 0;
	for( l = 0; l< pagesize16; l++){
        uint16_t lineAddress = (baseAddress % 65536);
		uint8_t chksum;
		// TODO: length is always 0x10 wired in !!
		//printf( "%s:10%04X00", leadstr, lineAddress );
		chksum = (0x10 + (lineAddress >> 8)) + (uint8_t) (lineAddress& 0xFF);

        printf( "-%08X-", baseAddress );
		for ( i=0; i<=15; i++ ){
			val = pageBuffer->buf[  pageOffset ];
			printf("%02X", val);
			chksum += val;
			pageOffset ++;
		}
		baseAddress += 16;
		chksum = 256 - chksum; // sum of all hex bytes must be zero

        printf("-%02X", chksum );
//		if( crypto && (l == 0)){
//			printf(":%04X%04X", pageBuffer->checksum, myrand() );
//		}

		printf("\r\n");
	}
}

/*
 *  pageBuffer->len must be set by application (beforehand!)
 */
void IntelHex::initPageBuffer(struct pagebuffer_t * pageBuffer)
{
     //fprintf( stdout, "START IntelHex::initPageBuffer len=%i\n", pageBuffer->len);
	int i;
	for(i = 0; i < pageBuffer->len; i++){
		pageBuffer->buf[i] = 0xFF;
	}
	pageBuffer->already_printed=0;
	addressOffset =0;
}

void IntelHex::initAddresOffset()
{
    addressOffset =0;
}
/*
 * copy lineBug to pageBuffer (address determined by lineBuf)
 */
void IntelHex::fillPageBuffer(struct pagebuffer_t *pageBuffer, struct line_t *lineBuf)
{
   //  fprintf( stdout, "START IntelHex::fillPageBuffer\n");
	uint16_t dataStartIdx = DATA_IN_LINE;
	uint16_t dataEndIdx = lineBuf->rawLength - 1;

    //fprintf( stdout, "START IntelHex::fillPageBuffer 2\n" );

	uint16_t pagelen = pageBuffer->len;
	uint32_t addressB = lineBuf->addressB;
	uint16_t pgidx = addressB / pagelen;
	pageBuffer->base_address = pgidx * pagelen;

   //fprintf( stdout, "START IntelHex::fillPageBuffer addressB: %i, pgidx: %i\n",addressB, pgidx);
	uint16_t idx = addressB % pagelen;
	uint8_t i;
//   if(pgidx == 255){
//                	printf("IntelHex::fillPageBuffer---------------------%i--%i--------------\n", dataStartIdx, dataEndIdx);
//   }
	for(i = dataStartIdx; (i< dataEndIdx) && (idx < pagelen); i++){
		uint8_t value = lineBuf->rawBytes[i];

//		if(pgidx == 255 && idx > 255-32){
//                	printf("-(%i:-%02X-", idx, value);
//        }
        pageBuffer->buf[idx] = value;
        idx++;
	}

	pageBuffer->already_printed=1;
}

uint16_t IntelHex::getPageIdx(uint32_t addressB)
{
	return addressB >> PAGE_SIZE_BITS;
}

