#ifndef FILEPLAYCOMMANDER_H
#define FILEPLAYCOMMANDER_H

class VemsTuneController;
class ThreadLogPlayer;
class GeneralEvent;

#include "../toolbartools/VemsToolBarToolBase.h"
#include "../events/SliderPosEvent.h"

WX_DECLARE_STRING_HASH_MAP( VemsToolBarToolBase*, ToolHash );

class FilePlayCommander : public wxEvtHandler
{
    public:
        FilePlayCommander() {}
        FilePlayCommander( VemsTuneController* vtc );
        virtual ~FilePlayCommander();

    public:
        void    Play();
        void    Pause();
        void    Stop();
        bool    IsPlaying() const;

        void    Reset();

        void    registerTool( const wxString& toolname, VemsToolBarToolBase* tool );
        void    unregisterTool( VemsToolBarToolBase* tool );
        void    unregisterTool( const wxString& toolname );

        void    enableTools( bool enabled = true );
        void    enablePlayTool( bool enabled = true );
        void    enableStopTool( bool enabled = true );
        void    enableSpeedTool( bool enabled = true );
        void    enableRepeatTool( bool enabled = true );

        void    setStoppedBitmaps();
        void    setReplaySpeed( const unsigned char& speed );
        int     getReplaySpeed() const { return m_speed; }

        void    setRepeat( bool repeat );

    private:
        VemsTuneController*     m_vtc;
        ThreadLogPlayer*        m_logPlayer;
        ToolHash                m_tools;

        bool                    m_isPaused;
        bool                    m_repeat;
        unsigned char           m_speed;

    private:
        void    OnSliderPos( SliderPosEvent& event );
		void	OnGeneralEvent( GeneralEvent& event );

        DECLARE_EVENT_TABLE()

        DECLARE_DYNAMIC_CLASS( FilePlayCommander )
};

#endif // FILEPLAYCOMMANDER_H
