#ifndef PROJECTWIZARD_H
#define PROJECTWIZARD_H

#include <wx/wx.h>

#include "../firmwareconfigitem.h"

class SimpleFwDlg;

class ProjectWizard: public wxDialog
{
    public:
        ProjectWizard(wxWindow * parent = NULL, int id = -1, const wxString &title = _T("Create a new project...") );
        virtual ~ProjectWizard();

        wxString GetProjectPath() { return m_projectPath; };

    protected:

        void OnButton(wxCommandEvent &evt);

        void SetupFirmware();
        bool SetupAndSaveProject();

    private:

        enum{
            idBtnFwDlg,
            idBtnSaveProject,
            idBtnClose,
            idBtnSaveAndLoad

        };

        SimpleFwDlg *   m_fwDlg;
        wxTextCtrl  *   m_projectName;

        FirmwareConfigItemArray m_configItemA;

        wxString    m_projectPath;


        DECLARE_EVENT_TABLE();
};

#endif // PROJECTWIZARD_H
