#ifndef AUDIOPLAYRECORDTHREAD_H
#define AUDIOPLAYRECORDTHREAD_H

#include <portaudiocpp/StreamParameters.hxx>
#include <portaudiocpp/BlockingStream.hxx>
#include "RBConsumerBase.h"

using namespace portaudio;

class RingBuffer;
//class BlockingStream;

class AudioPlayRecordThread : public RBConsumerBase
{
    public:
        AudioPlayRecordThread(RingBuffer* outputData, SyncObj* syncObj,
            RingBuffer* inputData, SyncObj* syncObjRecord);
        virtual ~AudioPlayRecordThread();
        void * Entry();
        void setStreamParameters(const StreamParameters* streamParameters);
        //void    init(const StreamParameters& streamParameters);
        void    init();
        void    Exit();
    protected:
    private:
        RingBuffer* m_recordBuffer;
        BlockingStream* m_blockingStream;
        const StreamParameters* m_streamParameters;

        unsigned long m_framesPerBuffer;
        bool m_needsToReopen;
        SyncObj* m_syncObjRecord;

        void    writeOutput();
        void    readInput();
        void    stopStream();


};



#endif // AUDIOPLAYRECORDTHREAD_H
