#include "EcuPruducerThread.h"

#include <wx/event.h>
#include "../events/ECUEvent.h"
#include "../logger.h"

#include "../rtdatamanager/RTDataMgrFacade.h"
#include "../stdatamanager/STDataMgrBase.h"
#include "../rtdatamanager/RTDataInputBase.h"


EcuPruducerThread::EcuPruducerThread(RTDataMgrFacade* rtDataMgr, STDataMgrBase* stdataMgr, wxEvtHandler* vemsTuneEvent)
{
    //ctor
    m_rtDataMgr = rtDataMgr;
    m_stDataMgr = stdataMgr;
    m_state = -2;
    m_vemsTuneEvent = vemsTuneEvent;
}

EcuPruducerThread::~EcuPruducerThread()
{
    //dtor
}


void* EcuPruducerThread::Entry()
{
    //Logger::logf(LOG_MSG, _T("RingBufferWriterThread::Entry() start"));
    while ( true )
    {
        waitEnable();

        if(m_state == ECUEvent::CONNECTED && m_stDataMgr != NULL){
            //Logger::logf(LOG_MSG, _T("EcuPruducerThread::Entry() DO SYNC"));
            m_stDataMgr->doSync();
        }

        //Logger::logf(LOG_MSG, _T("EcuPruducerThread::Entry() start 1"));
        int result = m_rtDataMgr->updateInputModel(INPUT_TYPE_RINGBUFFER_ECU);
        //Logger::logf(LOG_MSG, _T("EcuPruducerThread::Entry() result:%i"), result);

        if(m_state != result){

            m_rtDataMgr->sendInputEvent(INPUT_TYPE_RINGBUFFER_ECU, result);
//            ECUEvent event;
//            event.state = (ECUEvent::State)result;
//            m_vemsTuneEvent->AddPendingEvent(event);
        }

        m_state = result;
        if( !((result  == ECUEvent::CONNECTED)  || (result  == ECUEvent::AIM_MODE)) ){
                wxThread::Sleep(1000);
        }

        //wxThread::Sleep(1000);
    }
}

bool EcuPruducerThread::isConnected()
{
    return (m_state == ECUEvent::CONNECTED);
}
