#include "RBProducerBase.h"

#include "RingBuffer.h"
#include "../logger.h"

RBProducerBase::RBProducerBase(RingBuffer* ringBuffer, SyncObj* syncObj)
:RBThreadBase(ringBuffer, syncObj)
{

}

RBProducerBase::~RBProducerBase()
{
    //dtor
}

/*
void RBProducerBase::setCondition(int type, wxCondition* cond)
{

}
*/

void RBProducerBase::waitRingBufferNotFull()
{
     while( m_ringBuffer->isFull()  && !m_isStoped ) {
            //Logger::logf(LOG_MSG, _T("RBProducerBase::waitRingBufferNotFull() isFull() "));
            m_isNotFull->Wait(); // signaled by writer;
            //Logger::logf(LOG_MSG, _T("RBProducerBase::waitRingBufferNotFull() isFull() released"));
    }
}



void RBProducerBase::stop()
{
    ThreadBase::stop();
    m_isNotFull->Broadcast();

    //Logger::logf(LOG_MSG, _T("RBProducerBase::stop() end"));
}
