#ifndef RINGBUFFER_H
#define RINGBUFFER_H

/*
    writer writes to getHeadPointer()
    reader processes getTailPointer(), unless isEmpty()
*/
class RingBuffer
{
    public:
        RingBuffer(int recordSize, int bufferSize);
        virtual ~RingBuffer();
        void init();
        bool isEmpty();
        bool isFull();
        char * getHeadPointer();
        char * getTailPointer();
        int  nextHead();
        int  nextTail();
        bool Write(char * src, int len);
        bool Read(char* desc, int len);

        bool Write(char * src);
        bool Read(char* desc);
        int  getBufferSize();
    protected:
    private:
         void Create(int recordSize, int bufferSize);
        int getNextIdx(int idx);
        int m_head; //0 -- m_recordSize-1
        int m_tail; //

        int m_recordSize;
        int m_bufferSize;

        char **m_buff;
};



#endif // RINGBUFFER_H
