#ifndef RTDATAINPUTBASE_H
#define RTDATAINPUTBASE_H

#include <wx/wx.h>
#include "../common/types/DoubleHash.h"
#include "../Observable.h"

class RTDataMgrBase;

enum RTDataInputType
        {
            INPUT_TYPE_NONE,
            INPUT_TYPE_ECU,
            INPUT_TYPE_FILE,
            INPUT_TYPE_RAWFILE,
            INPUT_TYPE_RINGBUFFER,
            INPUT_TYPE_RINGBUFFER_NONE,
            INPUT_TYPE_RINGBUFFER_ECU,
            INPUT_TYPE_RINGBUFFER_RAWFILE,
            INPUT_TYPE_RINGBUFFER_XLSFILE,
            INPUT_TYPE_GPS,
            INPUT_TYPE_AIM,
            INPUT_TYPE_SIGNALGEN,
            INPUT_TYPE_SIPR
        };

class RTDataInputBase: public Observable
{
    public:
        RTDataInputBase();
        virtual ~RTDataInputBase();

        virtual void refreshDependency() = 0;

        virtual int updateViewerModel() = 0;
        virtual int updateInputModel() = 0;
        virtual double getValue(const wxString& symbolname) =0;
        virtual bool isExist(const wxString&  symbolname) =0;
        virtual bool isValid() =0;
        virtual RTDataInputType getType() =0;
        void setViewerModel(DoubleHash* table){ m_RegisteredSymbolTable = table; }
        virtual void reset() = 0;
        void setMgr(RTDataMgrBase* rtDataMgrBase);
        void setActive(bool a){m_isActive = a;}
        bool isActive(){return m_isActive;}
    protected:
        DoubleHash* m_RegisteredSymbolTable;
        RTDataMgrBase* m_rtDataMgrBase; /// TODO: remove
    private:
        bool m_isActive;



};



#endif // RTDATAINPUTBASE_H
