#ifndef RTDATAINPUTRAWLOG_H
#define RTDATAINPUTRAWLOG_H

#include "RTDataRawInputBase.h"
#include <wx/file.h>

#define HEADERBLOCKSIZE 512

class RTDataInputRawLog: public RTDataRawInputBase
{
    public:
        RTDataInputRawLog( SymbolMgr* mt, DoubleHash* viewerModel = NULL );
        virtual ~RTDataInputRawLog();

        bool SetInputFile(const wxString &filename);
        int ParseHeader();

        RTDataInputType getType();
        int updateViewerModel();
        int updateInputModel();
        bool isExist(const wxString& symbolname);
        bool isValid();

        unsigned int GetFilePos();
        unsigned int GetFileSize();

        void reset();
        long getRTDataPerBlock();
        wxString getHeaderValue(const wxString& key) const;
    protected:
    private:
        StringHash  m_headerHash;
        wxFile      m_rawFile;
        wxString    m_fileName;

        char    m_headerBuffer[HEADERBLOCKSIZE];
        char*   m_blockBuffer;
        uint8_t*   m_dataBuffer; //realtime data + gps data

        long    m_gpsDataLength;
        int     m_gpsBlockIdx;
        long    m_datalen;
        long    m_blocksize;
        int     m_blockIdx;
        long    m_RTDataPerBlock;

        bool m_isValid;

};



#endif // RTDATAINPUTRAWLOG_H
