#include "RTDataInputRingBufferAim.h"


#include "../logger.h"
#include "../vemsprotocol.h"
#include "../ringbuffer/SyncObj.h"
#include "../SerialException.h"

RTDataInputRingBufferAim::RTDataInputRingBufferAim(RingBuffer * rb, MTConfigData * mt, SyncObj* syncObj,
    VemsProtocol* vp)
: RTDataInputRingBufferSync(rb, mt,  syncObj)
{
    //ctor
    m_vp = vp;
}

RTDataInputRingBufferAim::~RTDataInputRingBufferAim()
{
    //dtor
}

RTDataInputType RTDataInputRingBufferAim::getType()
{
    return INPUT_TYPE_AIM;
}

int RTDataInputRingBufferAim::updateInputModel()
{
    //Logger::log(LOG_MSG, _T("RTDataInputRingBufferAim::updateInputModel() start"));
    //return ECU_NOT_CONNECTED;

    int state = getData();
    if(state != m_state){
        Logger::logf(LOG_MSG, _T("RTDataInputRingBufferAim::Entry() updateInputModel() state=%i"), state);
    }
    m_state = state;
    return m_state;
}

int RTDataInputRingBufferAim::getData()
{
 //m_buff;
   //Logger::logf(LOG_MSG, _T("RTDataInputRingBufferAim::Entry() getData()"));
    char* m_buff = m_ringBuffer->getHeadPointer(); // not increment the ringbuffer head index


 //Logger::logf(LOG_MSG, _T("RTDataInputRingBufferAim::Entry() writeRingBuffer() 1"));
 //    bool connected = (m_state == ECUEvent::CONNECTED);
    int res =-1;
    try{
        //Logger::logMilli(LOG_MSG,_T("RTDataInputRingBufferAim::getRtData() serialRead START"));
        res=  m_vp->getAimData(m_buff);

        //Logger::logMilli(LOG_MSG,_T("RTDataInputRingBufferAim::getRtData() serialRead END"));
    }catch (SerialException& se){
       // Logger::logf(LOG_MSG, _T("RTDataInputRingBufferAim::Entry() writeRingBuffer() SerialException"));
        //Thread::Sleep(1000);
        //Logger::logMilli(LOG_MSG,_T("RTDataInputRingBufferAim::getRtData() serialRead END exception"));
        return AIMEvent::NOT_CONNECTED;
    }catch (...){
       // Logger::logf(LOG_MSG, _T("RTDataInputRingBufferAim::Entry() writeRingBuffer() Unknown Exception"));
    }

    if(res == AIMEvent::CONNECTED && isActive() && !m_ringBuffer->isFull()){
        m_ringBuffer->nextHead();
        char* tmp = m_ringBuffer->getHeadPointer();
        memcpy(tmp, m_buff, 32);
        m_isNotEmpty->Broadcast();
    }
    return res;
}

