#ifndef RTDATAINPUTRINGBUFFERECU_H
#define RTDATAINPUTRINGBUFFERECU_H

#include "RTDataInputRingBufferSync.h"
#include "../events/ECUEvent.h"

class VemsProtocol;
class SyncObj;
class RTDataRawLogger;
class GPSData;

class RTDataInputRingBufferEcu : public RTDataInputRingBufferSync
{
    public:
        RTDataInputRingBufferEcu(RingBuffer * rb, SymbolMgr * mt, SyncObj* syncObj,
            VemsProtocol* vp, RTDataRawLogger* rtDataRawLogger, GPSData* gps,  DoubleHash* viewerModel = NULL );
        virtual ~RTDataInputRingBufferEcu();
        RTDataInputType getType();
        int updateInputModel();
    protected:
    private:
        //bool readFirmwareInfo(uint8_t trycount, bool force);
        void writeHeader();

        char m_RTBuff[256];
        ECUEvent::State getRtData();
        ECUEvent::State m_state;

        VemsProtocol* m_vp;
        RTDataRawLogger* m_rtDataRawLogger;

        int m_RTLen;
        GPSData* m_gpsData;
};



#endif // RTDATAINPUTRINGBUFFERECU_H
