#ifndef RTDATAINPUTSIPR_H
#define RTDATAINPUTSIPR_H

#include "RTDataInputBase.h"


class RT2ViewerConverter;
class SymbolMgr;
class DoubleHash;
class SIPRPacket;

class RTDataInputSIPR : public RTDataInputBase
{
    public:
                    RTDataInputSIPR( SymbolMgr* symbolManager, DoubleHash* viewerModel = NULL );
        virtual     ~RTDataInputSIPR();

        void refreshDependency();
        void convert(const SIPRPacket& packet);
        void convert(uint8_t* buff, int size);

        ///RTDataInputBase virtual methods
        int         updateViewerModel();
        double      getValue(const wxString& symbolname);
        int         updateInputModel() {return 0;}
        bool        isExist(const wxString& symbolname) {return true;}
        bool        isValid() {return true;}
        void        reset();
        RTDataInputType getType() { return INPUT_TYPE_SIPR; }
    protected:
    private:
        RT2ViewerConverter* m_converter;
};

#endif // RTDATAINPUTSIPR_H
