#ifndef RTDATARAWINPUTBASE_H
#define RTDATARAWINPUTBASE_H

#include "../SymbolMgr.h"
#include "RTDataInputBase.h"
#include "../expression/RPNParser.h"
#include "../expression/VariableData.h"

class SymbolMgr;

class RTDataRawInputBase : public RTDataInputBase
{
    public:
        RTDataRawInputBase(SymbolMgr* mt, DoubleHash* viewerModel = NULL ); //NULL = use internal viewer model
        virtual ~RTDataRawInputBase();

        void refreshDependency();

        void setRTDataBuffer( uint8_t* buff, int size );

        void printViewerModel();
    protected:
        uint8_t*        m_rtDataBuffer;     //external buffer for raw ecu data
        int             m_rtDataBufferSize;
        SymbolMgr*      m_symbolMgr;

        virtual void fillSymbolValues(int type = -1);
        double  getValue(const wxString& symbolname);

    private:
        VariableDataDH  m_variableData;     //DoubleHash variable data for m_rpn
        DoubleHash*     m_viewerModel;      //internal or external contanier for viewer data
        RPNParser       m_rpn;              //rpn calculator for expression symbols
        bool            m_hasInternalModel;

        void    fillScalarValues();
        void    fillScalarValues(int inputType);

        int     getValue(int size, int offset);
        double  getValue(int size, int offset, double scale, double translate);

        void fillGraphNodeSet(GraphNodeSet& nodes);
        void fillCalculatedValues(GraphNodeSetArray* levelA);
        void fillRegisteredSymbolTable();
};



#endif // RTDATARAWINPUTBASE_H
