#ifndef RTSYMBOLVIEWER_H
#define RTSYMBOLVIEWER_H


#include "RTDataViewerBase.h"


class SymbolMgr;


class RTSymbolViewer : public RTDataViewerBase
{
    public:
        RTSymbolViewer( const wxString& symbolName, SymbolMgr* symbolManager );
        virtual ~RTSymbolViewer();

        void refresh( DoubleHash* table );
        void require();
        void unregisterSymbols();
        void SetValueIdx( int idx ) {}
        void SetValue( double value ) {}

        bool isValid() const { return m_isSymbolValid; }
        bool isUpdated() const { return m_isSymbolUpdated; }
        double getLastValue() const { return m_symbolValue; }
        void configUpdated();

    private:
        SymbolMgr*          m_symbolManager;
        wxString            m_symbolName;
        double              m_symbolValue;
        bool                m_isSymbolRegistered;
        bool                m_isSymbolValid;
        bool                m_isSymbolUpdated;

        bool isSymbolValid();
};

#endif // RTSYMBOLVIEWER_H
