#ifndef MMCLOGGEREXTOVERVIEWFRAME_H
#define MMCLOGGEREXTOVERVIEWFRAME_H

#include <wx/wx.h>
#include <wx/grid.h>
#include "../FirmwareInfo.h"
#include "../Observable.h"
#include "../ObserverBase.h"
#include "../ProgressBar.h"
#include "MMCLoggerViewerBase.h"

class MMCLoggerManager;



WX_DECLARE_HASH_MAP( size_t, MMCFilesDesc, wxIntegerHash, wxIntegerEqual, MMCFilesDescHash);

class MMCLoggerExtOverviewFrame: public wxDialog, public Observable, public ObserverBase, public MMCLoggerViewerBase
{
    public:
        MMCLoggerExtOverviewFrame(wxWindow* parent, int id = wxID_ANY, const wxPoint &pos = wxDefaultPosition, const wxSize &size = wxDefaultSize);
        virtual ~MMCLoggerExtOverviewFrame();
        void OnClose(wxCloseEvent &evt);


        void SetMMCLoggerManager( MMCLoggerManager * mgr ) { m_mmcLoggerMgr = mgr; };
        void AddFileListLine(MMCFilesDesc &fdesc);
        void AddGridLine(DoubleHash& dHash){};

        void SaveSelectedFiles();

        void SetExtOvId(int id) { m_extOvId = id; };

        virtual void notify( int i );
        virtual void notify(int i, int idx);
        virtual void notify(const wxString& str);
        virtual void Init(const wxString& name, const wxString& msg, const int max) {};

    protected:

        void PutSummary(MMCFilesDesc &fdesc);

    private:
        enum {
            idFileListGrid,
            idSummaryGrid,
            idSaveButton,
            idFileListBox,
            idGetSummaryButt,
            idSelectAllButton,
            idCancelButton,
            idMMCCloseButton
        };

        bool  m_isAllSelected;
        bool  m_isCancelled;

        void OnCellLeftClick(wxGridEvent &evt);
        void OnButton(wxCommandEvent &evt);
        void OnListBoxClick(wxCommandEvent &evt);
        void OnCancelButton(wxCommandEvent& evt);

        MMCLoggerManager  *m_mmcLoggerMgr;

        //wxGrid    * m_fileListGrid;

        wxGrid    * m_summaryGrid;

        wxBoxSizer * m_mainsizer;

        MMCFilesDescHash m_fileDataDescHash;

        wxCheckListBox  *   m_fileListBox;

        wxTextCtrl  *   m_sampleCntCtrl;
        ProgressBar *   m_summaryProgress;

        ProgressBar*    m_overallProgress;
        ProgressBar*    m_logProgress;

        wxButton*       m_summbutt;
        wxButton*       m_selallbutton;
        wxButton*       m_saveselbutton;
        wxButton*       m_closeButton;

        size_t          m_numselected;
        size_t          m_timeAll;
        size_t          m_timeCtr;
        size_t          m_counter;
        int             m_currentId;

        void            enableButtons( bool enable = true );


      // MMCLogger * m_mmcLog;

        int m_extOvId;

        DECLARE_EVENT_TABLE();
};

#endif // MMCLOGGEREXTOVERVIEWFRAME_H
