#include "SdLogSelector.h"

int idSD_V3       = wxNewId();
int idSD_ImgFile  = wxNewId();
int idSD_CardReader = wxNewId();

BEGIN_EVENT_TABLE( SdLogSelector, wxDialog )
    EVT_BUTTON( idSD_CardReader, SdLogSelector::OnButton )
    EVT_BUTTON( idSD_ImgFile, SdLogSelector::OnButton )
    EVT_BUTTON( idSD_V3, SdLogSelector::OnButton )
    EVT_BUTTON( wxID_CANCEL, SdLogSelector::OnButton )
END_EVENT_TABLE()

SdLogSelector::SdLogSelector(wxWindow* parent) :
    wxDialog( parent, -1, _T("MMC Card Overview"), wxDefaultPosition, wxDefaultSize, wxDEFAULT_DIALOG_STYLE)
{

    wxBoxSizer* mainsizer = new wxBoxSizer( wxVERTICAL );

    wxStaticBoxSizer* ssizer = new wxStaticBoxSizer( wxHORIZONTAL, this, _T("Select source for SD Log"));

    wxButton* b_v3 = new wxButton( this, idSD_V3, _T("V3"));
    wxButton* b_img = new wxButton( this, idSD_ImgFile, _T("Image file"));
    wxButton* b_card = new wxButton( this, idSD_CardReader, _T("SD Card Reader"));

    ssizer->Add( b_v3, 0, wxEXPAND | wxALL, 5 );
    ssizer->Add( b_img, 0, wxEXPAND | wxALL, 5 );
    ssizer->Add( b_card, 0, wxEXPAND | wxALL, 5 );

    wxSizer* bsizer = CreateButtonSizer( wxCANCEL );

    mainsizer->Add( ssizer, 0, wxALL | wxEXPAND | wxALIGN_CENTER, 0 );
    mainsizer->Add( bsizer, 0, wxALL | wxEXPAND, 5 );

    SetSizer( mainsizer );
    mainsizer->Fit( this );
    mainsizer->SetSizeHints( this );
}

SD_LOG_SOURCE SdLogSelector::GetSource()
{
    return m_source;
}

SdLogSelector::~SdLogSelector()
{
}

void SdLogSelector::OnButton( wxCommandEvent& event )
{
    int id = event.GetId();

    m_source = SD_S_Cancel;
    if ( id == idSD_V3 ) { m_source = SD_S_V3; }
    if ( id == idSD_ImgFile ) { m_source = SD_S_IMG; }
    if ( id == idSD_CardReader ) { m_source = SD_S_DD; }

    EndModal( m_source );
}
