#include "serialhelper.h"

#include <wx/wx.h>

#include "serialporthandler.h"
#include "serialconfig.h"

#ifdef SFILE_LIB
    #include "vemsprotocol/SerialPortHandlerSFile.h"
#endif
    #include "vemsprotocol/SerialPortHandlerCTB.h"

#include "configmanager/ConfigHelper2.h"
#include "configmanager/SerialConfigMgr.h"
#include "ConfigBase.h"


#include "logger.h"

#if !defined (__WINCE_STANDARDSDK__)
#endif

CommunicationBase* SerialHelper::m_ECUComm = NULL;
CommunicationBase* SerialHelper::m_GPSComm = NULL;

SerialConfig* SerialHelper::m_serialConfigECU = NULL;
SerialConfig* SerialHelper::m_serialConfigGPS = NULL;

SerialHelper::SerialHelper()
{
    //ctor
}


SerialHelper::~SerialHelper()
{
    //dtor
}


CommunicationBase * SerialHelper::getECUCommCTB()
{
    ConfigBase* mainCfg = ConfigHelper2::getConfig();
     Logger::log(LOG_MSG,_T("SerialHelper::getECUCommCTB() START 10"));
    if(m_ECUComm == NULL){
        //SerialConfig * serialConfig = ConfigHelper::setECUSerialConfig();
        SerialConfigMgr scm(mainCfg, _T("/") );
        m_serialConfigECU = new SerialConfig();
        scm.load(m_serialConfigECU);
        //m_ECUComm = new SerialPortHandler(m_serialConfigECU);
        m_ECUComm = new SerialPortHandlerCTB(m_serialConfigECU);
    }
     Logger::log(LOG_MSG,_T("SerialHelper::getECUCommCTB() START 70"));
    return m_ECUComm;
}

CommunicationBase * SerialHelper::getECUComm()
{
    ConfigBase* mainCfg = ConfigHelper2::getConfig();
     Logger::log(LOG_MSG,_T("SerialHelper::getECUComm() START 10"));
    if(m_ECUComm == NULL){
        //SerialConfig * serialConfig = ConfigHelper::setECUSerialConfig();
        SerialConfigMgr scm(mainCfg, _T("/") );
        m_serialConfigECU = new SerialConfig();
        scm.load(m_serialConfigECU);

        //m_ECUComm = new SerialPortHandler(m_serialConfigECU);
#ifdef SFILE_LIB
        m_ECUComm = new SerialPortHandlerSFile(m_serialConfigECU);
#else
        m_ECUComm = new SerialPortHandlerCTB(m_serialConfigECU);
#endif
    }
     Logger::log(LOG_MSG,_T("SerialHelper::getECUComm() START 70"));
    return m_ECUComm;
}

CommunicationBase * SerialHelper::getGPSComm()
{
    ConfigBase* mainCfg = ConfigHelper2::getConfig();
    if(m_GPSComm == NULL){
        //SerialConfig * serialConfig = ConfigHelper::setECUSerialConfig();
        SerialConfigMgr scm(mainCfg, _T("/gps") );
        m_serialConfigGPS = new SerialConfig();
        scm.load(m_serialConfigGPS);
        m_GPSComm = new SerialPortHandler(m_serialConfigGPS);
    }
    return m_GPSComm;
}

void SerialHelper::setECUPort(const wxString& comPort)
{
    ConfigBase* mainCfg = ConfigHelper2::getConfig();
    if ( comPort == wxEmptyString ) return;

    m_serialConfigECU->setPortName(comPort);
    mainCfg->save();
}

void SerialHelper::setGPSPort(const wxString& comPort)
{
    ConfigBase* mainCfg = ConfigHelper2::getConfig();
    if ( comPort == wxEmptyString ) return;

    m_serialConfigGPS->setPortName(comPort);
    mainCfg->save();
}


