#include "AudioThread.h"
//#include "FullDuplexTest.h"
#include "../logger.h"
#include "../ringbuffer/SyncObj.h"
#include "../ringbuffer/RingBuffer.h"

AudioThread::AudioThread( RingBuffer *rbp, SyncObj* syncObj )
{
    m_ringBuffer = rbp;
    m_syncObj = syncObj;
    m_recordFlag = false;
    m_recordFlag = 0;
}

AudioThread::~AudioThread()
{
    //dtor
}

/**
 * Since this flag is only written from main(),
 * and only observed from AudioThread, mutex should not be necessary.
 * wx widget updating seems to work while audio is recorded. Nice.
 */
void AudioThread::setRecordFlag(uint8_t flag)
{
    m_recordFlag = flag;
}

void AudioThread::setAudioDevice(int audioDevice)
{
    m_audioDevice = audioDevice;
}

void AudioThread::setRTDataMgrBase( RTDataMgrBase *rtDataMgr)
{
    m_rtDataMgr = rtDataMgr;
    m_recordFlag = 0; // no recording until signalled
}

void* AudioThread::Entry()
{
    while(1){
        if( m_recordFlag ){
            // main just called setRecordFlag( 1 );
            // this should only block this thread. Why does wx widget updating block ??
            startRecording();
            //sineTest();
        }
        wxThread::Sleep(400);
    }
}

void AudioThread::startRecording()
{
//    FullDuplexTest * fullDuplex = new FullDuplexTest( m_ringBuffer, m_audioDevice, m_syncObj);
//    fullDuplex->initBuffer();
   // fullDuplex->init();
    //fullDuplex->fullDuplexTest();
    //delete fullDuplex;
    //m_recordFlag = 0; // we've done our task
}

void AudioThread::sineTest()
{
/*     m_sineTest = new SineTest(FRAMES_PER_BUFFER, SAMPLE_RATE);
    m_sineTest->setFrequency(1000);
    Logger::logf(LOG_MSG, _T("AudioTheread::sineTest() start") );
    int i;

    for( i=0; i<(RECORD_SECONDS*SAMPLE_RATE)/FRAMES_PER_BUFFER; ++i ){
        short *bufOut = (short *) m_sineTest->generate();

        ////////// EMULATE SOUND IO () /////////

         if( m_ringBuffer->isFull() ){
             wxThread::Sleep(1);
         }else{
            short * bufIn = (short*) m_ringBuffer->getHeadPointer();
            memcpy(bufIn, bufOut, 4 *FRAMES_PER_BUFFER);
            m_ringBuffer->nextHead();
            uint32_t milli = FRAMES_PER_BUFFER*1000/SAMPLE_RATE;
            wxThread::Sleep(milli);
        }
    }

     Logger::logf(LOG_MSG, _T("AudioTheread::sineTest() end") );
     delete m_sineTest;
     m_recordFlag = 0;
*/
}
