#include <iostream>
#include <wx/math.h>
#include "../logger.h"
#include "Histogram.h"
//#include "../vemsgauge/VemsGridWidget.h"
#define DOUBLE_PI M_PI*2


Histogram::Histogram()
:m_maxRate(1)
,m_idx(0)
{
    //ctor
}

Histogram::~Histogram()
{
    //dtor
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
/*print modell array*/
void Histogram::printModell()
{

        /*int n = 0;
        for(n = 0 ; n < 256 ; n++){
            printf("idx = %3d modell = %d  \n",n,m_modell_array[n]); // (2D vs 1D)???
        }*/
}
////////////////////////////////////////////////////////////////////////////////////////////////////////
/*print modell array*/
void Histogram::printHisztogram()
{

        int counter1 = 0;
        int counter2 = 0;
        for(counter1 = 0 ; counter1 < 256 ; counter1++){
            for(counter2 = 0; counter2 <720;counter2++ ){
                printf("amplitudeidx = %3d sparkidx =%3d =hisztogram = %d  \n",counter1,counter2,m_hisztogram_array[counter1][counter2]);
            }
        }
}

/** =============
*  insert current amplitude in right place of histogram: [x][y]
*/
uint16_t Histogram::putInHistogram(uint16_t x,uint16_t y)
{
   if( x >= AMPLIDUDE_BINS ){ // reached max amplitude
        x = AMPLIDUDE_BINS - 1;
    }
   if(y >= SPARKPHASE_BINS){
        y = SPARKPHASE_BINS -1;
   }
   uint16_t h = m_hisztogram_array[x][y];
   h = (h == 0xFFFF) ? 0xFFFF : h + 1; // prevent overflow
   m_hisztogram_array[x][y] = h;
   if( h > m_maxRate ){ // the max of all (for color)
        m_maxRate = h;
   }
   return x;
}
void Histogram::saveAmplitudeSums(uint16_t amplitude)
{
        //m_amplitudesum[(amplitude>>7)][1] += amplitude;
        amplitudevalues[( amplitude >>7 )].summation += amplitude;
        amplitudevalues[( amplitude >>7 )].sumofpower += amplitude*amplitude;
}
////////////////////////////////////////////////////////////////////////////////////////////////////////
/*put five half sinus period  in modell array*/
void Histogram::setModell(uint16_t amplitude)
{
    int counter = 0;
    int counter2 = 5; // number of place where put sinus
    int period = 6; // how many bin fill in around idx
    int idx = amplitude;

    for( counter = 0 ; counter < 256 ; counter++ ){
            // +2*pi (period of cos) for idx += 20
            m_modell_array[counter][0] = 0;
    }

    counter = 0;
    for( ; counter2 !=0 ; counter2--){
            idx /= (counter2 + 2);
            m_modell_array[idx][0] = (int)(( cos(0.0) + 1 ) * 100);
            for( counter=1 ; counter < period/2  ; counter++ ){
                    // +2*pi (period of cos) for idx += 20
                    m_modell_array[idx-counter][0] = (int)(( cos(counter * DOUBLE_PI /  period) + 1 ) * 100);
                    m_modell_array[idx+counter][0] = (int)(( cos(counter * DOUBLE_PI /  period) + 1 ) * 100);
            }
            idx = amplitude;
    }
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
/*multiply n. elem of hisztogra array and  n. elem of modell array and add to pruduct*/
double Histogram::konvulucio()
{
    int n = 0;
    double sum2 =0;

    for( n = 0 ; n < 256 ; n++ ){

        sum2 +=( m_hisztogram_array[n][0] * m_modell_array[n][0] );

        }

    return sum2;
}
void Histogram::loadHistogram(void)
{
      Logger::logf(LOG_MSG, _T("---------------------------------Histogram::load"));

    int counter1 = 0;
    int counter2 =0;
    for(counter1 = 0 ;counter1 < 5 ; counter1++){
            for(counter2 = 0 ; counter2 < 5 ; counter2++){
                     m_hisztogram_array[counter1][counter2] = 10;

        }
    }



}

void Histogram::printPacked(void)
{
    //Logger::logf(LOG_MSG, _T("---------------------------------Histogram::printPacked()"));

    int counter1 = 0;
    int counter2 = 0;
    int samp = 0;
    int sspark = 0;
    bool flag =0;
    int h2 = 0;


    for(counter1 = 0 ;counter1 < AMPLIDUDE_BINS ; counter1++){
            for(counter2 = 0 ; counter2 < SPARKPHASE_BINS ; counter2++){
                     int h1 = m_hisztogram_array[counter1][counter2];
                     if( (counter2 + 1) == SPARKPHASE_BINS ){
                            h2 = m_hisztogram_array[counter1+1][0];
                     }else{
                            h2 = m_hisztogram_array[counter1][counter2+1];

                     }
                     if( (h1 == 0) && (h2 == 0) ){ //if 2 next bins values == 0
                         if(flag == 0){
                            samp = counter1;
                            sspark = counter2;
                            flag = 1;
                    }
                    }else{
                            if(flag == 1 ){
        //                        printf("-----------------------------start(amp%d-spark%d) end(amp%d -spark%d) ... \n",samp,sspark,counter1,counter2);
                                flag =0;
                            }
                            if( h1 > 0 ){

      //                         printf("-----------------------------amplitude= %3d spark = %3d value = %d\n",counter1,counter2,m_hisztogram_array[counter1][counter2]);

                            }
                        }
        }
    }
    // Logger::logf(LOG_MSG, _T("---------------------------------Histogram::printPacked() END"));
}
void Histogram::saveSparkphase(uint16_t sparkphase)
{

    sparkringbuffer[m_idx] = sparkphase;
    m_idx++;
    if(m_idx == 255){
    m_idx = 0;
    }

}
