#ifndef GRIDBYTIME_H
#define GRIDBYTIME_H

#include "RTSignalViewerBase.h"
#include <wx/wx.h>
#include <wx/grid.h>
#include "../../common/types/DoubleHashArray.h"
#define  TIMECOL 0;
#define  SPARKCOL 1;
#define  RPMCOL 2;
#define  DWELLCOL 3;

//WX_DEFINE_ARRAY(DoubleHash*,DoubleHashArray);
class UpdateViewerEvent;

class GridByTime: public wxFrame, public RTSignalViewerBase
{
    public:
        GridByTime(wxWindow* parent, wxWindowID id,const wxString &title, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxDEFAULT_FRAME_STYLE, const wxString& name = wxPanelNameStr);
        virtual ~GridByTime();
        virtual void refresh(DoubleHash* table);

        int updateInputModel();
        void sendInputEvent(int type, int inputEvent);
        bool   isExist(const wxString& symbolname);
    protected:

        int updateViewerModel();
        double getValue(const wxString& symbolname);
    // DECLARE_EVENT_TABLE();
    private:

        void OnUpdateValue( UpdateViewerEvent& event );

        static const long  idScrollBar;

        void storeData(DoubleHash *table);
        void scrollGrid(wxScrollEvent& event);
        void refreshGrid();
        void refreshGridEvent();
        DoubleHashArray dataDoubleHashArray;
        wxGrid* m_grid;
        wxScrollBar* scrollBar;
        unsigned int rowCnt;
        int sparkPhaseOld;
        DECLARE_EVENT_TABLE();
};



#endif // GRIDBYTIME_H
