#ifndef TIMINGTESTER_H
#define TIMINGTESTER_H

#include "../common/types/Int2IntHash.h"

typedef unsigned short uint16_t;
typedef unsigned char uint8_t;

enum CHANNEL {LEFT=0, RIGHT};
enum CHANNEL_STATE {LOW=0, HIGH};

//WX_DEFINE_ARRAY_INT(int, IntArray);
//WX_DECLARE_HASH_MAP( int, int, wxIntegerHash, wxIntegerEqual, Int2IntHash);

class TimingTester
{
    public:
        TimingTester();
        virtual ~TimingTester();
        int processSamples( char* buf, int samplesleft, int channel, int currSampleIdx);
        void init();
        uint16_t getSample(char * buf, int index, int channel);
        long getRisingEdge(char *buf, long absidx, int sampleCnt, int channel);
        long getFallingEdge(char *buf, long absidx, int sampleCnt, int channel);
    protected:
        int m_wavOffset;
        int m_channelcount;
        int m_samplesize;
        double m_sampleTime;
    private:

        Int2IntHash channelState;
        Int2IntHash channelLowThr;
        Int2IntHash channelHighThr;
        Int2IntHash channelHighCnt;
        Int2IntHash channelLowCnt;

        Int2IntHash risingEdgeIndex;
        Int2IntHash fallingEdgeIndex;

        Int2IntHash remainedSampleIdx;
        // 60 / freq of the ref channel
        long rpm_period;
        int rpm;
};

#endif // TIMINGTESTER_H
