#ifndef STDATAIOMSQ_H
#define STDATAIOMSQ_H

#include "../common/types/Int2StringHash.h"
#include "../common/types/StringSet.h"
#include <wx/xml/xml.h>
#include <wx/wx.h>

class SymbolMgr;
class SymbolArray;
class SIPRDescriptor;
class Int2SymbolArrayHash;
class STDataModelBase;


class STDataIOMSQ
{
    public:
        STDataIOMSQ(SymbolMgr* symbolMgr, const SIPRDescriptor*  siprDesc, const wxArrayString& files_in);
        virtual ~STDataIOMSQ();

        void setModel( STDataModelBase* model ) { m_model = model; }
        void writeAllData();

    private:
        STDataModelBase*            m_model;
        SymbolMgr*                  m_symbolMgr;
        const SIPRDescriptor*       m_siprDesc;
        wxArrayString               m_filesArray;
        Int2StringHash              m_symbolOrder;
        wxXmlDocument*              m_XmlDocument;
        const Int2SymbolArrayHash* m_page2SymbolArrayHash;
        StringSet                  m_neededSymbols;

        wxString    getSymbolValue(wxString type, int rowSize,int colSize,const wxString& Symbolname);
        void        makeSybolNodes(SymbolArray* symbolArray,wxXmlNode* pageNode);
        void        makeSybolValueNodes(wxXmlNode* symbolNode);
        void        makeXmlStructure(const wxString& filname);
};


#endif // STDATAIOMSQ_H
