#include "STDataIOSIPR.h"
#include "../vemsprotocol/CommandRequestBase.h"
#include "../vemsprotocol/VemsCommand.h"


STDataIOSIPR::STDataIOSIPR( CommandRequestBase* requestBase, SymbolTable* symbolTable )
{
    m_pRequestBase  = requestBase;
    m_pSymbolTable  = symbolTable;
}

void STDataIOSIPR::burnData()
{
    m_pRequestBase->request( new BurnCommand() );
}

void STDataIOSIPR::readAllData()
{
    m_pRequestBase->request( new ReadAllPageCommand() );
}

void STDataIOSIPR::write( size_t page, size_t offset, uint8_t data )
{
    m_pRequestBase->request( new WritePageCommand( page, offset, data ) );
}

void STDataIOSIPR::read( int page )
{
   m_pRequestBase->request( new ReadPageCommand( page ) );
}
