#ifndef STDATAVIEWERBASE_H
#define STDATAVIEWERBASE_H


#include <wx/dynarray.h>
#include <wx/list.h>
#include <wx/wx.h>

#include "../Symbol.h"


class STDataMgrBase;


class STDataViewerBase
{
    public:
        STDataViewerBase() {}
        virtual ~STDataViewerBase() {}

        /// invoked in MgrBase
        void SetDataMgr( STDataMgrBase* mgr );
        void unregisterViewer();

        /// MgrBase invoke when the data has been updated
        virtual void update() = 0;
        virtual void updateTable( const wxString& tableName, wxPoint cursorPosition ) {}

        /// controller
        virtual void requestRead() = 0;
        virtual void updateModel() = 0;
        virtual void requestWrite() = 0;

        /// utility
        virtual wxString toString() { return _T("STDataViewerBase"); }
        virtual SymbolArray getSymbols();

    protected:
        STDataMgrBase*      m_stDataMgr;        /// do not delete it in desctructor
};


WX_DEFINE_ARRAY( STDataViewerBase*, STDataViewerBaseA );
//WX_DECLARE_LIST( STDataViewerBase, STDataViewerBaseList );                  //store pointers
WX_DECLARE_HASH_SET( STDataViewerBase*, wxPointerHash, wxPointerEqual, STDataViewerBaseSet );

WX_DECLARE_STRING_HASH_MAP(STDataViewerBase*, STDataViewerBaseHash );


#endif // STDATAVIEWERBASE_H
