#include "STDataViewerHash.h"
#include "STDataMgrBase.h"
#include "../logger.h"
#include "../Math.h"


STDataViewerHash::STDataViewerHash( DoubleHash* rtViewerModel )
{
    m_rtViewerModel = rtViewerModel;
}


void STDataViewerHash::update()
{
    double viewerData = m_stDataMgr->getDataFromViewerModel( m_symbol, 0, 0 );

    if(m_symbol.isBits()){
        uint32_t bitValue = getBitValue( (uint32_t) viewerData );
        (*m_rtViewerModel)[ m_symbol.getName() ] = (double) bitValue;
    }else{
        (*m_rtViewerModel)[ m_symbol.getName() ] = viewerData;
    }
}

uint32_t STDataViewerHash::getBitValue(uint32_t value)
{
    wxString name = m_symbol.getName();
    uint32_t bitLow = m_symbol.getBitLo();
    if(bitLow > 0){
        value  = value >> bitLow;
    }
    uint32_t bitHigh = m_symbol.getBitHi();
    uint32_t bitCount = bitHigh - bitLow+1;
    uint32_t mask = Math::powInt(2, bitCount)-1;

    uint32_t bitValue = (value & mask) + m_symbol.getBitOfs();

    return bitValue;
}

wxString STDataViewerHash::toString()
{
    return _T("STDataViewerHash - symbol: ") + m_symbol.getName();
}
