#include "tablefunction.h"
#include <wx/textfile.h>
#include <wx/tokenzr.h>

#include "logger.h"
#include "DirHelper.h"
#include <wx/log.h>

TableHash TableFunction::tables;

TableFunction::TableFunction()
{
    //ctor
}

TableFunction::~TableFunction()
{
    //dtor
}

FunctionBase* TableFunction::Create()
{
    return new TableFunction();
}

double TableFunction::exec()
{
    if( m_doubleArray.Count() != 1 && m_stringArray.Count() != 1){
        wxLogError(_T("parameter error!"));
        return -1; //need exception
    }

    wxString    name = m_stringArray[0];
    //double      key = m_doubleArray[0];
    int         key = (int)m_doubleArray[0];

    //Logger::logf(LOG_MSG, _T("TableFunction::exec file name: ") + name + _T(", Key: %f"), key );

    if(tables.find(name) == tables.end()){
        if(!doRead(name)){
            wxLogError(_T("file read error!"));
            return -1; //need exception
        }; //need exception
    }

    return get(name,key); //need exceptin
}


bool TableFunction::doRead(const wxString& fileName)
{
    const wxString dir = _T("resources");
    wxTextFile file;

    if (!file.Open(DirHelper::GetPath(dCONFIG) + fileName, wxConvLibc)){
        return false; //FC_CANNOT_OPEN_FILE; need exception?
    }

    wxString    line = file.GetFirstLine();
    bool        firstline = true;

    DoubleArray* da = new DoubleArray();

    do{
        if (firstline){
            firstline = false;
        }else{
            line = file.GetNextLine();
        }

        line.Trim(false);
        if(line[0] == _T(';')) continue;

        wxArrayString as = parseLine(line);

        if(as.GetCount() == 4){
            double d = -1;
            as[1].ToDouble(&d);
            da->Add(d);
        }

    }while(!file.Eof());

    tables[fileName] = da;

    return true; //FC_OK;
}

wxArrayString TableFunction::parseLine(const wxString& line)
{
    wxStringTokenizer   tkz(line, _T(" ;\t"), wxTOKEN_STRTOK);
    wxArrayString       tokens;

    while(tkz.HasMoreTokens()){
        tokens.Add(tkz.GetNextToken());
    }

    return tokens;
}

double TableFunction::get(const wxString& name, uint16_t key)
{
    if(tables.find(name) == tables.end()){
        wxLogError(_T("table not found!"));
        return -1; //need exception
    }

    DoubleArray* da = tables[name];

    if(key > da->GetCount() || da->GetCount() == 0){
        wxLogError(_T("invalid key!"));
        return -1; //need exception
    }

    return da->Item(key);
}
