#include "testpanel.h"

int idParseButton = wxNewId();
int idSearchButton = wxNewId();

BEGIN_EVENT_TABLE(TestPanel, wxPanel)
    EVT_BUTTON(idParseButton, TestPanel::OnParseButton)
    EVT_BUTTON(idSearchButton, TestPanel::OnSearchButton)
END_EVENT_TABLE()

TestPanel::TestPanel(wxWindow* parent, wxWindowID id):wxPanel(parent,id)
{
    m_parser = NULL;
    buildGUI();
}

TestPanel::~TestPanel()
{
    //dtor
}

void TestPanel::buildGUI()
{
    wxBoxSizer* topSizer  = new wxBoxSizer(wxVERTICAL);
    wxBoxSizer* ctrlSizer = new wxBoxSizer(wxHORIZONTAL);

    m_log = new wxTextCtrl( this, wxID_ANY, _T(""),wxDefaultPosition, wxDefaultSize,
                            wxTE_MULTILINE | wxTE_READONLY|wxHSCROLL, wxDefaultValidator, wxTextCtrlNameStr);

	wxButton* parseButton  = new wxButton(this, idParseButton,_T("Parse"),wxDefaultPosition,wxDefaultSize);
	wxButton* searchButton = new wxButton(this, idSearchButton,_T("Search"),wxDefaultPosition,wxDefaultSize);

    m_searchField = new wxTextCtrl(this, wxLB_EXTENDED);

	topSizer->Add(m_log,1,wxALL|wxEXPAND,5);
	ctrlSizer->Add(parseButton,0,wxALL,5);
    ctrlSizer->Add(m_searchField,1,wxALL,5);
    ctrlSizer->Add(searchButton,0,wxALL,5);
	topSizer->Add(ctrlSizer,0,wxALL|wxEXPAND,5);
    this->SetSizer(topSizer);
    topSizer->SetSizeHints(this);
}

void TestPanel::OnParseButton(wxCommandEvent& event)
{
    if(!m_parser){
        wxMessageBox(_T("Parser is not set!"));
        return;
    }

    try{
        wxMessageBox(wxString::Format(_T("Id : %d"), event.GetId()));
        m_parser->parse(_T("vemsv3.ini"));
        wxMessageBox(_T("Finish Parsing!"));
    }
    catch(ParserException e){
        wxMessageBox(e.toString());
    }

   /* m_log->Clear();
    wxArrayString errorLog = m_parser->getErrorLog();
    m_log->AppendText(wxString::Format(_T("Errors : %d \n"), errorLog.GetCount()));
    for(int i=0; i< errorLog.GetCount(); i++)
    {
        m_log->AppendText(errorLog[i] + _T("\n"));
    }

    buildMenu();
    */
}



void TestPanel::OnSearchButton(wxCommandEvent& event)
{
    UserDialogList  udl     = m_parser->getUserDialogList();
    udl.set();

    //udl.show(m_searchField->GetValue());
    USER_DIALOGS uds = udl.dialogs();
    for(USER_DIALOGS::iterator it = uds.begin(); it!=uds.end(); it++){
        it->second->show();
    }

    /*MTConfigData* configData = m_parser->getMTConfigData();
    if( !isParsed )
    {
        wxMessageBox( _T("Not parsed!"));
        return;
    }

    wxString symbolName = m_searchField->GetValue();

    m_log->Clear();
    if( configData->getSymbol(symbolName) == NULL ){
        m_log->AppendText(symbolName + _T(" not found! \n"));
    }
    else{
        m_log->AppendText(configData->getSymbol(symbolName)->toString() + _T("\n"));
    }

    m_log->AppendText(wxString::Format( _T("Symbol type %s \n"), configData->getSymbolType(symbolName).c_str()));
    int pageNo = configData->getSymbolPage(symbolName);
    m_log->AppendText(wxString::Format( _T("Symbol page number %d \n"), pageNo));
    m_log->AppendText(wxString::Format( _T("Real page number : %d \n"), configData->getPageActivate(pageNo)));
    m_log->AppendText(wxString::Format( _T("Page size: %d \n"), configData->getPageSize(pageNo)));
    m_log->AppendText(wxString::Format( _T("Page read command: %s \n"), configData->getPageReadCommand(pageNo).c_str()));
    m_log->AppendText(wxString::Format( _T("Page value write: %s \n"), configData->getPageValueWrite(pageNo).c_str()));
    //m_log->AppendText(configData->pageSizeToString());
*/
}


void TestPanel::buildMenu()
{
    UserMenuList    uml     = m_parser->getUserMenuList();
    wxFrame*        main    = (wxFrame*)GetGrandParent();
    wxMenuBar*      mb      = main->GetMenuBar();

    uml.attach(mb);
/*    main->Connect(wxID_ANY, wxEVT_COMMAND_MENU_SELECTED, wxCommandEventHandler(TestPanel::OnTest));


    for(int i=0; i<uml.getMenuCount(); i++)
    {
        UserMenu um = uml[i];
        wxMenu*  m =  new wxMenu();
        //wxLogMessage(um.getLabel());

        for(int j=0; j<um.getMenuItemCount(); j++)
        {
            UserMenuItem& umi = um[j];
            if(umi.isSeparator())
            {
                m->AppendSeparator();
            }
            else
            {
                umi.setId( wxNewId());
                m->Append(umi.getId(), umi.getLabel(), umi.getLabel());
                //add event
                //main->Connect(umi.getId(),wxEVT_COMMAND_MENU_SELECTED, wxCommandEventHandler(TestPanel::OnTest));

            }
        }

        main->Connect(wxID_ANY, wxEVT_COMMAND_MENU_SELECTED, wxCommandEventHandler(TestPanel::OnTest));
        mb->Append(m, um.getLabel());
    }


    //wxLogMessage(mb->GetLabelTop(0));
/*    wxFrame* main = (wxFrame*)GetGrandParent();

    if(main==NULL)
    {
        wxLogMessage(_T("NULL"));
    }
    else
    {
        wxLogMessage(_T("NOT NULL"));
        if(main->IsKindOf(CLASSINFO(wxFrame)))
        {
            wxLogMessage(_T("IS FRAME"));
        }
        else if (main->IsKindOf(CLASSINFO(wxWindow)))
        {
            wxLogMessage(_T("IS WINDOW"));
        }
        else
        {
            wxLogMessage(_T("WHAT KIND OF CLASS IS IT?"));
        }
    }

      wxMenuBar* mbar = new wxMenuBar();
    wxMenu* fileMenu = new wxMenu(_T(""));
    fileMenu->Append(idMenuOpen, _("&Open\tCtrl-O"), _("Open file"));


    frame->Connect( wxID_EXIT,
    wxEVT_COMMAND_MENU_SELECTED,
    wxCommandEventHandler(MyFrame::OnQuit) );
*/
}

void  TestPanel::OnTest(wxCommandEvent& e)
{
    int id = e.GetId();

    UserMenuList    uml     = m_parser->getUserMenuList();
    //UserDialogList  udl     = m_parser->getUserDialogList();
/*
    if( udl.get(uml.getDialogName(id)) != NULL ){
        udl.get(uml.getDialogName(id))->ShowModal();
    }else{
        wxMessageBox(_T("Error!"));
    }

    //wxMessageBox(wxString::Format(_T("ID: %d"), event.GetId()));
    */
}



