#ifndef TBTBDEVICES_H
#define TBTBDEVICES_H

#include "VemsToolBarToolBase.h"

class VemsTuneController;
class VemsDeviceControllerEvent;

class TbTbDevices: public VemsToolBarToolBase
{
    DECLARE_DYNAMIC_CLASS(TbTbDevices);

    public:
        TbTbDevices() {};
        TbTbDevices(int id);
        virtual ~TbTbDevices();

        void OnTool(wxCommandEvent &event);
        void OnToolR(wxCommandEvent &event);
        void OnToolEnter(wxCommandEvent &event) {};
        void Init();
        bool SendObject(int id, wxObject *object, const wxString &message = wxEmptyString) ;

    private:
        VemsTuneController* m_vemscontroller;

        void OnCannotOpenPort( VemsDeviceControllerEvent& event );
        void OnDeviceNotFound( VemsDeviceControllerEvent& event );
        void OnDeviceConnected( VemsDeviceControllerEvent& event );
        void OnDeviceDisconnected( VemsDeviceControllerEvent& event );
        void OnDeviceControllerStopped( VemsDeviceControllerEvent& event );
        void OnDeviceResumed( VemsDeviceControllerEvent& event );

        DECLARE_EVENT_TABLE()
};



#endif // TBTBDEVICES_H
