#ifndef TBTBSTATICCONTROL_H
#define TBTBSTATICCONTROL_H

#include "VemsToolBarToolBase.h"
#include "../stdatamanager/STDataViewerBase.h"
#include "../rtdatamanager/RTDataViewerBase.h"

class TbTbStaticControl: public VemsToolBarToolBase, public STDataViewerBase, public RTDataViewerBase
{
    DECLARE_DYNAMIC_CLASS(TbTbStaticControl);

    public:
        TbTbStaticControl() {};
        TbTbStaticControl(int id, const wxString &type);
        virtual ~TbTbStaticControl();

        void OnTool(wxCommandEvent &event) ;
        void OnToolR(wxCommandEvent &event) {};
        void OnToolEnter(wxCommandEvent &event) {};
        void Init() ;
        bool SendObject(int id, wxObject *object, const wxString &message = wxEmptyString) ;

        void    update();

        void    requestRead() {}
        void    updateModel() {}
        void    requestWrite() {}

        wxString toString();

        ///RTDataViewerBase methods
        void SetValue(double value);
        void refresh(DoubleHash* table);
        void require();
        void unregisterSymbols();
        void SetValueIdx(int idx) {}

    private:
        wxString    m_type;
        wxString    m_symbolName;
        wxTimer     m_timer;
        bool        m_isDataAvailable;
        bool        m_isRTSymbolRegistered;
        bool        m_burningFlag;

        const wxString& getCurrSymbolName() const { return m_symbolName; };
        bool isDataAvailable() const { return m_isDataAvailable; }
        void highlight( bool highlight );
        void OnTimer(wxTimerEvent& evt);
};

#endif // TBTBSTATICCONTROL_H
