#ifndef VEMSTOOLBARTOOLBASE_H
#define VEMSTOOLBARTOOLBASE_H

#include <wx/wx.h>
#include "../common/typedef.h"
#include "../SendObjectBase.h"

#include "ToolBarToolsNeedId.h"

class VemsAuiManager;

//enum ToolBitmapIds
//{
//    TBI_LOG_0,
//    TBI_LOG_1,
//    TBI_ECU_CONN,
//    TBI_ECU_NC,
//    TBI_ECU_OFFLINE,
//    TBI_ECU_AIM,
//    TBI_ECU_BOOT,
//    TBI_ECU_RT,
//    TBI_ECU_LOCK,
//    TBI_IS_NONE,
//    TBI_IS_ECU,
//    TBI_IS_HIGHF,
//    TBI_IS_RAWF,
//    TBI_SM_ONLINE,
//    TBI_SM_OFFLINE,
//    TBI_PLAY_INACTIVE,
//    TBI_PLAY_ACTIVE,
//    TBI_STOP_INACTIVE,
//    TBI_STOP_ACTIVE,
//    TBI_PAUSE_INACTIVE,
//    TBI_PAUSE_ACTIVE,
//    TBI_GPS_ON,
//    TBI_GPS_WARNING,
//    TBI_GPS_OFF,
//    TBI_GPS_OFFLINE,
//    TBI_DEV_V3,
//    TBI_DEV_ARM,
//    TBI_DEV_NONE,
//    TBI_DEV_ROUND,
//    TBI_DEV_NONERED,
//    TBI_GG_ON,
//    TBI_GG_OFF,
//    TBI_CVALI_RED,
//    TBI_CVALI_GREY,
//    TBI_CVALI_GOLD,
//    TBI_CVALI_GREEN,
//    TBI_CVALI_RED_BROKEN,
//    /*
//    TBI_STATICCONTROL_WRITE_INACTIVE,
//    TBI_STATICCONTROL_WRITE_ACTIVE,
//    TBI_STATICCONTROL_WRITE_WARNING,
//    TBI_STATICCONTROL_READ_INACTIVE,
//    TBI_STATICCONTROL_READ_ACTIVE,
//    TBI_STATICCONTROL_READ_WARNING,
//    TBI_STATICCONTROL_BURN_INACTIVE,
//    TBI_STATICCONTROL_BURN_ACTIVE,
//    TBI_STATICCONTROL_BURN_WARNING
//*/
//    TBI_STATICCONTROL_INACTIVE,
//    TBI_STATICCONTROL_ACTIVE,
//    TBI_STATICCONTROL_WARNING,
//    TBI_EDITMODE_ON,
//    TBI_EDITMODE_ONB,
//    TBI_EDITMODE_OFF,
//    TBI_LOGPLAY_INACTIVE,
//    TBI_LOGPLAY_ACTIVE_1,
//    TBI_LOGPLAY_ACTIVE_2,
//    TBI_LOGPLAY_ACTIVE_4,
//    TBI_LOGREPEAT_INACTIVE,
//    TBI_LOGREPEAT_ACTIVE
//};

WX_DECLARE_HASH_MAP( int, wxBitmap* , wxIntegerHash, wxIntegerEqual, BitmapHash );
WX_DECLARE_HASH_MAP( int, wxArrayString , wxIntegerHash, wxIntegerEqual, IntArrStrHash );

class VemsToolBarToolBase: public wxEvtHandler, public SendObjectBase
{
    DECLARE_ABSTRACT_CLASS(VemsToolBarToolBase);

    public:
        VemsToolBarToolBase() {};
        VemsToolBarToolBase(int id);
        virtual ~VemsToolBarToolBase();

                                                                    /** \~english When clicking in the tool with left mouse button.  \~hungarian A tool-on bal gombbal klikkelve ez a függvény hívódik meg.  */
        virtual void OnTool(wxCommandEvent &event) = 0;
                                                                    /** \~english When clicking in the tool with right mouse button.  \~hungarian A tool-on jobb gombbal klikkelve ez a függvény hívódik meg.  */
        virtual void OnToolR(wxCommandEvent &event) = 0;
                                                                    /** \~english When moving the mouse over the tool.  \~hungarian A tool fölött az egér mozgatására ez a függvény hívódik meg.   */
        virtual void OnToolEnter(wxCommandEvent &event) = 0;
                                                                    /** \~english Initializing the tool.  \~hungarian Inicializálja a tool-t. \~ \ref tbtover */
        virtual void Init() = 0;
                                                                    /** \~english Handle the arrived requests. \~hungarian A megérkezett kérések lekezelése. \~ \ref tbtsender */
        //virtual void SendObject(ToolBarToolsNeedId id, wxObject *object, const wxString &message = wxEmptyString) = 0;
        virtual void SendEvent( ToolBarToolsNeedId event, int value ) {}

        wxBitmap* GetDefaultBmp() { return m_defaultBitmap; };
        wxBitmap* GetInactiveBitmap() {
            if(m_inactiveBitmap == NULL)
                return &wxNullBitmap;
            else
                return m_inactiveBitmap;
        };

        int GetId() { return m_toolID; };
        void SetId(int id) { m_toolID = id; };

        void SetToolBar(wxToolBar* tb) { m_toolBar = tb; };
        wxToolBar* GetToolBar() { return m_toolBar; };


        TbNeedArray& GetObjectIds() { return m_needObjectIds; };

        void InitHelpStrings();

        static wxBitmap* LoadAndResample(const wxString &filename, const wxSize &size, bool islowlimit = false, const wxString &alternatefile = wxEmptyString, uint16_t lowlimit = 20);

        void InitBmpRes();

                /** \ref tbtsender */
        void SetHandler(VemsAuiManager *hand) { m_AUImanager = hand; } ;

        void SetItemId( int id ) { m_itemId = id; };
        int GetItemId() { return m_itemId; };

    protected:



        void SetToolBmp(int id, bool active = true);
        void SetToolBmp(const wxString &filename, bool active = true);
        void SetToolBmp(wxBitmap *bmp, bool active = true);

        void AddRequest(ToolBarToolsNeedId tbnid);
        void AddRequest(const TbNeedArray &tbnidarray);

        int             m_itemId;
        int             m_toolID;
        wxToolBar       *m_toolBar;
        wxBitmap        *m_defaultBitmap;
        wxBitmap        *m_inactiveBitmap;

        wxString        m_shortHelpString;
        wxString        m_longHelpString;

                        /** \~english Contains wxBitmaps-stored images  \~hungarian A képeket wxBitmap osztályokban tartalmazza  */
        BitmapHash      m_bmpHash;


        IntArrStrHash   m_bmpKeyListArray;


        VemsAuiManager*    m_AUImanager;
        //FrameLayoutHandler  *m_handler;

        int             m_ToolBmpId;


    private:
                        /** \~english Contains the requests. \~hungarian A kéréseket tartalmazza. \~ \ref tbtsender  */
        TbNeedArray     m_needObjectIds;


};



#endif // VEMSTOOLBARTOOLBASE_H
