#include "TriggerLogEvt.h"

#include "../events/TriggerLogEvent.h"

TriggerLogEvt::TriggerLogEvt(wxEvtHandler* evtHandler)
{
    m_evtHandler = evtHandler;
}

TriggerLogEvt::~TriggerLogEvt()
{
}

void TriggerLogEvt::clearData()
{
    m_rawFrameA.Clear();
    TriggerLog::clearData();
}

void TriggerLogEvt::parseTrigger(uint8_t data)
{
    if(data == 0x7e)
    {
        // Logger::logf(LOG_MSG, _T("TriggerLogEvt::parseTrigger size: %i"), m_rawFrameA.GetCount() );
        IntArray unescapedFrame;

        int res = unescape( m_rawFrameA, unescapedFrame );

        if( res  == -1 )
        {
            // Escaping error old/wrong Frame
            m_rawFrameA.Clear();
            return;
        }

        TriggerLogEvent trEvent;

        res = trEvent.m_frame.addFrame( unescapedFrame );

        if ( res != res != TriggerFrame::TRFRAME_EMPTY_FRAME )
        {
            if ( m_resultH.find( res ) == m_resultH.end() )
            {
                m_resultH[res] = 1;
            }
            else
            {
                m_resultH[res]++;
            }
        }
        // send only valid frame
        if ( ( res < 256 ) && m_evtHandler )
        {
             m_evtHandler->AddPendingEvent( trEvent );
        }

        m_rawFrameA.Clear();

    }
    else
    {
        /// TODO: rethink unescape
        m_rawFrameA.Add( data );
    }
}

void TriggerLogEvt::notify( int i )
{
    m_evtHandler = NULL;
}
