/*************************************/
/**                                 **/
/** UNUSED & DEPRECATED             **/
/**                                 **/
/*************************************/
/*
#include "TriggerLogV3Dialog.h"
#include "../DirHelper.h"
#include "../logger.h"

int idTriggerTimer = wxNewId();

BEGIN_EVENT_TABLE( TriggerLogV3Dialog, wxDialog )
    EVT_BUTTON( TriggerLogV3Dialog::TL_ID_SAVE, TriggerLogV3Dialog::OnButton )
    EVT_BUTTON( TriggerLogV3Dialog::TL_ID_START, TriggerLogV3Dialog::OnButton )
    EVT_BUTTON( TriggerLogV3Dialog::TL_ID_STOP, TriggerLogV3Dialog::OnButton )
    EVT_BUTTON( TriggerLogV3Dialog::TL_ID_CLOSE, TriggerLogV3Dialog::OnButton )
    EVT_TIMER(idTriggerTimer, TriggerLogV3Dialog::OnTimer)
    EVT_CLOSE(TriggerLogV3Dialog::OnClose )
END_EVENT_TABLE()



TriggerLogV3Dialog::TriggerLogV3Dialog( wxWindow* parent )
:m_timer(this, idTriggerTimer)
{
    Create( parent, -1, _T("Record trigger log data from V3"));
    m_ireadnum = 0;
    buildGUI( parent );
}

void TriggerLogV3Dialog::buildGUI( wxWindow* parent )
{
    wxBoxSizer* mainsizer = new wxBoxSizer( wxVERTICAL );

    // incoming bytes

    //m_txtreadData = new wxTextCtrl( this, -1, _T(""), wxDefaultPosition, wxSize(400,120),
    //    wxTE_MULTILINE | wxTE_RICH | wxTE_READONLY );

    wxFont font;
    font.SetNativeFontInfoUserDesc( _T("terminal 10 windows-437"));

    //wxTextAttr attr = m_txtreadData->GetDefaultStyle(); attr.SetFont(font);
    //m_txtreadData->SetDefaultStyle(attr);

    //mainsizer->Add( m_txtreadData, 0, wxALL | wxEXPAND, 5 );

    //read bytes

    wxBoxSizer* s1 = new wxBoxSizer( wxHORIZONTAL );
    wxStaticText* txt = new wxStaticText( this, -1, _T("Bytes read: ") );
    m_txtreadnum = new wxTextCtrl( this, -1, _T(""), wxDefaultPosition, wxDefaultSize, wxTE_READONLY );
    s1->Add( txt, 0, wxALL, 5 );
    s1->Add( m_txtreadnum, 0, wxALL, 5 );

    mainsizer->Add( s1, 0, wxALL | wxEXPAND, 5 );

    // buttons
    wxGridSizer* s2 = new wxGridSizer( 4 );
    wxButton* b1 = new wxButton( this, TL_ID_START, _T("Start log") );
    wxButton* b2 = new wxButton( this, TL_ID_STOP, _T("Stop log") );
    wxButton* b3 = new wxButton( this, TL_ID_SAVE, _T("Save log") );
    wxButton* b4 = new wxButton( this, TL_ID_CLOSE, _T("Close dialog") );
    s2->Add( b1, 0, wxALL, 5 ); s2->Add( b2, 0, wxALL, 5 ); s2->Add( b3, 0, wxALL, 5 );
    s2->Add( b4, 0, wxALL, 5 );
    b2->Disable(); b3->Disable();

    mainsizer->Add( s2, 0, wxALL | wxEXPAND | wxALIGN_CENTER, 5 );

    SetSizer( mainsizer );
    mainsizer->Fit( this );
    mainsizer->SetSizeHints( this );

    m_timer.Start(150, false );
}

/// observerNotify invoked from void TriggerLogManager::finished()
void TriggerLogV3Dialog::notify( int data )
{
    /// stopped
    //Logger::logf(LOG_MSG, _T("TriggerLogV3Dialog::notify()"));
    if ( data == -2 )
    {
        FindWindowById( TL_ID_START, this )->Enable();
        FindWindowById( TL_ID_SAVE, this )->Enable();
        FindWindowById( TL_ID_STOP, this )->Disable();
        FindWindowById( TL_ID_CLOSE, this )->Enable();
        return;
    }

    if ( data == -3 ) // timeout
    {
        FindWindowById( TL_ID_START, this )->Disable();
        FindWindowById( TL_ID_SAVE, this )->Enable();
        FindWindowById( TL_ID_STOP, this )->Disable();
        FindWindowById( TL_ID_CLOSE, this )->Enable();

        wxMessageBox( _T("No more data, process stopped"), _T("Information"), wxOK | wxICON_INFORMATION );
    }

    else
    {
        if ( data == -1 )
            return;

        m_strBuff.Append( (wxChar)data );

        //m_txtreadData->AppendText( (wxChar)data );
        m_ireadnum++;

        //m_txtreadnum->SetValue( wxString::Format( _T("%d"), m_ireadnum ) );
    }
}

void TriggerLogV3Dialog::OnButton( wxCommandEvent& event )
{
    int id = event.GetId();

    if ( id == TL_ID_START )
    {
        m_strBuff.Clear();
        m_ireadnum = 0;
        FindWindowById( TL_ID_START, this )->Disable();
        FindWindowById( TL_ID_SAVE, this )->Disable();
        FindWindowById( TL_ID_STOP, this )->Enable();
        FindWindowById( TL_ID_CLOSE, this )->Disable();
        observerNotify( TL_ID_START );

        return;
    }

    if ( id == TL_ID_STOP )
    {
        FindWindowById( TL_ID_START, this )->Enable();
        FindWindowById( TL_ID_SAVE, this )->Enable();
        FindWindowById( TL_ID_CLOSE, this )->Enable();
        FindWindowById( TL_ID_STOP, this )->Disable();
        observerNotify( TL_ID_STOP );
        return;
    }

    if ( id == TL_ID_SAVE )
    {
        FindWindowById( TL_ID_START, this )->Enable();
        FindWindowById( TL_ID_SAVE, this )->Enable();
        FindWindowById( TL_ID_CLOSE, this )->Enable(); // will be closed automatically
        FindWindowById( TL_ID_STOP, this )->Disable();

        observerNotify( _T("save") );
        return;
    }

    if ( id == TL_ID_CLOSE )
    {
        observerNotify( TL_ID_CLOSE );
        return;
    }

}

void TriggerLogV3Dialog::OnClose(wxCloseEvent& evt)
{
    observerNotify( TL_ID_CLOSE );
}

void TriggerLogV3Dialog::OnTimer( wxTimerEvent& event )
{
    //Logger::logf(LOG_MSG, _T("TriggerLogV3Dialog::OnTimer()"));

    //m_txtreadData->AppendText( m_strBuff );
    m_strBuff.Empty();
    m_txtreadnum->SetValue( wxString::Format( _T("%d"), m_ireadnum ) );
}
*/
