#include "VEMSMixtureViewFrame.h"

#include "../logger.h"
#include "../DirHelper.h"

#include "raceloganalyser.h"
#include "../fileparser/vemslogparser.h"
#include "../fileparser/vemsdatalogdesc.h"

#include "VEMSDataLogMixtureView.h"

BEGIN_EVENT_TABLE(VEMSMixtureViewFrame, wxFrame)
END_EVENT_TABLE()


VEMSMixtureViewFrame::VEMSMixtureViewFrame(const wxString& title, const wxPoint& pos, const wxSize&
size)
: wxFrame((wxFrame *)NULL, -1, title, pos, size)
{

    wxDirDialog dialog(this, _T("Please choose the mixturelog directory (*.xls)"),
                        DirHelper::GetPath() + _T("races\\"), wxDD_DEFAULT_STYLE, wxDefaultPosition, wxDefaultSize,_T("wxDirCtrl"));
    if (dialog.ShowModal() == wxID_OK)
    {
        wxString dirname(dialog.GetPath());
        //wxString dirname = DirHelper::GetPath() + _T("races\\");
        const wxString& filespec = _T("*.xls");

        VEMSLogParser *lp = new VEMSLogParser();
        int count = lp->parseDir(dirname, filespec);

        if( count < 1){ return;
        }

        VEMSDataLogDesc * vemsDataLogDesc = lp->getVemsDataLogDesc();

        VEMSDataLogMixtureView * view = new VEMSDataLogMixtureView(this,vemsDataLogDesc);
        view->Show();
    }
}
