#ifndef RACELOGANALYSER_H
#define RACELOGANALYSER_H

#include "../fileparser/vemsdatalogdesc.h"
#include "../common/types/IntArray.h"
#include "../common/types/Int2StringHash.h"

class CarParameters;
class CarParametersH;
class RacesCache;

WX_DEFINE_ARRAY(IntArray *, RaceArray);
WX_DEFINE_ARRAY(RaceArray *, ArrayOfRaceArray);

WX_DEFINE_ARRAY(wxArrayString *, ArrayOfArrayString);
class RaceLogAnalyser
{
    public:
        RaceLogAnalyser();
        virtual ~RaceLogAnalyser();
        void setVemsDataLogDesc(VEMSDataLogDesc * vemsDataLogDesc);
        wxArrayString * getDisplayedValuesArray();
        IntArray * getBinArray();
        void print();
        void analyzeRaces();
        void printRacesBins();
        //void printRacesBins_OLD();
        void setGearNo(int rowIndex, int raceNum, long gearNo);
        ArrayOfArrayString * getRacesTable();
    protected:
    private:
        //
        void analyzeRaces(int raceNum, IntArray* intArray);
        int analyzeRaces(DoubleArray * rowArray);
        int getBinIndex(int rpmV);
        double getavgValue(const  wxString&, IntArray *binRecord);
        double getDeltaRPM(IntArray * intArray);
        //void initCSVRow();
        void setEmptyValues(ArrayOfArrayString * displayedValuesTable);
        void initDisplayedValueTable(ArrayOfArrayString * displayedValueTable);
        double getFilteredDeltaValue(const wxString& key, IntArray * binRecord, bool isPrevBinValid, bool isNextBinValid);
        double getEngineToruqe(const wxString& fileName, int raceNum, double drpmPerdt);
        wxString getFileName( int startIdx);
        bool isBinValid(RaceArray *raceBinArray, int x, int minCount);

        VEMSDataLogDesc  * m_vemsDataLogDesc;

        RaceArray raceArray;
        IntArray rpmBinArray;

        wxArrayString csvRow;
        wxArrayString displayedValueA;

        IntArray newFileIndexA;

        CarParameters *m_carParams;
        CarParametersH *m_carParamsH;

        RacesCache *m_racesCache;
        Int2StringHash m_rowIndex2FileName;

/*
    raceBin index 0...raceNum value -> RaceArray

0-500 = 0
500-1000 = 1
1000-1500 = 2

RaceArray
index
bin 0-> IntArray --> 10,11,12,13,14
bin 1-> IntArray --> 15,16....
bin 2-> ...
*/
    ArrayOfRaceArray raceBin;
};



#endif // RACELOGANALYSER_H
