#include "vemsracesdataview.h"

#include "../common/typedef.h"
#include "../logger.h"
//ArrayOfRaceArray * raceBin, VEMSDataLogDesc * vemsDataLogDesc

BEGIN_EVENT_TABLE(VEMSRacesDataView, wxGrid)

    EVT_GRID_CELL_LEFT_CLICK(VEMSRacesDataView::OnLeftClick)
    EVT_GRID_CELL_RIGHT_CLICK(VEMSRacesDataView::OnRightClick)
END_EVENT_TABLE()

VEMSRacesDataView::VEMSRacesDataView(wxWindow *parent,
    RaceLogAnalyser * raceLogAnalyser)
: wxGrid(parent, wxID_ANY)
{
    //CreateGrid(10, 10);

    m_raceLogAnalyser = raceLogAnalyser;
    //m_vemsDataLogDesc = vemsDataLogDesc;


/*
    int racesNum = m_raceLogAnalyser->getBinArray()->Count(); //Count();

    wxArrayString * dispValuesA = m_raceLogAnalyser->getDisplayedValuesArray();
    IntArray * binA = m_raceLogAnalyser-> getBinArray();

    CreateGrid(racesNum * ( dispValuesA->Count() +1),  binA->Count() + 1);
*/
    BeginBatch();

    //wxString binColumnHeader = _T("Race nums;");
    //SetColLabelValue(0, _T("Race nums"));

    fillGrid();
/*
	m_logValues = &log_values;

	const int max_rpm = 8000;
	const int rpm_step = 500;

	CreateGrid(10 + 1, max_rpm / rpm_step + 1);

	BeginBatch();

	SetDefaultCellAlignment(wxALIGN_CENTRE, wxALIGN_CENTRE);
	SetEditable(false);


	float afr_table[100][100];
	float afr_target_table[100][100];
	int   afr_count[100][100];

	memset(afr_table, 0, sizeof(afr_table));
	memset(afr_count, 0, sizeof(afr_count));
	memset(afr_target_table, 0, sizeof(afr_target_table));

	int i;
	for (i = 0; i < max_rpm / rpm_step + 1; ++i)
	{
		wxString colText;
		colText.sprintf(_T("%u"), i * rpm_step);
		SetColLabelValue(i, colText);
	}

	for (i = 0; i < 10 + 1; ++i)
	{
		wxString rowText;
		rowText.sprintf(_T("%u"), i * 10);
		SetRowLabelValue(i, rowText);
	}


	for (i = 0; i < m_logValues->GetValuesCount(); ++i)
	{
		const float afr = m_logValues->GetValueFloat(VEMS_LOG_PARAM_LAMBDA, i);
		const float afr_target = m_logValues->GetValueFloat(VEMS_LOG_PARAM_LAMBDATARGET, i);
		const int load = m_logValues->GetValueInteger(VEMS_LOG_PARAM_TP, i);
		const int rpm = m_logValues->GetValueInteger(VEMS_LOG_PARAM_RPM, i);

		int col = rpm / rpm_step;
		int row = load / 10;

		if (col < 100 && row < 100)
		{
			afr_count[col][row]++;			// +1 value collected
			afr_table[col][row] += afr;
			afr_target_table[col][row] += afr_target;
		}
	}

	for (i = 0; i < max_rpm / rpm_step + 1; ++i)
	{
		for (int j = 0; j < 10 + 1; ++j)
		{
			if (afr_count[i][j] > 0)
			{
				const float afr = afr_table[i][j] / afr_count[i][j];
				const float afr_target = afr_target_table[i][j] / afr_count[i][j];

				wxString valText;
				valText.sprintf(_T("AFR=%3.2f\nCollected=%u\nTarget_AFR=%3.2f"), afr, afr_count[i][j], afr_target);
				SetCellValue(valText, j, i);

				if (vemsABS(afr - afr_target) < 0.05f)
				{
					SetCellBackgroundColour(*wxGREEN, j, i);
				}
				else if (vemsABS(afr - afr_target) < 0.1f)
				{
					SetCellBackgroundColour(*wxBLUE, j, i);
				}
				else
				{
					SetCellBackgroundColour(*wxRED, j, i);
				}
			}
		}
	}
*/
	AutoSize();

	EndBatch();
}

VEMSRacesDataView::~VEMSRacesDataView()
{
    delete m_raceLogAnalyser;
}

void VEMSRacesDataView::fillGrid()
{
     ArrayOfArrayString * racesTable = m_raceLogAnalyser->getRacesTable();
    wxArrayString *colRow = racesTable->Item(0);

    CreateGrid(racesTable->Count(), colRow->Count() - 1);

    for(uint16_t i = 0; i < colRow->Count(); i++){
            wxString colText = colRow->Item(i);
            SetColLabelValue(i, colText);
    }

     for(uint16_t i =1; i < racesTable->Count(); i++){
            wxArrayString *row = racesTable->Item(i);
             for(uint16_t y =0; y < row->Count(); y++){
                    wxString cell = row->Item(y);
                    SetCellValue(cell, i-1, y);
             }
    }
}

void VEMSRacesDataView::OnLeftClick(wxGridEvent& ev)
{
    int col = ev.GetCol();
    int row = ev.GetRow();

    long valueLong = 0;
    if( ((row % 10) == 0) && (col == 3) ){
        wxString value = GetCellValue(row, col);
         Logger::log(LOG_MSG, _T("VEMSRacesDataView::OnLeftClick: (gear select) ")+ value);

        /*bool res =*/ value.ToLong(&valueLong);

        if(valueLong == 6) {valueLong = 1;}
        else{ valueLong++;}
        //SetCellValue(row, col, wxString::Format(_T("%u"),valueLong));

        int raceNum = row / 10;
        m_raceLogAnalyser->setGearNo(row, raceNum, valueLong);
        fillGrid();
    }else{
        ev.Skip();
    }

}

void VEMSRacesDataView::OnRightClick(wxGridEvent& ev)
{
    int col = ev.GetCol();
    int row = ev.GetRow();

     long valueLong = 1;
    if( ((row % 10) == 0) && (col == 3) ){
        wxString value = GetCellValue(row, col);
        Logger::log(LOG_MSG, _T("VEMSRacesDataView::OnLeftClick: (gear select) ")+ value);

//        bool res = value.ToLong(&valueLong);

        if(valueLong == 1) {valueLong = 6;}
        else{ valueLong--;}

        //SetCellValue(row, col, wxString::Format(_T("%u"),valueLong));

        int raceNum = row / 10;
        m_raceLogAnalyser->setGearNo(row, raceNum, valueLong);
        fillGrid();
    }else{
        ev.Skip();
    }
}
