#include "vemsracesframe.h"

#include "../logger.h"
#include "../DirHelper.h"
#include "../appHelper.h"

#include "raceloganalyser.h"

#include "../fileparser/vemslogparser.h"
#include "../fileparser/vemsdatalogdesc.h"

#include "vemsracesdataview.h"

BEGIN_EVENT_TABLE(VEMSRacesFrame, wxFrame)
END_EVENT_TABLE()


VEMSRacesFrame::VEMSRacesFrame(wxWindow* parent, const wxString& title, const wxPoint& pos, const wxSize&
size)
//: wxFrame((wxFrame *)NULL, -1, title, pos, size)
: wxFrame(parent, -1, title, pos, size)
{
    wxString path = DirHelper::GetPath(dLOG);
    Logger::log(LOG_MSG, _T("VEMSRacesFrame::VEMSRacesFrame: path=")+ path);
    wxDirDialog dialog(this, _T("Please choose the racelog directory (*.csv)"),
                        path, wxDD_DEFAULT_STYLE, wxDefaultPosition, wxDefaultSize,_T("wxDirCtrl"));
    if (dialog.ShowModal() == wxID_OK)
    {
        wxString dirname(dialog.GetPath());
        //wxString dirname = DirHelper::GetPath() + _T("races\\");
        const wxString& filespec = _T("*.csv");

        VEMSLogParser *lp = new VEMSLogParser();
        int count = lp->parseDir(dirname, filespec);

        if( count < 1){ return;
        }

        VEMSDataLogDesc * vemsDataLogDesc = lp->getVemsDataLogDesc();


        RaceLogAnalyser * raceLog = new RaceLogAnalyser();


        raceLog->setVemsDataLogDesc(vemsDataLogDesc);

        raceLog->print();
        raceLog->analyzeRaces();
        raceLog->printRacesBins();

        VEMSRacesDataView * racesView = new VEMSRacesDataView(this,raceLog);
        racesView->Show();
        delete lp;
    }
}

VEMSRacesFrame::~VEMSRacesFrame()
{
}
