#ifndef ARRAYEDITORDIALOG_H
#define ARRAYEDITORDIALOG_H

#include <wx/dialog.h>
#include <wx/wx.h>

#include "../common/types/IntArray.h"

WX_DECLARE_STRING_HASH_MAP(wxFlexGridSizer *, SizerHash1);

class ArrayEditorDialog : public wxDialog
{
    public:
        ArrayEditorDialog(IntArray* intArray, wxWindow* parent = NULL,wxWindowID id = -1);
        virtual ~ArrayEditorDialog();
    protected:
    private:
    int m_boxCount;
    wxBoxSizer* m_topSizer;
    wxFlexGridSizer* m_currGridSizer;
    wxComboBox * m_insertComboBox;
    SizerHash1 m_sizerHash;

    wxButton* m_buttonOK;
    wxString m_arrayBoxName;

    IntArray* m_intArray;
    void addBox(const wxString& boxName);
    void showArray();
    void insertRow();
    void addDialogButtons();

    void OnComboBoxSelected( wxCommandEvent &event );

    DECLARE_EVENT_TABLE()
};

#endif // ARRAYEDITORDIALOG_H
