#include "CalibrationWBO2.h"

#include "../vemsprotocol/CommandRequestBase.h"

#include "../rtdatamanager/RTDataMgrBase.h"
#include "../stdatamanager/STDataMgrBase.h"

#include "../vemsprotocol/VemsCommand.h"
#include "../vemsprotocol/ECUInfo.h"

#include "../logger.h"

CalibrationWBO2::CalibrationWBO2()
{
    m_currSymbolName = _T("stallO2");
    m_targetValue = 20.9;
    m_wbo2State = WBO2_STOPED;
}

CalibrationWBO2::~CalibrationWBO2()
{
    stop();
}

void CalibrationWBO2::start()
{
    wxString command = _T("Manmde02bye");
    VemsCommand* vemsCommand = new StringCommand(command);
    m_commandRequest->request( vemsCommand );

    m_wbo2State = WBO2_HEATING;
}

void CalibrationWBO2::stop()
{
    wxString command = _T("Manmde00bye");
    VemsCommand* vemsCommand = new StringCommand(command);
    m_commandRequest->request( vemsCommand );

    m_wbo2State = WBO2_STOPED;
}

void CalibrationWBO2::refresh(DoubleHash* table)
{
    if( table->find(m_currSymbolName) == table->end() ){
        //data has not been found
        return;
    }
    double value = (*table)[m_currSymbolName];
    if(value > 9){
         m_wbo2State = WBO2_OK;
    }
    //Logger::logf(LOG_MSG, _T("CalibrationWBO2::refresh()")+ m_currSymbolName+ _T(" %f"), value);
/*
    wxString key = _T("wbo2_calibration");
    STDataViewerBaseHash::const_iterator IT = m_viewerBaseH.find(key);
    if( IT == m_viewerBaseH.end() ) return;

    STDataViewerBase* wbo2Cal =  m_viewerBaseH[key];
    Int2DoubleHash& values = wbo2Cal->getValues();
    double val = values[0];

    Logger::logf(LOG_MSG, _T("CalibrationWBO2::refresh ST()")+ key+ _T(" %f"), val);
    //wbo2Cal->requestWrite();
*/
    //STDataModelBase* stModel = m_stDataMgr->getModel();
    //stModel->getViewerData( const wxString& symbolName, Int2DoubleHash* values)
}

void CalibrationWBO2::unregisterSymbols()
{
    m_rtDataMgr->unregisterSymbol( m_currSymbolName );
}
