#include "CheckBoxMatrix.h"

//(*InternalHeaders(CheckBoxMatrix)
#include <wx/sizer.h>
#include <wx/checkbox.h>
#include <wx/intl.h>
#include <wx/string.h>
//*)
#include <wx/wx.h>

#include "../logger.h"
#include "../DirHelper.h"

/// only for desc
#include "CheckBoxMatrixViewer.h"

//(*IdInit(CheckBoxMatrix)
//const long CheckBoxMatrix::ID_CHECKBOX1 = wxNewId();
//*)

BEGIN_EVENT_TABLE(CheckBoxMatrix,wxPanel)
	//(*EventTable(CheckBoxMatrix)
	//*)
END_EVENT_TABLE()

CheckBoxMatrix::CheckBoxMatrix(CheckBoxMatrixDesc* pDesc,
    wxWindow* parent,wxWindowID id)
{
    m_pDesc = pDesc;
    Create(parent, id, wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL, _T("id"));
	BuildContent(parent,id);
}

void CheckBoxMatrix::setInjectorNum( unsigned char injnum )
{
    wxBitmap bmp =  getArrow(15,injnum*24,15,0);
    m_red_arrow->SetBitmap( bmp );
}

void CheckBoxMatrix::BuildContent(wxWindow* parent,wxWindowID id)
{
	//(*Initialize(CheckBoxMatrix)

	wxFlexGridSizer* topGridSizer1 = new wxFlexGridSizer(2,2, 0, 0);
	topGridSizer1->AddGrowableCol(1);
	topGridSizer1->AddGrowableRow(1);

    wxStaticText* tmpStaticText = NULL;

    //wxBitmap bmp( DirHelper::GetPath( dICON ) + _T("red_arrow.png"), wxBITMAP_TYPE_PNG );
    wxBitmap bmp = getArrow(15,50,15,0);
    m_red_arrow = new wxStaticBitmap( this, wxID_ANY, bmp );

    /// top 0;
    //topGridSizer1->AddStretchSpacer();
    topGridSizer1->Add( m_red_arrow, 0, wxTOP | wxALIGN_TOP, 55 );

//    setInjectorNum( 5 );
    /*
    /// top 1: mask(col) headername
    tmpStaticText = new wxStaticText( this, wxID_ANY,m_pDesc->m_maskHeaderName, wxDefaultPosition, wxDefaultSize,
            0,_T("Col name"));
    setBold(tmpStaticText);
    topGridSizer1->Add(tmpStaticText, 0, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    */
/*
    /// top 2: group(row) headername
    tmpStaticText = new wxStaticText( this, wxID_ANY, m_pDesc->m_groupHeaderName, wxDefaultPosition, wxDefaultSize,
            0,_T("Row name"));
    setBold(tmpStaticText);
    topGridSizer1->Add(tmpStaticText, 0, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
*/
    wxArrayString& row = m_pDesc->m_groupNames;
    IntArray& col = m_pDesc->m_maskPinNumbers;
    wxArrayString& rowColor =  m_pDesc->m_groupColors;

    wxFlexGridSizer* GridSizer1;

	//GridSizer1 = new wxGridSizer(row.GetCount()+1,col.GetCount()+2, 0, 0);
/////////////////////////////

    GridSizer1 = new wxFlexGridSizer(row.GetCount()+2,col.GetCount()+3, 0, 0);
    //GridSizer1->AddGrowableCol(9);

    /// 0. row  for Output
    tmpStaticText = new wxStaticText( this, wxID_ANY, _T("Output:"), wxDefaultPosition, wxDefaultSize,
            0,_T("staticText"));
    GridSizer1->Add(tmpStaticText, 1, wxALL/*|wxALIGN_CENTER_HORIZONTAL*/|wxALIGN_CENTER_VERTICAL, 5);
    setBold(tmpStaticText);
    ///
    ///+ 0. row for  Output names
    for(size_t i = 0; i < col.GetCount(); i++){
        //wxString colLabel = col.Item(i);
        wxString colLabel = wxString::Format(_T("%i"), i+1);
        tmpStaticText = new wxStaticText( this, wxID_ANY, colLabel, wxDefaultPosition, wxDefaultSize,
            0,_T("staticText"));
        setBold(tmpStaticText);
        GridSizer1->Add(tmpStaticText, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    }
    tmpStaticText = new wxStaticText(this,-1,_T("Channels using this"));
    setBold(tmpStaticText);
    GridSizer1->Add( tmpStaticText, 0, wxALL, 5 );
    GridSizer1->Add(70,10,1);

    /// 1. row for Pin
    tmpStaticText = new wxStaticText( this, wxID_ANY, _T("EC36 pin:"), wxDefaultPosition, wxDefaultSize,
            0,_T("staticText"));
    GridSizer1->Add(tmpStaticText, 1, wxALL/*|wxALIGN_CENTER_HORIZONTAL*/|wxALIGN_CENTER_VERTICAL, 5);
    setBold(tmpStaticText);

    ///+ 1. row for pin numbers
    for(size_t i = 0; i < col.GetCount(); i++){
        //wxString colLabel = col.Item(i);
        wxString colLabel = wxString::Format(_T("%i"), col.Item(i));
        tmpStaticText = new wxStaticText( this, wxID_ANY, colLabel, wxDefaultPosition, wxDefaultSize,
            0,_T("staticText"));
        setBold(tmpStaticText);
        GridSizer1->Add(tmpStaticText, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    }
    tmpStaticText = new wxStaticText(this,-1,_T("output:"));
    setBold(tmpStaticText);
    GridSizer1->Add( tmpStaticText, 0, wxALL, 5 );
    GridSizer1->Add(70,10,1);




    m_testButtons = new wxToggleButton*[row.GetCount()];
    m_outputs = new wxStaticText*[row.GetCount()];

    wxCheckBox* tmpCheckBox;
    int index = 0;
    for(size_t r = 0; r< row.GetCount(); r++){
        /// 0. row header
        wxString rowLabel = row.Item(r);
        tmpStaticText = new wxStaticText( this, wxID_ANY, rowLabel, wxDefaultPosition, wxDefaultSize,
            0,_T("staticText"));
        tmpStaticText->SetBackgroundColour( wxColour( rowColor.Item(r) ) );
        setBold(tmpStaticText);

        GridSizer1->Add(tmpStaticText, 1, wxALL/*|wxALIGN_CENTER_HORIZONTAL*/|wxALIGN_CENTER_VERTICAL, 5);
        /// 1. row summary
        ///tmpStaticText = new wxStaticText( this, wxID_ANY, _T("00"), wxDefaultPosition, wxDefaultSize,
        ///    0,_T("summary"));
        //tmpStaticText->SetBackgroundColour( wxColour( rowColor.Item(r) ) );
        ///GridSizer1->Add(tmpStaticText, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
        ///setBold(tmpStaticText);
        ///m_summaryCol[r] = tmpStaticText;
        m_rowSum[r] = 0;


        ///
        for(size_t c = 0; c < col.GetCount(); c++){
            long id = wxNewId();
            wxString name = wxString::Format(_T("ID_CHECKBOX-%i"), id);
            tmpCheckBox = new wxCheckBox(this, id, _(""), wxDefaultPosition, wxDefaultSize,
            0, wxDefaultValidator, name);
            tmpCheckBox->SetValue(false);
            tmpCheckBox->SetBackgroundColour( wxColour( rowColor.Item(r) ) );
            GridSizer1->Add(tmpCheckBox, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);

            Connect( id, wxEVT_COMMAND_CHECKBOX_CLICKED, wxCommandEventHandler(CheckBoxMatrix::OnCheckBox) );

            //m_guiIDToCheckbox[id] = tmpCheckBox;
            m_indexToCheckbox[index] = tmpCheckBox;
            m_guiIDToRow[id] = r;
            m_guiIDToCol[id] = c;
            index++;
        }

        m_outputs[r] = new wxStaticText( this, -1, _T("") );
        GridSizer1->Add( m_outputs[r], 0, wxALL, 5 );


        int buttId = wxNewId();
        m_testButtons[r] = new wxToggleButton( this, buttId, _T("OFF"), wxDefaultPosition, wxSize(60,18) );
        m_testButtons[r]->Show( false );
        m_buttonIds.Add( buttId );
        Connect( buttId, wxEVT_COMMAND_TOGGLEBUTTON_CLICKED, wxCommandEventHandler( CheckBoxMatrix::OnTestButton ));
        GridSizer1->Add( m_testButtons[r], 0, wxALL, 5 );
    }
/*
	GridSizer1 = new wxFlexGridSizer(row.GetCount()+1,col.GetCount()+2, 0, 0);


    /// 0. col for the rows: spaceer
    GridSizer1->AddStretchSpacer();
    /// 1. col for symbol name col
    tmpStaticText = new wxStaticText( this, wxID_ANY, m_pDesc->m_SymbolName, wxDefaultPosition, wxDefaultSize,
            0,_T("staticText"));
    GridSizer1->Add(tmpStaticText, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    setBold(tmpStaticText);


    ///+ 0. row
    for(size_t i = 0; i < col.GetCount(); i++){
        //wxString colLabel = col.Item(i);
        wxString colLabel = wxString::Format(_T("%i"), col.Item(i));
        tmpStaticText = new wxStaticText( this, wxID_ANY, colLabel, wxDefaultPosition, wxDefaultSize,
            0,_T("staticText"));
        setBold(tmpStaticText);
        GridSizer1->Add(tmpStaticText, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    }



    wxCheckBox* tmpCheckBox;
    int index = 0;
    for(size_t r = 0; r< row.GetCount(); r++){
        /// 0. row header
        wxString rowLabel = row.Item(r);
        tmpStaticText = new wxStaticText( this, wxID_ANY, rowLabel, wxDefaultPosition, wxDefaultSize,
            0,_T("staticText"));
        tmpStaticText->SetBackgroundColour( wxColour( rowColor.Item(r) ) );
        setBold(tmpStaticText);

        GridSizer1->Add(tmpStaticText, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
        /// 1. row summary
        tmpStaticText = new wxStaticText( this, wxID_ANY, _T("00"), wxDefaultPosition, wxDefaultSize,
            0,_T("summary"));
        //tmpStaticText->SetBackgroundColour( wxColour( rowColor.Item(r) ) );
        GridSizer1->Add(tmpStaticText, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
        setBold(tmpStaticText);
        m_summaryCol[r] = tmpStaticText;
        m_rowSum[r] = 0;


        ///
        for(size_t c = 0; c < col.GetCount(); c++){
            long id = wxNewId();
            wxString name = wxString::Format(_T("ID_CHECKBOX-%i"), id);
            tmpCheckBox = new wxCheckBox(this, id, _(""), wxDefaultPosition, wxDefaultSize,
            0, wxDefaultValidator, name);
            tmpCheckBox->SetValue(false);
            tmpCheckBox->SetBackgroundColour( wxColour( rowColor.Item(r) ) );
            GridSizer1->Add(tmpCheckBox, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);

            Connect( id, wxEVT_COMMAND_CHECKBOX_CLICKED, wxCommandEventHandler(CheckBoxMatrix::OnCheckBox) );

            //m_guiIDToCheckbox[id] = tmpCheckBox;
            m_indexToCheckbox[index] = tmpCheckBox;
            m_guiIDToRow[id] = r;
            m_guiIDToCol[id] = c;
            index++;
        }
    }
*/
    topGridSizer1->Add(GridSizer1, 1, wxALL | wxEXPAND/*|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL*/, 5);
	SetSizer(topGridSizer1);
	topGridSizer1->Fit(this);
	topGridSizer1->SetSizeHints(this);
	//*)
}

CheckBoxMatrix::~CheckBoxMatrix()
{
	//(*Destroy(CheckBoxMatrix)
	//*)
}

wxObject* CheckBoxMatrix::getObject(int row, int col)
{
    //int rowSize = m_pDesc.m_groupNames.GetCount();
    int colSize = m_pDesc->m_maskNames.GetCount();

    int index = row * colSize + col;
    wxObject* obj = m_indexToCheckbox[index];
    return obj;
}

int CheckBoxMatrix::getValue(int row)
{
    return   m_rowSum[row];
}

void CheckBoxMatrix::setValue(int row, int col, bool value)
{
    wxObject* obj = getObject(row, col);
    bool iswxCheckBox = obj->IsKindOf(CLASSINFO(wxCheckBox));
    if(!iswxCheckBox){ return; }

    ((wxCheckBox*) obj)->SetValue(value);

     calcSummary(row);
}

void CheckBoxMatrix::OnCheckBox(wxCommandEvent& event)
{
    int id  = event.GetId();
    Logger::logf( LOG_MSG, _T("CheckBoxMatrix::OnCheckBox event id: %i ---------------"), id);
    wxWindow * w = FindWindow(id);
    if(!w){ return; }

    bool iswxCheckBox = w->IsKindOf(CLASSINFO(wxCheckBox));
    if(!iswxCheckBox){ return; }

    bool isChecked = ((wxCheckBox*) w)->IsChecked();

    wxString wName = w->GetName();

    int row = m_guiIDToRow[id];
    int col = m_guiIDToCol[id];
    if(isChecked){ observerNotify(1);}
    else{observerNotify(0);}

    calcSummary(row);
    observerNotify(row, col);


    Logger::logf( LOG_MSG, _T("CheckBoxMatrix::OnCheckBox row:%i,coll:%i"), row, col);
}

void CheckBoxMatrix::calcSummary(int row)
{
    wxArrayString& col = m_pDesc->m_maskNames;
    IntArray& maskValueA = m_pDesc->m_maskValues;

    int value = 0;
    for(size_t c = 0; c < col.GetCount(); c++){
        wxObject* obj = getObject(row, c);
        bool isChecked = ((wxCheckBox*) obj)->IsChecked();
        if(isChecked) value |= maskValueA.Item(c);
    }

    m_rowSum[row] = value;
    /*
    wxObject* obj = m_summaryCol[row];
    wxStaticText* staticText =  (wxStaticText*) obj;

    wxString hexStr = wxString::Format(_T("%02X"), value);
    staticText->SetLabel(hexStr);
    */
}

void CheckBoxMatrix::setOutput( int row, const wxString& output, bool isConflicted, const wxString& conflicts )
{
    int maxrow = (int)m_pDesc->m_maskNames.GetCount();
    if ( row < 0 || row >=maxrow )
        return;

    wxString op = output;
    if ( isConflicted )
    {
        m_outputs[row]->SetForegroundColour( wxColor(255,0,0) );
        op += _T(" (CONFLICTED: ") + conflicts + _T(")");
    }
    else
        m_outputs[row]->SetForegroundColour( wxColor(0,0,0) );

    m_outputs[row]->SetLabel( op );
    GetSizer()->RecalcSizes();
    GetSizer()->Layout();
    GetSizer()->SetSizeHints(this);
    Refresh( false );
}

void CheckBoxMatrix::setBold(wxWindow* w)
{
    wxFont font = w->GetFont();
    font.SetWeight( wxFONTWEIGHT_BOLD );
    w->SetFont( font );
}

void CheckBoxMatrix::showTestButtons( bool show )
{
    wxArrayString& row = m_pDesc->m_groupNames;

    for ( size_t i = 0; i < row.GetCount(); ++i )
    {
        m_testButtons[i]->Show( show );
        if ( show == false && m_testButtons[i]->GetValue() )
        {
            SwitchOffTests( i );
            m_testButtons[i]->SetValue( false );
            m_testButtons[i]->SetLabel( _T("OFF") );
        }
    }
}

void CheckBoxMatrix::OnTestButton( wxCommandEvent& event )
{
    int id = event.GetId();

    int nr = m_buttonIds.Index( id );
    wxArrayString& row = m_pDesc->m_groupNames;

    if ( ( nr != wxNOT_FOUND ) && ( nr < (int)(row.GetCount()) ) )
    {

        wxString command;
        if ( m_testButtons[nr]->GetValue() )
        {
            m_testButtons[nr]->SetLabel( _T("ON") );
            command = wxString::Format( _T("Manmdh%x0bye"), nr+8 );
            // command = wxString::Format( _T("Manmdh8%dbye"), nr);
        }
        else
        {
            m_testButtons[nr]->SetLabel( _T("OFF") );
            //command = wxString::Format( _T("Manmdh0%dbye"), nr);
            command = wxString::Format( _T("Manmdh%d0bye"), nr );
        }
        observerNotify(command);
        Logger::logf(LOG_MSG, _T("CheckBoxMatrix::OnTestButton -- Test button nr. %d pressed"), nr );
        Logger::logf( LOG_MSG, _T("CheckBoxMatrix::OnTestButton - command=")+command );
    }
}

void CheckBoxMatrix::SwitchOffAllsignals()
{
    unsigned char count = m_pDesc->m_groupNames.GetCount();
    for ( unsigned char i = 0; i < count; ++i )
    {
        if ( m_testButtons[i]->GetValue() )
            SwitchOffTests( i );
    }
}

void CheckBoxMatrix::SwitchOffTests( unsigned char outputnr )
{
    wxString command = wxString::Format( _T("Manmdh%d0bye"), outputnr );
    observerNotify(command);
    Logger::logf( LOG_MSG, _T("CheckBoxMatrix::SwitchOffTests off command = ") + command );
}

wxBitmap CheckBoxMatrix::getArrow(  int start_x, int start_y, int end_x, int end_y )
{
    wxBitmap bmp( 30, start_y - end_y );
    wxMemoryDC dc;
    dc.SelectObject( bmp );
    dc.SetBackground( wxSystemSettings::GetColour( wxSYS_COLOUR_3DFACE ) );
    dc.Clear();

    double Hx = start_x;
    double Hy = start_y;
    double Dx = end_x;
    double Dy = end_y;

    double alpha, Ax, Ay, Bx, By, Cx, Cy, Ex, Ey, Fx, Fy, Gx, Gy, Qx, Qy;
    double len = sqrt(pow(Dx-Hx, 2) + pow(Dy-Hy,2));

    double head_inner_angle=0.5255;
    double head_width_ref=0.15;
    double tail_height_ref_out=0.83;
    double tail_height_ref=0.85;
    double tail_width_ref=0.055;

    double W = len * tail_width_ref;

    double beta = head_inner_angle;

    alpha = atan2(Hy-Dy,Dx-Hx);

    Ax = Hx + W/2*cos(M_PI/2-alpha); Ay = Hy + W/2*sin(M_PI/2-alpha);
    Gx = Hx - W/2*cos(M_PI/2-alpha); Gy = Hy - W/2*sin(M_PI/2-alpha);
    Fx = Gx + len*tail_height_ref*cos(alpha); Fy = Gy - len*tail_height_ref*sin(alpha);
    Bx = Ax + len*tail_height_ref*cos(alpha); By = Ay - len*tail_height_ref*sin(alpha);

    Qx = Hx + len*tail_height_ref_out*cos(alpha); Qy = Hy - len*tail_height_ref_out*sin(alpha);

    Ex = Qx + len*head_width_ref*tan(beta)*cos(M_PI/2+alpha);
    Ey = Qy - len*head_width_ref*tan(beta)*sin(M_PI/2-alpha);
    Cx = Qx + len*head_width_ref*tan(beta)*cos(alpha-M_PI/2);
    Cy = Qy - len*head_width_ref*tan(beta)*sin(alpha-M_PI/2);

    wxPoint pts[8];
    pts[0].x = (int)Ax; pts[0].y = (int)Ay;
    pts[1].x = (int)Bx; pts[1].y = (int)By;
    pts[2].x = (int)Cx; pts[2].y = (int)Cy;
    pts[3].x = (int)Dx; pts[3].y = (int)Dy;
    pts[4].x = (int)Ex; pts[4].y = (int)Ey;
    pts[5].x = (int)Fx; pts[5].y = (int)Fy;
    pts[6].x = (int)Gx; pts[6].y = (int)Gy;
    pts[7].x = (int)Hx; pts[7].y = (int)Hy;

    dc.SetBrush( *wxRED );
    dc.SetPen( *wxRED );
    dc.DrawPolygon( 8, pts );

    dc.SelectObject( wxNullBitmap );

    return bmp;
}
