#ifndef CONFIGLETPANEL_H
#define CONFIGLETPANEL_H


#include <wx/wx.h>

#include "../common/types/StringHash.h"
#include "../stdatamanager/STDataViewerBase.h"


struct ChangedSymbol;
class SymbolMgr;
class FirmwareConfigData;

WX_DEFINE_ARRAY( ChangedSymbol*, ArrayOfChangedSymbols );


class ConfigletPanel : public wxPanel, public STDataViewerBase
{
    public:
        ConfigletPanel( wxWindow* parent, const wxString& dirName, SymbolMgr* symbolmgr );
        virtual ~ConfigletPanel();

        void        update() {}
        void        requestRead() {}
        void        updateModel() {}
        void        requestWrite();
        wxString    toString();

    private:
        ArrayOfChangedSymbols       m_changedSymbols;
        wxString                    m_dirName;
        StringHash                  m_configName2FileName;
        SymbolMgr*                  m_symbolMgr;

        void refreshChangedSymbolsFromDeviceModel();
        void clearChangedSymbols();
        void init( const wxString& dirName );
        void OnSelect( wxCommandEvent& event );
        void add(const wxString& fileName, wxArrayString& files);
        void loadHTable(const FirmwareConfigData& fcData, const wxString name);

        DECLARE_EVENT_TABLE();
};


#endif // CONFIGLETPANEL_H
