#ifndef DIALOGSLAYOUTMANAGER_H
#define DIALOGSLAYOUTMANAGER_H

#include <wx/wx.h>
#include <wx/wxsqlite3.h>

class DialogsLayoutManager
{
    public:
        DialogsLayoutManager();
        virtual ~DialogsLayoutManager();

        void OpenDB(const wxString &dbfile = wxEmptyString);

        bool SaveLayout(const wxString &name, const wxPoint &pos, const wxSize &size, bool ismaximized ){
            return SaveLayout(name, pos.x, pos.y, size.x, size.y, ismaximized);
        }

        bool SaveLayout(const wxString &name, int xpos, int ypos, int width, int height, bool ismaximized);

        bool SaveLayout( wxFrame * frame ){
            return SaveLayout( frame->GetTitle(), frame->GetPosition(), frame->GetSize(), frame->IsMaximized() );

        }

        bool LoadLayout(const wxString &name, wxPoint &pos, wxSize &size, bool &ismax);



    protected:

    private:

        wxString    m_dbFileName;

        wxSQLite3Database m_db;

};

#endif // DIALOGSLAYOUTMANAGER_H
