#ifndef EXPRESSIONGRIDWIDGET_H
#define EXPRESSIONGRIDWIDGET_H

#include "../mtconfigdata.h"
#include "../common/types/wxPointArray.h"
#include "../common/types/StringSetArray.h"
#include "../rtdatamanager/RTDataViewerBase.h"
#include "../vemsgauge/ExpressionGridDesc.h"

#include <wx/window.h>
#include <wx/panel.h>

class STDataMgrBase;
class RTDataMgrBase;
class wxGrid;
class DoubleHash;

//class ExpressionGridDescHelper
//{
//    public:
//        static wxArrayString getRTVariables(const ExpressionGridDesc& expGridDesc, const MTConfigData& mtConfigData);
//        static wxArrayString getSTVariables(const ExpressionGridDesc& expGridDesc, const MTConfigData& mtConfigData);
//    private:
//        ExpressionGridDescHelper();
//};


class ExpressionGridWidget: public wxPanel, public RTDataViewerBase //, public STDataViewerBase
{
    public:
        ExpressionGridWidget(
                STDataMgrBase* stController,
                RTDataMgrBase* rtController,
                ExpressionGridDesc* expGridDesc,
                wxWindow* parent,
                wxWindowID id = wxID_ANY,
                const wxPoint& pos = wxDefaultPosition,
                const wxSize& size = wxDefaultSize,
                long style = wxTAB_TRAVERSAL );

        virtual ~ExpressionGridWidget();

        /// RTDataViewerBase
        void SetValue(double value){};
        void refresh(DoubleHash* table);
        void require();
        void unregisterSymbols();
        void SetValueIdx(int idx){};

        static ExpressionGridDesc* testDesc();
    protected:
    private:
        size_t m_rows;
        size_t m_cols;

        STDataMgrBase* m_stController;
        //RTDataMgrBase* m_rtDataMgr;
        ExpressionGridDesc* m_expGridDesc;

        wxGrid* m_grid;
        StringSet m_rtVariables;

        wxPointArray m_variablePointA;
        StringSetArray m_variableSetA;

        bool m_isSymbolsRegistered;
        DoubleHash* m_rtVariablesH;

        bool Create( wxWindow* parent, wxWindowID id, const wxPoint& pos, const wxSize& size, long style);
        void replaceRTVariables(const StringSet& varSet, wxString* cellStr);
        bool getValue(const wxString& name, double& var);
        size_t getVariable(const wxString& str, StringSet& variables);

        enum  { WAIT_DOLLAR, WAIT_START_BRACKET, WAIT_END_BRACKET};
};

#endif // EXPRESSIONGRIDWIDGET_H
