#ifndef STMAPPERVIEWER_H
#define STMAPPERVIEWER_H


#include "../Symbol.h"
#include "../stdatamanager/STDataViewerBase.h"
#include "../common/VemsMatrix.h"


class STMapperViewer : public STDataViewerBase
{
    public:
        STMapperViewer( const Symbol& s );
        virtual ~STMapperViewer();

        void update();

        void requestRead() {}
        void updateModel();
        void requestWrite() {}

        void remap( const VemsMatrix<double>& oldX,
                    const VemsMatrix<double>& oldY,
                    const VemsMatrix<double>& newX,
                    const VemsMatrix<double>& newY );

        wxString toString();

    private:
        VemsMatrix<double>  m_data;
        Symbol              m_symbol;
        bool                m_isAccepted;
};


#endif // STMAPPERVIEWER_H
