#include "SizePosDialog.h"

SizePosDialog::SizePosDialog(wxWindow * parent)
{
    //ctor
    Create(parent, -1, _T("Set size and position"));

    wxBoxSizer * mainsizer = new wxBoxSizer(wxVERTICAL);

    wxFlexGridSizer * flexsizer = new wxFlexGridSizer(2);

    m_xposCtrl = new wxTextCtrl(this, wxID_ANY, _T(""));
    m_yposCtrl = new wxTextCtrl(this, wxID_ANY, _T(""));
    m_widthCtrl = new wxTextCtrl(this, wxID_ANY, _T(""));
    m_heightCtrl = new wxTextCtrl(this, wxID_ANY, _T(""));

    flexsizer->Add( new wxStaticText(this, -1,_T("X Position")), 0, wxALL | wxALIGN_CENTER_VERTICAL , 3 );
    flexsizer->Add( m_xposCtrl, 0, wxALL | wxEXPAND, 3 );
    flexsizer->Add( new wxStaticText(this, -1,_T("Y Position")), 0, wxALL | wxALIGN_CENTER_VERTICAL , 3 );
    flexsizer->Add( m_yposCtrl, 0, wxALL | wxEXPAND, 3 );
    flexsizer->Add( new wxStaticText(this, -1,_T("Width")), 0, wxALL | wxALIGN_CENTER_VERTICAL , 3 );
    flexsizer->Add( m_widthCtrl, 0, wxALL | wxEXPAND, 3 );
    flexsizer->Add( new wxStaticText(this, -1,_T("Height")), 0, wxALL | wxALIGN_CENTER_VERTICAL , 3 );
    flexsizer->Add( m_heightCtrl, 0, wxALL | wxEXPAND, 3 );
/*
    mainsizer->Add( new wxButton(this, wxID_OK, _T("OK")), 0, wxALL | wxALIGN_RIGHT, 3);
    mainsizer->Add( new wxButton(this, wxID_CANCEL, _T("Cancel")), 0, wxALL | wxALIGN_LEFT, 3);
*/
    mainsizer->Add( flexsizer, 0, wxALL, 5 );

    mainsizer->Add( CreateStdDialogButtonSizer( wxOK | wxCANCEL ), 0, wxALL, 5 );


	wxTextValidator validator( wxFILTER_NUMERIC );
	m_xposCtrl->SetValidator(validator);
	m_yposCtrl->SetValidator(validator);
	m_widthCtrl->SetValidator(validator);
	m_heightCtrl->SetValidator(validator);

	SetSizer(mainsizer);
	mainsizer->Fit(this);
	mainsizer->SetSizeHints(this);

}

SizePosDialog::~SizePosDialog()
{
    //dtor
}

void SizePosDialog::SetValues( int xpos, int ypos, int width, int height )
{
    m_xposCtrl->SetValue(wxString::Format(_T("%i"),xpos));
    m_yposCtrl->SetValue(wxString::Format(_T("%i"),ypos));
    m_widthCtrl->SetValue(wxString::Format(_T("%i"),width));
    m_heightCtrl->SetValue(wxString::Format(_T("%i"),height));
}

void SizePosDialog::SetToWindow( wxWindow * win )
{
    if(win == NULL)
        win = GetParent();

    win->Move(GetTargetPosition());
    win->SetSize(GetTargetSize());

}

wxPoint SizePosDialog::GetTargetPosition()
{
    long x,y;
    m_xposCtrl->GetValue().ToLong(&x);
    m_yposCtrl->GetValue().ToLong(&y);
    return wxPoint(x,y);
}

wxSize SizePosDialog::GetTargetSize()
{
    long w,h;
    m_widthCtrl->GetValue().ToLong(&w);
    m_heightCtrl->GetValue().ToLong(&h);
    return wxSize(w,h);
}
