#include "UserDialog.h"

#include <wx/arrimpl.cpp>
WX_DEFINE_OBJARRAY(UserEditFieldArray);

/**********************************************************
*   UserMenuItem methods
**********************************************************/

/** @brief UserEditField
  *
  * @todo: document this function
  */
UserEditField::UserEditField(const wxString& label, const wxString& symbol, const wxString& expr)
    :m_label    (label)
    ,m_symbol   (symbol)
    ,m_expr     (expr)
{
    //ctor
}

/** @brief ~UserEditField
  *
  * @todo: document this function
  */
UserEditField::~UserEditField()
{
    //dtor
}

/**********************************************************
*   UserDialog methods
**********************************************************/

/** @brief UserDialog
  *
  * @todo: document this function
  */
IMPLEMENT_CLASS(UserDialog, wxObject)

UserDialog::UserDialog(const wxString& name, const wxString& title, int offset)
    :m_name     (name)
    ,m_title    (title)
    ,m_offset   (offset)
{
    //ctor
}

/** @brief ~UserDialog
  *
  * @todo: document this function
  */
UserDialog::~UserDialog()
{
    //dtor
}

/** @brief add
  *
  * @todo: document this function
  */
void UserDialog::add(const wxString& label, const wxString& symbol, const wxString& expr)
{
    m_uefs.Add(new UserEditField(label, symbol, expr));
}

/** @brief operator[]
  *
  * @todo: document this function
  */
UserEditField* UserDialog::operator[](uint16_t i) const
{
    if( i<m_uefs.GetCount() ){
        return &m_uefs[i];
    }else{
        return NULL;
    }
}

void UserDialog::addHelpTextLine( const wxString& helpText )
{
    m_HelpText.Append( helpText + _T("\n") );
    // remove <br> if exist
    int tagIdx = m_HelpText.Find( _T("<br>") );
    if ( tagIdx != wxNOT_FOUND ) { m_HelpText.Remove( tagIdx, 4 ); }
}

void UserDialog::setHelpID( const wxString& helpID )
{
    m_HelpID = helpID;
}

/**********************************************************
*   UserDialogList methods
**********************************************************/

/** @brief UserDialogList
  *
  * @todo: document this function
  */
UserDialogList::UserDialogList()
{
    //ctor
}

/** @brief ~UserDialogList
  *
  * @todo: document this function
  */
UserDialogList::~UserDialogList()
{
    //ctor
}

/** @brief add
  *
  * @todo: document this function
  */
void UserDialogList::add(const wxString& name,const wxString& title, int offset)
{
    if(m_uds.find(name) == m_uds.end()){
        m_uds[name] = new UserDialog(name, title, offset);
    }
}

/** @brief add
  *
  * @todo: document this function
  */
void UserDialogList::add(const wxString& dialog, const wxString& label, const wxString& symbol, const wxString& expr)
{
    m_uds[dialog]->add(label, symbol, expr);
}

/** @brief find
  *
  * @todo: document this function
  */
UserDialog* UserDialogList::find( const wxString& dialog )
{
    if( m_uds.find( dialog ) != m_uds.end() )
    {
        return m_uds[ dialog ];
    }
    else
    {
        return NULL;
    }
}

UserDialog* UserDialogList::findByHelpID( const wxString& helpID )
{
    for ( StringToUserDialogHash::const_iterator it = m_uds.begin(); it != m_uds.end(); ++it )
    {
        if ( helpID.IsSameAs( it->second->getHelpID() ) )
        {
            return it->second;
        }
    }

    return NULL;
}

void UserDialogList::setHelpID( const wxString& dialog, const wxString& helpID )
{
    m_uds[dialog]->setHelpID( helpID );
}

void UserDialogList::addHelpTextLine( const wxString& dialog, const wxString& helpText )
{
    m_uds[dialog]->addHelpTextLine( helpText );
}

void UserDialogList::clear()
{
    WX_CLEAR_HASH_MAP( StringToUserDialogHash, m_uds );
}
