#ifndef USERDIALOGFRAME_H
#define USERDIALOGFRAME_H

#include <wx/wx.h>
#include "UserDialogFrameBase.h"
#include "../FirmwareVersion.h"

class StaticViewersController;
class RTDataMgrBase;
class STDataMgrBase;
class VemsTableDesc;
class TblMapDesc;
class SuperCurveDescriptor;
class VemsCurveDialogDescH;
class UserDialog;
class UserDialogTemplate;
class SymbolTable;
class CheckBoxMatrixDesc;
class DialogsLayoutManager;
class VemsCurveDialogDesc;
class InterpolationWidgetDescriptor;
class UserDialogBase;
class SymbolMgr;
class CalibrationDesc;
class CommandRequestBase;
class MTConfigData;
class GaugeDescManager;
class StaticControlPanel;

//class UserDialogFrame : public wxFrame
class UserDialogFrame : public UserDialogFrameBase
{
    public:
        UserDialogFrame( wxWindow* parent, ConfigValidatorBase* validator = NULL, UserDialogBase* udManager = NULL, DialogsLayoutManager * dlglayoutmgr = NULL );
        virtual ~UserDialogFrame();

        void setSymbolsToMark( const wxArrayString& syms ) { m_symbolsToMark = syms; }

        //void setMenuId(int id);
        void createDialog( const UserDialog& desc, SymbolMgr* symbolMgr, STDataMgrBase* stMgr);

        void createTable( const VemsTableDesc& desc, STDataMgrBase* stMgr, RTDataMgrBase* realtimeController, MTConfigData* mtconfigdata, GaugeDescManager* gaugeDescMgr);
        void createCurve( VemsCurveDialogDesc* desc, STDataMgrBase* stMgr, RTDataMgrBase* realtimeController, SymbolMgr* symbolmgr);
        void createSuperCurve(  SuperCurveDescriptor* superCurveDesc, VemsCurveDialogDescH* curveDescs,
                                STDataMgrBase* stMgr, RTDataMgrBase* realtimeController,
                                SymbolMgr* symbolmgr );

        void createInterpolationWidget( InterpolationWidgetDescriptor* desc, STDataMgrBase* stMgr, RTDataMgrBase* realtimeController );
        void createMapper( const TblMapDesc& desc,
                           STDataMgrBase* stMgr,
                           SymbolTable* symbols );
        void create( SymbolMgr* symbolmgr, CheckBoxMatrixDesc* desc, STDataMgrBase* stMgr, CommandRequestBase* requestMgr);
        void createOutputChannelsDialog( const wxString& title, STDataMgrBase* stMgr,
            CommandRequestBase* requestMgr, SymbolTable* symbols );

        void createIgnitionOutputsVisual(   const wxString& title,
                                            STDataMgrBase* stMgr,
                                            SymbolTable* symbols,
                                            CommandRequestBase* requestHandler );

        void createRoundDisplaySettingsDialog( const wxString& title, STDataMgrBase* stMgr, RTDataMgrBase* rtMgr,
                                                SymbolTable* symbols, SymbolMgr* symMgr, FirmwareVersion fwVersion,
                                                CommandRequestBase* requestMgr );

        void createRoundDisplayDemoDialog(  const wxString& title, STDataMgrBase* stMgr, SymbolTable* symbols, SymbolMgr* symMgr );

        //void addCalibrationPanel( const CalibrationDesc& calDesc, STDataMgrBase* stMgr);
        //bool onDropFiles( const wxArrayString& filenames );

        //friend class SuperCurveEditor;
    protected:
        wxArrayString               m_symbolsToMark;

    private:

        UserDialogBase*             m_udManager;
/*
        StaticViewersController*    m_stViewersCtrl;
        DialogsLayoutManager*       m_dlgLayoutMgr;
        UserDialogBase*             m_udManager;
        int                         m_menuId;
        StaticControlPanel*         m_ctrlPanel;

        void        addControlPanel( StaticViewersController* stViewersCtrl, int buttons );
        bool        loadLayout( const wxString& title );
        void        prepareAndShow( const wxString& title );
        void        setLayout( const wxString& title );
        void        setLayout( UserDialogTemplate* dialog, const wxString& title );
        void        connectKeyDownEvent( wxWindow* pclComponent );
        void        connectKeyUpEvent( wxWindow* window );

        void        setStaticViewersController( StaticViewersController* stViewersCtrl );
        StaticControlPanel* getControlPanel() { return m_ctrlPanel; }

        void        OnKeyDown( wxKeyEvent& event );
        void        OnKeyUp( wxKeyEvent& event );
        void        OnClose( wxCloseEvent& event );
        void        OnActivate( wxActivateEvent& event );
        DECLARE_EVENT_TABLE()
    */
};

#endif // USERDIALOGFRAME_H
