#include "WindowTipper.h"

#include "../logger.h"

BEGIN_EVENT_TABLE(WindowTipper, wxFrame)

    EVT_TIMER(idTimer,WindowTipper::OnTimer)

END_EVENT_TABLE()

WindowTipper::WindowTipper(wxWindow * parent, int id, const wxPoint &pos)
    :m_timer(this,idTimer)
{
    //ctor
    m_parent = parent;
    Create(parent, id, _T(""), pos, wxSize(-1,-1), wxBORDER_SIMPLE |wxFRAME_FLOAT_ON_PARENT | wxFRAME_NO_TASKBAR );

    SetBackgroundColour(wxSystemSettings::GetColour(wxSYS_COLOUR_INFOBK));
    ClearBackground();




   // m_msgWin = new wxHtmlWindow(this, wxID_ANY);

    m_mainsizer = new wxBoxSizer(wxVERTICAL);

    m_msgWin = new wxStaticText(this,-1,_T(""));

    m_msgWin->SetBackgroundColour(wxSystemSettings::GetColour(wxSYS_COLOUR_INFOBK));

    m_mainsizer->Add(m_msgWin, 1, wxALL | wxEXPAND,2);

	SetSizer(m_mainsizer);
	m_mainsizer->Fit(this);
	m_mainsizer->SetSizeHints(this);
}

WindowTipper::~WindowTipper()
{
    //dtor
}

/** @brief HideWin
  *
  * @todo: document this function
  */
void WindowTipper::HideWin()
{
    Hide();
    m_timer.Stop();
}

/** @brief ShowMsg
  *
  * @todo: document this function
  */
void WindowTipper::ShowMsg(const wxString &msg, int showlenms, bool moveToParentCorner )
{
    Show(true);
    m_timer.Start(showlenms,wxTIMER_ONE_SHOT);
    m_msgWin->SetLabel( msg );
    m_mainsizer->Fit(this);
    if(!m_parent) return;
    if ( moveToParentCorner ) Move( m_parent->GetScreenPosition() );
    m_parent->SetFocus();
}

/** @brief OnTimer
  *
  * @todo: document this function
  */
void WindowTipper::OnTimer(wxTimerEvent &evt)
{
   Hide();
}
