#ifndef GPSCOMPASSGAUGE_H
#define GPSCOMPASSGAUGE_H

#include "VemsWidgetBase.h"

class GPSCompassGauge : public VemsWidgetBase
{

    DECLARE_DYNAMIC_CLASS( GPSCompassGauge );

    public:
        GPSCompassGauge();
        GPSCompassGauge( wxWindow* parent, wxWindowID id, GaugeDescManager* gdmgr, GaugeProperties &prop );
        ~GPSCompassGauge();

        // vemswidgetbase
        wxRegion    GetShape();
        wxRegion    GetBorderRegion();
        void        UpdateSize();
        void        setSize( int x, int y ) {}
        void        InitGauge();

        // RTDataViewerBase
        void        SetValue( double value );

        // Themeable
        void        SetNewTheme( WidgetThemeTable* theme );

    protected:
        void        GaugeRefresh();

    private:
        bool        m_needResize;
        wxStopWatch m_sp;
        double      m_course;
        wxBitmap*   m_compassBg;

        void        getCompassBg( int w, int h );
        wxBitmap*   getArrow( int w, int h );

        void        OnPaint( wxPaintEvent& event );
        void        OnSize( wxSizeEvent& event );

    DECLARE_EVENT_TABLE()
};

#endif // GPSCOMPASSGAUGE_H
