#ifndef GAUGECARRIERADVFRAME_H
#define GAUGECARRIERADVFRAME_H


#include <wx/frame.h>

#include "../rtdatamanager/RTDataViewerBase.h"

#include "../vemsdialog/UserDialog.h"
#include "../gaugedesc/GaugeProperties.h"

class CalibrationBase;
class STDataMgrBase;
class RTDataMgrBase;
class SymbolMgr;
//class GaugeProperties;
//class UserDialog;

class CalibrationDesc
{
    public:
        CalibrationDesc(const wxString& dialogName)
        {
            m_dialogName = dialogName;
            m_userDialog = NULL;
        }

        GaugeProperties& getGaugeProp(){
            return m_gaugeProp;
        }

        UserDialog* getUserDialog(){
            return m_userDialog;
        }

        void setUserDialog(const UserDialog& userDialog){
            //m_userDialog = userDialog;
        }
        void setGaugepProp(const GaugeProperties& gaugeProp){
            m_gaugeProp = gaugeProp;
        }
    private:
        wxString m_dialogName;
        GaugeProperties m_gaugeProp;
        UserDialog* m_userDialog;
};

class GaugeCarrierAdvFrame: public wxFrame
{
    public:
        GaugeCarrierAdvFrame(wxWindow* parent, wxWindowID id, const wxString& title,
                        const wxPoint& pos = wxDefaultPosition, size_t gaugeCount = 2,
                        long style = wxDEFAULT_FRAME_STYLE);
        virtual ~GaugeCarrierAdvFrame();

        void SetCalibrationBase(CalibrationBase* calibrationBase);
        void SetDataMgrObj(RTDataMgrBase *rtDataMgr);
        void SetDataMgrObj(STDataMgrBase *stDataMgr);

        void setCalibrationDesc(CalibrationDesc* desc);
        bool addGauge(GaugeProperties& prop);
        bool addDialog(UserDialog* userDialogDesc, SymbolMgr* symbolmgr);
        ///void addPanel(wxPanel* panel);
/*
        void registerCalibration(CalibrationBase& calibrationbase);
        void start();
        void stop();
        void autoCalibrate();
*/
        static CalibrationDesc getWBO2CallDesc();
    protected:
    private:
        CalibrationBase* m_calibrationBase;
        STDataMgrBase*  m_stDataMgr;
        RTDataMgrBase*  m_rtDataMgr;
        wxBoxSizer*     m_dialogSizer;

        ViewerBaseArray m_viewers;

        void buildGUI(wxWindow* parent);
        void unregisterViewer();


};

#endif // GAUGECARRIERADVFRAME_H
