#ifndef GAUGECARRIERBASE_H
#define GAUGECARRIERBASE_H

#include <wx/mdi.h>
#include <wx/region.h>
#include <wx/frame.h>
#include <wx/hashmap.h>


#include "WidgetFactoryBase.h"
//#include "../rtdatamanager/RTDataViewerBase.h"
#include "../common/types/wxControlHash.h"
#include "../common/types/wxWindowHashInt.h"
#include "../common/types/wxVariantHash.h"
#include "../common/typedef.h"



//class ThemeAble;
//class RTDataViewerBase;
//class TableEditor;
//class MTConfigData;
class GaugeGroupManager;
//class GaugeDescManager;
//class RTDataMgrBase;
//class STDataMgrBase;
//class LogHistoryBase;


//class VemsWidgetBase;
//class GroupMember;
class GaugeProperties;
//class VemsToolIconBase;
class WindowReg;
class VemsTaskBarIcon;

class VemsControlBase;
class GaugeCarrierBaseDesc;


class GaugeCarrierBase
{
    public:

/// stay

        GaugeCarrierBase(wxWindow * parent);
        virtual ~GaugeCarrierBase();

        void InitWindow(wxFrame * frame);
        void InitWindow(wxPanel * panel);
#if !defined(__WINCE_STANDARDSDK__) && !defined(__POCKETPC__)
        void InitWindow(wxMDIChildFrame * frame);
#endif

        virtual void connectKeyDownEvent( wxWindow* window ) = 0;
        virtual wxString GetTheme() = 0;
        virtual void ShowCarrier(bool isShow) = 0;
        virtual void CloseCarrier() = 0;
        virtual void CloseGauge(int winid, bool eraseHash = true) = 0;
        virtual void ResetMinMax() = 0;
        virtual void SetFocusToItem(int id = -1) = 0;
        virtual void SetEditMode(bool isedit) {};
        virtual void ProcessWidgetCommand(wxVariantHash& cmdHash) {};
        virtual void SetShaped(bool isShaped);
        void SetGaugeShowInit( bool GaugeShowInit );
        bool IsGaugeShowInit();
        void SetVirtualPos(const wxPoint &pos) { m_virtPos = pos; };
        wxPoint GetVirtualPos() { return m_virtPos; };
        void FitInnerSizer();


//        VemsWidgetBase* GetVemsWidget() { return m_gauge; };
//        TableEditor* GetTableEditor() { return m_table; };
        //ThemeAble * GetThemedObj() { return m_themedObj; };


        /// use the desc
        void ClearFrame(void);
        void SetWindowReg(WindowReg *wreg);
        void ClearFrameShape();
        //void SetCustomControlHash(wxWindowHashInt *customControlHash);
        void OnlyOneGauge(bool is);
        bool IsOnlyOneGauge();
        //wxWindowHashInt* GetControlHash();
        void unregisterViewer();
        int getType();
        //void RegIcon(int id, VemsToolIconBase *icon);
        void SetBGColor( const wxColor& color);
        void SetFloating( bool isfloat );
        bool IsFloating();
        wxWindowHashInt& GetIDControlHash();
        void setTaskBarIcon(VemsTaskBarIcon *ptr);
//        bool isDefGaugeDesc();
//        wxString GetDesc();


///del
//        void SetDataMgrObj(RTDataMgrBase *rtDataMgr);
//        void SetDataMgrObj(STDataMgrBase *stDataMgr);
//        RTDataMgrBase* GetDataMgrObj(void);
//        //void setOrientation( int orient = wxHORIZONTAL ) { m_orientation = orient; }
//        //int getOrientation() { return m_orientation; };
//        void SetLogHistory(LogHistoryBase * lhb) { m_logHistory = lhb; };
        void SetGroupMgr(GaugeGroupManager* mgr) { m_groupMgr = mgr; };
//




///move
        wxWindow* AddGauge( GaugeProperties &prop );
        wxWindow* AddVemsTable( GaugeProperties &prop );

        //int AddStateWidget(const wxString name, wxPoint pos, int size, bool isShow = false);

        void SetFactory(const wxString& type, WidgetFactoryBase* factory);
        void SetFactory(WidgetFactoryBaseHash& factories);
        void SetFactory(WidgetFactoryBase* factory);

        VemsControlBase* GetWidgetControl()  { return m_control; };

    protected:


        GaugeCarrierBaseDesc*   m_desc;

        WidgetFactoryBaseHash   m_widgetFactories;


//    /// to desc
//        wxFrame         *m_frame;
//        wxPanel         *m_panel;
//        wxWindow        *m_window;
//        WindowReg       *m_wreg;
//        wxWindowHashInt *m_CustomControlHash;
//        wxRegion        m_region;
//        int             m_type;
//        wxWindowHashInt m_IDtoControls;
//        bool            m_isStoreScreens;
//        bool            m_hasShape;
//        uint8_t         m_graphQual;
//        bool            m_onlyOneGauge;
//        bool            m_floating;
//        bool            m_GaugeShowInit;


    /// stay
//        ViewerBaseArray     m_viewers;
        VemsTaskBarIcon*    m_TaskBarIconApp;
        wxPoint             m_virtPos;

        VemsControlBase*    m_control; /// use only m_desc->m_onlyOneGauge is true

        //VemsWidgetBase*     m_gauge;
        //TableEditor*        m_table;
        //ThemeAble*          m_themedObj;

    /// move
        GaugeGroupManager*  m_groupMgr;
//        LogHistoryBase*     m_logHistory;
//        RTDataMgrBase*      m_rtDataMgr;
//        STDataMgrBase*      m_stController;

    /// del
        //wxString        m_rootdir;
        //int             m_orientation;


};

#endif // GAUGECARRIERBASE_H
