#include "GaugeCarrierMDIChildFrame.h"

#include "../logger.h"
#include "TableEditorPanel.h"

#include "../ThemeAble.h"
#include "../ThemesHelper.h"
#include "../rtdatamanager/RTDataViewerBase.h"

#include "GaugeCarrierBaseDesc.h"
#include "VemsControlBase.h"

BEGIN_EVENT_TABLE(GaugeCarrierMDIChildFrame, wxMDIChildFrame)

    EVT_LEFT_DCLICK(GaugeCarrierMDIChildFrame::OnDoubleClick)

    EVT_KEY_DOWN(GaugeCarrierMDIChildFrame::OnChar)



END_EVENT_TABLE()

GaugeCarrierMDIChildFrame::GaugeCarrierMDIChildFrame(wxMDIParentFrame * parent, int id, const wxPoint &pos, const wxSize &size, int style)
    :GaugeCarrierBase (parent)
{
    Create(parent,id,_T("test"), pos, size, style);
    InitWindow(this);
    //ctor
    SetBackgroundColour(wxColour(0,0,0));


    m_desc->m_hasShape = true;

    m_desc->m_graphQual = 2;
    m_desc->m_type = -1;
    //m_orientation = wxVERTICAL;



}

GaugeCarrierMDIChildFrame::~GaugeCarrierMDIChildFrame()
{
    //dtor
}


void GaugeCarrierMDIChildFrame::SetFocusToItem(int id)
{

}

wxString GaugeCarrierMDIChildFrame::GetTheme()
{
    if(m_control){
        ThemeAble* w = dynamic_cast<ThemeAble*>(m_control);
        if(w)
            return w->GetThemeName();
    }

        return ThemesHelper::m_defaultThemeName;
}

void GaugeCarrierMDIChildFrame::ShowCarrier(bool isShow)
{

};

void GaugeCarrierMDIChildFrame::CloseCarrier()
{
    Logger::logf(LOG_MSG,_T("GaugeCarrierMDIChildFrame::CloseCarrier()"));

    for( wxWindowHashInt::iterator it = m_desc->m_IDtoControls.begin(); it != m_desc->m_IDtoControls.end(); it++ ){
        CloseGauge( it->first );
    }
    Destroy();



};

void GaugeCarrierMDIChildFrame::CloseGauge(int winid, bool eraseHash)
{
    if(winid == -1 || !m_desc->m_IDtoControls[winid] ) {
        Destroy();
        return;
    }


    m_desc->m_IDtoControls[winid]->Hide();

    m_desc->m_IDtoControls[winid]->GetParent()->GetParent()->SetFocus();


    m_desc->m_IDtoControls.erase(winid);

    RTDataViewerBase * vwb = 0;
    TableEditorPanel* tep = 0;

    if(vwb = dynamic_cast<RTDataViewerBase*> (m_desc->m_IDtoControls[winid])){
        vwb->UnRegisterViewer();
    } else if(tep = dynamic_cast<TableEditorPanel*> (m_desc->m_IDtoControls[winid])){
        //tep->GetTableEditor()->UnRegisterViewer();
        wxWindow* t = tep->GetTable();
        VemsControlBase* vcb = dynamic_cast<VemsControlBase*>(t);
        if(vcb) vcb->b_UnRegisterViewer();
    }

};

void GaugeCarrierMDIChildFrame::ResetMinMax()
{

};


void GaugeCarrierMDIChildFrame::connectKeyDownEvent( wxWindow* window )
{
    //Logger::logf( LOG_MSG, _T("GaugeCarrierMDIChildFrame::connectKeyDownEvent") );
    if( window )
    {
        window->Connect( wxID_ANY,
                         wxEVT_KEY_DOWN,
                         wxKeyEventHandler( GaugeCarrierMDIChildFrame::OnChar ),
                         (wxObject*) NULL,
                         this );

        wxWindowListNode* node = window->GetChildren().GetFirst();

        while( node )
        {
            wxWindow* child = node->GetData();
            this->connectKeyDownEvent( child );

            node = node->GetNext();
        }
    }
}




void GaugeCarrierMDIChildFrame::OnChar( wxKeyEvent& event )
{
    int keyCode = event.GetKeyCode();

    // Logger::logf( LOG_MSG, _T("GaugeCarrierFrame::OnChar() - %c"), keyCode );

    switch( keyCode )
    {
        case WXK_ESCAPE :
        {
            GetParent()->SetFocus();
        }break;
        case 'R' :
        {
            if( event.AltDown() && m_control ) { m_control->b_refreshData(); }
            else { event.Skip(); }//Logger::logf( LOG_MSG, _T("GaugeCarrierFrame::OnChar() - %c"), keyCode ); }

        }break;
        case 'W' :
        {
            if( event.AltDown() && m_control ) { m_control->b_writeData(); }
            else { event.Skip(); }
        }break;
        case 'B' :
        {
            if( event.AltDown() && m_control ) { m_control->b_burnData(); }
            else { event.Skip(); }
        }break;
        case 'G' :
        {
            if ( m_control ) { m_control->b_showTable3D(); }
        } break;
/*
        case 'T' :
        {
            wxString name = ::wxGetTextFromUser( _T(""),
                                                _T("Change table!"),
                                                _T(""),
                                                this,
                                                wxDefaultCoord,
                                                wxDefaultCoord,
                                                true );
            if ( m_table ) { m_table->change( name ); }
        } break;
    */
        default :
        {
            event.Skip();
        }
    }
}




void GaugeCarrierMDIChildFrame::OnDoubleClick(wxMouseEvent& WXUNUSED(evt))
{
    Logger::logf(LOG_MSG,_T("GaugeCarrierMDIChildFrame::OnDoubleClick() START"));

    //region.ConvertToBitmap().SaveFile(_T("region.bmp"),wxBITMAP_TYPE_BMP,0);

    if(m_desc->m_onlyOneGauge ) {

        SetWindowStyleFlag(GetWindowStyle()|wxRESIZE_BORDER);
//        SetWindowStyleFlag(GetWindowStyle()&~wxRESIZE_BORDER);

    }




}
