#ifndef GAUGEFRAMEBASE_H
#define GAUGEFRAMEBASE_H

#include <wx/region.h>
#include <wx/frame.h>
#include <wx/hashmap.h>
//#include <wx/keybinder.h>

#include "../rtdatamanager/RTDataViewerBase.h"
#include "../ThemeAble.h"
#include "VemsWidgetBase.h"
#include "../common/types/wxControlHash.h"

class RTDataMgrBase;
class STDataMgrBase;
class VemsToolIconBase;
//class VemsWidgetBase;

class WindowReg;
class VemsTaskBarIcon;
class TableEditor;
//class ThemeAble;

//WX_DECLARE_HASH_MAP(int, wxControl*, wxIntegerHash, wxIntegerEqual, wxControlHash);

//WX_DECLARE_HASH_MAP(int, ThemeAble*, wxIntegerHash, wxIntegerEqual, ThemeAbleHash);

class GaugeFrameBase: public wxFrame
{
    public:
        GaugeFrameBase( wxWindow* parent,
                        wxWindowID id,
                    //    VemsTuneController * ctrl,
                        const wxString& title,
                        const wxPoint& pos = wxDefaultPosition,
                        const wxSize& size = wxDefaultSize,
                        long style = wxDEFAULT_FRAME_STYLE);

        virtual ~GaugeFrameBase();

        void SetDataMgrObj(RTDataMgrBase *rtDataMgr);
        void SetDataMgrObj(STDataMgrBase *stDataMgr);
        RTDataMgrBase* GetDataMgrObj(void);
/*
        VemsWidgetBase* AddGauge(int itemid, const VEMSGaugeDescArray * vemsGaugeDescA, const WidgetThemeTableArray * themes, const wxString type, const wxString& symbolName = _T("rpm"), wxPoint pos = wxPoint(0,0),
                      int width = 200, int height = 100, bool ShowBorder = 1, GaugeGroupManager* groupManager = NULL,
                      const wxString groupName = wxEmptyString, const wxString& currTheme = ThemesHelper::m_defaultThemeName, const wxString& desc = _T("defaultdesc"), const wxString& ghotkey = _T(""));
                      */
        VemsWidgetBase* AddGauge( GaugeDescManager * gaugemgr, GaugeProperties &prop );

      // int AddIcon(const wxString name, wxPoint pos, wxMenu *menu = NULL);

        int AddStateWidget(const wxString name, wxPoint pos, int size, bool isShow = false);
        int AddFlagWidget(const wxString &name, wxPoint pos, int size);
        GroupMember* AddFlagWidget( const wxString& name, GaugeGroupManager* groupManager = NULL, const wxString groupName = wxEmptyString );
        GroupMember* AddVemsTable( GaugeDescManager * gaugemgr, GaugeProperties &prop );
        //const wxString& symbolName, wxPoint pos, int width, bool hasControlPanel = false,
          //                GaugeGroupManager* groupManager = NULL, const wxString groupName = wxEmptyString );

        void OnlyOneGauge(bool is) { m_onlyOneGauge = is; };

        void ClearFrame(void);

        void SetWindowReg(WindowReg *wreg);

        //void SetVemsTuneController(VemsTuneController * ctrl) {    m_vemsTuneController = ctrl; } ;

        void SetRootDir(wxString dir);
        void setTaskBarIcon(VemsTaskBarIcon *ptr);

        void ClearFrameShape();

        void SetCustomControlHash(wxControlHash *customControlHash);

        wxControlHash* GetControlHash();

        void InitInputSources();

        void unregisterViewer();
        int getType() { return m_type; }
        void setOrientation( int orient = wxHORIZONTAL ) { m_orientation = orient; }
        int getOrientation() { return m_orientation; };

        wxString& GetTheme() {
            if(m_themedObj)
                return m_themedObj->GetThemeName();
            else
                return ThemesHelper::m_defaultThemeName;
        };

        ThemeAble * GetThemedObj() { return m_themedObj; };

        wxString GetDesc() {
            if(m_gauge)
                return m_gauge->GetSelectedGaugeDesc();
            else
                return _T("defaultdesc");
        };

        bool isDefGaugeDesc() {
            if(m_gauge)
                return m_gauge->isDefaultGaugeDesc();
            else
                return true;
        };

        void RegIcon(int id, VemsToolIconBase *icon);

        VemsWidgetBase* GetVemsWidget() { return m_gauge; };

    protected:
        DECLARE_EVENT_TABLE();
        //wxADD_KEYBINDER_SUPPORT();

    private:
//        VemsTuneController  *m_vemsTuneController;

        WindowReg       *m_wreg;
        VemsTaskBarIcon *m_TaskBarIconApp;
        wxControlHash   *m_CustomControlHash;
        RTDataMgrBase   *m_rtDataMgr;
        STDataMgrBase   *m_stController;
        ThemeAble       *m_themedObj;
        VemsWidgetBase  *m_gauge;  /// use only m_onlyOneGauge is true
        TableEditor     *m_table;

        wxString        m_rootdir;
        wxControlHash   m_IDtoControls;

        ViewerBaseArray m_viewers;
        wxRegion        m_region;

        int             m_type;
        int             m_orientation;  //multigauge flags orientation
                                      //multigauge frame contains only flag widgets
        bool m_isStoreScreens;
        bool hasShape;
        uint8_t m_graphQual;
        bool m_onlyOneGauge;

        void OnActivate(wxActivateEvent& evt);
        void OnLeftDown(wxMouseEvent& evt);
        void OnFrameClose(wxCloseEvent& event);
        void OnDoubleClick(wxMouseEvent& WXUNUSED(evt));
        void connectKeyDownEvent( wxWindow* window );
        void OnChar(wxKeyEvent& event);
        void OnMove( wxMoveEvent& event );
};




#endif // GAUGEFRAMEBASE_H
