#ifndef MVG_TOOLBARPANEL_H
#define MVG_TOOLBARPANEL_H

#include <wx/wx.h>

#include "../../bcWidgets/BitmapCanvasParentBase.h"

class bcButton;
class MultiValueGraph;
class wxBitmapToggleButton;

class MVG_ToolbarPanel: public wxPanel, public BitmapCanvasParentBase
{
    public:
        MVG_ToolbarPanel(MultiValueGraph * graphParent);
        virtual ~MVG_ToolbarPanel();

        bool SendCommand(const wxString& cmd, wxVariant var);

        wxVariant GetValue(const wxString& type);

        void UpdateSize(const wxSize& size);
    protected:

        void OnText(wxCommandEvent& evt);

        void OnMouse(wxMouseEvent& evt);

        void OnButton(wxCommandEvent& evt);

        void OnPaint(wxPaintEvent& evt);

    private:

        enum {
            idButtonZoomIn = 3000,
            idButtonZoomOut,
            idButtonZoomOri,
            idButtonZoomFitSel,
            idButtonMarkerDlg,
            idButtonRTOnlineRefresh,
            idButtonOpenDescEditor,
            idButtonOpenThemeEditor,
            idZoomBox,
            idButtonRefresh,
            idButtonSearch
        };

        wxBitmapButton  *       m_zoomInBtn;
        wxBitmapButton  *       m_zoomOutBtn;
        wxBitmapButton  *       m_zoomOriBtn;
        wxBitmapButton  *       m_zoomFitSelBtn;

        bcButton *  m_refreshButton;

        wxComboBox      *   m_zoomBox;

        MultiValueGraph *   m_graph;

        DECLARE_EVENT_TABLE();

};

#endif // MVG_TOOLBARPANEL_H
