#ifndef SELECTABLEWIDGETBASE_H
#define SELECTABLEWIDGETBASE_H

#include "../common/types/wxVariantHash.h"

#define ptrdel(ptr) \
    if( (ptr) != NULL ) { delete (ptr); (ptr) = NULL; }

class SelectableWidgetRendererBase;

class SelectableWidgetBase
{
    public:
        SelectableWidgetBase(SelectableWidgetRendererBase* renderer = NULL);
        virtual ~SelectableWidgetBase();

        virtual void ProcessWidgetCommand(wxVariantHash& cmdHash) = 0;

        virtual void SetRenderer(SelectableWidgetRendererBase* renderer) { m_renderer = renderer; };
        virtual SelectableWidgetRendererBase* GetRenderer() { return m_renderer; }

        bool IsSelected();
        void SetSelected(bool isSel);

        wxBitmap* GetSelectionBitmap() { return m_selectionBitmap; };

        void DrawSelectionBitmap(wxWindow* win);
        void DrawSelectionBitmap(const wxRect& rect);

    protected:

        SelectableWidgetRendererBase* m_renderer;

        bool m_isSelected;

        wxBitmap*   m_selectionBitmap;

};

#endif // SELECTABLEWIDGETBASE_H
