#include "SelectableWidgetRendererAgg.h"

#include "../agg/wxAgg2.h"

SelectableWidgetRendererAgg::SelectableWidgetRendererAgg()
{
    //ctor
}

SelectableWidgetRendererAgg::~SelectableWidgetRendererAgg()
{
    //dtor
}

wxBitmap* SelectableWidgetRendererAgg::Render(const wxRect& rect)
{
    double w = rect.width;
    double h = rect.height;

    wxAgg2 aggCanvas(rect.width,rect.height);

    aggCanvas.getBrush()->SetStyle( wxAGGBRUSH_SOLID );
    aggCanvas.getPen()->SetStyle( wxAGGPEN_TRANSPARENT );

    aggCanvas.setBrush(m_faceColor);
    aggCanvas.drawRectangle( 0,0, w, h );

    aggCanvas.setBrush(m_markerColor);

    double r = m_markerWidth;

    aggCanvas.drawRectangle( 0,0,r, r );
    aggCanvas.drawRectangle( w-r,0,r,r );
    aggCanvas.drawRectangle( w-r,h-r,r,r );
    aggCanvas.drawRectangle( 0,h-r,r,r );

    return aggCanvas.renderToBitmap();
}
