#ifndef TABLEEDITORFACTORY_H
#define TABLEEDITORFACTORY_H

#include "WidgetFactoryBase.h"

class GaugeDescManager;
class GaugeGroupManager;
class RTDataMgrBase;
class STDataMgrBase;
class MTConfigData;

class GaugeCarrierBaseDesc;


class TableEditorFactory: public WidgetFactoryBase
{
    DECLARE_DYNAMIC_CLASS(TableEditorFactory);

    public:
        TableEditorFactory();
        virtual ~TableEditorFactory();

        virtual VemsControlBase* CreateWidget(GaugeProperties &prop, GaugeCarrierBaseDesc* desc);

        void SetGaugeDescManager(GaugeDescManager* gdmgr) { m_gdMgr = gdmgr; };
        void SetGaugeGroupManager(GaugeGroupManager* grpmgr) { m_groupMgr = grpmgr; };
        void SetSTDataMgrBase(STDataMgrBase* stmgr) { m_stController = stmgr; };
        void SetRTDataMgrBase(RTDataMgrBase* rtmgr) { m_rtController = rtmgr; };
        void SetMTConfigData(MTConfigData* mtc) { m_mtconfigdata = mtc; };

    protected:

    private:

        GaugeDescManager*   m_gdMgr;
        GaugeGroupManager*  m_groupMgr;
        STDataMgrBase*      m_stController;
        RTDataMgrBase*      m_rtController;
        MTConfigData*       m_mtconfigdata;



};

#endif // TABLEEDITORFACTORY_H
