
#ifndef VEMSGAUGEAS_H
#define VEMSGAUGEAS_H

#include <wx/dcbuffer.h>
#include <wx/wx.h>

//#include "../rtdatamanager/RTDataViewerBase.h"
#include "vemsgaugedesc.h"
#include "VemsWidgetBase.h"
#include "../common/wxhashdef.h"

#include "../gaugevalueselector.h"

#include "../MGraphics/MGraphics.h"

#define RADIAN_FACTOR 0.0174532925

#define BGP_BEZEL         1
#define BGP_DIALFACE      2
#define BGP_COLOREDAREA   4
#define BGP_TICKMARKS     8
#define BGP_GAUGENUMBERS  16
#define BGP_INNERCIRCLE   32
#define BGP_ALLPAINT      63

//WX_DECLARE_HASH_MAP( int, int, wxIntegerHash, wxIntegerEqual, Int2IntHash);
//class RTDataViewerBase;



class VemsGaugeAs : public VemsWidgetBase
{
	DECLARE_DYNAMIC_CLASS(VemsGaugeAs);

	public:
        VemsGaugeAs();
		VemsGaugeAs(wxWindow* parent, wxWindowID id, wxPoint CustomPosition = wxPoint(0,0),
            wxSize CustomSize = wxDefaultSize, bool DefaultPosSize = true,
            long style = 0, const VEMSGaugeDescArray * gaugeDescA = NULL);

		void SetGaugeDesc(VEMSGaugeDesc* gaugeDesc);
		virtual void UpdateSize();

		void SetValue(double value);
		virtual wxRegion GetShape();
		wxRegion GetBorderRegion() { return wxRegion(); };
		void SetFaceColor(wxColor *color);
		void SetPointerColor(wxColor *color);
		void SetMarkingsColor(wxColor *color);
		void SetCenterColor(wxColor *color);

        void setSize(int x , int y);

		wxBitmap * VemsGaugeAsBgBitmap;

		wxBitmap * VemsGaugeAsBmpBezel;
        wxBitmap * VemsGaugeAsBmpDialFace;
        wxBitmap * VemsGaugeAsBmpColArea;
        wxBitmap * VemsGaugeAsBmpTickMarks;
        wxBitmap * VemsGaugeAsBmpGaugeNums;
        wxBitmap * VemsGaugeAsBmpInnerCirc;

		bool sem1;

        void enableMenuItem(const wxString& item);
        void disableMenuItem(const wxString& item);

		void SetGaugeSweep(int angle);
		void SetRedLine(int i);
		void SetMaximum(int i);
		void SetMajorDivisions(int i);
		void SetMinorDivisions(int i);
		void setGaugeNumers();

		void OnSize(wxSizeEvent& event);

		void TestRawAccess(wxBufferedPaintDC &DC);

	public:
		virtual ~VemsGaugeAs(void);
		void CalculateSize();
        wxBitmap m_bmp;
	private:

		void UpdateGaugeValue();
		void UpdatePointer();
		void OnPaint(wxPaintEvent& event);
		void OnMouseWheel(wxMouseEvent& event);
		void CalculateLegentPoint(wxDC& dc);

		wxRect GetPointerRect();

	// TODO: Organise variables again!

        void ReCreateFace();
        void DrawBezel();
        void DrawTickMarks();
        void DrawNumbers();
        void DrawPointer();        // Draw value and pointer
        void CreateBoundMask();

        void paintBezel(wxDC& dc);
        void paintDialFace(wxDC& dc);
        void paintColoredArea(wxDC& dc);
        void paintTickMarks(wxDC& dc);
        void paintGaugeNumbers(wxDC& dc);
        void paintGaugeTitle(wxDC &dc);

		void paintGaugeBg(int whatpaint);

        void setMenuItemState(const wxString& item, bool state);


//		lookups for graphical points
		wxPoint centerPoint;
		wxPoint gaugeValuePoint;
		wxPoint gaugeLegendPoint;
		wxPoint gaugeBrandPoint;
		wxPoint pointerPoints[3];

		wxBitmap *wood;
		wxImage * image;

//		 dimensions
		wxCoord width;
		wxCoord height;

//		 storage for unchanging dial text values
		wxString gaugeBrand;
		wxString gaugeLegend;
		wxString gaugeValue;

//		 areas to redraw
		wxRect gaugeValueExtents;

        int m_width;

		//wxArrayString choices;
//		IntArray choices2gaugeDescA;

//        GaugeValueSelector* vselector;


//		int scaleFactor;
//		int majorDivisions;
//		int minorDivisions;

//

		int intervalFactor; // = 10;
		double pointerAngle;
		int gaugeRadius;
		double tickInnerRadius;
		double tickOuterRadius;
		double pointerInnerRadius;
		double pointerOuterRadius;
		double textRadius;
		double brandRadius;
		double legendRadius;
		double valueRadius;
		wxFont font;
		wxFont DigitalFont;
		int fontSize;
        bool DefPosSize;
        wxSize gsize;

		wxColor *faceColor;
		wxBrush *faceBrush;
		wxPen *pointerPen;
		wxBrush *pointerBrush;
		wxPen *markingsPen;
		wxColor *markingsColor;
		wxPen *centerPen;
		wxBrush *centerBrush;

        TMGraphics  *GBuffer;
        TMGraphics  *GCover;

        int         W;          // width and height
        TDPoint     CP;         // Centerpoint
        double      RS;         // Boundary sensitive radius
        double      RG;         // Main radius of VemsGauge
        TDPoint PPoint[4];



    protected:

		DECLARE_EVENT_TABLE();


        wxWindow* m_parent;
        wxPoint  m_delta;


};

#endif

