#include "VemsGaugeDigital.h"


#include <wx/dcclient.h>
#include <wx/brush.h>
#include <wx/bitmap.h>
#include <wx/font.h>
#include <wx/fontenum.h>
#include <wx/fontmap.h>
#include <wx/image.h>
#include <wx/intl.h>
#include <wx/settings.h>

#include "../logger.h"
#include "../DirHelper.h"

#include "../wxStaticTextEx.h"
#include "../DrawHelper.h"
#include "../agg/wxAgg.h"


//(*IdInit(testFrame)
const long VemsGaugeDigital::ID_STATICTEXT1 = wxNewId();
const long VemsGaugeDigital::ID_STATICTEXT2 = wxNewId();
const long VemsGaugeDigital::ID_STATICTEXT3 = wxNewId();
const long VemsGaugeDigital::ID_TEXTCTRL1 = wxNewId();


BEGIN_EVENT_TABLE(VemsGaugeDigital,VemsWidgetBase)
	//(*EventTable(testFrame)

//	EVT_LEFT_DOWN(VemsGaugeDigital::OnLeftDown)
	EVT_PAINT(VemsGaugeDigital::OnPaint)
#ifndef __WINCE_STANDARDSDK__
	//EVT_SIZE(VemsGaugeDigital::OnSize)
#endif

	//*)
END_EVENT_TABLE()


VemsGaugeDigital::VemsGaugeDigital(wxWindow* parent,wxWindowID id, GaugeDescManager * gdmgr, GaugeProperties &prop )
/*const wxString& symbolName,
    wxPoint gPos, int width, wxString rootdir,long style, const VEMSGaugeDescArray * gaugeDescA,
    const WidgetThemeTableArray * themes, GaugeGroupManager* groupManager, const wxString& groupName, const wxString& currTheme )*/
{
	/// Crashed on linux SetBackgroundStyle(wxBG_STYLE_CUSTOM);
    m_borderWidth = 1;
    m_sideRatio = 0.5;
    m_isGaugeDescMenu = true;

    InitTheme(prop);

    if( m_theme->BmpBorder )
        prop.height = (int)(prop.width*m_sideRatio);
#ifdef __WINCE_STANDARDSDK__
    else
        prop.height = (int)(prop.width*m_sideRatio);
#endif

    m_oriSize = prop.getSize();

    CreateWidget( parent, id, gdmgr, prop);
    m_isGaugeDescMenu = true;
    //gPos, gSize,style,_T("VemsGaugeDigital"),gaugeDescA, themes, groupManager, groupName, currTheme );

    if( m_theme->BmpBorder )
        m_sideRatioRestriction = m_sideRatio;

    Creator(parent, prop.symbolName ,prop.getPos(),prop.getSize());

    //SetWindowStyleFlag(GetWindowStyle()|wxNO_BORDER);
    sp.Start(51);
	Connect( wxEVT_SIZE, wxSizeEventHandler(VemsGaugeDigital::OnSize), NULL, this );
}

void VemsGaugeDigital::Creator(wxWindow* parent, const wxString& symbolName,wxPoint gPos, wxSize gSize)
{
//(gSize.y-18.5)*0.93


    wxImage backgroundImage;

    //Logger::logMilli(LOG_MSG, wxString::Format(_T("VemsGaugeDigital::Creator START ") ));

    m_DigitalFont = wxFont( (int)((gSize.x*0.3)-10) ,wxSWISS,wxFONTSTYLE_NORMAL,wxFONTWEIGHT_NORMAL,false,_T("7 Segment"),wxFONTENCODING_DEFAULT);
/*
    wxPoint vPos,uPos;
    wxSize vSize,uSize;

    m_tPos  = wxPoint(gSize.x/9,gSize.x/14);
    m_tSize = wxSize(gSize.x-gSize.x/10-m_tPos.x, 13);
	//StaticTextTitle = new wxStaticTextEx(this,ID_STATICTEXT1,_(""),m_tPos,m_tSize,wxALIGN_CENTER_HORIZONTAL | wxST_NO_AUTORESIZE );

    uSize = wxSize(20,12);
    uPos  = wxPoint(gSize.x-(gSize.x/10)-uSize.x,gSize.y-(gSize.x/14)-uSize.y);
	StaticTextUnit  = new wxStaticTextEx(this,ID_STATICTEXT3,_(""),uPos,uSize,wxALIGN_LEFT | wxST_NO_AUTORESIZE );

    vPos  = wxPoint(gSize.x/13,m_tPos.y+m_tSize.y );
    vSize = wxSize(uPos.x-vPos.x,gSize.y - vPos.y - (gSize.x/12) + 1);
	StaticTextValue = new wxStaticTextEx(this,ID_STATICTEXT2,_(""),vPos,vSize,wxALIGN_RIGHT | wxST_NO_AUTORESIZE );


    DigitalFont.SetWeight(wxFONTSTYLE_NORMAL);
    StaticTextValue->SetFont(DigitalFont);

  */
    //SetTextsColors();

//    StaticTextValue->Show(false);

    backgroundImageFrom.LoadFile(DirHelper::GetPath(dGRAPHICS) + _T("vgdBG.png"),wxBITMAP_TYPE_PNG);


    if(m_theme->BmpBorder) {


    #if defined (__WINCE_STANDARDSDK__)

        wxString filenamepath = DirHelper::GetPath(dCACHE) + wxString::Format(_T("vgdsmall%i.png"),gSize.x);

        if(!wxFileExists(filenamepath)){
            backgroundImage = wxImage(backgroundImageFrom.ResampleBicubic(gSize.x,gSize.y));
            backgroundImage.SaveFile(filenamepath);
        }
        else
            backgroundImage = wxImage(filenamepath,wxBITMAP_TYPE_PNG);

    #else

        backgroundImage = wxImage(backgroundImageFrom.ResampleBicubic(gSize.x,gSize.y));

    #endif

        backgroundBmp = new wxBitmap( backgroundImage );

    } else {

        backgroundBmp = GetBackgroundBitmap( gSize );

    }


    SetBackgroundColour(*wxWHITE);

    //Logger::logMilli(LOG_MSG, wxString::Format(_T("VemsGaugeDigital::Creator END ") ));


    m_barBackgrounBmp = new wxBitmap(m_tSize.x,m_tSize.y);



//    UpdateSize();

    m_barSem = true;

}

VemsGaugeDigital::~VemsGaugeDigital()
{
    //dtor
    //UnRegisterViewer();

	//delete StaticTextTitle;

    delete backgroundBmp;
    delete m_barBackgrounBmp;

}

wxBitmap* VemsGaugeDigital::GetBackgroundBitmap(int width, int height)
{
    wxAgg aggCanvas(width,height);

    aggCanvas.clear( wxColor(0,0,0,0) );

    aggCanvas.setPen( m_theme->BorderColor );

    int mins = 0;

    if( width <= height )
        mins = width;
    if( height < width )
        mins = height;

    double stroke = (double)mins/30.0;

    double m = stroke/2.0;


    m_borderWidth = stroke;

    aggCanvas.drawRoundedRectangle(m,m,width-stroke,height-stroke,stroke*3.0,stroke);

    wxBitmap* bmp = aggCanvas.renderToBitmap();

    return bmp;
}

void VemsGaugeDigital::SetTextsColors()
{/*
	StaticTextValue->SetForegroundColour( m_theme->ValueColor );
	StaticTextUnit->SetForegroundColour( m_theme->ValueColor );

    GetParent()->SetBackgroundColour( m_theme->BackgroundColor );
    GetParent()->ClearBackground();

    SetBackgroundColour( m_theme->BackgroundColor );
    ClearBackground();

    StaticTextValue->SetBackgroundColour( wxColor(255,255,255) );
    StaticTextUnit->SetBackgroundColour( m_theme->BackgroundColor );

    StaticTextValue->ClearBackground();
*/
}

void VemsGaugeDigital::OnSize(wxSizeEvent &evt)
{
#ifndef __WINCE_STANDARDSDK__
    UpdateSize();
    evt.Skip();
#endif
}

void VemsGaugeDigital::SetNewTheme(WidgetThemeTable *theme)
{
    m_theme = theme;
    m_barSem = true;
    UpdateSize();
    Refresh(false);



}

void VemsGaugeDigital::OnPaint(wxPaintEvent& event)
{

  //  Logger::logf(LOG_MSG, _T("VemsGaugeDigital::OnPaint START") );

	wxBufferedPaintDC dc(this);

    dc.SetBackground( m_theme->BackgroundColor );

    dc.Clear();


    int width = GetSize().x;
    int height = GetSize().y;

	if(m_graphQual==2)
	{
    /// recalc barbackground bitmap if need, and paint

        if( m_barSem )
            m_barSem = !DrawBarBackGround();

        dc.DrawBitmap( *m_barBackgrounBmp, m_tPos.x, m_tPos.y, 1);

    /// paint actual value

        uint16_t barbeginpx = int((m_tSize.x + m_tPos.x) - ((m_tSize.x / m_fullValue) * (m_gd->GetMaxValue() - m_value)) + 1);

        //Logger::logf(LOG_MSG,_T("barbeginpx=%.0f, m_value = %.0f, m_fullValue = %.0f, m_tSize.x = %i "),barbeginpx,m_value,m_fullValue,m_tSize.x);

        if(barbeginpx < m_tPos.x + m_tSize.x - 1) {

            wxPoint tmp[4];

            tmp[0].x = tmp[3].x = barbeginpx;
            tmp[1].x = tmp[2].x = m_tPos.x + m_tSize.x;

            tmp[0].y = tmp[1].y = m_tPos.y;
            tmp[2].y = tmp[3].y = m_tPos.y + m_tSize.y -1;

            wxColor inactivecolor = m_theme->ColorSymbols[_T("inactive")];

            dc.SetPen( inactivecolor );
            dc.SetBrush( inactivecolor );

            dc.DrawPolygon( 4, tmp);
        }

    /// paint border bitmap

        dc.DrawBitmap(*backgroundBmp,0,0,true);
	}
    /// paint title text

        wxString title = GetSymbolTitle();
        //wxString title = m_gd->GetType();

        wxFont font = dc.GetFont();

        font.SetPointSize( (int)(m_tSize.y*0.65 + 2) );

        dc.SetFont( font );

        wxSize textsize = dc.GetTextExtent(title);

        //dc.SetTextForeground( DrawHelper::InvertColor(m_theme->ColorSymbols[_T("normal")]) );
        dc.SetTextForeground( wxColor(255,255,255) );
        dc.DrawText(title, (width - textsize.x)/2, (int)(m_tPos.y*0.7) );

    /// paint unit

        font.SetPointSize( (int)(height*0.1 + 1) );

        dc.SetFont( font );

        dc.SetTextForeground( m_theme->SuffixColor );

        wxSize uSize = dc.GetTextExtent( m_gd->GetUnit() );
        wxPoint uPos  = wxPoint( (int)(width-m_borderWidth*2-uSize.x),height-(height/7)-uSize.y);

        dc.DrawText( m_gd->GetUnit(), (int)(width - uSize.x - m_borderWidth*1.2), (int)( height - m_borderWidth*1.5 - uSize.y ));

    /// paint value

        dc.SetFont( m_DigitalFont );
        dc.SetTextForeground( m_theme->ValueColor );

        //wxSize vSize = dc.GetTextExtent( m_prevValue );

        wxString tmp = _T("N/A ");

        if ( isDataAvailable() ) { tmp = m_prevValue; }

        wxSize vSize = dc.GetTextExtent( tmp );

        int xdiff = (int)fabs(45.0/(double)(m_DigitalFont.GetPointSize()-10));

        //Logger::logf(LOG_MSG,_T("xdiff=%i, fontsize=%i"),xdiff,m_DigitalFont.GetPointSize());

        dc.DrawText( tmp, width - vSize.x - uSize.x - xdiff, (int)(height - m_DigitalFont.GetPointSize()*1.14 - m_borderWidth*1.5 - height*0.05));


    DrawExtraLayer(dc);
}


void VemsGaugeDigital::SetValue(double value)
{
    m_value = value;
    wxString tmp = wxString::Format(m_gd->GetGaugeNumberFormat()+_T(""),m_value);
    if(tmp != m_prevValue) {
        //StaticTextValue->SetLabel( tmp );
        Refresh(false);
    }

    m_prevValue = tmp;
}


wxRegion VemsGaugeDigital::GetShape()
{
    wxRegion region = wxRegion(*backgroundBmp,wxColor(100,0,0,0));   /// inside the 3D frame in the vgdBG.png there are a chamfer rectangle with 1% opacity

//    wxRegion region = wxRegion(0,0,Gem_tSize().x+2,Gem_tSize().y-1);

    region.Offset( -2, -2 ); //parent's border

    return region;

}

void VemsGaugeDigital::UpdateSize()
{

    if(sp.Time() < 50) return;
    sp.Start();

    int width = GetClientSize().x;
    int height = GetClientSize().y;

    if(m_theme->BmpBorder) {

        m_sideRatioRestriction = m_sideRatio;

        if( backgroundImageFrom.IsOk() == false ) return;

        if( height > width * m_sideRatioRestriction )
            height = (int)(width * m_sideRatioRestriction);

        if( width * m_sideRatioRestriction > height  )
            width = (int)(height / m_sideRatioRestriction);


        wxImage backgroundImage = wxImage(backgroundImageFrom.ResampleBox(width,height));

        delete backgroundBmp;
        backgroundBmp = new wxBitmap( backgroundImage );

        m_borderWidth = width * 0.03;

    } else {

        m_sideRatioRestriction = DefaultSideRaitoRestriction;

        delete backgroundBmp;
        backgroundBmp = GetBackgroundBitmap( width, height );

    }

    //StaticTextUnit->SetLabel( m_gd->GetUnit() );



    double title_height_ref = m_gd->Properties[_T("TitleTextHeightDigi")].GetDouble();
    if(title_height_ref < 0) title_height_ref = 0.125;


    m_tPos  = wxPoint((int)(m_borderWidth*4),(int)(m_borderWidth * 1.5));
    m_tSize = wxSize((int)(width-m_borderWidth*8), (int)(height * title_height_ref) );

	//StaticTextTitle = new wxStaticTextEx(this,ID_STATICTEXT1,_(""),m_tPos,m_tSize,wxALIGN_CENTER_HORIZONTAL | wxST_NO_AUTORESIZE );

//    uSize = wxSize(20,12);
  //  uPos  = wxPoint(width-m_borderWidth*2-uSize.x,height-(height/7)-uSize.y);
	//StaticTextUnit->Move(uPos);
	//StaticTextUnit->Sem_tSize(uSize);

//    vPos  = wxPoint(width/13,m_tPos.y+m_tSize.y+1 );
//    vSize = wxSize(uPos.x-vPos.x,height - vPos.y - (height/6) + 1);
	//StaticTextValue->Move(vPos);
	//StaticTextValue->Sem_tSize(vSize);

    delete m_barBackgrounBmp;
    m_barBackgrounBmp = new wxBitmap(m_tSize.x,m_tSize.y);
    m_barSem = true;

    if(m_theme->BmpBorder)
        SetSize( width, height );


/*
    wxFont font = StaticTextValue->GetFont();
    font.SetPoinm_tSize(height - m_tPos.y - m_tSize.y - 4*m_borderWidth);
    StaticTextValue->SetFont( font );
*/
    m_DigitalFont.SetPointSize((int)(height - m_tPos.y - m_tSize.y - 4*m_borderWidth));

//    wxMemoryDC memdc;
//    memdc.SetFont(m_DigitalFont);
//
//    wxString str = wxString::Format(m_gd->GetFormat(),m_gd->GetMaxValue());
//
//    wxSize s = memdc.GetTextExtent(str);

    //if(s.x > width) {}

    Refresh(false);
}

bool VemsGaugeDigital::DrawBarBackGround()
{

    if(m_gd == NULL) return false;

    wxMemoryDC  memdc;

    memdc.SelectObject( *m_barBackgrounBmp );

    memdc.SetBackground( *wxWHITE_BRUSH );

    memdc.Clear();

    m_fullValue = m_gd->GetMaxValue() - m_gd->GetMinValue();

    double zeroXpos = 0 - ((m_gd->GetMinValue() / m_fullValue) * m_tSize.x);


    //Logger::logf(LOG_MSG,_T("VemsGaugeDigital::DrawBarBackGround ") + m_gd->GetName() + _T(" = %f"),m_fullValue);


    /// draw default segment
    wxPoint tmp[4];

    tmp[0].x = tmp[3].x = 0;
    tmp[1].x = tmp[2].x = m_tSize.x;

    tmp[0].y = tmp[1].y = 0;
    tmp[2].y = tmp[3].y = m_tSize.y;

    memdc.SetBrush( m_theme->ColorSymbols[_T("normal")] );
    memdc.SetPen(   m_theme->ColorSymbols[_T("normal")] );
    memdc.DrawPolygon(4, tmp);

  //  Logger::logf(LOG_MSG,_T("VemsGaugeDigital::DrawBarBackGround zeroXpos=%f"),zeroXpos);

    /// draw colored segments

    for(uint16_t i = 0; i <  m_gd->coloredA.Count(); i++){

        ColoredArea * ca = m_gd->coloredA.Item(i);

        if( m_theme->ColorSymbols.find(ca->ColorName) == m_theme->ColorSymbols.end() ) continue;

        double minColorPix = ( ca->minValue / m_fullValue ) * m_tSize.x ;
        double maxColorPix = ( ca->maxValue / m_fullValue ) * m_tSize.x ;

        tmp[0].x = tmp[3].x = (int)(zeroXpos + minColorPix);
        tmp[1].x = tmp[2].x = (int)(zeroXpos + maxColorPix);

        tmp[0].y = tmp[1].y = 0;
        tmp[2].y = tmp[3].y = 0 + m_tSize.y;

        memdc.SetPen( m_theme->ColorSymbols[ ca->ColorName ] );
        memdc.SetBrush( m_theme->ColorSymbols[ ca->ColorName ] );
        memdc.DrawPolygon(4, tmp);

    }



    memdc.SelectObject( wxNullBitmap );

    return true;

}
