#ifndef VEMSGRAPHWIDGETAGG_H
#define VEMSGRAPHWIDGETAGG_H

#include "VemsWidgetBase.h"

#include "../common/types/wxBitmapArray.h"
#include "../common/types/DoubleArray.h"
#include "../common/types/wxVariantHashHash.h"
#include "../common/types/Int2StringHash.h"


class wxAgg;
class wxHotKeyManager;

class VemsGraphWidgetAgg : public VemsWidgetBase
{
    DECLARE_DYNAMIC_CLASS(VemsGraphWidgetAgg);

    public:
        VemsGraphWidgetAgg() {};
        VemsGraphWidgetAgg( wxWindow* parent, wxWindowID id, GaugeDescManager * gdmgr, GaugeProperties &prop);

                            /*
                            wxPoint pos = wxPoint(0,0),
                            wxSize size = wxDefaultSize,
                            long style = 0,
                            const VEMSGaugeDescArray* gaugeDescA = NULL,
                            const WidgetThemeTableArray * themes = NULL,
                            long drawingStyle = 0,
                            GaugeGroupManager* groupManager = NULL,
                            const wxString& groupName = wxEmptyString,
                            const wxString& currTheme = ThemesHelper::m_defaultThemeName );*/

        virtual ~VemsGraphWidgetAgg();

        //VemsWidgetBase virtual functions
        wxRegion GetShape();
        wxRegion GetBorderRegion();
        void UpdateSize();
        void setSize( int x , int y );

        //RTDataViewerBase virtual functions
        void SetValue( double value );
        void SetNewTheme(WidgetThemeTable *theme);

        virtual void RedrawWidget();

    protected:

        void renderBackground();
        void renderGraph(bool isFullRender = false);
        void CalcHistoryLen();

    private:
        wxTimer     m_timer;
        //wxAgg*      m_aggCanvas;
        bool        m_isResized;
        DoubleArray m_valuesA;
        uint32_t    m_historyLength;
        uint32_t    m_historyLengthBase;
        wxSize      m_frameSize;
        wxString    m_currentSymbol;
        double      m_maxValue;
        double      m_minValue;

        //title settings
        wxString    m_titleText;
        wxPoint     m_titlePosition;
        wxFont      m_titleFont;
        wxColor     m_titleColor;
        //value settings
        wxString    m_valueText;
        wxPoint     m_valuePosition;
        wxFont      m_valueFont;
        wxColor     m_valueColor;


        wxPoint     m_minValuePosition;
        wxPoint     m_maxValuePosition;

        bool        m_bShowLines;
        bool        m_bShowLinesValues;
        bool        m_bShowMarker;
        double      m_dMarkerValue;

        //void drawGraph( wxAgg* aggCanvas );
        //void drawGraph();
        void drawTitle( wxDC& dc );
        void drawValue( wxDC& dc );
        void drawDivisionsText( wxDC& dc );
        void drawUnitText( wxDC& dc );

        void LoadSettings();
        void SaveSettings();

        void OnPaint(wxPaintEvent &event);
        void OnSize( wxSizeEvent &event );
        void OnChar( wxKeyEvent& event );
        void OnTimer( wxTimerEvent& event );

        void setDcFontSize(wxDC& dc, const wxString& type);

        wxBitmapArray     m_bmpHistory;

        wxHotKeyManager*    m_hotkeyMgr;


        wxBitmap*       m_backgroundBitmap;
        wxBitmap*       m_helpPanel;
        bool            m_showHelpPanel;

        wxVariantHashHash   m_fontSizes;

        DECLARE_EVENT_TABLE()

};

class FontSizePanel: public wxFrame
{
    public:
        FontSizePanel(VemsWidgetBase* parent, wxVariantHashHash* model, int default_size = 10);


    private:

        void OnSlider(wxCommandEvent& evt);
        void OnButton(wxCommandEvent& evt);

        enum{
            idButtonOk,
            idButtonCancel,
            idButtonReset
        };

        VemsWidgetBase*     m_parent;

        wxVariantHashHash*  m_model;

        Int2StringHash      m_sliders;

        long     m_defval;

};

#endif // VEMSGRAPHWIDGETAGG_H
