#ifndef VEMSWIDGETBASEFACTORY_H
#define VEMSWIDGETBASEFACTORY_H


#include "WidgetFactoryBase.h"

class GaugeDescManager;
class GaugeGroupManager;
class RTDataMgrBase;
class STDataMgrBase;
class LogHistoryBase;

class GaugeCarrierBaseDesc;

class VemsWidgetBaseFactory: public WidgetFactoryBase
{
    DECLARE_DYNAMIC_CLASS(VemsWidgetBaseFactory);

    public:
        VemsWidgetBaseFactory();
        virtual ~VemsWidgetBaseFactory();

        virtual VemsControlBase* CreateWidget(GaugeProperties &prop, GaugeCarrierBaseDesc* desc);


        void SetGaugeDescManager(GaugeDescManager* gdmgr) { m_gdMgr = gdmgr; };
        void SetGaugeGroupManager(GaugeGroupManager* gaugemgr) { m_groupMgr = gaugemgr; };
        void SetDataMgrObj(STDataMgrBase *stDataMgr) { m_stController = stDataMgr; };
        void SetDataMgrObj(RTDataMgrBase *rtDataMgr) { m_rtController = rtDataMgr; };
        void SetLogHistoryBase(LogHistoryBase* lhb) { m_logHistory = lhb; };


    protected:

        GaugeDescManager*   m_gdMgr;
        GaugeGroupManager*  m_groupMgr;
        STDataMgrBase*      m_stController;
        RTDataMgrBase*      m_rtController;
        LogHistoryBase*     m_logHistory;

};


#endif // VEMSWIDGETBASEFACTORY_H
