#ifndef AIMDEVICECONTROLLER_H
#define AIMDEVICECONTROLLER_H

#include "../configmanager/VemsDeviceControllerConfig.h"
#include "DeviceInfo.h"
#include "../common/types/IntArray.h"

class SIPRPacket;
class CommunicationBase;
class CommunicationController2;
class CommunicationControllerClient;

class AIMDeviceController: public wxEvtHandler
{
    public:
        AIMDeviceController( const VemsDeviceControllerConfig& config, wxEvtHandler* handler = NULL );
        virtual ~AIMDeviceController();


        void start();
        void stop();

        void reset(VemsDeviceControllerConfig& config);

        void SendSIPRPacket(SIPRPacket& packet);

    protected:

        void initCommunication();

        void clearCommBase();

    private:

        VemsDeviceControllerConfig      m_config;
        IntArray                        m_reqChannels;


        CommunicationController2*       m_controller;
        CommunicationBase*              m_commBase;

        CommunicationControllerClient*  m_communicationClient;
        CommunicationControllerClient*  m_prevCommunicationClient;

        DeviceInfo                      m_deviceInfo;

        wxEvtHandler*                   m_handler;

        wxEvtHandler*                   m_clientHandler;

        bool                            m_isStopped;
};

#endif // AIMDEVICECONTROLLER_H
