#include "BootModeFactory.h"


#include "BootModeBase.h"
#include "BootModeV3.h"
#include "BootModeRound.h"
#include "BootModeARM.h"
#include "ECUInfo.h"

#include "../CommunicationBase.h"
#include "../logger.h"

BootModeFactory::BootModeFactory()
{
    //ctor
}

BootModeFactory::~BootModeFactory()
{
    //dtor
}


BootModeBase* BootModeFactory::create(CommunicationBase* commBase, int device)
{

    BootModeBase* bootModeBase;

    //bootModeBase = new BootModeV3(vp );
    //bootModeBase = new BootModeRound(vp );
    //bootModeBase = new BootModeARM(vp );

    Logger::logf(LOG_MSG,_T("BootModeFactory::create() device: %i"), device);

    switch(device){
        case ECUInfo::DEVICE_V3:
            bootModeBase = new BootModeV3(commBase );
            break;
        case ECUInfo::DEVICE_ROUND:
            bootModeBase = new BootModeRound(commBase );
            break;
        case ECUInfo::DEVICE_ARM:
            bootModeBase = new BootModeARM(commBase );
            break;
        case ECUInfo::DEVICE_UNKNOWN:
        default:
            bootModeBase = NULL;
            break;
    }

    return bootModeBase;
}


