#ifndef BOOTMODEV3_H
#define BOOTMODEV3_H

#include "BootModeBase.h"
#include "../ntcfinder.h"

class CommunicationBase;

class BootModeV3 :public BootModeBase
{
    public:
        BootModeV3(CommunicationBase* vp);
        virtual ~BootModeV3();
        int       verifyPage(uint32_t idx);
        bool      failSafeVerifyPage(uint32_t idx);
        int       verifyFlash();

        int       uploadPage(uint32_t idx);
        int       uploadFlash();
        bool      failSafeUploadPage(uint32_t idx);
        int eraseFlash();
    protected:
    private:
        //uint32_t getPageChecksum(uint8_t* checksumStr);
        int selectPageTMP(uint32_t idx);
        uint32_t getPageID(uint32_t pageIdx);

        static NTCFinder m_ntcfinder;

};


#endif // BOOTMODEV3_H
