#ifndef ECUSTATEBASE_H
#define ECUSTATEBASE_H


#include "../common/types/IntArray.h"
#include "../common/types/Int2StringHash.h"


class CommunicationBase;


class ECUStateBase
{
    public:
        ECUStateBase( int id, const wxString& name, CommunicationBase* commBase, int baudRate);
        virtual ~ECUStateBase();

        virtual bool check() = 0;
        virtual void goToState( int state );

        int     getID() const { return m_id; }
        int     getParentID() const { return m_parent_id; }
        void    setParentID( int id ) { m_parent_id = id; }
        bool    equal( ECUStateBase*  state ) { return this->m_id == state->getID(); }
        void    addChangeState( int id, const wxString&  command );
        wxString getName() { return m_name; }
        //Int2StringHash* getChangeStateH() {  return &m_changeStateH; }
        IntArray*       getChangeStateA() { return &m_changeStateA; }

        const IntArray& getBaudRates();
        void  addBaudRate(int baudRate);
    protected:
        CommunicationBase*  m_commBase;
        Int2StringHash      m_changeStateH; //name -> command;
        IntArray            m_changeStateA;
        IntArray            m_baudRateA;
        wxString            m_name;
        int m_id;
        int m_parent_id; //temporary ( realtive parent )
        //int m_baudRate;
    private:
};

WX_DEFINE_ARRAY( ECUStateBase*, ECUStateBaseArray );



#endif // ECUSTATEBASE_H
