#ifndef ECUSTATEMGRFIRMWAREINFODTOR_H
#define ECUSTATEMGRFIRMWAREINFODTOR_H

#include "ECUStateMgrBase.h"

class CommunicationBase;
class FirmwareInfo;

class ECUStateMgrFirmwareInfoDtor : public ECUStateMgrBase
{
    public:
        ECUStateMgrFirmwareInfoDtor(ECUStateMgrBase* mgrBase,
            FirmwareInfo* fwInfo);
        virtual ~ECUStateMgrFirmwareInfoDtor();

        void reset();
   const ECUStateBaseArray* getStates( int device );
        int getStoredState();
        int getDevice();
        int getState();
        int setState( int state );
        int setState( int fromState, int toState );
        void setBaudRate( int baudRate );
        int getBaudRate();
    protected:
    private:
        ECUStateMgrBase* m_mgrBase;
        FirmwareInfo* m_fwInfo;

        uint8_t* command_ctime;
        uint8_t* command_fwversion;
        uint8_t* command_serNum;
        uint8_t* command_Signature;
        uint8_t* command_S;

        void fetchV3FirmwareInfo(int state);
        void fetchV3FirmwareInfo();
};



#endif // ECUSTATEMGRFIRMWAREINFODTOR_H
