#ifndef MEGATUNECONFIG_H
#define MEGATUNECONFIG_H


#include "../common/types/Int2IntHash.h"
#include "../FirmwareVersion.h"
#include "SIPRPacket.h"
#include "ECUInfo.h"


class MegatuneConfig
{
    public:
        enum CheckType { LENGTH, CRC, TRIGGER };
        enum RealtimeType { NORMAL, EXTENDED };

        int             minRealtimeLength;
        int             maxRealtimeLength;

        /// detected params
        CheckType       rtCheckType;
        RealtimeType    rtType;
        CheckType       pageCheckType;

        ECUInfo::Device device;
        FirmwareVersion fwVersion;
        wxString        readRealtimeCommand; //8BitData
        int             realtimeLength;
        int             siprSensorType;
        Int2IntHash     pageSize;
        SIPRPacketList  pages;
        size_t          detectedSiprTableCount;

        /// user params
        int     timeout;
        int     interWriteDelay;
        int     maxRealtimeError;

};


#endif // MEGATUNECONFIG_H
