#include "MegatuneHelper.h"
#include "../Math.h"

bool MegatuneHelper::checkCrc( uint8_t* buffer, size_t length )
{
    if ( length < 2 ) return false;

    uint16_t crc = 0xFFFF;

    for ( size_t i = 0; i < ( length - 2 ); ++i ) {
        crc = Math::crc16_sipr( crc, buffer[i] );
    }

    uint16_t rxCrc = buffer[length - 2];
    rxCrc |= ((uint16_t)buffer[length - 1]<<8);

    return ( rxCrc == crc );
}
