#ifndef SIPRFILELOGGER_H
#define SIPRFILELOGGER_H

#include <wx/wfstream.h>
#include "SIPRPacket.h"
#include "../common/types/StringHash.h"

class SIPRFileLogger
{
    public:
        SIPRFileLogger(int blockSize = 512);
        virtual ~SIPRFileLogger();
        void setHeader(const wxString& header);
        void process(const SIPRPacket& p );
        void setFile(const wxString& ofileName);
        void enableLog(bool b);
        bool isLog(){ return m_isLog; }

        void setSaveSDCard( bool enable );

    private:
        wxString m_header;
        size_t m_blockSize;
        size_t m_bufferCount;
        char * m_buffer;
        wxFileOutputStream * m_fos;
        wxString m_fileName;
        bool m_isLog;
        bool m_waitFirstPacket;
        StringHash  m_headerHash;
        bool            m_bSaveSDCard;          // for SD card saving
        SIPRPacketList  m_SavedPages;           // for SD card saving

        void fillBuffer();
        void setBlockSize(int bSize);
        void Flush();
        void writeHeader();
        void writeHeader(const char * buff, size_t size);
};

#endif // SIPRFILELOGGER_H
