#ifndef SERIALPORTHANDLERCTB_H
#define SERIALPORTHANDLERCTB_H

#include <wx/string.h>

#include "../common/typedef.h"
#include "../CommunicationBase.h"


#ifdef CTB15
//    class SerialPort;
    #include <wx/ctb/serport.h>
#else
    class wxSerialPort;
#endif

class SerialConfig;

class SerialPortHandlerCTB : public CommunicationBase
{
    public:
        SerialPortHandlerCTB(SerialConfig* serialConfig);
        virtual ~SerialPortHandlerCTB();

        SerialConfig* getSerialConfig(){ return m_serialConfig; };
        bool IsOpen();
        void close();

        int SendString( const wxString& str);
      //  int SendString(wxChar * chr);
        int SendString(const uint8_t* chr);
        int SendString(const uint8_t* str, size_t len);
        int sendStringBlock(uint8_t* value, size_t len, size_t blockLen);

        int Read(uint8_t* str, size_t len);
        int ReadString(uint8_t* str, size_t len);
        int ReadString(uint8_t* data, size_t len, int maxTryCount);
        //int ReadUntilEOS(char ** readbuf,
//            char * eosString = "\n", long timeout_in_ms = 1000L);
        /*virtual*/void setBaudRate(int bRate);
        /*virtual*/int  clear();
        int getBaudRate();

        void setPortName( const wxString& portname ) {}
        wxString getPortName() const;

        int clearSerialBuffer(int len);
        int clearSerialBufferCircle(int len, int count);

        int sendNumber(uint32_t number, int length);
        int sendNumber(uint16_t number);

    protected:
    private:
                //wxIOBase * dev;
#ifdef CTB15
           ctb::SerialPort * dev;
#else
           wxSerialPort * dev;
#endif
        int m_baudrate;


        SerialConfig* m_serialConfig;

        int open();
        int getTimeOut(size_t len);

        double m_magicTimeoutConstA;
        double m_magicTimeoutConstB;
};

#endif // SERIALPORTHANDLERCTB_H
