#ifndef SERIALPORTHANDLERSFILE_H
#define SERIALPORTHANDLERSFILE_H

#include <wx/string.h>

#include "../common/typedef.h"
#include "../CommunicationBase.h"

class SFile;
class SerialConfig;

class SerialPortHandlerSFile : public CommunicationBase
{
    public:
        SerialPortHandlerSFile(SerialConfig* serialConfig);
        virtual ~SerialPortHandlerSFile();

                //void setSerialConfig(SerialConfig * serialConfig);
        SerialConfig* getSerialConfig(){ return m_serialConfig; };
        bool IsOpen();
        void close();

        int SendString( const wxString& str);
      //  int SendString(wxChar * chr);
        int SendString(const uint8_t* chr);
        int SendString(const uint8_t* str, size_t len);
        int sendStringBlock(uint8_t* value, size_t len, size_t blockLen);

        int Read(uint8_t* str, size_t len);
        int ReadString(uint8_t* str, size_t len);
        int ReadString(uint8_t* data, size_t len, int maxTryCount);
        //int ReadUntilEOS(char ** readbuf,
//            char * eosString = "\n", long timeout_in_ms = 1000L);
        /*virtual*/void setBaudRate(int bRate);
        /*virtual*/int  clear();
        int getBaudRate();

        void setPortName( const wxString& portname ) {}
        wxString getPortName() const;

        int clearSerialBuffer(int len);
        int clearSerialBufferCircle(int len, int count);

        int sendNumber(uint32_t number, int length);
        int sendNumber(uint16_t number);

    protected:
    private:
        SFile * dev;
        DWORD m_baudrate;

        SerialConfig* m_serialConfig;

        int open();
        int getTimeOut(size_t len);

        double m_magicTimeoutConstA;
        double m_magicTimeoutConstB;
};

#endif // SERIALPORTHANDLERSFILE_H
