#include "SiprDescHelper.h"
#include "ECUInfo.h"
#include "../common/TxData.h"

TxData* SiprDescHelper::getPageReadCommand( wxString cmd, int device )
{
    if ( cmd.Len() == 0 )
        return NULL;

    if ( cmd.StartsWith( _T("0x") ) || cmd.StartsWith( _T("0X") ) ) {

        unsigned long val = 0 ;

        if ( cmd.ToULong(&val,0 ) ) {
            uint8_t buff[2];
            buff[0] = val;

            size_t cmdSize = 1;

            if ( device == ECUInfo::DEVICE_ROUND ) {
                buff[1] = '.';
                cmdSize = 2;
            }

            return new TxData( buff, cmdSize );
        } else {
            return NULL;
        }
    }

    if ( device == ECUInfo::DEVICE_ROUND ) {
        cmd += _T('.');
    }

    return new TxData( cmd );
}

