#include "VemsLogHeaderParser.h"
#include "../Utils.h"
#include "../logger.h"
#include "../common/typedef.h"

VemsLogHeaderParser::VemsLogHeaderParser( wxFile& file )
{
    if( file.Read(m_headerBuffer,HEADERBLOCKSIZE) != HEADERBLOCKSIZE )
        return;

    wxString tmp = wxString::From8BitData(m_headerBuffer, HEADERBLOCKSIZE);
//    Logger::logf(LOG_MSG,_T("VemsLogHeaderParser::VemsLogHeaderParser(): header size:%d"), tmp.size() );

    wxArrayString tmparray;

    Utils::tokenizeToArray( tmp, _T("\n"), tmparray);

    for(uint16_t a=0; a<tmparray.GetCount();a++) {
        // Logger::logf(LOG_MSG,tmparray.Item(a));
        //if( tmparray.Item(a).StartsWith(0) continue;
        if( tmparray.Item(a).StartsWith(_T("#"))) continue;
        wxArrayString tmpitemarray;
        Utils::tokenizeToArray( tmparray.Item(a), _T("="), tmpitemarray);
        if(tmpitemarray.GetCount() < 2) continue;

        wxString key = tmpitemarray.Item(0);
        wxString value = tmpitemarray.Item(1);

        for(size_t i = 2; i < tmpitemarray.GetCount(); i++){
            value += _T("=")+tmpitemarray.Item(i);
        }
        m_headerHash[key] = value;
    }
}

StringHash VemsLogHeaderParser::getHeaderHash()
{
    return m_headerHash;
}
