#ifndef VEMSLOGREADER_H
#define VEMSLOGREADER_H

#include <wx/file.h>
#include "../common/types/StringHash.h"
#include "SIPRPacket.h"
#include "../Observable.h"

#define HEADERBLOCKSIZE 512



class VemsLogReader : public Observable
{
    public:
         VemsLogReader();
        virtual ~VemsLogReader();
        enum VemslogVersion{
            VEMSLOG_VERSION_1 = 1,
            VEMSLOG_VERSION_2 = 2,
            VEMSLOG_VERSION_3 = 3
        };
        void init();
        void reset();
        bool SetInputFile(const wxString &filename);
        int ParseHeader();

        unsigned int GetFilePos();
        unsigned int GetFileSize();
        void SetFilePos(double percent);
        void start();

        int getNext(SIPRPacket& siprPacket);
        //long getRTDataPerBlock();

        wxString getHeaderValue(const wxString& key) const;
        const StringHash& getHeaderHash(){ return m_headerHash; }

        bool* getGPSCapturedRef(){ return &m_isGPSCaptured; }
    protected:
    private:
        StringHash  m_headerHash;
        wxFile      m_rawFile;
        wxString    m_fileName;
        char    m_headerBuffer[HEADERBLOCKSIZE];
        char*   m_blockBuffer;
        uint8_t   m_dataBuffer[255]; /// MAX SIPR DATA

/// NEED for old log
        long    m_gpsDataLength;
        int     m_gpsBlockIdx;
        long    m_datalen;
        long    m_blocksize;
        int     m_blockIdx;
        //long    m_RTDataPerBlock;
        uint8_t m_seq;
        bool    m_isGPSCaptured;
        bool    m_isFirstAfterGPS;
        SIPRPacket m_tmpPacket;

         bool m_isValid;
        int parseHeaderPriv();

        uint32_t m_seekIdx;
        bool m_isSeekSet;
        VemslogVersion m_vemsLogVersion;

        int loadNextBlock();
        int getNextVersion1(SIPRPacket& siprPacket);
        int getNextVersion2(SIPRPacket& siprPacket);
        int getNextVersion3(SIPRPacket& siprPacket);

};

#endif // VEMSLOGREADER_H
