#include "RegExRecognizer.h"
#include "../../common/TxData.h"


RegExRecognizer::RegExRecognizer( const wxString& regEx )
    : m_regEx( regEx, wxRE_ADVANCED )
{
    m_received = wxEmptyString;
    m_result = wxEmptyString;
}

RegExRecognizer::~RegExRecognizer()
{
}

bool RegExRecognizer::feed( char c )
{
    m_received += wxString::From8BitData( &c, 1 );

    if ( m_regEx.Matches( m_received ) ) {
        m_result = m_regEx.GetMatch( m_received, 1 );
        return true;
    }

    return false;
}

void RegExRecognizer::reset()
{
    m_received = wxEmptyString;
    m_result = wxEmptyString;
}

TxData* RegExRecognizer::getReceivedData()
{
    return new TxData( m_result.mb_str() );
}
