#ifndef RESPONSERECOGNIZER_H
#define RESPONSERECOGNIZER_H

#include "IRecognizer.h"

class TxData;

class ResponseRecognizer : public IRecognizer
{
    public:
        ResponseRecognizer( int id, TxData* request, IRecognizer* recognizer, int timeout );
        virtual ~ResponseRecognizer();

        bool feed( char c );
        void reset();
        TxData* getReceivedData();
        void timeout() { ++m_timeoutCount; }
        bool isTimedOut() const { return m_timeoutCount >= m_timeout; }

        int     getId() const { return m_id; }
        size_t  getTimeout() const { return m_timeout; }
        TxData* getRequest() const { return m_request; }


    private:
        int             m_id;
        int             m_timeout;
        int             m_timeoutCount;
        IRecognizer*    m_recognizer;
        TxData*         m_request;
};

#endif // RESPONSERECOGNIZER_H
