#include "ExitIcon.h"

#include <wx/dcbuffer.h>
#include "../logger.h"
#include <wx/app.h>

BEGIN_EVENT_TABLE(ExitIcon, VemsToolIconBase)
     //EVT_PAINT(ExitIcon::OnPaint)
     EVT_LEFT_DOWN(ExitIcon::OnLeftDown)
     EVT_LEFT_UP(ExitIcon::OnLeftUp)

END_EVENT_TABLE()

ExitIcon::ExitIcon(wxWindow *parent, wxWindowID id, const wxString& icondir, const wxPoint &pos)
         :VemsToolIconBase(parent,id,icondir,pos,_T("officon.png"))
{
    //ctor
    m_parent = parent;

    m_exitUpBmp     = new wxBitmapLayer(0, icondir +  _T("officon.png"));
    m_exitDownBmp   = new wxBitmapLayer(0, icondir +  _T("officon-down.png"));
}

ExitIcon::~ExitIcon()
{
    //dtor
}

void ExitIcon::IconInit()
{

    IconInitBase(m_exitUpBmp);

}

void ExitIcon::OnPaint(wxPaintEvent& event)
{


}

void ExitIcon::OnLeftUp(wxMouseEvent& evt)
{
    m_bmpLayers->AddBitmap(m_exitUpBmp);
    Refresh(false);

    m_parent->Close();
    //m_parent->Destroy();

#if defined (__WINCE_STANDARDSDK__)
    wxExit();
#endif

//    Logger::log(LOG_MSG,wxString::Format(_T("Destroy res=%i"),res));
}

void ExitIcon::OnLeftDown(wxMouseEvent& evt)
{
    m_bmpLayers->AddBitmap(m_exitDownBmp);
    Refresh(false);
}
