#ifndef GPSICON_H
#define GPSICON_H

#include "VemsToolIconBase.h"

#include "../ObserverBase.h"

class RTDataMgrBase;
class GPSEvent;
class GPSCommEvent;

class GPSIcon: public VemsToolIconBase, public ObserverBase
{
    public:

        //SelectInputIcon(wxWindow* parent, wxWindowID id, const wxPoint pos = wxDefaultPosition);
        GPSIcon(wxWindow* parent, wxWindowID id, const wxString& icondir, const wxPoint pos = wxDefaultPosition,
                        wxEvtHandler* eventHandler = NULL, RTDataMgrBase   *rtDataMgr = NULL );
        virtual ~GPSIcon();
        void connectEventHandler();

        void IconInit();
        void notify( int i ) {}
        void notify(int i, int idx);
        void notify(const wxString & str) {};
        void Init(const wxString& name, const wxString& msg, const int max) {};

    protected:

        DECLARE_EVENT_TABLE();

        void show();

    private:

        void OnGpsEvent(GPSEvent& event);
        void OnGpsCommState(GPSCommEvent& event);

        void SetMenuState();
        void RefreshIcon();

        void OnLeftDown(wxMouseEvent& evt);
        void OnLeftUp(wxMouseEvent& evt);
        void OnSelectGaugeInput(wxCommandEvent& event);
        void OnActivate(wxActivateEvent& evt);
        void SetDataMgr(RTDataMgrBase *rtDataMgr);




        RTDataMgrBase   *m_rtDataMgr;



        wxEvtHandler*   m_eventHandler;


        wxMenu          *m_menu;

        wxBitmapLayer   *m_sGpsNoData;
        wxBitmapLayer   *m_sGpsConn;
        wxBitmapLayer   *m_sGpsNotConn;
        wxBitmapLayer   *m_sGpsOff;

        int m_gpsState;
        int m_gpsCommState;


};



#endif // GPSICON_H
