#include "HideIcon.h"


#include "../logger.h"
#include "../WindowReg.h"


BEGIN_EVENT_TABLE(HideIcon, VemsToolIconBase)

    EVT_LEFT_DOWN(HideIcon::OnLeftDown)
    EVT_LEFT_UP(HideIcon::OnLeftUp)

END_EVENT_TABLE()

HideIcon::HideIcon(wxWindow *parent, wxWindowID id, const wxString& icondir, const wxPoint &pos)
         :VemsToolIconBase(parent,id,icondir,pos,_T("hide.png"))
         ,m_wreg (NULL)
{
    //ctor
    m_hideUpBmp     = new wxBitmapLayer(0, icondir +  _T("hide.png"));
    m_hideDownBmp   = new wxBitmapLayer(0, icondir +  _T("hide-down.png"));

}

HideIcon::~HideIcon()
{
    //dtor
    delete m_hideUpBmp;
    delete m_hideDownBmp;
}

void HideIcon::IconInit()
{

    IconInitBase(m_hideUpBmp);

}

void HideIcon::OnLeftDown(wxMouseEvent& evt)
{
    Logger::log(LOG_MSG,_T("HideIcon::OnLeftDown"));

    m_bmpLayers->AddBitmap(m_hideDownBmp);

    Refresh(false);


}

void HideIcon::OnLeftUp(wxMouseEvent& evt)
{
    Logger::log(LOG_MSG,_T("HideIcon::OnLeftUp"));

    m_bmpLayers->AddBitmap(m_hideUpBmp);

    Refresh(false);

    if(m_wreg == NULL) return;

	m_wreg->UpdateList();

	m_wreg->Minimize();

}


void HideIcon::SetWindowReg(WindowReg *wreg)
{

    m_wreg = wreg;

}
