#include "VemsToolIconBase.h"


#include <wx/dcbuffer.h>
#include "../logger.h"
#include "../DrawHelper.h"

BEGIN_EVENT_TABLE(VemsToolIconBase, wxControl)
    EVT_PAINT(VemsToolIconBase::OnPaint)
END_EVENT_TABLE()

VemsToolIconBase::VemsToolIconBase(wxWindow* parent, wxWindowID id, const wxString& icondir, const wxPoint pos, wxString IconFileName, wxSize size, long style , const wxString name)
{
    //ctor
    //Logger::log(LOG_MSG,_T("VemsToolIconBase CTOR START"));

    Create(parent,id,pos,size, style, wxDefaultValidator,  _T("VemsToolIconBase"));
    Hide();

    m_iconbmp = new wxBitmapLayer();

    //m_parent = parent;

    //Logger::log(LOG_MSG,_T("VemsToolIconBase CTOR END"));

    m_iconDir = icondir;
    m_IconFileName = IconFileName;
    m_size = size;

    m_bmpLayers = new LayerHandler();
}

VemsToolIconBase::~VemsToolIconBase()
{
    //dtor
    delete m_iconbmp;
//    delete m_bmpLayers;
}

void VemsToolIconBase::IconInitBase(wxBitmapLayer *icon)
{
    if(icon != NULL && icon->IsOk() ) {
        m_bmpLayers->AddBitmap(icon);
    }
    else {
        wxString fntmp = m_iconDir + m_IconFileName;

        if(!wxFileExists(fntmp)) {
            fntmp = m_iconDir + _T("default.png");
            if(!wxFileExists(fntmp)) return;
        }

        m_iconbmp->LoadFile(fntmp,wxBITMAP_TYPE_PNG);


        //SetSize(m_iconbmp->GetWidth(),m_iconbmp->GetHeight());

        m_bmpLayers->AddBitmap(m_iconbmp);

    }

    wxBitmapLayer *tmp = m_bmpLayers->GetBitmapPtrByDepth(0);

    if(tmp == NULL) return;

    SetSize(tmp->GetWidth(),tmp->GetHeight());

}

void VemsToolIconBase::OnPaint(wxPaintEvent& event)
{

    wxBufferedPaintDC dc(this);

    dc.SetBackground(*wxBLACK_BRUSH);

    dc.Clear();

/*
    dc.DrawBitmap(m_underIconBmp,0,0,1);

    dc.DrawBitmap(*m_iconbmp,0,0,1);

    dc.DrawBitmap(m_overIconBmp,0,0,1);
*/

    m_bmpLayers->DrawBitmaps(dc);

//    dc.SetBrush(*wxTRANSPARENT_BRUSH);

//    dc.DrawRectangle(0,0,GetSize().x,GetSize().y);

}

wxRegion VemsToolIconBase::GetShape()
{

    return wxRegion(0,0,GetSize().x,GetSize().y);

}

void VemsToolIconBase::InitBmpTinyChar(wxMemoryDC &memdc, wxBitmapLayerHash::iterator it, const wxSize &diff)
{
    wxSize ts = DrawHelper::GetTinyTextExtent( it->second->GetName() );
    wxPoint center( (it->second->GetWidth()-ts.x)/2 , (it->second->GetHeight()-ts.y)/2 );
    center += diff;
    memdc.SelectObjectAsSource(*((wxBitmap*)it->second));
    DrawHelper::DrawTinyText(&memdc,it->second->GetName(),center);
    memdc.SelectObject(wxNullBitmap);
}
