#ifndef VEMSTOOLICONBASE_H
#define VEMSTOOLICONBASE_H

#include <wx/control.h>
#include <wx/frame.h>
#include <wx/bitmap.h>

#include "../rtdatamanager/RTDataMgrBase.h"

#include "../wxBitmapLayer.h"
#include "../LayerHandler.h"

WX_DECLARE_HASH_MAP( int, wxBitmapLayer*, wxIntegerHash, wxIntegerEqual, wxBitmapLayerHash );

class VemsToolIconBase: public wxControl
{
    public:
        VemsToolIconBase(wxWindow* parent, wxWindowID id, const wxString& icondir, const wxPoint pos = wxDefaultPosition, wxString IconFileName = _T("default.png"),  wxSize size = wxSize(100,100), long style = wxNO_BORDER | wxSTAY_ON_TOP, const wxString name = wxPanelNameStr);
        virtual ~VemsToolIconBase();
        virtual void IconInit() = 0;
        wxRegion GetShape();
        void IconInitBase(wxBitmapLayer *icon = NULL);

        //void SetIconStateFromBitmap(const wxBitmap &bmp, bool UnderMainIcon);

        LayerHandler    *m_bmpLayers;

    protected:

        DECLARE_EVENT_TABLE();

        void InitBmpTinyChar(wxMemoryDC &memdc, wxBitmapLayerHash::iterator it, const wxSize &diff = wxSize(0,0));

    private:

        void OnPaint(wxPaintEvent& event);
        wxString    m_IconFileName;
        wxSize      m_size;
        wxString    m_iconDir;

        //wxWindow *m_parent;
        wxBitmapLayer   *m_iconbmp;


};



#endif // VEMSTOOLICONBASE_H
