#include "VTFilesMD5CheckerThread.h"

#include <hl_hashwrapper.h>
#include <hl_md5wrapper.h>

#include "../events/GeneralEvent.h"

VTFilesMD5CheckerThread::VTFilesMD5CheckerThread( wxEvtHandler* evtHandler, const StringHash& files, const wxString& baseDir )
{
    m_filesToCheck = files;
    m_running = false;
    m_baseDir = baseDir;
    m_evtHandler = evtHandler;
}

bool VTFilesMD5CheckerThread::process()
{
    if ( m_running )
        return false;

    m_running = true;

    m_filesToUpdate.Clear();

    StringHash::const_iterator it = m_filesToCheck.begin();

    for ( ; it != m_filesToCheck.end(); ++it )
    {
        wxString fname = m_baseDir + it->first;
        if ( ! wxFileExists( fname ) )
        {
            m_filesToUpdate.Add( it->first );
            continue;
        }
        hashwrapper* wrapper = new md5wrapper();

        std::string temp = wxString2stdString( fname );
        wxString tmp;

        std::string hash2 = wrapper->getHashFromFile( temp );
        wxString md5hash = stdString2wxString (hash2 );

        delete wrapper;

        if ( md5hash != it->second )
        {
            m_filesToUpdate.Add( it->first );
        }
    }

    GeneralEvent event;
    event.SetVoidPtr( this );
    event.SetLong( 300 );

    m_evtHandler->AddPendingEvent( event );

    return false;
}



wxString VTFilesMD5CheckerThread::stdString2wxString( const std::string& str )
{

    wxString temp( str.c_str(), wxConvUTF8 );
    return temp;

}

std::string VTFilesMD5CheckerThread::wxString2stdString( const wxString& str )
{
    int length = str.Length();

    std::string temp;

    length = str.Length();

    for ( int i = 0; i < length; ++i )
    {
        char c = str.GetChar( i );
        temp.push_back( c );
    }

    return temp;
}
