#include "ImageContentLoaderURL.h"

#include <wx/url.h>

bool ImageContentLoaderURL::Load(wxVariantHash& params)
{
    wxString urlstr = params[_T("url")].GetString();

    int imtype = params.find(_T("imagetype")) == params.end() ? wxBITMAP_TYPE_PNG : params[_T("imagetype")].GetLong();

    wxImage image;

    long restype = CLR_NO_ERROR;

    wxURL url( urlstr );

    if(url.GetError() == wxURL_NOERR) {
        wxInputStream *ins = NULL;

        ins = url.GetInputStream();

        if(ins) {
            image = wxImage(*ins,imtype);
            restype = CLR_NO_ERROR;
        } else {
            restype = CLR_NO_CONNECTION;
        }

    } else {
        restype = CLR_NO_CONNECTION;
    }

    if(!image.IsOk())  /// utana kell nezni, milyen hibákat dob, ha pl szöveget adok meg, etc.
        restype = CLR_WRONG_FORMAT;
    else
        params[_T("image")] << image;


    params[_T("resultType")] = restype;

    return true;
}

