#include "IgnitionLockFrame.h"

#include <wx/wx.h>

#include "../gaugedesc/GaugeDescManager.h"
#include "../gaugedesc/GaugeProperties.h"
#include "../gaugedesc/GaugeDescHelper.h"
#include "../vemsgauge/GaugeCarrierPanel.h"
#include "../vemsgauge/GaugeType.h"
#include "../vemsgauge/GaugeGroupManager.h"

IgnitionLockFrame::IgnitionLockFrame(wxWindow* parent, wxWindowID id, const wxString& title,
                        const wxPoint& pos, size_t gaugeCount, long style)
{
    //ctor
    //InitWindow( ((wxFrame*)this) );
     //wxSize fSize = wxSize(( gaugeCount +1) *240,380);

#if defined(__WINCE_STANDARDSDK__)
    Create(parent,id,title,pos,wxDefaultSize,style);
#else
    #if defined(__WXMSW__)
        //Create(parent,id,title,pos,size,style|wxFRAME_SHAPED | wxFRAME_TOOL_WINDOW  | wxFRAME_FLOAT_ON_PARENT );
        Create(parent,id,title,pos,wxDefaultSize, style | wxFRAME_FLOAT_ON_PARENT );
    #else
        Create(parent,id,title,pos,wxDefaultSize,style);
    #endif
#endif
    //this->SetSizer( new wxBoxSizer( wxHORIZONTAL ) );

    wxFlexGridSizer* FlexGridSizer1 = new wxFlexGridSizer( 0, gaugeCount+1, 0, 0 );
    FlexGridSizer1->AddGrowableCol(0,0);
    FlexGridSizer1->AddGrowableRow(0,0);
    this->SetSizer( FlexGridSizer1 );

    m_dialogSizer = new wxBoxSizer( wxVERTICAL );

    GetSizer()->Add( m_dialogSizer, 0, wxEXPAND );


}

IgnitionLockFrame::~IgnitionLockFrame()
{
    //dtor
    unregisterViewer();
}


void IgnitionLockFrame::unregisterViewer()
{
    for( size_t i = 0; i < m_viewers.GetCount(); ++i )
    {
        m_viewers.Item( i )->UnRegisterViewer();
    }

}

void IgnitionLockFrame::SetDataMgrObj(RTDataMgrBase *rtDataMgr)
{
    m_rtDataMgr = rtDataMgr;
}

bool IgnitionLockFrame::addGauge(GaugeProperties& prop)
{

    GaugeCarrierPanel* gaugePanel = new GaugeCarrierPanel(this, wxID_ANY, _T("Text"));

    gaugePanel->SetFactory( GaugeDescHelper::GetGDMgr()->GetGaugeGrpMgr()->GetFactories() );

//    gaugePanel->SetDataMgrObj(m_rtDataMgr);
    //gaugePanel->SetDataMgrObj(m_stDataMgr);

    gaugePanel->OnlyOneGauge( true );
    gaugePanel->SetGaugeShowInit( true );
    gaugePanel->SetFloating( false );

    wxWindow* gauge = gaugePanel->AddGauge( prop );
    if(!gauge){
        Logger::logf( LOG_MSG, _T("IgnitionLockFrame::addGauge() NULL!!!") );
        return false;
    }
    //m_viewers.Add(gauge);

    gaugePanel->ShowCarrier(true);

    GetSizer()->Add( gaugePanel, 1, wxEXPAND );
    //GetSizer()->Fit(this);
    GetSizer()->SetSizeHints(this);
    //m_gaugeCrrierBase = gaugePanel;
    return true;
}

void IgnitionLockFrame::addPanel(wxPanel* panel)
{
    m_dialogSizer->Add( panel, 1, wxEXPAND);
    //GetSizer()->Fit(this);
    GetSizer()->SetSizeHints(this);
}
