#include "wxImageHelper.h"

#include "wxHSLColor.h"

bool wxImageHelper::ShiftLuminance(wxImage& img, double lumdiff)
{
    if(!img.IsOk()) return false;

    unsigned char* img_data = img.GetData();
    unsigned char* img_alpha = img.GetAlpha();

    if(!img_data) return false;

    uint16_t img_w, img_h, img_x, img_y, img_didx, img_aidx;

    img_w = img.GetWidth();
    img_h = img.GetHeight();

    wxHSLColor tmpHSL;
    wxColor tmpRGB;

    for( img_y=0 ; img_y < img_h ; img_y++ ) {
        for( img_x=0 ; img_x < img_w ; img_x++ ) {

            img_aidx = img_x + img_w * img_y;

            if(img_alpha && img_alpha[img_aidx] == 0) continue;

            img_didx = img_aidx * 3;

            tmpHSL.FromRGB( img_data[img_didx], img_data[img_didx+1], img_data[img_didx+2] );

            tmpHSL.OffsetLum(lumdiff);

            tmpHSL.ToRGB(tmpRGB);

            img_data[img_didx] = tmpRGB.Red();
            img_data[img_didx+1] = tmpRGB.Green();
            img_data[img_didx+2] = tmpRGB.Blue();
        }
    }

    return true;
}
