#include "wxListCtrlHelper.h"

#include "logger.h"

#include "common/SortFunctions.h"

void wxListCtrlHelper::SortColoumData(wxListCtrl * lc, int col, bool isASC, bool isNum)
{
    long item = -1;

    wxVariantIntHashArray arr;

    while(1)
    {
        item = lc->GetNextItem(item, wxLIST_NEXT_ALL, wxLIST_STATE_DONTCARE);
        if ( item == -1 )
            break;

        wxVariantIntHash hash;

        for(int a=0; a < lc->GetColumnCount(); a++ ) {

            wxString label = GetCellLabel(lc, item, a);

            hash[ a ] = label;
        }

        arr.Add(hash);

    }

    if(col == 0 && isASC) {

        if(isNum)
            arr.Sort(&SortFunctions::compare_func_item_0_asc_num);
        else
            arr.Sort(&SortFunctions::compare_func_item_0_asc);

    } else if(col == 1 && isASC) {

        if(isNum)
            arr.Sort(&SortFunctions::compare_func_item_1_asc_num);
        else
            arr.Sort(&SortFunctions::compare_func_item_1_asc);

    } else if(col == 2 && isASC) {

        if(isNum)
            arr.Sort(&SortFunctions::compare_func_item_2_asc_num);
        else
            arr.Sort(&SortFunctions::compare_func_item_2_asc);

    } else if(col == 0 && !isASC) {

        if(isNum)
            arr.Sort(&SortFunctions::compare_func_item_0_desc_num);
        else
            arr.Sort(&SortFunctions::compare_func_item_0_desc);

    } else if(col == 1 && !isASC) {

        if(isNum)
            arr.Sort(&SortFunctions::compare_func_item_1_desc_num);
        else
            arr.Sort(&SortFunctions::compare_func_item_1_desc);

    } else if(col == 2 && !isASC) {

        if(isNum)
            arr.Sort(&SortFunctions::compare_func_item_2_desc_num);
        else
            arr.Sort(&SortFunctions::compare_func_item_2_desc);

    } else {

        LOGP(_T("wrong col"));

    }


    lc->DeleteAllItems();

    lc->Freeze();

    for(size_t a=0; a < arr.GetCount(); a++) {

        wxVariantIntHash& hash = arr[a];

//        for(wxVariantIntHash::iterator it = hash.begin(); it != hash.end(); it++) {
        for(int c=0; c < lc->GetColumnCount(); c++ ) {

            //wxString label = it->second.GetString();
            wxString label = hash[c];

            wxListItem item;

            item.SetId( a );
            item.SetColumn( c );
            item.SetText(label);

            if(c==0)
                lc->InsertItem(item);
            else
                lc->SetItem(item);

        }

    }

    lc->Thaw();
}


long wxListCtrlHelper::GetCellData(wxListCtrl * lc, int idx, int col, bool* result)
{
    wxListItem info;

    info.SetColumn(col);
    info.SetId(idx);
    info.SetMask(wxLIST_MASK_DATA);

    bool res = lc->GetItem(info);

    if(result) *result = res;

    if(res)
        return info.GetData();
    else
        return 0;
}

wxString wxListCtrlHelper::GetCellLabel(wxListCtrl * lc, int idx, int col, bool* result)
{
    wxListItem info;

    info.SetColumn(col);
    info.SetId(idx);
    info.SetMask(wxLIST_MASK_TEXT);

    bool res = lc->GetItem(info);

    if(result) *result = res;

    if(res)
        return info.GetText();
    else
        return wxEmptyString;
}
