#ifndef WXREALPOINTEX_H
#define WXREALPOINTEX_H

#include "wxPointEx.h"

#define DEFAULTREALPOSPRECISION 0.001

class wxRealPointEx: public wxRealPoint, public wxObject
{
    DECLARE_DYNAMIC_CLASS(wxRealPointEx);

    public:
        wxRealPointEx() : wxRealPoint(-1.0,-1.0) { m_precision = DEFAULTREALPOSPRECISION; };
        wxRealPointEx(const wxPoint& pos) : wxRealPoint(pos.x,pos.y) { m_precision = DEFAULTREALPOSPRECISION; };
        wxRealPointEx(const wxPointEx& pos) : wxRealPoint(pos.x,pos.y) { m_precision = DEFAULTREALPOSPRECISION; };
        wxRealPointEx(const wxRealPoint& pos) : wxRealPoint(pos.x,pos.y) { m_precision = DEFAULTREALPOSPRECISION; };
        wxRealPointEx(double xx, double yy) : wxRealPoint(xx,yy) { m_precision = DEFAULTREALPOSPRECISION; };

        void SetPrecision(double prec) { m_precision = prec; }
        double GetPrecision() const { return m_precision; };

        void operator=(const wxRealPointEx& pos);
        bool operator==(const wxRealPointEx& pos) const;
        bool operator!=(const wxRealPointEx& pos) const;

        wxRealPointEx operator+(const wxRealPointEx& pos) const;
        wxRealPointEx operator-(const wxRealPointEx& pos) const;
        wxRealPointEx& operator+=(const wxRealPointEx& pos);
        wxRealPointEx& operator-=(const wxRealPointEx& pos);

        wxRealPointEx operator*(double factor) const;
        wxRealPointEx operator/(double factor) const;
        wxRealPointEx& operator*=(double factor);
        wxRealPointEx& operator/=(double factor);

        void IncBy(double d) { x += d; y += d; };
        void IncBy(double xx, double yy) { x += xx; y += yy; };
        void IncBy(const wxRealPointEx& p) { x += p.x; y += p.y; };

        void DecBy(double d) { x -= d; y -= d; };
        void DecBy(double xx, double yy) { x -= xx; y -= yy; };
        void DecBy(const wxRealPointEx& p) { x -= p.x; y -= p.y; };

        wxPoint Ceil() const;
        wxPoint Floor() const;


    protected:

    private:

        double m_precision;

};

extern wxRealPointEx wxDefaultRealPointEx;


DECLARE_VARIANT_OBJECT(wxRealPointEx);

#endif // WXREALPOINTEX_H
