#ifndef WXRECTEX_H
#define WXRECTEX_H

class wxRectEx;

WX_DECLARE_OBJARRAY( wxRectEx, wxRectExArray );


class wxRectEx: public wxRect
{
    public:

        wxRectEx() { Init(-1,-1,0,0); };
        wxRectEx(int xx, int yy, int ww, int hh) { Init(xx,yy,ww,hh); };
        wxRectEx(const wxPoint& topLeft, const wxPoint& bottomRight) {
            Init(topLeft.x, topLeft.y, bottomRight.x - topLeft.x, bottomRight.y - topLeft.y);
        };
        wxRectEx(const wxPoint& pos, const wxSize& size) {
            Init(pos.x, pos.y, size.x, size.y);
        };
        virtual ~wxRectEx();

        void Init(int xx, int yy, int ww, int hh);

        void operator=(const wxRectEx& rect);
        void operator=(const wxRect& rect);
        bool operator==(const wxRectEx& rect) const;
        bool operator!=(const wxRectEx& rect) const;

        wxRectEx& operator+=(const wxRectEx& rect);
        wxRectEx operator+(const wxRectEx& rect) const;

        wxRectExArray Subtract(const wxRectEx& rect) const;
        wxRectExArray Subtract(const wxRectExArray& rects, bool removeNullRects = true) const;

        wxString GetAsString();
        wxString GetAsStringBorders();

    protected:
    private:
};

#endif // WXRECTEX_H
