#ifndef WXSQLITEHELPER_H
#define WXSQLITEHELPER_H

#include <wx/wx.h>
#include "common/types/wxVariantHash.h"
#include "wxSQLColumnDesc.h"

class wxSQLite3Database;
class wxSQLite3ResultSet;


class wxSqliteHelper
{
    public:

        static bool TablesCheck( const wxArrayString &tablenames, const wxString dbfilename );
        static bool ColumnExists(wxSQLite3Database *db, const wxString &tableName, const wxString &columnName, bool isCreate = false, const wxString &colType = _T("integer"));
        static wxString ConvertWxTypesToSQLTypes( const wxString &wxdatatype);
        static bool Exist(const wxString &dbpath);
        static void EscapeString(wxString &str);
        static wxString EscapeString(const wxString &str);


        static bool DatabaseCheck(const wxString& filename, ColumnDescArrayHash& desc, const wxString& dbname = wxEmptyString);
        static bool DatabaseCheck(wxSQLite3Database& db, ColumnDescArrayHash& desc, const wxString& dbname = wxEmptyString);


        static void ExecuteFromFile(wxSQLite3Database *db, const wxString& filepath);

        static void SQLLineToVariantHash(wxSQLite3ResultSet& res, wxVariantHash& hash);

        static bool CheckDBFile(const wxString& filepath);
};

#endif // WXSQLITEHELPER_H
