#ifndef WXSYSTEMHELPER_H
#define WXSYSTEMHELPER_H

#include "common/types/StringHash.h"
#include "common/types/Int2StringHash.h"

#if defined __WXMSW__
    #include <windows.h>
    #include <stdio.h>
    #include <psapi.h>
#endif

enum SystemProperties {
    SYSPROP_FIRST = 1,

    SYSPROP_OSNAME,
    SYSPROP_OSVER,
    SYSPROP_OSMANUFACTURER,
    SYSPROP_INSTALLDATE,
    SYSPROP_UPTIME,
    SYSPROP_TYPE,
    SYSPROP_CPUS,
    SYSPROP_BIOS,
    SYSPROP_TOTAL_PHYSICAL_MEMORY,

    SYSPROP_LAST
};

class wxSystemHelper
{
    public:

        static void LaunchDeviceManager();
        static void GetSystemSummary(Int2StringHash& data);

        static size_t GetMemoryUsage(long processid = -1); // -1 = memory usage of the current process

        static wxString GetSysPropString(int id);

#if defined __WXMSW__
        static void GetSystemSummaryMSW(StringHash& data);
        static bool GetMemoryInfoMSW(DWORD processID, PROCESS_MEMORY_COUNTERS& pmc);
#endif



};

#endif // WXSYSTEMHELPER_H
