#ifndef WXTEXTCTRLHOTKEY_H
#define WXTEXTCTRLHOTKEY_H

#include <wx/wx.h>
#include "Observable.h"

#include "customwidgets/ControlColorContentValidator.h"

class wxTextCtrlHotKey: public wxTextCtrl, public ControlColorContentValidator, public Observable
{
    public:
        wxTextCtrlHotKey(wxWindow* parent, wxWindowID id, const wxString& value = _T(""), const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0, const wxValidator& validator = wxDefaultValidator, const wxString& name = wxTextCtrlNameStr);

        void SetDefaultValue(const wxString& val) { m_defVal = val; }

    protected:

    private:

        void OnKeyDown(wxKeyEvent &evt);
        void OnKeyUp(wxKeyEvent &evt);

        void OnUpdated(wxCommandEvent& evt);

        bool m_isValid;

        wxString m_defVal;

    DECLARE_EVENT_TABLE()

};

#endif // WXTEXTCTRLHOTKEY_H
